SystemOrganization addCategory: #'NetMorph-Morphic-Network'!
SystemOrganization addCategory: #'NetMorph-Support-Common'!
SystemOrganization addCategory: #'NetMorph-Network-Client'!
SystemOrganization addCategory: #'NetMorph-Network-RPC'!
SystemOrganization addCategory: #'NetMorph-Network-Services'!
SystemOrganization addCategory: #'NetMorph-Morphic-eToys'!
SystemOrganization addCategory: #'NetMorph-Morphic-Marker'!
SystemOrganization addCategory: #'NetMorph-Morphic-WorldMap'!
SystemOrganization addCategory: #'NetMorph-Support-Client'!
SystemOrganization addCategory: #'NetMorph-Morphic-Project'!
SystemOrganization addCategory: #'NetMorph-Support-Server'!
SystemOrganization addCategory: #'NetMorph-WorldMap'!
SystemOrganization addCategory: #'NetMorph-Server-MapServer'!

RmtRpcConnector subclass: #NmRemoteConnector
	instanceVariableNames: ''
	classVariableNames: 'CriticalSemaphore'
	poolDictionaries: ''
	category: 'NetMorph-Network-RPC'!

NmRemoteConnector class
	instanceVariableNames: 'connectionPool'!

!NmRemoteConnector class methodsFor: 'utility' stamp: 'mu 7/30/2005 03:02'!
callFindBy: uuid retry: numberOfRetries 
	numberOfRetries
		timesRepeat: [NmWorldMap default
				survivorsDo: [:ipAndPort | 
					| connector return | 
					[connector _ self connect: ipAndPort first port: ipAndPort last.
					return _ connector callFindBy: uuid asString]
								on: RmtNetworkError
								do: [:ex | 
									NmTranscript crShow: '#callFindBy: cannot find: ' , uuid asString.
									ActiveWorld netMorphProxyCache removeKey: uuid ifAbsent:[].
									NmWorldMap default removeAtAddress: ipAndPort.
									ex return: nil].
					return isNil
						ifFalse: [^ return]].
			(Delay forSeconds: 1) wait].
	^ nil! !

!NmRemoteConnector class methodsFor: 'utility' stamp: 'mu 5/31/2004 01:00'!
closeAllConnections
	self connectionPool ifNotNilDo: [:cp | cp release]! !

!NmRemoteConnector class methodsFor: 'accessing' stamp: 'MU 11/29/2002 15:57'!
connectionPool
	^connectionPool! !

!NmRemoteConnector class methodsFor: 'instance creation' stamp: 'mu 5/10/2005 21:25'!
connect: ipAddressOrHost port: portNumber timeout: timeoutSecs 
	
	^self connectionPool connect: ipAddressOrHost port: portNumber asInteger timeout: timeoutSecs! !

!NmRemoteConnector class methodsFor: 'constants' stamp: 'MU 12/3/2002 11:39'!
defaultPort
	^44445! !

!NmRemoteConnector class methodsFor: 'constants' stamp: 'mu 7/26/2005 02:07'!
defaultTimeoutSeconds
	^7! !

!NmRemoteConnector class methodsFor: 'class initialization' stamp: 'mu 5/31/2004 00:59'!
initialize
	"NmRemoteConnector initialize"
	connectionPool _ RmtConnectorPool connectorClass: self.! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 5/29/2004 19:08'!
basicCallCatchAndGo: morphByteArray 
	^ self send: #catchAndGo: arguments: morphByteArray by: #none
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 5/29/2004 19:09'!
basicCallCatchAndGo: morphByteArray x: x y: y 
	| args |
	args _ {morphByteArray. x. y}.
	^ self send: #catchAndGo:x:y: arguments: args by: #DataStream
		
	! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 7/24/2005 13:14'!
basicCallDispatch: uuidString to: target selector: selector 
	| args |
	args _ {uuidString. target. selector}.
	^ self send: #dispatch:to:selector: arguments: args by: #DataStream
		
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 5/29/2004 19:10'!
basicCallDispatch: uuidString to: target selector: selector withArguments: arguments 
	| args |
	args _ {uuidString. target. selector. arguments}.
	^ self send: #dispatch:to:selector:withArguments: arguments: args by: #ReferenceStream
		
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 5/29/2004 19:11'!
basicCallFindBy: uuidString 
	| args |
	args _ {uuidString}.
	^ self send: #findBy: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 7/2/2005 22:11'!
basicCallGetNumberOfProjectsMatches: matchString matchOptions: matchOptionString
	| args |
	args _ {matchString. matchOptionString}.
	^ self send: #getNumberOfProjectsMatches:matchOptions: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 6/20/2005 00:07'!
basicCallGetProjectInfo: projectName 
	| args |
	args _ {projectName}.
	^ self send: #getProjectInfo: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 7/2/2005 22:25'!
basicCallGetProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString
	| args |
	args _ {start. end. matchString. matchOptionString. sortOptionString}.
	^ self send: #getProjectNamesFrom:to:matches:matchOptions:sortOptions: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 6/20/2005 00:06'!
basicCallGetProjectThumbnail: projectName 
	| args |
	args _ {projectName}.
	^ self send: #getProjectThumbnail: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 6/20/2005 00:05'!
basicCallGetProject: projectName 
	| args |
	args _ {projectName}.
	^ self send: #getProject: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 6/16/2005 23:26'!
basicCallTakeAPicture: shrunkBySize
	| args |
	args _ {shrunkBySize}.
	^ self send: #takeAPicture: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'sending' stamp: 'mu 8/3/2005 10:00'!
basicRedirectIpAndPortOf: uuidString 
	| args |
	args := {uuidString}.
	^ self send: #redirectIpAndPortOf: arguments: args by: #DataStream
		
	
		! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'kuri-t 1/24/2003 14:06'!
callCatchAndGo: morphByteArray 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self basicCallCatchAndGo: morphByteArray]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'MU 12/29/2002 17:43'!
callCatchAndGo: morphByteArray x: x y: y 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self
						basicCallCatchAndGo: morphByteArray
						x: x
						y: y]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'MU 12/29/2002 17:43'!
callDispatch: uuidString to: target selector: selector 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self
						basicCallDispatch: uuidString
						to: target
						selector: selector]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'MU 12/29/2002 17:44'!
callDispatch: uuidString to: target selector: selector withArguments: arguments 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self
						basicCallDispatch: uuidString
						to: target
						selector: selector
						withArguments: arguments]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'MU 12/29/2002 17:44'!
callFindBy: uuidString 
	| ret |
	ret _ nil.
	NmProcessManager
		critical: [ret _ self basicCallFindBy: uuidString]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 7/26/2005 01:52'!
callGetNumberOfProjectsMatches: matchString matchOptions: matchOptionString 
	| ret |
	ret _ 0.
	ret _ self basicCallGetNumberOfProjectsMatches: matchString matchOptions: matchOptionString.
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 6/20/2005 01:23'!
callGetProjectInfo: projectName
	| ret |
	ret _ nil.
	ret _ self basicCallGetProjectInfo: projectName.
	^ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 7/26/2005 01:52'!
callGetProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString 
	| ret |
	ret _ #().
	[ret _ self
				basicCallGetProjectNamesFrom: start
				to: end
				matches: matchString
				matchOptions: matchOptionString
				sortOptions: sortOptionString]
		on: RmtNetworkError
		do: [:ex | ex inspect].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 6/20/2005 01:22'!
callGetProjectThumbnail: projectName 
	| ret |
	ret _ nil.
	ret _ self basicCallGetProjectThumbnail: projectName.
	^ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 6/20/2005 01:18'!
callGetProject: projectName 
	| ret |
	ret _ nil.
	ret _ self basicCallGetProject: projectName.
	^Project loadFrom: ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 8/3/2005 10:00'!
callRedirectIpAndPortOf: uuidString 
	| ret |
	ret := nil.
	NmProcessManager
		critical: [ret := self basicRedirectIpAndPortOf: uuidString]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'calling' stamp: 'mu 6/16/2005 23:39'!
callTakeAPicture: shrunkBySize
	| ret |
	ret _ nil.
	ret _ self basicCallTakeAPicture: shrunkBySize.
	^Form fromCompactBytes: ret uncompressOnDemand! !

!NmRemoteConnector methodsFor: 'initialize' stamp: 'mu 7/30/2005 03:18'!
connect: ipAddressOrHost port: portNumber timeout: timeoutSeconds 
	| ret |
	ret _ nil.
	
	NmProcessManager
		critical: [ret _ Cursor execute
						showWhile: [super
								connect: ipAddressOrHost
								port: portNumber
								timeout: timeoutSeconds]]
		ifError: [:ex | 
			NmProcessManager releaseAllLockedProcesses.
			ex pass].
	^ ret! !

!NmRemoteConnector methodsFor: 'factory' stamp: 'mu 5/29/2004 18:52'!
messageClass
	^NmRpcMessage! !

!NmRemoteConnector methodsFor: 'private-sending' stamp: 'mu 5/29/2004 19:03'!
send: selector arguments: args by: encoder
	^self send: selector arguments: args by: encoder timeout: self class timeoutSeconds ! !

!NmRemoteConnector methodsFor: 'private-sending' stamp: 'mu 5/29/2004 19:01'!
send: selector arguments: args by: encoder timeout: timeoutSecs 
	| msg |
	msg _ NmRpcMessage
				selector: selector
				arguments: args
				encoder: encoder.
	^ self sendData: msg rawData timeout: timeoutSecs! !

!NmRemoteConnector methodsFor: 'private' stamp: 'mu 8/2/2005 07:19'!
signalExceptionFrom: exceptionArray 
	| exception |
	exception := self buildExceptionFrom: exceptionArray.
	exception class name = #NmNoSuchMorph
		ifTrue: [| localMorph | 
			localMorph := NmFinder
						findMorphBy: exception uuidString
						ifNone: [].
			localMorph notNil
				ifTrue: [
			NmTranscript cr;crShow: 'Unneeded exception so just ignore...'.
		"Unneeded exception so just ignore..." ^ self]].
	exception signal! !

!MenuMorph methodsFor: '*NetMorph-override-initialization' stamp: 'kuri-t 2/14/2003 12:11'!
delete
	activeSubMenu
		ifNotNil: [activeSubMenu delete].
	^ self topRendererOrSelf isFlexMorph
		ifTrue: [self topRendererOrSelf delete]
		ifFalse: [super delete]! !

RmtRpcMessage subclass: #NmRpcMessage
	instanceVariableNames: 'selectorIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-RPC'!

NmRpcMessage class
	instanceVariableNames: 'selectorIndexArray'!

!NmRpcMessage class methodsFor: 'class initialization' stamp: 'mu 5/29/2004 18:33'!
initialize
	"self initialize"
	super initialize.
	self initSelectorIndexArray.
	! !

!NmRpcMessage class methodsFor: 'class initialization' stamp: 'mu 8/3/2005 10:02'!
initSelectorIndexArray
	"self initSelectorIndexArray"
	| selectors seviceCats |
	selectors := OrderedCollection new.
	seviceCats := NmServiceHandler organization categories select: [:each | each beginsWith: 'service'].
	seviceCats do: [:eachCat | 
		selectors addAll: (NmServiceHandler organization listAtCategoryNamed: eachCat)].
	selectorIndexArray := selectors asArray.! !

!NmRpcMessage class methodsFor: 'accessing' stamp: 'mu 5/29/2004 18:32'!
selectorIndexArray
	^selectorIndexArray! !

!NmRpcMessage class methodsFor: 'actions' stamp: 'mu 5/29/2004 18:32'!
selectorIndexOf: selectorOfCommand	
	^selectorIndexArray indexOf: selectorOfCommand! !

!NmRpcMessage class methodsFor: 'actions' stamp: 'mu 5/29/2004 18:32'!
selectorOf: selectorIndex
	^selectorIndexArray at: selectorIndex ifAbsent:[]! !

!NmRpcMessage class methodsFor: 'instance creation' stamp: 'mu 5/29/2004 19:27'!
selector: selector arguments: args encoder: encoder 
	| inst |
	inst _ self new.
	inst type: #send.
	inst selectorIndex: (self selectorIndexOf: selector).
	inst arguments: args.
	inst body: (self stream: args by: encoder).
	inst encoder: encoder.
	^ inst! !

!NmRpcMessage methodsFor: 'initialize-release' stamp: 'mu 5/29/2004 19:02'!
extractHeaderAttributeFromTagChar: tagChar on: headerStream 
	"do nothing"! !

!NmRpcMessage methodsFor: 'initialize-release' stamp: 'mu 5/29/2004 18:47'!
extractHeaderBasicAttributesFrom: headerStream 
	| selectorIndicator |
	super extractHeaderBasicAttributesFrom: headerStream.
	selectorIndicator _ headerStream next.
	selectorIndicator ifNil: [^selectorIndex _ 0]. 	 
	selectorIndex _ selectorIndicator asciiValue.
	! !

!NmRpcMessage methodsFor: 'formats' stamp: 'mu 5/29/2004 18:47'!
headerOn: aStream
	selectorIndex ifNotNil: [aStream nextPut: selectorIndex].	
	! !

!NmRpcMessage methodsFor: 'accessing' stamp: 'mu 5/29/2004 19:34'!
realSelector
	^self class selectorOf:  selectorIndex! !

!NmRpcMessage methodsFor: 'accessing' stamp: 'mu 5/29/2004 19:22'!
receiver
	^'' ! !

!NmRpcMessage methodsFor: 'actions' stamp: 'mu 5/29/2004 19:53'!
restoreObject
	| tp |
	tp _ self type.
	tp == #send
		ifTrue: [^ Array
				with: self selector asSymbol
				with: (encoder == #none
						ifTrue: [Array with: self basicRestoreObject]
						ifFalse: [self basicRestoreObject])].
	^ super restoreObject! !

!NmRpcMessage methodsFor: 'accessing' stamp: 'mu 5/29/2004 19:22'!
selector
	^self realSelector ifNil: [''] ! !

!NmRpcMessage methodsFor: 'accessing' stamp: 'mu 5/29/2004 18:47'!
selectorIndex: anIntegerOfSelectorIndex
	selectorIndex _ anIntegerOfSelectorIndex asNumber! !

Object subclass: #NmAbstractInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmAbstractInitializer class methodsFor: 'class initialization' stamp: 'mu 12/24/2004 00:12'!
initialize
	"NmAbstractInitializer initialize"
	self == NmAbstractInitializer
		ifTrue: [self initializeAll]
		ifFalse: [Smalltalk addToStartUpList: self.
			Smalltalk addToShutDownList: self]! !

!NmAbstractInitializer class methodsFor: 'class initialization' stamp: 'mu 12/24/2004 00:11'!
initializeAll
	"self initializeAll"
	self allSubclassesDo: [:each | each initialize]! !

!NmAbstractInitializer class methodsFor: 'system shutdown' stamp: 'mu 7/8/2005 20:12'!
lightShutDown
	! !

!NmAbstractInitializer class methodsFor: 'system startup' stamp: 'mu 7/8/2005 20:12'!
lightStartUp
	! !

!NmAbstractInitializer class methodsFor: 'class initialization' stamp: 'mu 12/24/2004 00:11'!
obsolete
	self == NmAbstractInitializer
		ifFalse: [Smalltalk removeFromStartUpList: self.
			Smalltalk removeFromShutDownList: self]! !

!NmAbstractInitializer class methodsFor: 'system shutdown' stamp: 'mu 12/24/2004 00:10'!
shutDown
	! !

!NmAbstractInitializer class methodsFor: 'system shutdown' stamp: 'mu 7/8/2005 20:13'!
shutDown: quitting
	quitting ifTrue: [self shutDown] ifFalse: [self lightShutDown]! !

!NmAbstractInitializer class methodsFor: 'system startup' stamp: 'mu 12/24/2004 00:10'!
startUp
	! !

!NmAbstractInitializer class methodsFor: 'class initialization' stamp: 'mu 7/8/2005 21:01'!
startUpAll
	"self startUpAll"
	self allSubclassesDo: [:each | each startUp]! !

!NmAbstractInitializer class methodsFor: 'system startup' stamp: 'mu 7/8/2005 20:12'!
startUp: resuming
	resuming ifTrue: [self startUp] ifFalse: [self lightStartUp]! !

NmAbstractInitializer subclass: #NmInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Client'!

!NmInitializer class methodsFor: 'class initialization' stamp: 'mu 7/8/2005 21:01'!
initialize
	"NmInitializer initialize"
	super initialize.
	Vocabulary initialize.
	
! !

!NmInitializer class methodsFor: 'startup actions' stamp: 'mu 8/12/2005 12:32'!
initializeForNet
	[NmServerManager startWarpServer.
	NmUrl initialize.
	NmRemoteConnector initialize.
	NmAutoWorldInfoUpdater default startAfter: 1.
	NmWorldMapLocationListener default start.
	NmAvailabilityChecker default start]
		on: SoapImplError, RmtNetworkError
		do: [:ex | 
			self inform: 'NetMorph: network initialize failed!!'.
			ex pass].
	! !

!NmInitializer class methodsFor: 'system shutdown' stamp: 'mu 7/8/2005 20:20'!
lightShutDown

	NmProcessManager releaseAllLockedProcesses! !

!NmInitializer class methodsFor: 'system startup' stamp: 'mu 7/9/2005 15:52'!
lightStartUp
	NmUrl initialize.
	NmFlapSetup addFlap.
	ActiveWorld fenceEnabled: false.
	NmProcessManager initialize.
	Player freeUnreferencedSubclasses.
	self removeObsoletePlayerClasses.
	PaintBoxMorph classPool at: #RecentColors put: nil.
	! !

!NmInitializer class methodsFor: 'startup actions' stamp: 'mu 8/15/2005 00:22'!
removeObsoletePlayerClasses
	"NmInitializer removeObsoletePlayerClasses"
	| obsoleteClasses |
	SystemNavigation default obsoleteClasses
		do: [:obsoleteClass | 
			| obsoleteClassName | 
			obsoleteClassName _ obsoleteClass name.
			('*Player*' match: obsoleteClassName)
				ifTrue: [obsoleteClass
						allInstancesDo: [:inst | inst becomeForward: nil].
					obsoleteClass becomeForward: nil].
			NmTranscript crShow: '>> An obsolete player class: ' , obsoleteClassName , ' is removed.'].
	obsoleteClasses _ SystemNavigation default obsoleteClasses.
	obsoleteClasses size > 0
		ifTrue: [NmTranscript crShow: '>> Obsolete classes that still exist: '.
			obsoleteClasses
				do: [:obsoleteClass | NmTranscript crShow: '  ' , obsoleteClass name]]! !

!NmInitializer class methodsFor: 'system shutdown' stamp: 'mu 8/22/2005 16:06'!
shutDown
	NmAvailabilityChecker default stop.
	NmWorldMapLocationListener default stop.
	NmAutoWorldInfoUpdater default stop.
	NmRemoteConnector closeAllConnections.
	NmServerManager stopWarpServer.
	NmProcessManager releaseAllLockedProcesses.
	
	Project trimNetMorphPublishDirectory.
	ActiveWorld flushMorphIdentifierWarpedList! !

!NmInitializer class methodsFor: 'system startup' stamp: 'mu 7/9/2005 15:52'!
startUp
	"NmInitializer startUp"
	self initializeForNet.
	NmFlapSetup addFlap.
	ActiveWorld fenceEnabled: false.
	NmProcessManager initialize.
	Player freeUnreferencedSubclasses.
	self removeObsoletePlayerClasses.
	PaintBoxMorph classPool at: #RecentColors put: nil.
	! !

NmAbstractInitializer subclass: #NmServerInitializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

!NmServerInitializer class methodsFor: 'system startup' stamp: 'mu 7/13/2005 20:44'!
lightStartUp
	"NmServerInitializer startUp"
	NmFlapSetup addFlap.
	NmServerSettings load.
	NmServerSettings shouldRunMapServer
		ifTrue: [NmServerManager isMapServerRunning
				ifFalse: [NmServerManager startMapServer].
			NmWorldMapLocationBroadcaster default isRunning
				ifFalse: [NmWorldMapLocationBroadcaster default startAfter: 3]].
	NmWorldMapServer default clearMapsNotUsedFor: 1! !

!NmServerInitializer class methodsFor: 'system startup' stamp: 'mu 7/9/2005 15:52'!
startUp
	"NmServerInitializer startUp"
	NmFlapSetup addFlap.
	NmServerSettings load.
	NmServerSettings shouldRunMapServer
		ifTrue: [NmServerManager startMapServer.
			NmWorldMapLocationBroadcaster default startAfter: 3].
	NmServerSettings saveMapServerPort ifFalse: [NmServerSettings mapServerPort: -1.  "reset port"].
	NmWorldMapServer default clearMapsNotUsedFor: 1.
	! !

Object subclass: #NmBaseUtil
	instanceVariableNames: ''
	classVariableNames: 'PlatformSymbol'
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmBaseUtil class methodsFor: 'development' stamp: 'mu 8/22/2005 16:56'!
browseAllStringReferences
	"NmBaseUtil browseAllStringReferences"
	| package references classes methods stringMethods extensionMethods |
	package := PackageOrganizer default
				packageNamed: 'NetMorph'
				ifAbsent: [].
	references := Set new.
	classes := package classesAndMetaClasses.
	classes
		do: [:eachClass | 
			methods := eachClass methodDictionary values.
			stringMethods := methods
						select: [:m | (m literals
								select: [:e | e isString
										and: [e isSymbol not]]) size > 0].
			references
				addAll: (stringMethods
						collect: [:each | each methodReference])].
	extensionMethods := package extensionMethods.
	extensionMethods := extensionMethods
				select: [:each | (each compiledMethod literals
						select: [:e | e isString
								and: [e isSymbol not]]) size > 0].
	references addAll: extensionMethods.
	MessageSet openMessageList: references name: 'NetMorph String references', '-', references size asString! !

!NmBaseUtil class methodsFor: 'class initialization' stamp: 'mu 5/12/2005 23:03'!
initialize
	"NmBaseUtil initialize"
	PlatformSymbol _ nil.
	Smalltalk addToStartUpList: self.
	! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 5/13/2005 00:02'!
ipAndPortFromString: aString 
	"NmBaseUtil ipAndPortFromString: 'aaa:9090'"
	"NmBaseUtil ipAndPortFromString: 'aaaa'"
	"NmBaseUtil ipAndPortFromString: 'nm://aaaa'"
	"NmBaseUtil ipAndPortFromString: 'nm://aaaa:99'"
	| port tokens hostIndex host |
	(aString isEmptyOrNil)ifTrue: [^ nil].

	tokens _ aString findTokens: '/:'.
	port _ tokens detect: [:each | each isAllDigits] ifNone: [NmSettings defaultWarpPort asString].
	hostIndex _ tokens indexOf: port.
	host _ hostIndex = 0 ifTrue: [tokens last] ifFalse: [tokens at: (hostIndex -1)].
	
	^Array with: host with: port asNumber! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 8/7/2005 22:45'!
isLocal: ipOrHost port: portNumber
	portNumber asNumber = NmBaseSettings warpPort ifFalse: [^false].
	ipOrHost = '127.0.0.1' ifTrue: [^true].
	ipOrHost = 'localhost' ifTrue: [^true].
	ipOrHost = self localAddress ifTrue: [^true].
	ipOrHost = self localHostname ifTrue: [^true].
	^false! !

!NmBaseUtil class methodsFor: 'testing' stamp: 'mu 6/15/2005 23:35'!
isSixxInstalled
	^Smalltalk includesKey: #SixxXmlUtil! !

!NmBaseUtil class methodsFor: 'storing/loading' stamp: 'mu 6/21/2005 00:31'!
loadDataFrom: stream 
	^ (self isSixxInstalled
			or: [stream peek = $<])
		ifTrue: [Object readSixxFrom: stream contents]
		ifFalse: [stream binary.
			ReferenceStream unStream: stream contents]! !

!NmBaseUtil class methodsFor: 'storing/loading' stamp: 'mu 6/21/2005 00:32'!
loadFrom: dir named: fileName 
	| readFileStream loaded |
	(dir fileExists: fileName)
		ifFalse: [^ nil].
	[readFileStream _ dir readOnlyFileNamed: fileName.
	loaded _ self loadDataFrom: readFileStream]
		ensure: [readFileStream ifNotNilDo: [:str | str close]].
	^ loaded! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 5/29/2005 03:41'!
localAddress
	"NmBaseUtil localAddress"
	^ NmBaseSettings explicitGlobalAddress isNil
		ifTrue: [NetNameResolver localAddressString]
		ifFalse: [NmBaseSettings explicitGlobalAddress]! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 5/13/2005 00:02'!
localHostname
	"Squeak specific"
	"NmBaseUtil localHostname"
	| localHostname |
	localHostname _ NetNameResolver nameForAddress: NetNameResolver localHostAddress timeout: 10.
	localHostname isNil ifTrue: [^self localAddress].
	^ localHostname! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 8/18/2005 09:03'!
localIpAndPortString
	"NmBaseUtil localIpAndPortString"
	^self localAddress, ':', NmBaseSettings warpPort asString! !

!NmBaseUtil class methodsFor: 'adapter for Network' stamp: 'mu 6/15/2005 00:26'!
localMapServerUrl
	"NmBaseUtil localMapServerUrl"
	NmServerManager isMapServerInstalled
		ifFalse: [^ NmBaseSettings defaultMapServerUrl].
	^ 'http://' , self localAddress , ':' , NmServerSettings mapServerPort asString , '/' , NmBaseSettings defaultMapServerTargetName! !

!NmBaseUtil class methodsFor: 'class initialization' stamp: 'mu 5/12/2005 22:59'!
obsolete
	"NmBaseUtil obsolete"

	Smalltalk removeFromStartUpList: self.
	! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 5/13/2005 00:02'!
platformSymbol
	"NmBaseUtil platformSymbol"
	PlatformSymbol ifNil: [PlatformSymbol _ Smalltalk platformName asLowercase asSymbol ].
	^PlatformSymbol! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 5/13/2005 00:02'!
resetSystem
	"NmBaseUtil resetSystem"
	! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 6/15/2005 23:50'!
shortImageName
	"NmBaseUtil shortImageName"
	^ FileDirectory
		localNameFor: (Smalltalk fullNameForImageNamed: Smalltalk imageName)! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 6/15/2005 23:52'!
shortImagePrefix
	^ FileDirectory baseNameFor: self shortImageName! !

!NmBaseUtil class methodsFor: 'system' stamp: 'mu 5/12/2005 23:03'!
startUp

	PlatformSymbol := nil.
! !

!NmBaseUtil class methodsFor: 'storing/loading' stamp: 'mu 6/21/2005 00:32'!
storeData: obj to: stream 
	self isSixxInstalled
		ifTrue: [stream nextPutAll: obj sixxString]
		ifFalse: [stream binary;
				nextPutAll: (ReferenceStream streamedRepresentationOf: obj)]! !

!NmBaseUtil class methodsFor: 'storing/loading' stamp: 'mu 6/21/2005 00:32'!
store: obj to: dir named: fileName 
	| writeFileStream |
	[writeFileStream _ dir forceNewFileNamed: fileName.
	self storeData: obj to: writeFileStream]
		ensure: [writeFileStream notNil
				ifTrue: [writeFileStream close]]! !

NmBaseUtil subclass: #NmServerUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

!NmServerUtil class methodsFor: 'soap support' stamp: 'ns 1/23/2003 14:33'!
inspectRegisteredServices
	"NmServerUtil inspectRegisteredServices"
	SoapServiceHandler default serviceHome inspect! !

!NmServerUtil class methodsFor: 'soap support' stamp: 'mu 5/29/2005 03:48'!
runningTransportDescriptions
	"NmServerUtil runningTransportDescriptions"
	"Show what transport server(s) is running"
	| setup |
	(setup _ NmServerManager soapServerSetup)
		ifNil: [^ #()].
	^setup runningTransportDescriptions! !

NmBaseUtil subclass: #NmUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Client'!

NmUtil class
	instanceVariableNames: 'netMorphProxyCache'!

!NmUtil class methodsFor: 'other' stamp: 'mu 6/23/2005 00:34'!
funnyName
	^ #('Kuma' 'Hau' 'Moe' 'Poh' 'Auau' 'Daimon' 'Foo' 'Bar' 'Baz' 'Ton' 'Gyu' 'Uoo' 'Oops' 'Stro' 'Nae' 'Jaao' 'Vbba' 'Aoo' 'Fufu' 'Dee' 'Mww' 'Wmm' 'Cu' 'Yuz' 'Pam' 'Dee' 'Doo' 'Daz' 'Oow' 'Snx' 'Ooa' 'Auea' 'Hhhh' 'Hehe' 'Orz' 'Ccb' 'Yaxx' 'Mee' 'Cud') atRandom ,
	 999 atRandom asString! !

!NmUtil class methodsFor: 'gzip support' stamp: 'ka 10/15/2002 17:45'!
gunzippedFrom: aByteArray 
	"NmUtil gunzippedFrom: (NmUtil gzippedFrom: 'hello' asByteArray) asString"
	| gzipStream |
	gzipStream _ GZipReadStream on: aByteArray.
	^ gzipStream contents! !

!NmUtil class methodsFor: 'gzip support' stamp: 'ka 10/15/2002 17:42'!
gzippedFrom: aByteArray 
	"NmUtil gzippedFrom: 'hello' asByteArray"
	| bufferStream gZipStream |
	bufferStream _ RWBinaryOrTextStream
				on: (ByteArray new: 5000).
	bufferStream binary.
	gZipStream _ GZipWriteStream on: bufferStream.
	aByteArray
		do: [:each | gZipStream nextPut: each].
	gZipStream close.
	^ bufferStream contents! !

!NmUtil class methodsFor: 'adapter for Network' stamp: 'mu 12/30/2004 02:21'!
ipAndPortFromString: aString 
	"NmUtil ipAndPortFromString: 'aaa:9090'"
	"NmUtil ipAndPortFromString: 'aaaa'"
	"NmUtil ipAndPortFromString: 'nm://aaaa'"
	"NmUtil ipAndPortFromString: 'nm://aaaa:99'"
	| port tokens hostIndex host |
	(aString isEmptyOrNil)ifTrue: [^ nil].

	tokens _ aString findTokens: '/:'.
	port _ tokens detect: [:each | each isAllDigits] ifNone: [NmSettings defaultWarpPort asString].
	hostIndex _ tokens indexOf: port.
	host _ hostIndex = 0 ifTrue: [tokens last] ifFalse: [tokens at: (hostIndex -1)].
	
	^Array with: host with: port asNumber! !

!NmUtil class methodsFor: 'system' stamp: 'mu 8/15/2005 12:03'!
makeNeighborImages
	"NmUtil makeNeighborImages"
	| oldName |
	World leftFenceEnabled: false;
		 rightFenceEnabled: false.
	
	oldName _ FileDirectory
				localNameFor: (Smalltalk fullNameForImageNamed: Smalltalk imageName).
	oldName _ (FileDirectory baseNameFor: oldName)
				copyReplaceAll: '.'
				with: '#'.
	[{0 @ 0. 1 @ 0}
		do: [:point | 
			| newName localEntry | 
			newName _ oldName , '-' , self funnyName.
			(FileStream
					isAFileNamed: (Smalltalk fullNameForImageNamed: newName))
				ifFalse: [(SourceFiles at: 2)
						ifNotNil: [SmalltalkImage current
								saveChangesInFileNamed: (SmalltalkImage current fullNameForChangesNamed: newName)].
					SmalltalkImage current
						saveImageInFileNamed: (SmalltalkImage current fullNameForImageNamed: newName).
					localEntry _ NmWorldMap localEntry.
					localEntry name: newName.
					localEntry point: point.
					localEntry port: NmSettings defaultWarpPort + point x]]]
		on: CannotDeleteFileException
		do: [:ex | ex].
	ActiveWorld resetWorldForNetMorph.
	
	! !

!NmUtil class methodsFor: 'system' stamp: 'mu 7/9/2005 17:52'!
resetSystem
	"NmUtil resetSystem"
	Morph resetWarpProtect.
	
	ActiveWorld resetWorldForNetMorph.
	NmImageId startUp.
	NmInitializer startUp
	! !

Object subclass: #NmCatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-Services'!

!NmCatcher methodsFor: 'actions' stamp: 'mu 7/29/2005 01:38'!
catchAndGo: morphByteArray
	Project savingWorldDo: [
	| read newMorph |
	read _ RWBinaryOrTextStream with: (NmUtil gunzippedFrom: morphByteArray) asString.
	Cursor read
		showWhile: [newMorph := Morph readFrom: read].
	newMorph resetIdentifierIfDuplicated: newMorph identifier.
	self relocate: newMorph.
	newMorph restoreAfterWarp.
	^ nil]! !

!NmCatcher methodsFor: 'actions' stamp: 'mu 7/29/2005 01:38'!
catchAndGo: morphByteArray x: x y: y 
	Project savingWorldDo: [
	| read newMorph |
	read _ RWBinaryOrTextStream with: (NmUtil gunzippedFrom: morphByteArray) asString.
	Cursor read
		showWhile: [newMorph _ Morph readFrom: read].
	newMorph resetIdentifierIfDuplicated: newMorph identifier.
	self relocate: newMorph x: x y: y.
	newMorph restoreAfterWarp.
	^ nil]! !

!NmCatcher methodsFor: 'actions' stamp: 'kuri-t 1/23/2003 17:30'!
relocate: morph 
	| newX newY validRect newRect morphRect |
	morphRect _ morph bounds.
	validRect _ self validRectangleFor: morph.
	newRect _ morphRect translatedToBeWithin: validRect.
	newX _ newRect left.
	newY _ newRect top.
	morph warpDirection == #leftWarp
		ifTrue: [newX _ validRect right - morphRect width].
	morph warpDirection == #rightWarp
		ifTrue: [newX _ validRect left].
	morph warpDirection == #bottomWarp
		ifTrue: [newY _ validRect top].
	morph warpDirection == #topWarp
		ifTrue: [newY _ validRect bottom - morphRect height].
	morph position: newX @ newY.
! !

!NmCatcher methodsFor: 'actions' stamp: 'kuri-t 1/24/2003 12:10'!
relocate: morph x: x y: y 
	morph position: x @ y! !

!NmCatcher methodsFor: 'private' stamp: 'kuri-t 1/23/2003 15:28'!
validBottomBoundFor: morph 
	| height adjustmentHeight |
	height _ morph bounds height.
	adjustmentHeight _ morph warpType == #ifOutOfWorldBounds
				ifTrue: [height]
				ifFalse: [morph warpType == #ifCrossingWorldBounds
						ifTrue: [height // 2]
						ifFalse: [morph warpType == #ifTouchedWorldBounds
								ifTrue: [0]]].
	^ ActiveWorld bounds bottom + adjustmentHeight! !

!NmCatcher methodsFor: 'private' stamp: 'kuri-t 1/23/2003 15:27'!
validLeftBoundFor: morph 
	| width adjustmentWidth |
	width _ morph bounds width.
	adjustmentWidth _ morph warpType == #ifOutOfWorldBounds
				ifTrue: [width negated]
				ifFalse: [morph warpType == #ifCrossingWorldBounds
						ifTrue: [(width // 2) negated]
						ifFalse: [morph warpType == #ifTouchedWorldBounds
								ifTrue: [0]]].
	^ ActiveWorld bounds left + adjustmentWidth! !

!NmCatcher methodsFor: 'private' stamp: 'kuri-t 1/23/2003 14:43'!
validRectangleFor: morph 
	^ (self validLeftBoundFor: morph)
		@ (self validTopBoundFor: morph) corner: (self validRightBoundFor: morph)
			@ (self validBottomBoundFor: morph)! !

!NmCatcher methodsFor: 'private' stamp: 'kuri-t 1/23/2003 15:28'!
validRightBoundFor: morph 
	| width adjustmentWidth |
	width _ morph bounds width.
	adjustmentWidth _ morph warpType == #ifOutOfWorldBounds
				ifTrue: [width]
				ifFalse: [morph warpType == #ifCrossingWorldBounds
						ifTrue: [width // 2]
						ifFalse: [morph warpType == #ifTouchedWorldBounds
								ifTrue: [0]]].
	^ ActiveWorld bounds right + adjustmentWidth! !

!NmCatcher methodsFor: 'private' stamp: 'kuri-t 1/23/2003 15:45'!
validTopBoundFor: morph 
	| height adjustmentHeight |
	height _ morph bounds height.
	adjustmentHeight _ morph warpType == #ifOutOfWorldBounds
				ifTrue: [height negated]
				ifFalse: [morph warpType == #ifCrossingWorldBounds
						ifTrue: [(height // 2) negated]
						ifFalse: [morph warpType == #ifTouchedWorldBounds
								ifTrue: [0]]].
	^ ActiveWorld bounds top + adjustmentHeight! !

Object subclass: #NmCostumeState
	instanceVariableNames: 'imageForm rotationCenter rotationStyle referencePosition forwardDirection shouldRememberCostumes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-eToys'!

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 14:59'!
forwardDirection
	^ forwardDirection! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 15:09'!
forwardDirection: aNumber
	forwardDirection _ aNumber! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 15:12'!
imageForm
	^ imageForm! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 15:13'!
imageForm: aForm
	imageForm _ aForm! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 14:58'!
referencePosition
	^ referencePosition! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 14:59'!
referencePosition: aPosition
	referencePosition _ aPosition! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 14:57'!
rotationCenter
	^ rotationCenter! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 14:57'!
rotationCenter: aPointOrNil
	rotationCenter _ aPointOrNil! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 14:57'!
rotationStyle
	^ rotationStyle! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 14:58'!
rotationStyle: aSymbol
	rotationStyle _ aSymbol! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 15:09'!
shouldRememberCostumes
	^ shouldRememberCostumes! !

!NmCostumeState methodsFor: 'accessing' stamp: 'kuri-t 12/17/2002 15:10'!
shouldRememberCostumes: aBoolean
	shouldRememberCostumes _ aBoolean! !

Object subclass: #NmDispatcher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-Services'!

!NmDispatcher methodsFor: 'actions' stamp: 'mu 10/8/2002 17:10'!
dispatch: uuidString to: target selector: selector
	"Performance tuning for no argument selector"
	^self dispatch: uuidString to: target selector: selector withArguments: #()! !

!NmDispatcher methodsFor: 'actions' stamp: 'mu 8/2/2005 07:18'!
dispatch: uuidString to: target selector: selector withArguments: arguments 
	| morph returnObject |
	morph := NmFinder
				findMorphBy: uuidString
				ifNone: [NmNoSuchMorph signalWithUuidString: uuidString].
	returnObject := [(self performer: target for: morph)
				perform: selector asSymbol
				withArguments: arguments]
				on: MessageNotUnderstood
				do: [:ex | NmDispatchFailed new target: uuidString;
						 selector: selector;
						 arguments: arguments asString;
						 signal].
	^ returnObject shouldPassAsProxy
		ifTrue: [returnObject asProxy]
		ifFalse: [returnObject]! !

!NmDispatcher methodsFor: 'actions' stamp: 'mu 9/25/2002 10:38'!
performer: targetString for: morph 
	targetString = #player
		ifTrue: [^ morph player].
	^ morph! !

Object subclass: #NmFinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-Services'!

!NmFinder class methodsFor: 'utility' stamp: 'mu 12/11/2003 03:01'!
findMorphBy: uuidString ifNone: noneBlock
	| uuid morph |
	uuid _ UUID fromString: uuidString.
	morph _ (ActiveWorld allMorphs
				reject: [:each | each isRenderer])
				detect: [:each | each identifier = uuid]
				ifNone: noneBlock.
	^morph! !

!NmFinder methodsFor: 'actions' stamp: 'mu 12/11/2003 02:34'!
findBy: uuidString 

	| morph | 
	morph _ self class findMorphBy: uuidString ifNone: [].
	^ (morph isNil or: [morph isWarping]) ifTrue: [nil]
		ifFalse: [morph asProxy]! !

!NmFinder methodsFor: 'actions' stamp: 'mu 8/4/2005 08:56'!
redirectIpAndPortOf: uuidString 
	| redirectMapEntryId entry |
	redirectMapEntryId := ActiveWorld morphIdentifierWarpedList
				at: uuidString
				ifAbsent: [].
	redirectMapEntryId
		ifNil: [^ nil].
	 entry _ NmWorldMap default
		at: redirectMapEntryId
		ifAbsent: [ActiveWorld morphIdentifierWarpedList
				removeKey: uuidString
				ifAbsent: [].
			^nil].
	^entry ipAndPort! !

Object subclass: #NmFlapSetup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmFlapSetup commentStamp: '<historical>' prior: 0!
To add aMorph to NetMorph Flap;

1)	make a morph.
2)	add the definition to NmFlapSetup class>>quadsDefiningNetMorphFlap.
3)	do "NmFlapSetup reInstall.".

Browser newOnClass: NmFlapSetup class selector: #quadsDefiningNetMorphFlap!

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'mu 6/19/2005 08:40'!
addFlap
	"NmFlapSetup addFlap."
	| aFlapTab |
	self netMorphFlapTab notNil ifTrue: [^ nil].
	aFlapTab _ self newNetMorphFlapTab.
	aFlapTab setBalloonText: self balloonTextForFlaps.
	Flaps addGlobalFlap: aFlapTab.
	ActiveWorld addGlobalFlaps.
	aFlapTab
		changeTabText: (Vocabulary eToyVocabulary translatedWordingFor: self tabName asSymbol).
	^ aFlapTab! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 7/25/2005 01:18'!
addPanelsTo: aPartsBin
	NmServerManager isMapServerOnlyImage ifTrue: [^self].
	aPartsBin addMorphFront: NmControlPanelMorph new.! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 9/13/2002 15:11'!
balloonTextForFlaps
	^ 'NetMorph tools!!' copy! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'ns 2/14/2003 13:38'!
destroyFlap
	"NmFlapSetup destroyFlap."
	"PartsBin initialize."
	(ActiveWorld flapTabs
		select: [:each | each flapID = self tabName])
		do: [:each | each destroyFlap]! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 9/13/2002 15:12'!
flapColor
	^ Color
		r: 0.516
		g: 0.452
		b: 1.0! !

!NmFlapSetup class methodsFor: 'accessing' stamp: 'mu 6/19/2005 00:48'!
netMorphFlapTab
	^ ActiveWorld submorphs
		detect: [:each | (each isKindOf: FlapTab)
				and: [each flapID = self tabName]]
		ifNone: []! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 6/19/2005 08:41'!
newNetMorphFlapTab
	| aFlapTab aStrip |
	aStrip _ PartsBin newPartsBinWithOrientation: #leftToRight from: self quadsDefiningNetMorphFlap.
	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab
		setName: self tabName
		edge: #bottom
		color: self flapColor.
	aStrip extent: self currentWorld width @ 78.
	aFlapTab position: 104 @ (self currentWorld height - aFlapTab height).
	aStrip beFlap: true.
	aStrip color: self stripColor.
	aStrip autoLineLayout: true.
	self addPanelsTo: aStrip.
	^ aFlapTab! !

!NmFlapSetup class methodsFor: 'predefined flaps' stamp: 'mu 5/29/2005 03:19'!
quadsDefiningNetMorphFlap
	^ NmServerManager isWarpServerInstalled
		ifTrue: [NmServerManager isMapServerInstalled
				ifTrue: [self quadsDefiningNetMorphFlapForClientServer]
				ifFalse: [self quadsDefiningNetMorphFlapForClient]]
		ifFalse: [self quadsDefiningNetMorphFlapForServer]! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 7/29/2005 23:59'!
quadsDefiningNetMorphFlapForClient
	"Answer a fully-instantiated flap named 'NetMorph' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"
		"class					makeThumbnail		nameInFlap		ballonText"
	^ #(
		(NmWorldMapMorph		createWindow			'WorldMap'		'organize a world map')
		(NmMarkerDockMorph		createWindow			'Footprints'		'see morph footprints')
		(NmSettingsMorph		createWindow			'Setting'			'NetMorph settings')
	)! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 2/19/2003 14:38'!
quadsDefiningNetMorphFlapForClientServer
	^self quadsDefiningNetMorphFlapForClient, self quadsDefiningNetMorphFlapForServer
! !

!NmFlapSetup class methodsFor: 'private' stamp: 'kuri-t 2/20/2003 12:17'!
quadsDefiningNetMorphFlapForServer
	"Answer a fully-instantiated flap named 'NetMorph' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"
		"class					makeThumbnail		nameInFlap		ballonText"
	^ #(
		(NmServerSettingsMorph		createWindow			'Server Setting'			'NetMorph Server settings')
	)! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'kuri-t 2/20/2003 12:26'!
reInstall
	"NmFlapSetup reInstall."
	NmFlapSetup destroyFlap.
	PartsBin initialize.
	NmFlapSetup addFlap! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'mu 6/18/2005 23:04'!
stripColor
	^self flapColor alpha: 0.3! !

!NmFlapSetup class methodsFor: 'private' stamp: 'ns 2/14/2003 13:23'!
tabName
	^ self tabSymbol! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 2/14/2003 13:22'!
tabSymbol
	^ #NetMorph! !

Object subclass: #NmImageId
	instanceVariableNames: ''
	classVariableNames: 'LastImageName LastIp LastIdString'
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

NmImageId class
	instanceVariableNames: 'current'!

!NmImageId class methodsFor: 'accessing' stamp: 'mu 8/15/2005 11:31'!
current
	^ current! !

!NmImageId class methodsFor: 'private' stamp: 'mu 5/13/2005 00:51'!
hasEnvironmentChanged
	"NmImageId hasEnvironmentChanged"
	self lastIp ~= NmBaseUtil localAddress ifTrue: [^true].
	self lastImageName ~= SmalltalkImage current imageName ifTrue: [^true].
	^false
	! !

!NmImageId class methodsFor: 'class initialization' stamp: 'mu 1/15/2005 01:45'!
initCurrent
	self initCurrent: UUID new.
	! !

!NmImageId class methodsFor: 'class initialization' stamp: 'mu 8/16/2005 11:37'!
initCurrentLeaving
	| newCurrent |
	newCurrent _ UUID new.
	[self leaveIfFailedRemove: current] on: NmSoapCallFailedWarning do: [:ex | current _ newCurrent.  ex resume ].
	self initCurrent: newCurrent.
	! !

!NmImageId class methodsFor: 'class initialization' stamp: 'mu 5/14/2005 00:43'!
initCurrent: uuid 
	| oldCurrent |
	oldCurrent _ current.
	current _ uuid.
	oldCurrent = current
		ifFalse: [self changed: #imageIdNew with: current asString]! !

!NmImageId class methodsFor: 'class initialization' stamp: 'mu 8/15/2005 11:24'!
initialize
	"NmImageId initialize"
	LastIdString _ LastIp _ LastImageName _ nil.
	self nullify.
	self rememberEnvironment.
	self initCurrent.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.
	! !

!NmImageId class methodsFor: 'private' stamp: 'mu 6/18/2005 00:32'!
lastIdString
	LastIdString
		ifNil: [LastIdString _ UUID new asString].
	^ LastIdString! !

!NmImageId class methodsFor: 'private' stamp: 'mu 5/13/2005 00:40'!
lastImageName
	LastImageName
		ifNil: [LastImageName _ SmalltalkImage current imageName].
	^ LastImageName! !

!NmImageId class methodsFor: 'private' stamp: 'mu 5/13/2005 00:25'!
lastIp
	LastIp
		ifNil: [LastIp _ NmBaseUtil localAddress].
	^ LastIp! !

!NmImageId class methodsFor: 'actions' stamp: 'mu 8/16/2005 07:47'!
leave
	"self leave"
	self changed: #imageIdLeave with: current asString.
! !

!NmImageId class methodsFor: 'actions' stamp: 'mu 8/16/2005 09:05'!
leaveIfFailedRemove: uuid
	"self leave"
	self changed: #imageIdLeaveIfFailedRemove with: current asString.	
	! !

!NmImageId class methodsFor: 'actions' stamp: 'mu 8/15/2005 11:40'!
nullify
	"self nullify"
	self changed: #imageIdNull with: current asString.
	current _ nil
! !

!NmImageId class methodsFor: 'class initialization' stamp: 'mu 8/15/2005 11:24'!
obsolete
	"NmImageId initialize"
	self nullify.
	Smalltalk removeFromStartUpList: self.
	Smalltalk removeFromShutDownList: self.
	! !

!NmImageId class methodsFor: 'private' stamp: 'mu 5/14/2005 00:37'!
rememberEnvironment
	current
		ifNotNilDo: [:uid | LastIdString _ uid asString].
	LastIp _ NmBaseUtil localAddress.
	LastImageName _ SmalltalkImage current imageName! !

!NmImageId class methodsFor: 'actions' stamp: 'mu 8/16/2005 09:00'!
resetTo: uuid 
	| newCurrent |
	newCurrent _ (uuid isMemberOf: UUID)
				ifTrue: [uuid]
				ifFalse: [[UUID fromString: uuid asString]
						on: Error
						do: [:ex | ex return: nil]].
	newCurrent isNil
		ifTrue: [^ self].
	self leave.
	self initCurrent: newCurrent.
	! !

!NmImageId class methodsFor: 'system startup' stamp: 'mu 8/15/2005 11:21'!
shutDown: quitting
	quitting ifTrue: [self leave]! !

!NmImageId class methodsFor: 'system startup' stamp: 'mu 8/16/2005 09:15'!
startUp: resuming 
	self hasEnvironmentChanged
		ifTrue: [resuming
				ifTrue: [self initCurrent]
				ifFalse: [self initCurrentLeaving]]
		ifFalse: [current _ UUID fromString: self lastIdString].
	self rememberEnvironment! !

Object subclass: #NmObjectReference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

NmObjectReference subclass: #NmMorphReference
	instanceVariableNames: 'className uuid ip port'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

!NmMorphReference class methodsFor: 'instance creation' stamp: 'mu 12/29/2004 23:57'!
className: classNameSymbol uuid: uuidObject ipAndPortArray: ipAndPortArray 
	^ self
		className: classNameSymbol
		uuid: uuidObject
		ip: ipAndPortArray first asString
		port: ipAndPortArray second asNumber! !

!NmMorphReference class methodsFor: 'instance creation' stamp: 'KY 12/20/2003 01:51'!
className: classNameSymbol uuid: uuidObject ip: ipString port: portNumber
	| morphReference |
	morphReference _ self new.
	morphReference className: classNameSymbol.
	morphReference uuid: uuidObject.
	morphReference ip: ipString.
	morphReference port: portNumber.
	^ morphReference.! !

!NmMorphReference class methodsFor: 'instance creation' stamp: 'mu 12/30/2004 00:00'!
on: aMorph 
	^ self
		className: aMorph class name
		uuid: aMorph identifier
		ipAndPortArray: NmWorldMap default localIpAndPortArray! !

!NmMorphReference methodsFor: 'converting' stamp: 'mu 12/30/2004 00:00'!
asProxy
	^ NmMorphProxy
		className: className
		uuid: uuid
		ipAndPortArray: {ip. port}! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/22/2002 14:28'!
className
	^className! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/12/2002 15:35'!
className: aString
	className _ aString.! !

!NmMorphReference methodsFor: 'accessing' stamp: 'KY 12/20/2003 01:50'!
ip
	^ip! !

!NmMorphReference methodsFor: 'accessing' stamp: 'KY 12/20/2003 01:50'!
ip: ipAddressString
	ip _ ipAddressString! !

!NmMorphReference methodsFor: 'accessing' stamp: 'KY 12/20/2003 01:50'!
port
	^port! !

!NmMorphReference methodsFor: 'accessing' stamp: 'KY 12/20/2003 01:50'!
port: portNumber
	port _ portNumber! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/22/2002 14:28'!
uuid
	^uuid! !

!NmMorphReference methodsFor: 'accessing' stamp: 'kuri-t 11/12/2002 15:34'!
uuid: anUUID
	uuid _ anUUID.! !

NmObjectReference subclass: #NmPlayerReference
	instanceVariableNames: 'costume'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

!NmPlayerReference class methodsFor: 'instance creation' stamp: 'kuri-t 11/21/2002 14:34'!
costume: aMorph
	| playerReference |
	playerReference _ self new.
	playerReference costume: (aMorph asObjectReference).
	^ playerReference.! !

!NmPlayerReference class methodsFor: 'instance creation' stamp: 'kuri-t 11/21/2002 14:35'!
on: aPlayer
	^self costume: aPlayer costume! !

!NmPlayerReference methodsFor: 'converting' stamp: 'kuri-t 11/12/2002 15:56'!
asProxy
	^ NmPlayerProxy for: costume asProxy.! !

!NmPlayerReference methodsFor: 'accessing' stamp: 'kuri-t 11/22/2002 14:29'!
costume
	^costume! !

!NmPlayerReference methodsFor: 'accessing' stamp: 'kuri-t 11/12/2002 15:52'!
costume: aMorph
	costume _ aMorph.! !

Object subclass: #NmPointAllocator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

NmPointAllocator class
	instanceVariableNames: 'default'!

!NmPointAllocator class methodsFor: 'instance creation' stamp: 'mu 7/20/2005 01:51'!
default
	default ifNil: [default _ self new].
	^default! !

!NmPointAllocator class methodsFor: 'class initialization' stamp: 'mu 7/20/2005 18:34'!
initialize
	default _ nil.
	! !

!NmPointAllocator methodsFor: 'actions' stamp: 'mu 8/15/2005 12:53'!
emptyPointConsidering: existingPoints 
	| recomPoint randomPoint point |
	NmServerSettings allocateByRandom ifTrue: [^self randomPointConsidering: existingPoints].
	recomPoint _ self recommendedPointAt: existingPoints size.
	point _  (existingPoints includes: recomPoint)
		ifTrue: [randomPoint _ self randomPointConsidering: existingPoints]
		ifFalse: [recomPoint].
	NmBaseSettings isDebugging ifTrue: [{existingPoints. recomPoint. randomPoint} inspect].
	^point! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:27'!
level1Matrix
	^NmServerSettings level1Matrix! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:28'!
level1Matrix: aPoint
	NmServerSettings level1Matrix: aPoint! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:18'!
level1Point: index 
	^self levelNPoint: index maxX: self level1Matrix x maxY: self level1Matrix y! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:27'!
level2Matrix
	^NmServerSettings level2Matrix! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:28'!
level2Matrix: aPoint
	NmServerSettings level2Matrix: aPoint! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:19'!
level2Point: index 
	^self levelNPoint: index maxX: self level2Matrix x maxY: self level2Matrix y! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:27'!
level3Matrix
	^NmServerSettings level3Matrix! !

!NmPointAllocator methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:28'!
level3Matrix: aPoint
	NmServerSettings level3Matrix: aPoint! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:19'!
level3Point: index 
	^self levelNPoint: index maxX: self level3Matrix x maxY: self level3Matrix y! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:14'!
levelNPoint: index maxX: maxX maxY: maxY 
	| x y |
	(index between: 0 and: maxX * maxY - 1)
		ifFalse: [^ self
				levelNPoint: index - (maxX * maxY)
				maxX: maxX
				maxY: maxY].
	x _ index \\ maxX.
	y _ (index / maxX) floor.
	^ x @ y! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 7/20/2005 01:47'!
randomPointConsidering: existingPoints
	"NmWorldMap default emptyPointConsidering: {0@1. 0@0}"
	"NmWorldMap default emptyPointConsidering: {1@1. 0@0. 1@3. 2@3}"
	| maxPoint minPoint xSize ySize points |
	maxPoint _ existingPoints
				inject: 0 @ 0
				into: [:sum :eachPoint | sum max: eachPoint].
	minPoint _ existingPoints
				inject: maxPoint
				into: [:sum :eachPoint | sum min: eachPoint].
	xSize _ maxPoint x - minPoint x + 1.
	ySize _ maxPoint y - minPoint y + 1.
	points _ OrderedCollection new: xSize * ySize.
	minPoint x
		to: maxPoint x
		do: [:x | minPoint y
				to: maxPoint y
				do: [:y | points
						add: (Point x: x y: y)]].
	points removeAllFoundIn: existingPoints.
	points isEmpty
		ifTrue: [| candidate | 
			existingPoints
				detect: [:each | (candidate _ each fourNeighbors
								detect: [:ep | (existingPoints includes: ep) not]
								ifNone: []) notNil]
				ifNone: [].
			^ candidate].
	^ (points asSortedCollection: [:a :b | a y < b y]) first! !

!NmPointAllocator methodsFor: 'private' stamp: 'mu 8/9/2005 10:14'!
recommendedPointAt: index 
	| largeIndex largePoint middleIndex middlePoint delta deltaPoint point |
	largeIndex := (index / (self level3Matrix x * self level3Matrix y * self level2Matrix x * self level2Matrix y)) floor.
	largePoint := self level3Point: largeIndex.
	middleIndex := (index / (self level1Matrix x * self level1Matrix y)) floor.
	middlePoint := self level2Point: middleIndex.
	delta := index \\ (self level1Matrix x * self level1Matrix y).
	deltaPoint := self level1Point: delta.
	point _ largePoint * (self level3Matrix * self level2Matrix) + (middlePoint * self level1Matrix) + deltaPoint.
	^point * (1@-1)! !

Object subclass: #NmPoofs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-eToys'!

NmPoofs class
	instanceVariableNames: 'poofs'!

!NmPoofs commentStamp: '<historical>' prior: 0!
Original 'NmPoofs' was written by Masato Sumi <sumi@mac.com>. Arigato, Sumi-san!!
-- Kazuhiro ABE <abee.abe@nifty.ne.jp>!

!NmPoofs class methodsFor: 'constants' stamp: 'ka 9/4/2002 22:09'!
defaultExtent
	^ 100 @ 100! !

!NmPoofs class methodsFor: 'constants' stamp: 'ka 9/4/2002 21:00'!
defaultWait
	^ 100! !

!NmPoofs class methodsFor: 'examples' stamp: ''!
example1
	"NmPoofs example1"
	NmPoofs showAt: 100 @ 100! !

!NmPoofs class methodsFor: 'examples' stamp: 'ka 9/4/2002 21:37'!
example2
	"NmPoofs example2"
	NmPoofs
		showInBounds: (100 @ 100 extent: 200 @ 200)! !

!NmPoofs class methodsFor: 'class initialization' stamp: 'mu 7/8/2005 00:59'!
initialize
	"NmPoofs initialize"
	poofs _ OrderedCollection new.
	1
		to: 5
		do: [:index | 
			| base64Str bytes form | 
			base64Str _ self perform: ('poofString' , index asString) asSymbol.
			bytes _ (Base64MimeConverter mimeDecodeToBytes: base64Str readStream) contents uncompressOnDemand.
			form _ ImageReadWriter formFromStream: bytes readStream.
			poofs
				add: (SketchMorph withForm: form)]! !

!NmPoofs class methodsFor: 'constants' stamp: 'mu 7/8/2005 00:50'!
poofString1
	"str _ FileStream readOnlyFileNamed: 'Image1.gif'.
	str binary.
	encoded _ Base64MimeConverter mimeEncode: (str contents compressIfMoreThan: 1000) readStream.
	poofString1 _ encoded contents storeString.
	str close."
	^'H4sIAAAAAAAAAOXT+z8TjMPGcedzcj6EnM/kmEPIIWdNmmHOw5aNzaE5R05jjnMYW4kYhlF3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' copy! !

!NmPoofs class methodsFor: 'constants' stamp: 'mu 7/8/2005 00:51'!
poofString2
	 ^'H4sIAAAAAAAAAOXT+zsTjOPG8c0p5xznXE7DHBI5kzOzOZ/PpwxzzHmOIXKuHMaInI3RcppJ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' copy! !

!NmPoofs class methodsFor: 'constants' stamp: 'mu 7/8/2005 00:52'!
poofString3
	 ^'H4sIAAAAAAAAAOXT+z8TigPG8bnm1inXCo1hWqwkikSGuZty2WguHWPGYpj7tancu2yMXDa3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' copy! !

!NmPoofs class methodsFor: 'constants' stamp: 'mu 7/8/2005 00:53'!
poofString4
	 ^ 'H4sIAAAAAAAAAOXT+zsTigPH8U1bVl/KJXPNde65HBxhaC1kLtUwc5lcYrOVS64Nx5FLbBgz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' copy! !

!NmPoofs class methodsFor: 'constants' stamp: 'mu 7/8/2005 00:53'!
poofString5
	 ^  'H4sIAAAAAAAAAHP3dLOwTIxiSGV4zgAC1dX/W1r+9/T8nzLl/5w5/5cu/b927f+tW//v3fv/
2LH/5879v3btP8PIByMfDEeg+JOFE0TrgAhQnmDg+MfAyCHjsWHBwWYOYSGXAwKNh9oFlL3m
zNjwsJGZTzPrzglDJWdmCeMyGc9Jyk3dnGIdOic3pbqycoXsmuO5OeHwLIviVyE3Cp6emy8k
qCGwapLihcX8/lIJFRfVLy1nEpRQcFhwIGh5wMR5MgoJBy6tSVispWHQ4MC0JrHxm8vsbWtv
by94fGqu9/Z1d3eXVT862tlwsGlGTum6Wq0vKQ/X1ErymK765tC4SpH58pvVmxiS5003V6rw
OdCQ3hMlqVE256dCE2u6qrLN2x+vri7uFLXYpiPp2MQ0zfR36ASGZyc3Z/2dt3SXSMVR5tRQ
aZuzt795XsgKrFa7N2V5I+NOU63anK9f/Z+tLfzX3LLvVwPjYxHz4qN8RS++P5vvaMW/Jvzz
G+aVUyeHvKr8k/lXeS1rgqfPz+u3G6rXqiVkcpq9eNAs4Cbx0FdISEOqSfTWl+k+klnfxFtl
2VJvR35qlZiS83cr+6JOs5tlDKE7RBvimUySdkwPCBY0cIgMi70ypTf/qrmAMzOLwoGJoV/b
5Zt5521jaHdWczgw0aNr+6MWfydLFSardxFTexyOmUZ0iyVOmeUdfso0zbuzNVIxNWpTx82A
H6Kq6v71ezvmBqTf2xnDpC/3cmqlz71KoUi3pHbpyjq+TIZIm6L2uMWBP0/cr8xT25EwK3Ot
Z2ZIdmfZw+XOv6Y+XVn4i/P5ZJNLHDNm/JtTNUN17rNWkSXF8YI/wn2cK8WS183NE0texmDw
9E7OfiFphelhorPisv8e1Xi8JMHwSrLXzEcaayvYd4in9G8TilgwdWWb6tRJp8R2N1R6T83W
273lrMqDmNaVHquaNt5bnd8xr+qJTpxf2kp5Z/9l3hI+TNVfVPLfMd0R3rr6Y5rckVl2XnOK
rgUdXdEcVKjKwCgRf110A/+8JcqM0torkhlF7r+4k/SPSzNx3+9rOZ/P5v/zzkr8KVkTHs+p
o7rxnM4/deX8eT993nfob7oz51KW227lZaaPLUTDNZx9xbNj02o/L7PI1tp8tkbOY/NCR/uw
sFPzb4UxTGWasGb9yQmGC75e+1wkIsBgDQAMpyZAHwYAAA==' copy! !

!NmPoofs class methodsFor: 'displaying' stamp: 'ka 9/4/2002 22:10'!
showAt: aPoint 
	"NmPoofs showAt: 100@100"
	| bounds |
	bounds _ 0 @ 0 extent: self defaultExtent.
	bounds _ bounds align: bounds center with: aPoint.
	self showInBounds: bounds! !

!NmPoofs class methodsFor: 'displaying' stamp: 'ka 9/4/2002 22:01'!
showInBounds: bounds 
	"NmPoofs showInBounds: (100@100 extent: 200@200)"
	[poofs
		do: [:poof | 
			poof topLeft: bounds topLeft;
				 extent: bounds extent;
				 openInWorld;
				 refreshWorld.
			(Delay forMilliseconds: self defaultWait) wait.
			poof delete]] fork! !

Object subclass: #NmProcessManager
	instanceVariableNames: ''
	classVariableNames: 'CriticalSemaphore IsForking'
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

NmProcessManager class
	instanceVariableNames: 'processDict'!

!NmProcessManager class methodsFor: 'actions' stamp: 'mu 12/26/2002 20:53'!
critical: mutuallyExcludedBlock ifError: errorBlock
	^self critical: mutuallyExcludedBlock ifError: errorBlock on: CriticalSemaphore ! !

!NmProcessManager class methodsFor: 'private' stamp: 'mu 12/27/2002 18:46'!
critical: mutuallyExcludedBlock ifError: errorBlock on: semaphore 
	| blockValue error | 
	semaphore wait.
	error _ false.
	blockValue _ nil.
	blockValue _ [mutuallyExcludedBlock value]
				on: Error
				do: [:ex | 
					error _ true.
					semaphore signal.
					errorBlock value: ex].
	error
		ifFalse: [semaphore signal].
	^ blockValue! !

!NmProcessManager class methodsFor: 'actions' stamp: 'mu 5/13/2003 17:35'!
fork: block for: scriptInstantiation ifError: errorHandlerBlock
	| semaphore |
	semaphore _ processDict
				at: scriptInstantiation player costume identifier asString , scriptInstantiation selector
				ifAbsentPut: [Semaphore forMutualExclusion].
	semaphore size > 10
		ifTrue: [5
				timesRepeat: [semaphore terminateProcess].
			NmTranscript crShow: '		Trim the too many waiting processes'].
	[self critical: block ifError: errorHandlerBlock on: semaphore]
		forkAt: Processor userSchedulingPriority - 1! !

!NmProcessManager class methodsFor: 'class initialization' stamp: 'kuri-t 1/9/2003 14:39'!
initialize
	"NmProcessManager initialize"
	IsForking _ true.
	processDict _ Dictionary new.
	CriticalSemaphore _ Semaphore forMutualExclusion.
	
! !

!NmProcessManager class methodsFor: 'testing' stamp: 'kuri-t 1/9/2003 14:38'!
isForking
	"NmProcessManager isForking"
	^ IsForking! !

!NmProcessManager class methodsFor: 'testing' stamp: 'kuri-t 1/9/2003 14:38'!
isForking: boolean
	"NmProcessManager isForking: true"
	"NmProcessManager isForking: false"
	IsForking _ boolean! !

!NmProcessManager class methodsFor: 'actions' stamp: 'mu 5/13/2003 17:36'!
process: aBlock for: aScriptInstantiation ifError: errorHandlerBlock
	IsForking
		ifTrue: [self fork: aBlock for: aScriptInstantiation ifError: errorHandlerBlock]
		ifFalse: [aBlock ifError: errorHandlerBlock]! !

!NmProcessManager class methodsFor: 'actions' stamp: 'mu 4/28/2005 17:49'!
releaseAllLockedProcesses
	"NmProcessManager releaseAllLockedProcesses"
	CriticalSemaphore isSignaled
		ifFalse: [NmTranscript crShow: '		', #'NetMorph: releaseAllLockedProcesses'.
			[CriticalSemaphore isEmpty]
				whileFalse: [CriticalSemaphore terminateProcess].
			CriticalSemaphore initSignals.
			CriticalSemaphore signal]! !

!NmProcessManager class methodsFor: 'actions' stamp: 'kuri-t 1/8/2003 18:06'!
terminateAll
	processDict
		valuesDo: [:semaphore | semaphore
				ifNotNil: [semaphore isSignaled
						ifFalse: [semaphore signal].
					[semaphore isEmpty]
						whileFalse: [semaphore terminateProcess].
					semaphore initSignals.
					semaphore signal]].
	processDict _ Dictionary new! !

!NmProcessManager class methodsFor: 'actions' stamp: 'kuri-t 2/14/2003 16:35'!
terminateAllOf: identifier 
	| removingsKeys semaphore |
	removingsKeys _ processDict keys
				select: [:each | each beginsWith: identifier asString].
	removingsKeys
		do: [:eachKey | 
			semaphore _ processDict
						at: eachKey
						ifAbsent: [].
			semaphore
				ifNotNil: [[semaphore isEmpty]
						whileFalse: [semaphore terminateProcess].
					semaphore initSignals.
					semaphore signal]].
	removingsKeys
		do: [:eachKey | processDict removeKey: eachKey]! !

Object subclass: #NmProjectLoader
	instanceVariableNames: 'worldMapEntry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectLoader class methodsFor: 'instance creation' stamp: 'mu 7/6/2005 21:24'!
on: aNmWorldMapEntry
	"NmProjectLoader on: NmWorldMap localEntry"
	^self new worldMapEntry: aNmWorldMapEntry! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/7/2005 01:11'!
connector
	| ent |
	ent _ self worldMapEntry.
	^ [NmRemoteConnector connect: ent ip port: ent port asInteger]
		on: RmtNetworkError
		do: [:ex | 
			NmShortMessageMorph contents: ex messageText at: ActiveWorld center.
			ex return: nil]! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/26/2005 01:35'!
connectorDo: aBlock 
	^ self connectorDo: aBlock ifErrorReturn: nil! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/26/2005 01:58'!
connectorDo: aBlock ifErrorReturn: returnObj 
	| con |
	con _ self connector.
	con isNil
		ifTrue: [^ returnObj].
	^ [aBlock value: con]
		on: RmtNetworkError
		do: [:ex | 
			NmShortMessageMorph contents: ex messageText at: ActiveWorld center.
			ex return: returnObj]! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 6/21/2005 01:09'!
detailedInfoTextFor: projectName 
	| details detailText |
	details _ self getProjectDetails: projectName.
	detailText _ String
				streamContents: [:str | details
						keysAndValuesDo: [:k :v | v notEmpty
								ifTrue: [str nextPutAll: (k copyFrom: 'project' size + 1 to: k size)
											, ':';
										 tab;
										 nextPutAll: v;
										 cr]]].
	^ detailText! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 7/14/2005 23:27'!
enterNewProject: projectName 
	| proj |
	proj _ self getAndTrimProject: projectName.
	proj enter! !

!NmProjectLoader methodsFor: 'private' stamp: 'mu 7/15/2005 00:12'!
getAndTrimProject: projectName 
	| proj |
	proj _ self getProject: projectName.
	proj renameTo: (self longNameFrom: projectName).
	self trimDuplicates: proj.
	^ proj! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/26/2005 01:37'!
getNumberOfProjectsMatches: matchString matchOptions: matchOptionString 
	^ self
		connectorDo: [:c | c callGetNumberOfProjectsMatches: matchString matchOptions: matchOptionString]
		ifErrorReturn: 0! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 6/21/2005 00:34'!
getProjectDetails: projectName 
	| data stream datails |
	data _ self getProjectInfo: projectName.
	stream _ RWBinaryOrTextStream with: data.
	datails _ NmBaseUtil loadDataFrom: stream .
	^datails! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/7/2005 01:14'!
getProjectInfo: projectName 
	^ [self
		connectorDo: [:c | c callGetProjectInfo: projectName]]
		on: FileDoesNotExistException
		do: [:ex | ex return: Dictionary new]! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/26/2005 01:35'!
getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString 
	^ [self
		connectorDo: [:c | c
				callGetProjectNamesFrom: start
				to: end
				matches: matchString
				matchOptions: matchOptionString
				sortOptions: sortOptionString] ifErrorReturn: #()]
		on: Error
		do: [:ex | ex messageText = 'key not found'
				ifTrue: [NmProjectSortFailed sortOptionString: sortOptionString]
				ifFalse: [ex pass]]! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 6/21/2005 00:20'!
getProjectThumbnailForm: projectName
	| data form |
	data _ self getProjectThumbnail: projectName.
	form _ ImageReadWriter formFromStream: (RWBinaryOrTextStream with: data).
	^form! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/7/2005 01:16'!
getProjectThumbnail: projectName 
	^ [self
		connectorDo: [:c | c callGetProjectThumbnail: projectName]]
		on: FileDoesNotExistException
		do: [:ex | ex
				return: (Form extent: Display extent // 8 depth: Display depth)]! !

!NmProjectLoader methodsFor: 'actions-basic' stamp: 'mu 7/7/2005 01:16'!
getProject: projectName 
	^ self
		connectorDo: [:c | c callGetProject: projectName]! !

!NmProjectLoader methodsFor: 'private' stamp: 'mu 7/15/2005 00:45'!
longNameFrom: aProjectShortName 
	self worldMapEntry
		ifNil: [^ aProjectShortName].
	^ aProjectShortName , '-' , self worldMapEntry destination! !

!NmProjectLoader methodsFor: 'actions' stamp: 'mu 7/14/2005 23:59'!
openProjectView: projectName 
	| proj projView |
	proj _ self getAndTrimProject: projectName.
	projView _ ActiveWorld allMorphs
				detect: [:each | (each isKindOf: ProjectViewMorph)
						and: [each project = proj]]
				ifNone: [ProjectViewMorph on: proj].
	projView extent: ActiveWorld extent // 4.
	^ projView! !

!NmProjectLoader methodsFor: 'private' stamp: 'mu 7/15/2005 00:14'!
trimDuplicates: proj
	| duplicates |
	duplicates _ Project allProjects
				select: [:each | each name = proj name
						and: [each lastSavedAtSeconds = proj lastSavedAtSeconds]].
	duplicates remove: proj ifAbsent:[].
	duplicates
		ifNotEmpty: [proj inheritAdjustmentFrom: duplicates first.
			Project removeAll: duplicates.
			duplicates
				do: [:p | ChangeSorter removeChangeSet: p changeSet]].
! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/6/2005 21:21'!
worldMapEntry
	^worldMapEntry! !

!NmProjectLoader methodsFor: 'accessing' stamp: 'mu 7/6/2005 21:21'!
worldMapEntry: aNmWorldMapEntry
	worldMapEntry _ aNmWorldMapEntry! !

Object subclass: #NmProjectServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-Services'!

!NmProjectServer methodsFor: 'actions' stamp: 'mu 7/23/2005 00:25'!
getNumberOfProjectsMatches: matchString matchOptions: matchOptionString 
	| matches |
	matches _ self listMatches: matchString with: matchOptionString.
	^ matches size! !

!NmProjectServer methodsFor: 'actions' stamp: 'mu 7/2/2005 23:10'!
getProjectDetails: projectName 
	| data stream datails |
	data _ self getProjectInfo: projectName.
	stream _ RWBinaryOrTextStream with: data.
	datails _ NmBaseUtil loadDataFrom: stream .
	^datails! !

!NmProjectServer methodsFor: 'actions' stamp: 'mu 6/20/2005 23:05'!
getProjectInfo: projectName
	| fullProjName infoName stream contents  |
	fullProjName _ self latestFullProjectNameOf: projectName.
	infoName _ (fullProjName copyFrom: 1 to: (fullProjName lastIndexOf: $.)), Project infoFileExtension.
	[stream _ self projectDirectory readOnlyFileNamed: infoName.
	stream binary.
	contents _ stream contents]
		ensure: [stream close].
	^ contents! !

!NmProjectServer methodsFor: 'actions' stamp: 'mu 7/3/2005 22:05'!
getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString
	| matches startIndex endIndex matchNames |
	matches _ self listMatches: matchString with: matchOptionString.
	startIndex _ start.
	endIndex _ end.
	startIndex < 0 ifTrue: [startIndex _ 1].
	endIndex > matches size ifTrue: [endIndex _ matches size].
	matchNames _  self sortMatched: matches with: sortOptionString.
	^ (matchNames copyFrom: startIndex to: endIndex) ! !

!NmProjectServer methodsFor: 'actions' stamp: 'mu 6/20/2005 23:04'!
getProjectThumbnail: projectName
	| fullProjName thumbnailName stream contents  |
	fullProjName _ self latestFullProjectNameOf: projectName.
	thumbnailName _ (fullProjName copyFrom: 1 to: (fullProjName lastIndexOf: $.)), Project thumbnailFileExtension.
	[stream _ self projectDirectory readOnlyFileNamed: thumbnailName.
	stream binary.
	contents _ stream contents]
		ensure: [stream close].
	^ contents! !

!NmProjectServer methodsFor: 'actions' stamp: 'mu 6/19/2005 09:52'!
getProject: projectName 
	| fullProjName stream contents |
	fullProjName _ self latestFullProjectNameOf: projectName.
	[stream _ self projectDirectory readOnlyFileNamed: fullProjName.
	stream binary.
	contents _ stream contents]
		ensure: [stream close].
	^ contents! !

!NmProjectServer methodsFor: 'private' stamp: 'mu 6/19/2005 09:44'!
latestFullProjectNameOf: shortName 
	| rawName nameVersionExtension name version extension |
	rawName _ self projectDirectory lastNameFor: shortName extension: Project projectExtension.
	nameVersionExtension _ self projectDirectory splitNameVersionExtensionFor: rawName.
	name _ nameVersionExtension first.
	version _ nameVersionExtension second printPaddedWith: $0 to: 3.
	extension _ nameVersionExtension last.
	^ String
		streamContents: [:str | str nextPutAll: name;
				 nextPut: $.;
				 nextPutAll: version;
				 nextPut: $.;
				 nextPutAll: extension]! !

!NmProjectServer methodsFor: 'private' stamp: 'mu 7/2/2005 23:40'!
listAllProjectDetails
	| allDetails names |
	names _ self listAllProjectNames.
	allDetails _ Dictionary new: names size.
	names
		do: [:nm | 
			| detailDic | 
			detailDic _ self getProjectDetails: nm.
			detailDic at: #projectfilename put: nm.
			allDetails at: nm put: detailDic].
	^ allDetails! !

!NmProjectServer methodsFor: 'private' stamp: 'mu 7/23/2005 00:21'!
listAllProjectNames
	^ (self projectDirectory fileNames
		collect: [:each | each upTo: $.]) asSet asSortedCollection remove: '' ifAbsent:[];
		 yourself! !

!NmProjectServer methodsFor: 'private' stamp: 'mu 7/2/2005 23:37'!
listMatches: matchString with: matchOptionString
	| matches |
	matches _ self listAllProjectDetails
				select: [:eachDetails | eachDetails
						anySatisfy: [:detail | matchString match: detail]].
	^matches! !

!NmProjectServer methodsFor: 'accessing' stamp: 'mu 6/19/2005 09:28'!
projectDirectory
	^Project netMorphPublishDirectory! !

!NmProjectServer methodsFor: 'private' stamp: 'mu 7/3/2005 22:45'!
sortMatched: matchedProjectDetails with: sortOptionString 
	| sorted sortBlock |
	sortBlock _ [:a :b | (a at: #projectfilename)
				< (b at: #projectfilename)]. "Default is by name"
	sortOptionString = 'date'
		ifTrue: [sortBlock _ [:a :b | (TimeStamp fromString: (a at: ##projecttimestamp))
						> (TimeStamp fromString: (b at: ##projecttimestamp))]].
	sorted _ matchedProjectDetails asSortedCollection: sortBlock.
	^ (sorted
		collect: [:each | each at: #projectfilename]) asArray! !

!NmProjectServer methodsFor: 'actions' stamp: 'mu 6/16/2005 23:12'!
takeAPicture: shrunkBySize
	^(Display thumbnailShrunkBy: shrunkBySize) asCompactBytes compressOnDemand! !

Object subclass: #NmProperties
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmProperties commentStamp: '<historical>' prior: 0!
I represent an appication specific name/value properties.

My subclasses will have many default value provider methods. 
Or just use #at: #at:put like a normal dictionary.

#creator
[:masashi | ^umezawa] 
#version 0.4 M.U. 11/21/1999 22:12!

!NmProperties class methodsFor: 'examples' stamp: 'ns 1/20/2003 18:45'!
example1
	"NmProperties example1"
	| props |
	props _ NmProperties newFrom: #(#(#SqIsCool #true) #(#defaultPassword #fooBar) #(#greeting 'Hi!!') ).
	^ props! !

!NmProperties class methodsFor: 'examples' stamp: 'ns 1/20/2003 18:45'!
example2
	"NmProperties example2"
	| props |
	props _ self example1.
	props disable: #SqIsCool.
	^ props
		overridden: (NmProperties newFrom: #(#(#SqueakVersion 2.7) #(#greeting 'Hello!!') ))! !

!NmProperties class methodsFor: 'instance creation' stamp: 'ns 1/20/2003 18:45'!
new
	^ super new initialize! !

!NmProperties class methodsFor: 'instance creation' stamp: 'ns 1/20/2003 18:45'!
newFrom: aKeyValueArray 
	"brace expressions are no longer used for Squeak 2.7+: M.U. 11/21/1999 22:15"
	"instead use: #(#(key1 value1) #(key2 value2))"
	^ self new fromArray: aKeyValueArray! !

!NmProperties methodsFor: 'converting' stamp: 'ns 1/20/2003 18:46'!
asArray
	| idx outArr |
	idx _ 0.
	outArr _ Array new: self size.
	self dictionary
		associationsDo: [:assoc | outArr
				at: (idx _ idx + 1)
				put: (Array with: assoc key with: assoc value)].
	^ outArr! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey 
	^ self dictionary
		at: aKey
		ifAbsent: []! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
at: aKey ifAbsentPutValue: aValue 
	^ self dictionary
		at: aKey
		ifAbsent: [self dictionary at: aKey put: aValue]! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey ifAbsentPut: aBlock 
	^ self dictionary at: aKey ifAbsentPut: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey ifAbsent: aBlock 
	^ self dictionary at: aKey ifAbsent: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
at: aKey put: aValue 
	| val |
	val _ aValue.
	"for self class >> newFrom: aKeyValueArray"
	aValue == #true
		ifTrue: [val _ true].
	aValue == #false
		ifTrue: [val _ false].
	aValue == #nil
		ifTrue: [val _ nil].
	^ self dictionary at: aKey put: val! !

!NmProperties methodsFor: 'factory' stamp: 'ns 1/20/2003 18:46'!
defaultDictionaryClass
	^ IdentityDictionary! !

!NmProperties methodsFor: 'accessing' stamp: 'ns 1/20/2003 18:46'!
dictionary
	dictionary isNil
		ifTrue: [dictionary _ self defaultDictionaryClass new].
	^ dictionary! !

!NmProperties methodsFor: 'accessing' stamp: 'ns 1/20/2003 18:46'!
dictionary: aValue 
	dictionary _ aValue! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
disable: aKey 
	^ self at: aKey put: false! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
do: aBlock 
	^ self dictionary do: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
enable: aKey 
	^ self at: aKey put: true! !

!NmProperties methodsFor: 'converting' stamp: 'ns 1/20/2003 18:46'!
fromArray: aKeyValueArray 
	"brace expressions are no longer used for Squeak 2.7+: M.U. 11/21/1999 22:15"
	"instead use: #(#(key1 value1) #(key2 value2))"
	| dict |
	dict _ self defaultDictionaryClass new: aKeyValueArray size.
	aKeyValueArray
		do: [:each | dict at: each first put: each last].
	self dictionary: dict! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
includesKey: aKey 
	^ self dictionary includesKey: aKey! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
inherit: aNmProperties 
	aNmProperties
		keysAndValuesDo: [:key :value | self at: key ifAbsentPutValue: value]! !

!NmProperties methodsFor: 'initialize-release' stamp: 'ns 1/20/2003 18:45'!
initialize
	"do nothing"! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
keys
	^ self dictionary keys! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
keysAndValuesDo: aBlock 
	^ self dictionary keysAndValuesDo: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
keysDo: aBlock 
	^ self dictionary keysDo: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
overridden: aNmProperties 
	aNmProperties
		keysAndValuesDo: [:key :value | self at: key put: value]! !

!NmProperties methodsFor: 'actions' stamp: 'mu 2/12/2003 16:53'!
removeKey: aKey
	^ self dictionary
		removeKey: aKey! !

!NmProperties methodsFor: 'actions' stamp: 'mu 2/12/2003 16:53'!
removeKey: aKey ifAbsent: aBlock
	^ self dictionary
		removeKey: aKey ifAbsent: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
size
	^ self dictionary size! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
valuesDo: aBlock 
	^ self dictionary valuesDo: aBlock! !

Object subclass: #NmServerManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/29/2005 03:18'!
isMapServerInstalled
	"NmServerManager isMapServerInstalled"
	^ (Smalltalk includesKey: #SoapServerSetup)
			and: [Smalltalk includesKey: #NmWorldMapServer]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 6/3/2005 09:26'!
isMapServerOnlyImage
	"NmServerManager isMapServerOnlyImage"
	^ (Smalltalk includesKey: #NmSettings) not
			! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/30/2005 18:12'!
isMapServerRunning
	"NmServerManager isMapServerRunning"
	| descriptor |
	descriptor _ ('http:', NmServerSettings mapServerPort asString) asSymbol.
	^SoapServerSetup runningTransportDescriptions includes: descriptor! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 7/23/2005 00:04'!
isWarpServerInstalled
	"NmServerManager isWarpServerInstalled"
	^ Smalltalk includesKey: #NmCatcher ! !

!NmServerManager class methodsFor: 'factory' stamp: 'mu 5/6/2003 01:38'!
soapServerSetup
	^ Smalltalk
		at: #SoapServerSetup
		ifAbsent: []! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/31/2005 18:04'!
startMapServer
	"NmServerManager startMapServer"
	| setup |
	self isMapServerInstalled
		ifTrue: [(setup _ self soapServerSetup)
				ifNotNil: [setup restartAt: #http port: NmServerSettings mapServerPort]]
		ifFalse: [self error: 'MapServer is not installed']! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 6/1/2005 16:36'!
startMapServerWithBroadcaster
	"NmServerManager startMapServer"
	self startMapServer.
	NmWorldMapLocationBroadcaster default start! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 11/23/2003 01:51'!
startWarpServer
	"NmServerManager startWarpServer"
	| server |
	self isWarpServerInstalled
		ifTrue: [server := self warpServer.
			server
				ifNil: [server := NmRemoteService startOn: NmSettings warpPort]
				ifNotNil: [server portNumber = NmSettings warpPort
						ifFalse: [server portNumber: NmSettings warpPort]]]
		ifFalse: [self error: 'WarpServer is not installed']! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 5/29/2005 03:20'!
stopMapServer
	"NmServerManager stopMapServer"
	| setup |
	(setup _ self soapServerSetup)
		ifNotNil: [setup
				stop: (Array with: #http)]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 6/1/2005 16:37'!
stopMapServerWithBroadcaster
	"NmServerManager startMapServer"
	self stopMapServer.
	NmWorldMapLocationBroadcaster default stop! !

!NmServerManager class methodsFor: 'server administration' stamp: 'mu 11/25/2003 03:05'!
stopWarpServer
	"NmServerManager stopWarpServer"
	"clean old sockets if any"
	| setup openSockets |
	(setup := self warpServer)
		ifNotNil: [setup stop].
	openSockets := Socket allInstances
				select: [:each | each isWaitingForConnection].
	(openSockets
		select: [:each | each port = NmSettings warpPort])
		do: [:each | each closeAndDestroy].
	NmRemoteService allInstances do: [:e| e kill]! !

!NmServerManager class methodsFor: 'factory' stamp: 'mu 11/22/2003 20:12'!
warpServer
	^ NmRemoteService current
		! !

Object subclass: #NmSoapServer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

NmSoapServer class
	instanceVariableNames: 'default'!

!NmSoapServer class methodsFor: 'class initialization' stamp: 'mu 8/12/2005 13:00'!
basicInitialize
	default ifNotNil: [default release].
	default _ nil.
	self registerServices.! !

!NmSoapServer class methodsFor: 'accessing' stamp: 'mu 6/16/2005 18:41'!
default
	default
		ifNil: [default _ self basicNew initialize].
	^ default! !

!NmSoapServer class methodsFor: 'class initialization' stamp: 'mu 3/12/2003 00:18'!
initialize
	self initializeAll! !

!NmSoapServer class methodsFor: 'class initialization' stamp: 'mu 6/7/2004 01:35'!
initializeAll
	"NmSoapServer initializeAll"
	self allSubclasses do:[:each | each initialize]! !

!NmSoapServer class methodsFor: 'utilities' stamp: 'mu 6/7/2004 01:35'!
inspectRegisteredServices
	"NmSoapServer inspectRegisteredServices"
	SoapServiceHandler default serviceHome inspect! !

!NmSoapServer class methodsFor: 'instance creation' stamp: 'mu 3/13/2003 19:25'!
new
	self shouldNotImplement! !

!NmSoapServer class methodsFor: 'private' stamp: 'mu 5/29/2005 03:17'!
registerServiceNamed: serviceNameSymbol paramNames: anArrayOfParamNames
	| impl serv |
	impl := self default.
	serv := SoapService implementor: impl selector: serviceNameSymbol.
	serv signature: (SoapServiceSignature name: serviceNameSymbol asString paramNames: anArrayOfParamNames).
	serv targetObjectURI: (NmServerSettings mapServerUrl asUrl fullPath).
	SoapServiceHandler default add: serv.

	! !

!NmSoapServer methodsFor: 'initialize-release' stamp: 'mu 8/12/2005 12:59'!
initialize! !

!NmSoapServer methodsFor: 'initialize-release' stamp: 'mu 8/12/2005 12:59'!
release! !

NmSoapServer subclass: #NmWorldMapServer
	instanceVariableNames: 'worldMaps clearProcess storeProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Server-MapServer'!

!NmWorldMapServer class methodsFor: 'constants' stamp: 'mu 2/2/2005 01:01'!
defaultClearingIntervalSeconds
	^20! !

!NmWorldMapServer class methodsFor: 'constants' stamp: 'mu 6/16/2005 00:57'!
defaultStoringIntervalSeconds
	"1 hour"
	^60 * 60
	! !

!NmWorldMapServer class methodsFor: 'utilities' stamp: 'mu 4/10/2005 02:08'!
exploreMaps
	"NmWorldMapServer exploreMaps"
	self default worldMaps explore! !

!NmWorldMapServer class methodsFor: 'class initialization' stamp: 'mu 3/12/2003 00:19'!
initialize
	self basicInitialize! !

!NmWorldMapServer class methodsFor: 'utilities' stamp: 'mu 6/15/2005 23:39'!
load
	"NmWorldMapServer load"
	^self default load! !

!NmWorldMapServer class methodsFor: 'class initialization' stamp: 'mu 2/2/2005 00:52'!
obsolete
	self release.
	super obsolete! !

!NmWorldMapServer class methodsFor: 'registering' stamp: 'mu 5/7/2005 10:23'!
registerServices
	"NmWorldMapServer registerServices"
	self registerServiceNamed: #'putMapString:named:' paramNames: #(#mapCSVString #mapName ).
	self registerServiceNamed: #'getMapStringNamed:' paramNames: #(#mapName ).
	self registerServiceNamed: #'getVersionNamed:' paramNames: #(#mapName ).
	self registerServiceNamed: #listAllMapNames paramNames: #().
	self registerServiceNamed: #'updateEntryWith:named:' paramNames: #(#mapEntryString #mapName ).
	self registerServiceNamed: #'removeEntryWith:named:' paramNames: #(#uuidStr #mapName )! !

!NmWorldMapServer class methodsFor: 'utilities' stamp: 'mu 2/2/2005 00:51'!
release
	"self release"
	self default release! !

!NmWorldMapServer class methodsFor: 'utilities' stamp: 'mu 6/15/2005 23:56'!
store
	"NmWorldMapServer store"
	^self default store! !

!NmWorldMapServer methodsFor: 'accessing' stamp: 'mu 6/15/2005 23:54'!
backupFilename
	^NmBaseUtil shortImagePrefix, '.AllWorldMaps.bak'! !

!NmWorldMapServer methodsFor: 'accessing' stamp: 'mu 2/2/2005 01:03'!
clearingIntervalSeconds
	^self class defaultClearingIntervalSeconds! !

!NmWorldMapServer methodsFor: 'clearning' stamp: 'mu 5/4/2005 18:48'!
clearMapsNotUsed
	self clearMapsNotUsedFor: self clearingIntervalSeconds.
	! !

!NmWorldMapServer methodsFor: 'clearning' stamp: 'mu 6/15/2005 00:06'!
clearMapsNotUsedFor: intervalSeconds 
	| seconds emptyMaps emptyMapKeys |
	seconds _ intervalSeconds.
	self worldMaps
		do: [:each | each removeNotUpdatedFor: seconds].
	emptyMaps _ self worldMaps
				select: [:each | each isEmpty].
	emptyMaps
		keysAndValuesDo: [:name :map | map forgetNamed: name useServer: false].
	emptyMapKeys _ emptyMaps keys.
	emptyMapKeys
		do: [:each | self worldMaps
				removeKey: each
				ifAbsent: []]! !

!NmWorldMapServer methodsFor: 'clearning' stamp: 'mu 5/10/2005 17:39'!
clingTogether
	self worldMaps
		do: [:each | 
			each clingTogetherAloneEntries].! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'mu 1/21/2005 02:03'!
getMapStringNamed: mapName 
	| map |
	map _ self worldMaps
				at: mapName
				ifAbsent: [].
	^ map isNil
		ifFalse: [map csvString]! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'mu 5/7/2005 10:22'!
getVersionNamed: mapName 
	| map |
	map _ self worldMaps
				at: mapName
				ifAbsent: [].
	^ map isNil
		ifFalse: [map version]! !

!NmWorldMapServer methodsFor: 'initializing' stamp: 'mu 8/22/2005 11:10'!
initClearProcess
	| cleaner |
	clearProcess notNil
		ifTrue: [self release].
	cleaner := [[self clearMapsNotUsed.
			self clingTogether.
			(Delay forSeconds: self clearingIntervalSeconds) wait] repeat].
	clearProcess := cleaner forkAt: Processor userSchedulingPriority - 2.
	clearProcess name: self name, ':Clear'.! !

!NmWorldMapServer methodsFor: 'initializing' stamp: 'mu 6/15/2005 23:58'!
initialize
	"self default initialize"
	super initialize.
	self release.
	worldMaps _ nil.
	self initClearProcess.
	self initStoreProcess! !

!NmWorldMapServer methodsFor: 'initializing' stamp: 'mu 8/22/2005 11:10'!
initStoreProcess
	| saver |
	storeProcess notNil
		ifTrue: [self release].
	saver := [[self store.
			(Delay forSeconds: self storingIntervalSeconds) wait] repeat].
	storeProcess := saver forkAt: Processor userSchedulingPriority - 5.
	storeProcess name: self name, ':Store'.! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'mu 5/4/2005 02:29'!
listAllMapNames
	self clearMapsNotUsed.
	^self worldMaps keys asSortedCollection asArray
	
	! !

!NmWorldMapServer methodsFor: 'storing/loading' stamp: 'mu 6/15/2005 23:56'!
load
	| loaded |
	loaded _ NmBaseUtil loadFrom: FileDirectory default named: self backupFilename.
	loaded notNil
		ifTrue: [worldMaps _ loaded.
			NmTranscript crShow: '## All MapServer data were loaded: ' , self backupFilename]! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'mu 8/11/2005 08:44'!
putMapString: mapCSVString named: mapName 
	| map |
	map := self worldMapsAt: mapName.
	map fromCsvString: mapCSVString.
	map mapName: mapName.
	map incrementVersion.
	map storeNamed: mapName useServer: false.
	Transcript cr; show: mapCSVString.
	^ nil! !

!NmWorldMapServer methodsFor: 'initializing' stamp: 'mu 6/15/2005 23:41'!
release
	clearProcess ifNotNilDo: [:p | p terminate].
	clearProcess _ nil.
	storeProcess ifNotNilDo: [:p | p terminate].
	storeProcess _ nil
	! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'mu 2/2/2005 00:30'!
removeEntryWith: uuidStr named: mapName
	| map |
	map _ self worldMapsAt: mapName.
	map
		removeKey: uuidStr
		ifAbsent: [^ false].
	map storeNamed: mapName useServer: false.
	^ true! !

!NmWorldMapServer methodsFor: 'storing/loading' stamp: 'mu 6/16/2005 18:58'!
store
	self worldMaps isEmpty ifTrue: [^self].
	NmBaseUtil store: self worldMaps to: FileDirectory default named: self backupFilename! !

!NmWorldMapServer methodsFor: 'accessing' stamp: 'mu 6/15/2005 23:43'!
storingIntervalSeconds
	^self class defaultStoringIntervalSeconds! !

!NmWorldMapServer methodsFor: 'actions' stamp: 'mu 8/11/2005 12:46'!
updateEntryWith: mapEntryString named: mapName 
	| worldMap originalEntry newEntry |
	self clearMapsNotUsed.
	worldMap := self worldMapsAt: mapName.
	newEntry := (NmWorldMapEntry fromCsvString: mapEntryString) unchanged.
	originalEntry := worldMap at: newEntry id.
	originalEntry = newEntry
		ifTrue: [originalEntry resetLastChangedTime]
		ifFalse: [worldMap registerDodgeIfConflict: newEntry.
			worldMap incrementVersion.
			worldMap storeNamed: mapName useServer: false].
	^ worldMap csvString! !

!NmWorldMapServer methodsFor: 'accessing' stamp: 'mu 1/21/2005 01:16'!
worldMaps
	worldMaps ifNil: [worldMaps _ Dictionary new].
	^worldMaps! !

!NmWorldMapServer methodsFor: 'accessing' stamp: 'mu 8/11/2005 13:17'!
worldMapsAt: mapName 
	^ self worldMaps
		at: mapName
		ifAbsentPut: [NmWorldMap new]! !

Object subclass: #NmTimerUpdater
	instanceVariableNames: 'updateProcess intervalSeconds priority'
	classVariableNames: 'WatchDog'
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

NmTimerUpdater class
	instanceVariableNames: 'default'!

NmTimerUpdater subclass: #NmAutoWorldInfoUpdater
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-Client'!

!NmAutoWorldInfoUpdater class methodsFor: 'constants' stamp: 'mu 4/1/2005 00:45'!
defaultIntervalSeconds
	^ 11! !

!NmAutoWorldInfoUpdater class methodsFor: 'examples' stamp: 'mu 1/23/2005 03:34'!
example1
	"NmAutoWorldInfoUpdater example1."
	| updater |
	updater _ NmAutoWorldInfoUpdater new.
	(Delay forMilliseconds: 5000) wait.
	updater release.
	NmAutoWorldInfoUpdater flushInstances! !

!NmAutoWorldInfoUpdater methodsFor: 'testing' stamp: 'mu 8/22/2005 10:30'!
shouldRunAlways
	^true! !

!NmAutoWorldInfoUpdater methodsFor: 'actions' stamp: 'mu 5/7/2005 10:31'!
update
	
	NmWorldMap default update
	! !

NmTimerUpdater subclass: #NmAvailabilityChecker
	instanceVariableNames: 'availableAddresses deadlineSeconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-Client'!

NmAvailabilityChecker class
	instanceVariableNames: 'isDebugging'!

!NmAvailabilityChecker class methodsFor: 'constants' stamp: 'mu 1/4/2005 03:07'!
defaultDeadlineSeconds
	^4! !

!NmAvailabilityChecker class methodsFor: 'constants' stamp: 'mu 4/1/2005 00:15'!
defaultIntervalSeconds
	^ 30! !

!NmAvailabilityChecker class methodsFor: 'class initialization' stamp: 'mu 12/11/2002 10:45'!
initialize
	"NmAvailabilityChecker initialize"
	default _ nil.
	isDebugging _ true! !

!NmAvailabilityChecker class methodsFor: 'accessing' stamp: 'mu 12/11/2002 10:46'!
isDebugging
	^isDebugging! !

!NmAvailabilityChecker class methodsFor: 'accessing' stamp: 'mu 12/11/2002 10:46'!
isDebugging: aBoolean
	isDebugging _ aBoolean! !

!NmAvailabilityChecker methodsFor: 'private' stamp: 'mu 5/29/2005 03:33'!
allConnectAddresses
	^NmWorldMap default allConnectAddresses asOrderedCollection asSet! !

!NmAvailabilityChecker methodsFor: 'accessing' stamp: 'mu 5/29/2005 04:10'!
availableAddresses
	availableAddresses ifNil: [self initAvailableAddresses].
	self isRunning ifFalse: [^self allConnectAddresses].
	^availableAddresses! !

!NmAvailabilityChecker methodsFor: 'actions' stamp: 'mu 5/29/2005 04:08'!
checkAvailability
	
	NmSettings useAvailabilityChecker
		ifFalse: [availableAddresses _ self allConnectAddresses.
			^ self].
	self allConnectAddresses 
		do: [:ipAndPortArray | | isAvailable |
			isAvailable _ self isAvailableAddress: ipAndPortArray first port: ipAndPortArray last.
			isAvailable
				ifTrue: [self availableAddresses add: ipAndPortArray]
				ifFalse: [self availableAddresses remove: ipAndPortArray ifAbsent:[]]].
	availableAddresses isEmpty ifTrue: [self computeDeadlineSeconds].
	! !

!NmAvailabilityChecker methodsFor: 'private' stamp: 'mu 5/31/2004 02:17'!
computeDeadlineSeconds
	self deadlineSeconds: self deadlineSeconds + 1.
	self deadlineSeconds > 30 ifTrue: [self initDeadlineSeconds].! !

!NmAvailabilityChecker methodsFor: 'accessing' stamp: 'mu 5/8/2003 14:57'!
deadlineSeconds
	deadlineSeconds ifNil:[deadlineSeconds _ self class defaultDeadlineSeconds].
	^deadlineSeconds! !

!NmAvailabilityChecker methodsFor: 'accessing' stamp: 'mu 5/8/2003 14:58'!
deadlineSeconds: seconds
	deadlineSeconds _ seconds! !

!NmAvailabilityChecker methodsFor: 'initialize-release' stamp: 'mu 6/7/2004 02:23'!
initAvailableAddresses
	availableAddresses _ Set new.
	! !

!NmAvailabilityChecker methodsFor: 'initialize-release' stamp: 'mu 5/31/2004 02:16'!
initDeadlineSeconds
	
	deadlineSeconds _ self class defaultDeadlineSeconds.
	
! !

!NmAvailabilityChecker methodsFor: 'initialize-release' stamp: 'mu 6/7/2004 02:23'!
initialize
	self initAvailableAddresses.
	self initDeadlineSeconds! !

!NmAvailabilityChecker methodsFor: 'private' stamp: 'mu 5/31/2004 02:05'!
isAvailableAddress: ipAddressString port: port 
	"NmAvailabilityChecker default isAvailableAddress: '172.25.0.68' port: 4649."
	"NmAvailabilityChecker default isAvailableAddress: NmUtil localAddress port: NmSettings warpPort."
	| ipAsBytes con |
	ipAddressString ifNil: [^ false].
	
	ipAsBytes _ NetNameResolver addressFromString: ipAddressString.
	(NmRemoteConnector connectionPool connectorDict includesKey: ipAsBytes)  ifTrue: [^true].
	
	[con _ NmRemoteConnector connect: ipAddressString port: port timeout: self deadlineSeconds.
	^con isConnected .
	] on: RmtNetworkError do: [:ex | ^false].
	
	^false! !

!NmAvailabilityChecker methodsFor: 'actions' stamp: 'mu 8/22/2005 11:55'!
start
	updateProcess notNil
		ifTrue: [self stop].
	self initDeadlineSeconds.
	updateProcess := [[| currentValue nextValue | 
			self update.
			currentValue := Time millisecondClockValue.
			nextValue := self nextMillisecondClockValue.
			(Delay forMilliseconds: nextValue - currentValue) wait.
			deadlineSeconds notNil] whileTrue] newProcess.
	updateProcess priority: self class defaultPriority.
	updateProcess resume.
	updateProcess name: self name.! !

!NmAvailabilityChecker methodsFor: 'actions' stamp: 'mu 5/20/2005 20:16'!
update
	self checkAvailability! !

!NmTimerUpdater class methodsFor: 'instance creation' stamp: 'mu 8/22/2005 10:12'!
default
	default isNil
		ifTrue: [default := self basicNew initialize].
	^ default! !

!NmTimerUpdater class methodsFor: 'constants' stamp: 'mu 5/20/2005 19:35'!
defaultIntervalSeconds
	^ 10! !

!NmTimerUpdater class methodsFor: 'constants' stamp: 'mu 5/31/2005 00:48'!
defaultPriority
	^ Processor userSchedulingPriority - 1! !

!NmTimerUpdater class methodsFor: 'utilities' stamp: 'mu 8/22/2005 09:50'!
defaultSubInstances
	^self allSubclasses collect: [:each | each default]! !

!NmTimerUpdater class methodsFor: 'class initialization' stamp: 'mu 8/22/2005 10:57'!
flushAllSubInstances
	"NmTimerUpdater flushAllSubInstances."
	self allSubclassesDo: [:each | each flushInstances]! !

!NmTimerUpdater class methodsFor: 'class initialization' stamp: 'mu 8/22/2005 10:57'!
flushInstances
	"NmTimerUpdater flushInstances."
	self allInstances
		do: [:each | 
			each stop.
			each become: Object new].
	Smalltalk garbageCollect.
	default notNil
		ifTrue: [default class = self ifTrue: [default stop].
			default := nil]! !

!NmTimerUpdater class methodsFor: 'class initialization' stamp: 'mu 8/22/2005 10:57'!
initialize
	"NmTimerUpdater initialize"
	self initWatchDog.

	! !

!NmTimerUpdater class methodsFor: 'watch dog' stamp: 'mu 8/22/2005 11:06'!
initWatchDog
	WatchDog := [[WatchDog isNil]
				whileFalse: [(Delay forSeconds: 30) wait.
					(self defaultSubInstances
						select: [:each | each shouldRunAlways])
						do: [:each | each isRunning
								ifFalse: [each start]]]] newProcess.
	WatchDog priority: Processor userBackgroundPriority.
	WatchDog name: self name, ':WatchDog'.
	WatchDog resume! !

!NmTimerUpdater class methodsFor: 'instance creation' stamp: 'mu 5/20/2005 19:33'!
new
	self shouldNotImplement! !

!NmTimerUpdater class methodsFor: 'class initialization' stamp: 'mu 8/22/2005 10:56'!
release
	self releaseWatchDog.

	! !

!NmTimerUpdater class methodsFor: 'watch dog' stamp: 'mu 8/22/2005 10:51'!
releaseWatchDog
	(WatchDog notNil)
		ifTrue: [WatchDog terminate.
			WatchDog := nil]! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/20/2005 19:33'!
intervalSeconds
	intervalSeconds
		ifNil: [intervalSeconds _ self class defaultIntervalSeconds].
	^ intervalSeconds! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 8/22/2005 10:16'!
intervalSeconds: seconds 
	intervalSeconds := seconds.
	self stop.
	self start! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/20/2005 19:33'!
interval: msec 
	"obsolete"
	self intervalSeconds: (msec / 1000) asFloat! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 8/22/2005 10:17'!
isRunning
	updateProcess ifNil: [^false].
	updateProcess isSuspended ifTrue: [^false].
	updateProcess isTerminated ifTrue: [^false].
	^true! !

!NmTimerUpdater methodsFor: 'private' stamp: 'mu 5/20/2005 19:33'!
nextMillisecondClockValue
	^ Time millisecondClockValue + (self intervalSeconds * 1000) truncated! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/31/2005 00:53'!
priority
	priority
		ifNil: [priority _ self class defaultPriority].
	^ priority! !

!NmTimerUpdater methodsFor: 'accessing' stamp: 'mu 5/31/2005 00:54'!
priority: anInteger
	priority _ anInteger asInteger! !

!NmTimerUpdater methodsFor: 'testing' stamp: 'mu 8/22/2005 10:15'!
shouldRunAlways
	^false! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 8/22/2005 11:00'!
start
	self isRunning ifTrue: [^self].
	[self update] forkAt: self priority.
	self stop.
	updateProcess := [[| currentValue nextValue | 
			currentValue := Time millisecondClockValue.
			nextValue := self nextMillisecondClockValue.
			(Delay forMilliseconds: nextValue - currentValue) wait.
			true]
				whileTrue: [self update]] newProcess.
	updateProcess name: self name.
	updateProcess priority: self priority.
	updateProcess resume! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 5/20/2005 19:33'!
startAfter: seconds 
	[(Delay forSeconds: seconds) wait.
	self start]
		forkAt: Processor userBackgroundPriority! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 8/22/2005 10:43'!
stop
	(updateProcess notNil
			and: [updateProcess isTerminated not
					or: [updateProcess isSuspended]])
		ifTrue: [updateProcess terminate].
	updateProcess := nil! !

!NmTimerUpdater methodsFor: 'actions' stamp: 'mu 5/20/2005 19:35'!
update
	
	! !

NmTimerUpdater subclass: #NmWorldMapLocationBroadcaster
	instanceVariableNames: 'broadcastClient'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Server-MapServer'!

!NmWorldMapLocationBroadcaster class methodsFor: 'constants' stamp: 'mu 5/30/2005 18:52'!
defaultIntervalSeconds
	^ 12! !

!NmWorldMapLocationBroadcaster methodsFor: 'accessing' stamp: 'mu 5/29/2005 03:00'!
broadcastClient
	broadcastClient ifNil: [broadcastClient _ RbtClient new].
	^broadcastClient! !

!NmWorldMapLocationBroadcaster methodsFor: 'private' stamp: 'mu 5/29/2005 02:48'!
broadcastingIntervalSeconds
	^(self intervalSeconds // self broadcastingPorts size) max: 1! !

!NmWorldMapLocationBroadcaster methodsFor: 'private' stamp: 'mu 6/3/2005 03:23'!
broadcastingPorts
	^NmServerSettings broadcastingWarpPorts! !

!NmWorldMapLocationBroadcaster methodsFor: 'private' stamp: 'mu 5/29/2005 03:52'!
locationMessage
	^NmBaseUtil localAddress, ':', NmServerSettings mapServerPort asString! !

!NmWorldMapLocationBroadcaster methodsFor: 'testing' stamp: 'mu 8/22/2005 10:30'!
shouldRunAlways
	^true! !

!NmWorldMapLocationBroadcaster methodsFor: 'actions' stamp: 'mu 6/21/2005 18:52'!
update
	NmServerManager isMapServerRunning ifFalse: [^self].
	self broadcastingPorts
		do: [:port | 
			self broadcastClient bindForBroadcast: port.
			self broadcastClient sendData: self locationMessage.
			(Delay forSeconds: self broadcastingIntervalSeconds) wait]! !

Object subclass: #NmTranscript
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

NmTranscript class
	instanceVariableNames: 'isDebugging'!

!NmTranscript class methodsFor: 'actions' stamp: 'mu 7/8/2005 20:44'!
crShow: aString
	self isDebugging ifTrue: [Transcript cr; show: aString]! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 8/15/2005 00:24'!
enable: aBoolean
	"NmTranscript enable: true"
	"NmTranscript enable: false"
	isDebugging _ aBoolean == true! !

!NmTranscript class methodsFor: 'class initialization' stamp: 'mu 7/8/2005 20:43'!
initialize
	"NmTranscript initialize"
	isDebugging _ nil! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 7/8/2005 20:43'!
isDebugging
	isDebugging ifNil: [isDebugging _ false].
	^isDebugging! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 7/8/2005 20:44'!
show: aString
	self isDebugging ifTrue: [Transcript show: aString]! !

!NmTranscript class methodsFor: 'actions' stamp: 'mu 4/11/2003 14:44'!
toggleDebugging
	isDebugging _ isDebugging not! !

Object subclass: #NmWorldInfoReadWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmWorldInfoReadWriter class methodsFor: 'private' stamp: 'mu 5/1/2005 22:07'!
createPath
	 ^self defaultPath = '.' ifTrue: [FileDirectory default pathName] ifFalse: [self defaultPath].
	! !

!NmWorldInfoReadWriter class methodsFor: 'accessing' stamp: 'mu 6/15/2005 23:07'!
defaultPath
	NmServerManager isMapServerInstalled ifTrue: [^NmServerSettings mapPath].
	^NmSettings mapPath! !

!NmWorldInfoReadWriter class methodsFor: 'accessing' stamp: 'mu 6/15/2005 23:07'!
defaultPath: path
	NmServerManager isMapServerInstalled ifTrue: [^NmServerSettings mapPath: path].
	^NmSettings mapPath: path! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/10/2005 17:55'!
deleteCsvFile: fileNameString 
	| readDir |
	readDir _ FileDirectory on: self createPath.
	(readDir directoryExists: readDir pathName)
		ifTrue: [readDir
				deleteFileNamed: (self trimFileName: fileNameString)
				ifAbsent: [^ false].
			^ true].
	^ false! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/10/2005 17:55'!
getCsvStringFromFile: fileNameString
	| readDir fileName |
	fileName _ self trimFileName: fileNameString.
	readDir _ FileDirectory on: self createPath.
	(readDir fileExists: fileName)
		ifTrue: [| fileStream csvString | 
	
			[fileStream _ CrLfFileStream readOnlyFileNamed: (readDir fullNameFor: fileName).
			csvString _ fileStream contentsOfEntireFile]
				ensure: [fileStream
						ifNotNil: [fileStream close]].
			^ csvString]
		ifFalse: [^ nil]! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/2/2005 01:38'!
listAllCsvFileNamesFromDirectory
	| readDir | 
	readDir _ FileDirectory on: self createPath.
	(readDir directoryExists: readDir pathName)
		ifTrue: [| fileNames mapNames | 
			fileNames _ readDir fileNames. 
			mapNames _ fileNames
						select: [:each | '*.csv' match: each].
			^ mapNames]
		ifFalse: [^ #()]! !

!NmWorldInfoReadWriter class methodsFor: 'actions' stamp: 'mu 5/13/2005 23:10'!
putCsvString: csvString toFile: fileNameString 
	| writeFileStream path dir fileName |
	fileName _ self trimFileName: fileNameString.
	path _ self createPath.
	dir _ FileDirectory on: path.
	[[writeFileStream _ CrLfFileStream
				forceNewFileNamed: (dir fullNameFor: fileName)]
		on: CannotDeleteFileException , FileDoesNotExistException
		do: [:ex | 
			self defaultPath: FileDirectory default pathName.
			NmTranscript show: 'Wrong path or filename: ' , dir pathName asString , '. Use default directory anyway'.
			^ self putCsvString: csvString toFile: fileNameString].
	writeFileStream
		ifNil: [NmTranscript show: 'Falied to store to: ', fileNameString. ^nil].
	writeFileStream nextPutAll: csvString]
		ensure: [writeFileStream
				ifNotNil: [writeFileStream close]]! !

!NmWorldInfoReadWriter class methodsFor: 'private' stamp: 'mu 5/10/2005 17:55'!
trimFileName: fileNameString 
	^(fileNameString endsWith: '.csv')
				ifTrue: [fileNameString]
				ifFalse: [fileNameString , '.csv'].
	! !

!Object methodsFor: '*NetMorph-testing' stamp: 'mu 5/10/2005 20:25'!
isNmUrl
	^false! !

!Object methodsFor: '*NetMorph-testing' stamp: 'kuri-t 11/21/2002 17:30'!
isProxy
	^false! !

!Object methodsFor: '*NetMorph-testing' stamp: 'kuri-t 12/13/2002 15:03'!
shouldPassAsProxy
	^ false.! !

!PhraseTileMorph methodsFor: '*NetMorph-dropping/grabbing' stamp: 'ns 10/3/2002 15:58'!
aboutToBeGrabbedBy: aHand 
	super aboutToBeGrabbedBy: aHand.
	self formerOwner: nil.
	self formerPosition: nil.
	self removeProperty: #undoGrabCommand.
	"CommandHistory resetAllHistory"! !

!Point methodsFor: '*NetMorph-override-printing' stamp: ''!
storeOn: aStream 
	"x@y printed form is good for storing too"
	aStream nextPut: $(.
	self printOn: aStream.
	aStream nextPut: $)! !

!SmalltalkImage methodsFor: '*NetMorph-accessing' stamp: 'mu 12/17/2004 01:29'!
id
	^NmImageId current! !

!Debugger class methodsFor: '*NetMorph-override-opening' stamp: 'mu 5/15/2005 01:49'!
openInterrupt: aString onProcess: interruptedProcess
	"Open a notifier in response to an interrupt. An interrupt occurs when the user types the interrupt key (cmd-. on Macs, ctrl-c or alt-. on other systems) or when the low-space watcher detects that memory is low."
	| debugger |
	<primitive: 19> "Simulation guard"
	debugger _ self new.
	debugger
		process: interruptedProcess
		controller: ((Smalltalk isMorphic not
					and: [ScheduledControllers activeControllerProcess == interruptedProcess])
						ifTrue: [ScheduledControllers activeController])
		context: interruptedProcess suspendedContext.
	debugger externalInterrupt: true.

Preferences logDebuggerStackToFile ifTrue:
	[(aString includesSubString: 'Space') & 
		(aString includesSubString: 'low') ifTrue: [
			Smalltalk logError: aString inContext: debugger interruptedContext to:'LowSpaceDebug.log']].
	Preferences eToyFriendly ifTrue: [NmProcessManager terminateAll.
	World stopRunningAll].
	^ debugger
		openNotifierContents: nil
		label: aString
! !

!ClassDescription methodsFor: '*NetMorph-compiling' stamp: 'ka 10/17/2002 19:34'!
compile: text classified: category withStamp: changeStamp notifying: requestor logged: logFlag 
	^ self
		compile: text
		classified: category
		withStamp: changeStamp
		notifying: requestor
		logSource: logFlag! !

Warning subclass: #NmNoSuchMorphWarning
	instanceVariableNames: 'uuidString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

!NmNoSuchMorphWarning class methodsFor: 'instance creation' stamp: 'mu 7/30/2005 23:04'!
signalWithUuidString: uuidString 
	| inst |
	inst := self new.
	inst uuidString: uuidString.
	^ inst signal: 'Morph(' , uuidString , ') is not found'! !

!NmNoSuchMorphWarning methodsFor: 'exceptionDescription' stamp: 'mu 7/30/2005 17:38'!
defaultAction
	^ NmBaseSettings isDebugging
		ifTrue: [super defaultAction]
		ifFalse: [NmShortMessageMorph contents: self messageText at: ActiveWorld center.
			nil]! !

!NmNoSuchMorphWarning methodsFor: 'exceptionDescription' stamp: 'mu 7/30/2005 17:38'!
defaultActionAt: point
	^ NmBaseSettings isDebugging
		ifTrue: [super defaultAction]
		ifFalse: [NmShortMessageMorph contents: self messageText at: point.
			nil]! !

!NmNoSuchMorphWarning methodsFor: 'exceptionDescription' stamp: 'mu 7/30/2005 17:35'!
messageText
	self uuidString ifNil: [^super messageText].
	^'Morph(' , self uuidString , ') is not found' translated! !

!NmNoSuchMorphWarning methodsFor: 'accessing' stamp: 'mu 7/30/2005 17:36'!
uuidString
	^uuidString! !

!NmNoSuchMorphWarning methodsFor: 'accessing' stamp: 'mu 7/30/2005 17:36'!
uuidString: aString
	uuidString _ aString! !

Warning subclass: #NmSoapCallFailedWarning
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

!NmSoapCallFailedWarning methodsFor: 'exceptionDescription' stamp: 'mu 8/16/2005 09:45'!
defaultAction
	^nil! !

!String methodsFor: '*NetMorph-converting' stamp: 'mu 5/10/2005 20:36'!
asDestination
	^self! !

!String methodsFor: '*NetMorph-converting' stamp: 'mu 1/12/2005 01:43'!
asNmUrl
	^ (self beginsWith: NmUrl protocolIdentifier)
		ifTrue: [self asUrl]
		ifFalse: [NmUrl readFrom: self readStream]! !

!String methodsFor: '*NetMorph-converting' stamp: 'mu 8/18/2005 11:08'!
copyLastPortPartTo: portNumber 
	"'' copyLastPortPartTo: 23"
	"'qwerty' copyLastPortPartTo: 23"
	"'qwerty:11' copyLastPortPartTo: 23"
	"'nm://qwerty:11' copyLastPortPartTo: 23"
	| index orig portPartStr resetPortPart |
	self isAddressString
		ifFalse: [^ self].
	index := self lastIndexOf: $:.
	orig := self copyFrom: 1 to: index.
	portPartStr := portNumber asString.
	resetPortPart := portPartStr isAllDigits
				ifTrue: [portPartStr]
				ifFalse: [NmSettings defaultWarpPort asString].
	^ orig , resetPortPart! !

!String methodsFor: '*NetMorph-testing' stamp: 'mu 8/18/2005 11:03'!
isAddressString
	^ (self isNmUrlString)
		or: [self isIpAndPortString]! !

!String methodsFor: '*NetMorph-testing' stamp: 'mu 1/12/2005 01:40'!
isIpAndPortString
	"'123.2.3.4:30' isIpAndPortString"
	"'qwerty:30' isIpAndPortString"
	"'nm://123.2.3.499:30' isIpAndPortString"
	| index ipOrHostPart isIp portPart |
	(self occurrencesOf: $: ) = 1 ifFalse: [^false].
	index _ self indexOf: $:.
	ipOrHostPart _ self copyFrom: 1  to: index -1.
	isIp _ (NetNameResolver addressFromString: ipOrHostPart) notNil.
	(isIp isNil and: [isIp occurrencesOf: $.]) ifTrue: [^false].
	portPart _ self copyFrom: index +1 to: self size.
	portPart isAllDigits ifFalse: [^false].
	^true! !

!String methodsFor: '*NetMorph-testing' stamp: 'mu 8/18/2005 11:06'!
isNmUrlString
	^self beginsWith: NmUrl protocolIdentifier
	! !

!MorphExtension class methodsFor: '*NetMorph-private' stamp: ''!
classesHasInstVarNames: anArray 
	"MorphExtension classesHasInstVarNames: (Array with: (#home))."
	"MorphExtension classesHasInstVarNames: (Array with: (#address))."
	"MorphExtension classesHasInstVarNames: (Array with: (#identifier))."
	| classes collection |
	classes _ Morph allSubclasses asOrderedCollection.
	classes add: Morph.
	collection _ OrderedCollection new.
	classes
		do: [:each | anArray
				do: [:varName | (each instVarNames includes: varName)
						ifTrue: [collection add: each]]].
	^ collection! !

!MorphExtension class methodsFor: '*NetMorph-private' stamp: ''!
test
	"Time millisecondsToRun: [MorphExtension test]."
	"15 : without making assureExtension in initialize, 188 : with making assureExtension in initialize."
	BouncingAtomsMorph new openInWorld.
	Display restore! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 7/13/2005 18:35'!
address
	"ADDRESS may be confusing - meaning logical address in WorldMap (not ip address)"
	^ self pathNames last! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 7/11/2005 21:06'!
basicIdentifier
	^identifier
		! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 7/13/2005 17:09'!
basicIdentifier: anUUID
	identifier _ anUUID
		! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 8/4/2005 12:36'!
basicPath
	^path
	! !

!MorphExtension methodsFor: '*NetMorph-copying' stamp: ''!
clone
	| cloneObject |
	cloneObject _ super clone.
	cloneObject instVarNamed: 'identifier' put: UUID new.
	^ cloneObject! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 7/13/2005 18:35'!
home
	^self pathNames first! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 12/15/2004 22:47'!
identifier
	identifier
		ifNil: [identifier _ UUID new].
	^ identifier! !

!MorphExtension methodsFor: '*NetMorph-override-other' stamp: 'mu 12/11/2003 23:41'!
isDefault
	"In NetMorph,  allways returns false."
	"Return true if the receiver is a default and can be omitted"
	locked == true
		ifTrue: [^ false].
	visible == false
		ifTrue: [^ false].
	sticky == true
		ifTrue: [^ false].
	balloonText isNil
		ifFalse: [^ false].
	balloonTextSelector isNil
		ifFalse: [^ false].
	externalName isNil
		ifFalse: [^ false].
	isPartsDonor == true
		ifTrue: [^ false].
	actorState isNil
		ifFalse: [^ false].
	player isNil
		ifFalse: [^ false].
	eventHandler isNil
		ifFalse: [^ false].
	self hasOtherProperties
		ifTrue: [self otherProperties isEmpty
				ifFalse: [^ false]].
	^ false! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 8/7/2005 18:42'!
path
	path
		ifNil: [path := OrderedCollection new.
			path addLast: NmWorldMap localEntry asDeferredUpdate].
	^ path! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: 'mu 7/13/2005 18:32'!
pathNames
	^self path collect:[:each | each destination]! !

!MorphExtension methodsFor: '*NetMorph-accessing' stamp: ''!
path: visitedLocationCollection 
	path _ visitedLocationCollection! !

!MorphExtension methodsFor: '*NetMorph-initialize' stamp: 'mu 7/9/2005 17:40'!
resetIdAndPath
	identifier _ UUID new.
	path _ nil.! !

!MorphExtension methodsFor: '*NetMorph-initialize' stamp: 'kuri-t 1/15/2003 12:13'!
resetIdentifier
	identifier _ nil! !

!MorphExtension methodsFor: '*NetMorph-copying' stamp: ''!
veryDeepCopyWith: deepCopier 
	| newObject |
	newObject _ super veryDeepCopyWith: deepCopier.
	newObject instVarNamed: 'identifier' put: UUID new.
	^ newObject! !

!MorphExtension methodsFor: '*NetMorph-override-copying' stamp: ''!
veryDeepInner: deepCopier
	| list values vv |
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  This is special code for the dictionary.  See DeepCopier."

	super veryDeepInner: deepCopier.
	locked _ locked veryDeepCopyWith: deepCopier.
 	visible _ visible veryDeepCopyWith: deepCopier.
 	sticky _ sticky veryDeepCopyWith: deepCopier.
 	balloonText _ balloonText veryDeepCopyWith: deepCopier.
 	balloonTextSelector _ balloonTextSelector veryDeepCopyWith: deepCopier.
 	externalName _ externalName veryDeepCopyWith: deepCopier.
 	isPartsDonor _ isPartsDonor veryDeepCopyWith: deepCopier.
 	actorState _ actorState veryDeepCopyWith: deepCopier.
 	player _ player veryDeepCopyWith: deepCopier.	"Do copy the player of this morph"
 	eventHandler _ eventHandler veryDeepCopyWith: deepCopier.	"has its own restrictions"
 	path _ path veryDeepCopyWith: deepCopier.
 	identifier _ identifier veryDeepCopyWith: deepCopier.

	otherProperties ifNotNil: [
		otherProperties _ otherProperties copy.
		list _ self copyWeakly.	"Properties whose values are only copied weakly"
		values _ list collect: [:pp | 
			vv _ otherProperties at: pp ifAbsent: [nil].
			vv ifNotNil: [otherProperties at: pp put: nil]. "zap it"
			vv].
	 	otherProperties _ otherProperties veryDeepCopyWith: deepCopier.
		1 to: list size do: [:ii | "put old values back"
			(values at: ii) ifNotNil: [otherProperties at: (list at: ii) put: (values at: ii)]]].
! !

RectangleMorph subclass: #NmControlPanelMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Client'!

!NmControlPanelMorph class methodsFor: 'interface opening' stamp: 'mu 7/25/2005 01:19'!
open
	"NmControlPanelMorph open"	
	^self new openInWorld! !

!NmControlPanelMorph methodsFor: 'dropping/grabbing' stamp: 'mu 6/21/2005 18:17'!
aboutToBeGrabbedBy: aHand 
	^nil! !

!NmControlPanelMorph methodsFor: 'constants' stamp: 'mu 6/19/2005 00:35'!
defaultColor
	^  (TranslucentColor r: 0.161 g: 0.839 b: 0.742 alpha: 0.298)! !

!NmControlPanelMorph methodsFor: 'initialize-release' stamp: 'mu 6/19/2005 00:33'!
initColor
	self borderColor: self color darker
	
	! !

!NmControlPanelMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 06:57'!
initialize
	super initialize.
	self initLayout.
	self initColor.
	
	self addMorphFront: (NmProjectPublishButtonMorph new)! !

!NmControlPanelMorph methodsFor: 'initialize-release' stamp: 'mu 6/19/2005 00:38'!
initLayout
	self changeTableLayout.
	self listDirection: #leftToRight.
	self wrapCentering: #center.
	self listCentering: #center.
	self layoutInset: 5@15.
	self cellInset: 3.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.

	self useRoundedCorners
	
	! !

!NmControlPanelMorph methodsFor: 'dropping/grabbing' stamp: 'mu 6/19/2005 08:36'!
slideToTrash: evt 
	| flapTab partsBin found |
	flapTab _ NmFlapSetup netMorphFlapTab.
	flapTab
		ifNil: [^ super slideToTrash: evt].
	partsBin _ flapTab referent.
	partsBin
		ifNil: [^ super slideToTrash: evt].
	found _ partsBin submorphs
				detect: [:each | each class = self class]
				ifNone: [].
	found
		ifNil: [partsBin addMorphFront: self]
		ifNotNil: [super slideToTrash: evt]! !

RectangleMorph subclass: #NmMarkerMorph
	instanceVariableNames: 'targetMorphIdentifier uuid textMorph isLost createdTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Marker'!

!NmMarkerMorph class methodsFor: 'instance creation' stamp: 'mu 7/30/2005 03:51'!
on: aMorph
	| inst |
	inst := self new.
	inst targetMorphIdentifier: aMorph topRendererOrSelf identifier.
	inst label: aMorph externalName.
	inst addMorph: (ThumbnailMorph new objectToView: aMorph).
	^inst! !

!NmMarkerMorph methodsFor: 'menu' stamp: 'mu 7/23/2005 23:40'!
addCustomMenuItems: aCustomMenu hand: aHandMorph 
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self addMenuItemsOn: aCustomMenu! !

!NmMarkerMorph methodsFor: 'menu' stamp: 'mu 8/2/2005 08:04'!
addMenuItemsOn: aMenu 
	self isLost
		ifTrue: [aMenu add: 'delete' translated action: #delete]
		ifFalse: [aMenu addLine.
			aMenu add: 'bring the morph back' translated action: #bringMorphHome.
			aMenu add: 'where it is?' translated action: #showLocationInMap.
			aMenu add: 'show identifier' translated action: #showIdentifier.
			aMenu add: 'perform' translated action: #remotePerform]! !

!NmMarkerMorph methodsFor: 'actions-menu' stamp: 'mu 8/2/2005 07:52'!
bringMorphHome
	| morph |
	Cursor execute showWhile: [morph := self morphOf: self targetMorphIdentifier.].
	morph isNil
		ifTrue: [self warnNotFound]
		ifFalse: [| localIpAndPort | 
			localIpAndPort := self worldMap localIpAndPortArray.
			localIpAndPort
				ifNil: [^ self inform: 'No local info' translated].
			morph afterWarpActions:  #(#zoomIn).
			morph
				warp: localIpAndPort first
				port: localIpAndPort second
				x: ActiveHand position x
				y: ActiveHand position y.
			self morphFound]! !

!NmMarkerMorph methodsFor: 'accessing' stamp: 'mu 7/27/2005 21:16'!
createdTime
	^createdTime! !

!NmMarkerMorph methodsFor: 'constants' stamp: 'MU 12/28/2002 00:58'!
defaultHeight
	^ 20! !

!NmMarkerMorph methodsFor: 'constants' stamp: 'MU 12/28/2002 00:58'!
defaultWidth
	^ 40! !

!NmMarkerMorph methodsFor: 'event handling' stamp: 'mu 6/13/2004 00:24'!
handlesMouseDown: evt
	^ evt yellowButtonPressed.! !

!NmMarkerMorph methodsFor: 'event handling' stamp: 'mu 6/13/2004 00:19'!
handlesMouseOver: evt
	^ true.! !

!NmMarkerMorph methodsFor: 'initialization' stamp: 'mu 7/27/2005 21:16'!
initialize
	super initialize.
	self rememberCreatedTime.
	textMorph _ TextMorph new contents: '       '.
	textMorph centered.
	textMorph borderWidth: 4.
	textMorph borderColor: Color transparent.
	textMorph width: self defaultWidth.
	textMorph lock.
	self addMorphCentered: textMorph;
		 clipSubmorphs: true;
		 setBorderStyle: #complexAltInset.
	self color: Color random lighter;
		 width: self defaultWidth;
		 height: self defaultHeight.
	self changeTableLayout;
		listDirection: #leftToRight;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap. 
	! !

!NmMarkerMorph methodsFor: 'accessing' stamp: 'mu 7/23/2005 23:35'!
isLost
	isLost ifNil: [isLost _ false].
	^isLost! !

!NmMarkerMorph methodsFor: 'accessing' stamp: 'mu 7/23/2005 23:35'!
isLost: aBoolean
	isLost _ aBoolean == true! !

!NmMarkerMorph methodsFor: 'actions' stamp: 'mu 7/30/2005 03:12'!
label: aString
	[textMorph contents: aString asString.
	self width: textMorph width] fork.
	! !

!NmMarkerMorph methodsFor: 'accessing' stamp: 'mu 7/28/2005 22:57'!
morph
	^self morphOf: self targetMorphIdentifier! !

!NmMarkerMorph methodsFor: 'private' stamp: 'mu 8/2/2005 08:00'!
morphFound
	| targetMorph |
	targetMorph := self morph.
	targetMorph ifNil: [^ self morphNotFound].
	self borderColor: #complexAltInset.
	targetMorph warnIfPingFailed.
	self setName: targetMorph externalName. 
	self thumbnailMorph
		ifNotNilDo: [:thum | thum releaseCachedState; objectToView: targetMorph imageFormForThumbnail].
	self isLost: false! !

!NmMarkerMorph methodsFor: 'private' stamp: 'mu 7/28/2005 23:29'!
morphNotFound
	self borderColor: Color red.
	self setName: 'Lost!!' translated.
	self name: '00000000__LOST'. "To be first"
	self isLost: true! !

!NmMarkerMorph methodsFor: 'actions' stamp: 'mu 8/2/2005 08:01'!
morphPerform: selector
	^self morphPerform: selector withArguments: #()! !

!NmMarkerMorph methodsFor: 'actions' stamp: 'mu 8/2/2005 08:00'!
morphPerform: selector withArguments: args
	| target |
	target := self morph.
	target ifNil: [^self warnNotFound].
	target warnIfPingFailed.
	^target perform: selector  withArguments: args! !

!NmMarkerMorph methodsFor: 'actions' stamp: 'mu 8/2/2005 08:01'!
morphPerform: selector with: arg
	^self morphPerform: selector withArguments: {arg}! !

!NmMarkerMorph methodsFor: 'actions' stamp: 'mu 8/2/2005 08:01'!
morphPerform: selector with: arg with: arg2
	^self morphPerform: selector withArguments: {arg. arg2}! !

!NmMarkerMorph methodsFor: 'actions' stamp: 'mu 8/2/2005 08:02'!
morphPerform: selector with: arg with: arg2 with: arg3
	^self morphPerform: selector withArguments: {arg. arg2. arg3}! !

!NmMarkerMorph methodsFor: 'event handling' stamp: 'mu 6/13/2004 00:24'!
mouseDown: evt 
	evt yellowButtonPressed
		ifTrue: [self popupYellowButtonMenu: evt]
		! !

!NmMarkerMorph methodsFor: 'event handling' stamp: 'mu 7/28/2005 22:57'!
mouseEnter: evt 
	
	self showBalloon: self targetMorphIdentifier asString! !

!NmMarkerMorph methodsFor: 'menu' stamp: 'mu 7/23/2005 23:40'!
popupYellowButtonMenu: evt 
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	self addMenuItemsOn: menu.
	menu popUpInWorld! !

!NmMarkerMorph methodsFor: 'private' stamp: 'mu 7/28/2005 02:51'!
rememberCreatedTime
	createdTime _ Time millisecondClockValue

 
 ! !

!NmMarkerMorph methodsFor: 'actions-menu' stamp: 'mu 8/2/2005 08:15'!
remotePerform
	| selector ret |
	selector := FillInTheBlank request: 'Enter selector' initialAnswer: 'address'.
	selector ifNil: [^self].
	ret := self morphPerform: selector asSymbol.
	ret isProxy ifFalse: [ret inspect]! !

!NmMarkerMorph methodsFor: 'private' stamp: 'mu 7/28/2005 23:26'!
setName: aSring
	self label: aSring.
	self name: aSring
	! !

!NmMarkerMorph methodsFor: 'actions-menu' stamp: 'mu 7/28/2005 22:57'!
showIdentifier
	| identifier stringMorph |
	identifier _ self targetMorphIdentifier asString.
	stringMorph _ StringMorph contents: identifier.
	stringMorph name: identifier.
	ActiveHand attachMorph: stringMorph! !

!NmMarkerMorph methodsFor: 'actions-menu' stamp: 'mu 8/2/2005 09:38'!
showLocationInMap
	| worldMapMorph target |
	worldMapMorph := NmWorldMapMorph openSingleOn: NmWorldMap default.
	[target := self morph.
	target ifNil: [self warnNotFound].
	target warnIfPingFailed.
	(Delay forMilliseconds: 500) wait.
	worldMapMorph showLocationOf: target.] fork! !

!NmMarkerMorph methodsFor: 'stepping' stamp: 'mu 7/30/2005 03:17'!
step
	"default do nothing"
	[self morph
		ifNil: [self morphNotFound]
		ifNotNil: [self morphFound]]
		forkAt: Processor userBackgroundPriority! !

!NmMarkerMorph methodsFor: 'stepping' stamp: 'mu 7/23/2005 22:46'!
stepTime
	^10000! !

!NmMarkerMorph methodsFor: 'accessing' stamp: 'mu 7/28/2005 22:58'!
targetMorphIdentifier
	^targetMorphIdentifier! !

!NmMarkerMorph methodsFor: 'accessing' stamp: 'mu 7/28/2005 22:58'!
targetMorphIdentifier: anUuid
	targetMorphIdentifier _ anUuid! !

!NmMarkerMorph methodsFor: 'accessing' stamp: 'mu 7/23/2005 22:47'!
thumbnailMorph
	^self findA: ThumbnailMorph! !

!NmMarkerMorph methodsFor: 'private' stamp: 'mu 8/2/2005 07:51'!
warnNotFound
	NmShortMessageMorph contents: 'Morph(' , self targetMorphIdentifier asString , ') is not found' translated for: self.
	self morphNotFound! !

!NmMarkerMorph methodsFor: 'comparing' stamp: 'mu 7/28/2005 22:54'!
= aNmMarkerMorph
	self class = aNmMarkerMorph class ifFalse: [^false].
	^self targetMorphIdentifier = aNmMarkerMorph targetMorphIdentifier! !

RectangleMorph subclass: #NmProjectPageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectPageMorph methodsFor: 'accessing' stamp: 'mu 7/14/2005 22:27'!
cellMorphs
	^self submorphs select: [:each | each isKindOf: NmProjectCellMorph]! !

!NmProjectPageMorph methodsFor: 'constants' stamp: 'mu 6/21/2005 15:13'!
defaultColor
	^  (TranslucentColor r: 0.161 g: 0.839 b: 0.742 alpha: 0.298)! !

!NmProjectPageMorph methodsFor: 'user interface' stamp: 'mu 6/21/2005 17:06'!
defaultLabelForInspector
	^self knownName! !

!NmProjectPageMorph methodsFor: 'layout' stamp: 'mu 7/15/2005 15:13'!
fixExtent: maxExtent
	| recommendedExtent max |
	self cellMorphs isEmpty
		ifTrue: [^ self].
	max _ (self cellMorphs collect: [:each | each formExtent]) max.
	recommendedExtent _ max min: maxExtent.
	self cellMorphs
		do: [:each | each scaledToSize: recommendedExtent].
	! !

!NmProjectPageMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 16:50'!
initialize
	super initialize.
	self initLayout.
	
	self setNameTo: 'Projects'.
	self borderColor: self color darker.
	! !

!NmProjectPageMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 16:49'!
initLayout
	self changeTableLayout;
		listDirection: #leftToRight;
		wrapCentering: #topLeft;
		wrapDirection: #topToBottom;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap.
	self layoutInset: 5@5.
	self cellInset: 3.
	
	self useRoundedCorners
		! !

!NmProjectPageMorph methodsFor: 'initialize-release' stamp: 'mu 7/16/2005 21:00'!
initSubmorphsFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString
	| projNames cells |
	projNames _ [self loader getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString] on: NmProjectSortFailed do: [:ex | self inform: ex messageText, ' sort failed' translated. ^self].
	cells _ OrderedCollection new.
	projNames
		do: [:each | 
			| form cellMorph | 
			form _ self loader getProjectThumbnailForm: each.
			cellMorph _ NmProjectCellMorph form: form label: each.
			cellMorph setBalloonText: (self loader detailedInfoTextFor: each).
			cells add: cellMorph].
	self removeAllMorphs.
	cells
		do: [:each | 
			self addMorphBack: each.
			each initTarget].
	cells size > 0 ifTrue: [self extent: 10000 @ 10000].
	self layoutChanged! !

!NmProjectPageMorph methodsFor: 'testing' stamp: 'mu 6/21/2005 16:01'!
isWarpable
	^false! !

!NmProjectPageMorph methodsFor: 'layout' stamp: 'mu 7/15/2005 15:33'!
layoutChanged
	super layoutChanged.
	self fixExtent: (ActiveWorld extent // 6).
	! !

!NmProjectPageMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:35'!
loader
	| parent |
	parent _ (self ownerThatIsA: NmProjectBookMorph) ifNil: [^nil].
	^parent loader! !

RectangleMorph subclass: #NmWorldMapEntryMorph
	instanceVariableNames: 'textMorph exists mapEntry oldDest locker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapEntryMorph class methodsFor: 'scripting' stamp: 'ns 9/17/2002 15:49'!
additionsToViewerCategories
	^ #(#additionsToViewerCategoryBasic #additionsToViewerCategoryScripts #additionsToViewerCategoryColorAndBorder #additionsToViewerCategoryGeometry #additionsToViewerCategoryMiscellaneous #additionsToViewerCategoryButton #additionsToViewerCategoryMotion #additionsToViewerCategoryObservation #additionsToViewerCategoryPenUse #additionsToViewerCategoryLayout #additionsToViewerCategoryDragAndDrop #additionsToViewerCategoryScripting #additionsToViewerCategoryTests #additionsToViewerCategoryNmUrl )
		select: [:aSelector | self respondsTo: aSelector]
		thenCollect: [:aSelector | self perform: aSelector]! !

!NmWorldMapEntryMorph class methodsFor: 'scripting' stamp: 'mu 4/12/2003 19:38'!
additionsToViewerCategoryNmUrl
	"Answer viewer additions for the 'URL' category"

	^#(
		URL 
		(
"			(slot url 'url' String	readWrite Player getUrl Player setUrl:)"
			(slot host 'host' String	readWrite Player getAuthority Player setAuthority:)
"			(slot path 'path' String	readWrite Player getPath Player setPath:)"
			(slot port 'port' Number readWrite Player getPort Player  setPort:)
			(slot ipAddress 'ip address' String readOnly Player getIpAddress unused  unused)
		)
	)
! !

!NmWorldMapEntryMorph class methodsFor: 'scripting' stamp: 'mu 4/12/2003 19:39'!
additionsToViewerCategoryNmUrlDeluxe
	"Answer viewer additions for the 'URL' category"

	^#(
		URL 
		(
			(slot url 'url' String	readWrite Player getUrl Player setUrl:)
			(slot fragment 'fragment' String	readWrite Player getFragment Player setFragment:)
			(slot scheme 'scheme' String	readWrite Player getScheme Player setScheme:)
			(slot host 'host' String	readWrite Player getAuthority Player setAuthority:)
			(slot path 'path' String	readWrite Player getPath Player setPath:)
			(slot query 'query' String	readWrite Player getQuery Player setQuery:)
			(slot port 'port' Number readWrite Player getPort Player  setPort:)
			(slot realm 'realm' String	readWrite Player getRealm Player setRealm:)
		)
	)
! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 1/14/2005 02:02'!
defaultCellHeight
	^ 50! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 4/29/2005 19:33'!
defaultCellWidth
	^ 81! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:20'!
defaultColor
	^ Color white darker! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:00'!
defaultEditedColor
	^ Color red! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:19'!
defaultExistsColor
	^ Color tan! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:37'!
defaultLocalColor
	^ Color cyan! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultMapColor
	^ Color lightGray! !

!NmWorldMapEntryMorph class methodsFor: 'constants' stamp: 'mu 3/16/2005 01:37'!
defaultVacantColor
	^ Color darkGray! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 7/23/2005 22:24'!
acceptDroppingMorph: morphToDrop event: evt 

	| formerOwner formerPosition |
	formerOwner _ morphToDrop formerOwner.
	formerPosition _ morphToDrop formerPosition.
	
	self frenchDoorOpen.
	morphToDrop beforeWarpActions:  #(#zoomOut).
	morphToDrop afterWarpActions:  #(#zoomIn).
	morphToDrop
		warp: self ip
		port: self port
		x: morphToDrop topLeft x
		y: morphToDrop topLeft y
		onError: [:ex | 
			morphToDrop handleWarpError: ex.
			morphToDrop formerOwner: formerOwner.
			morphToDrop formerPosition: formerPosition.
			morphToDrop rejectDropMorphEvent: evt]! !

!NmWorldMapEntryMorph methodsFor: 'menu' stamp: 'mu 7/23/2005 23:49'!
addProjectMenuItemsTo: aMenu 
	| book numberOfProjects |
	book _ NmProjectBookMorph on: self.
	numberOfProjects _ book numberOfProjects.
	numberOfProjects = 0 ifTrue: [^self].
	aMenu add: 'load remote project...' translated target: book action: #openInHand! !

!NmWorldMapEntryMorph methodsFor: 'actions' stamp: 'mu 8/2/2005 09:36'!
blink
	self fillStyle: self blinkFillStyle.
	[(Delay forSeconds: 1) wait.
	self fillStyle: self defaultFillStyle] fork! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'mu 8/2/2005 09:18'!
blinkFillStyle
	| fill |
	fill := GradientFillStyle ramp: {0.0 -> (Color r: 1.0 g: 0.909 b: 0.544). 1.0
					-> ( (Color r: 1.0 g: 0.819 b: 0.09))}.
	fill origin: self bounds topLeft + (14 @ 10).
	fill direction: 30 @ 6.
	fill radial: false.
	^ fill! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 4/10/2005 01:59'!
computeColor
	| col |
	self exists ifFalse: [^self class defaultVacantColor].
	col _ self isLocal
				ifTrue: [self class defaultLocalColor]
				ifFalse: [self class defaultExistsColor].
	self hasChanged
		ifTrue: [col _ self class defaultEditedColor].
	^ col! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 7/6/2005 02:41'!
computeDestinationFrom: dest 
	oldDest = dest
		ifTrue: [^ self destinationLabelFrom: oldDest].
	oldDest _ dest.
	dest isNmUrlString
		ifTrue: [| url ip port | 
			url _ dest asNmUrl.
			ip _ url parsedIp.
			port _ url port.
			self mapEntry
				ifNotNilDo: [:ent | ip ifNotNil: [ent ip: ip].
						 ent port: port asNumber]].
	^ self destinationLabelFrom: dest! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'mu 1/14/2005 01:39'!
defaultCellHeight
	^ self class defaultCellHeight! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultCellWidth
	^ self class defaultCellWidth! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:22'!
defaultColor
	^ self class defaultColor! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultExistsColor
	^ self class defaultExistsColor! !

!NmWorldMapEntryMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 02:06'!
defaultFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0 -> Color white. 1.0
					-> (Color
							r: 0.86
							g: 0.86
							b: 0.86)}.
	fill origin: self bounds topLeft + (14 @ 10).
	fill direction: 30 @ 6.
	fill radial: false.
	^ fill! !

!NmWorldMapEntryMorph methodsFor: 'describing state' stamp: 'mu 1/23/2005 05:07'!
descriptionString
	 self mapEntry ifNil: [^'<NO_ENTRY>'].
	^ self mapEntry descriptionString! !

!NmWorldMapEntryMorph methodsFor: 'actions' stamp: 'mu 1/9/2005 01:40'!
destination
	^ mapEntry isNil
		ifTrue: ['']
		ifFalse: [mapEntry destination]! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 1/21/2005 23:45'!
destinationLabelFrom: destString 
	| destStr label |
	destStr _ destString asString.
	label _ (destStr beginsWith: NmUrl protocolIdentifier)
				ifTrue: [| tailIndex | 
					tailIndex _ ((destStr endsWith: '/')
								ifTrue: [destStr size - 1]
								ifFalse: [destStr size])
								max: NmUrl protocolIdentifier size.
					destStr _ destStr copyFrom: NmUrl protocolIdentifier size + 1 to: tailIndex]
				ifFalse: [destStr].
	^ label copyReplaceAll: ':' with: String cr! !

!NmWorldMapEntryMorph methodsFor: 'testing' stamp: 'mu 1/9/2005 01:34'!
exists
	^ mapEntry notNil! !

!NmWorldMapEntryMorph methodsFor: 'event handling' stamp: 'mu 1/7/2005 01:49'!
handlesMouseDown: evt
	evt shiftPressed ifTrue: [^true].
	evt yellowButtonPressed ifTrue: [^true].
	^super handlesMouseDown: evt! !

!NmWorldMapEntryMorph methodsFor: 'testing' stamp: 'mu 1/21/2005 23:26'!
hasChanged
	^ self mapEntry
		ifNil: [false]
		ifNotNil: [self mapEntry hasChanged]! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/9/2005 01:23'!
host
	mapEntry isNil ifTrue: [^nil].
	^ NetNameResolver
		nameForAddress: (NetNameResolver addressFromString: mapEntry ip)
		timeout: 30! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/15/2005 01:34'!
id
	mapEntry isNil ifTrue: [^''].
	^ mapEntry id! !

!NmWorldMapEntryMorph methodsFor: 'initialization' stamp: 'mu 6/3/2005 02:08'!
initialize
	super initialize.
	textMorph _ TextMorph new.
	textMorph centered.
	textMorph borderColor: Color transparent.
	textMorph width: self defaultCellWidth.
	textMorph fillStyle: self defaultFillStyle.
	textMorph lock.
	self addMorphCentered: textMorph;
		 clipSubmorphs: true;
		 borderWidth: 2;
		 setBorderStyle: #complexAltInset.
	self width: self defaultCellWidth.
	self fillStyle: self defaultFillStyle.
	self text: ''! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/7/2005 01:47'!
ip
	mapEntry isNil ifTrue: [^''].
	^ mapEntry ip! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 8/18/2005 11:10'!
isBadLocalUrlName: aString 
	^ aString isAddressString
		and: [(aString asNmUrl hostOrIpEquals: NmUrl local) not]! !

!NmWorldMapEntryMorph methodsFor: 'testing' stamp: 'mu 1/9/2005 01:21'!
isLocal
	mapEntry isNil ifTrue: [^false].
	^mapEntry isLocal! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/10/2005 02:54'!
justDroppedInto: aMorph event: anEvent
	super justDroppedInto: aMorph event: anEvent.
	locker notNil
		ifTrue: [self myLockerMap ifNotNilDo: [:lo | lo unlockWith: locker]]! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/10/2005 02:54'!
justGrabbedFrom: formerOwner
	super justGrabbedFrom: formerOwner.
	locker _ self myLockerMap ifNotNilDo: [:lo | lo lock].
	! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/7/2005 01:47'!
mapEntry
	^mapEntry! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/7/2005 01:47'!
mapEntry: aNmMapEntry
	mapEntry _ aNmMapEntry! !

!NmWorldMapEntryMorph methodsFor: 'event handling' stamp: 'mu 1/7/2005 01:49'!
mouseDown: evt 
	evt yellowButtonPressed ifTrue: [^self popupYellowButtonMenu: evt].
	self requestDestination
	! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 5/10/2005 02:51'!
myLockerMap
	^self worldMapMorph ifNotNilDo: [:mo | mo worldMap]! !

!NmWorldMapEntryMorph methodsFor: 'actions' stamp: 'mu 3/8/2005 00:50'!
point
	mapEntry isNil ifTrue: [^0@0].
	^ mapEntry point! !

!NmWorldMapEntryMorph methodsFor: 'menu' stamp: 'mu 7/23/2005 00:58'!
popupYellowButtonMenu: evt 
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	((self isLocal not
				and: [NmWorldMap localEntry isNil])
			and: [NmServerManager isMapServerOnlyImage not])
		ifTrue: [menu add: 'set as local' translated action: #setAsLocal].
	self exists
		ifTrue: [NmServerManager isMapServerOnlyImage
				ifFalse: [menu add: 'set destination name' translated action: #requestDestination.
					menu addLine].
			menu add: 'take a picture' translated action: #takeAPicture.
			self addProjectMenuItemsTo: menu].
	menu popUpInWorld! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/15/2005 02:35'!
port
	mapEntry isNil ifTrue: [^0].
	^ mapEntry port asNumber! !

!NmWorldMapEntryMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/10/2005 02:44'!
privateDelete
	super privateDelete.
	mapEntry removeDependent: self.! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/10/2005 02:54'!
rejectDropMorphEvent: evt 
	super rejectDropMorphEvent: evt.
	locker notNil
		ifTrue: [self myLockerMap ifNotNilDo: [:lo | lo unlockWith: locker]]! !

!NmWorldMapEntryMorph methodsFor: 'menu-actions' stamp: 'mu 8/22/2005 11:46'!
requestDestination
	| isLocal point ans originalEntry tmpEntry|
	isLocal := self isLocal.
	point := self point.
	ans := FillInTheBlank request: 'Enter a new destination name (any string)' initialAnswer: ''.
	ans isEmpty
		ifTrue: [^ self].
	(isLocal
			and: [self isBadLocalUrlName: ans])
		ifTrue: [^ PopUpMenu inform: 'The url does not match your local host and port' translated].
	(isLocal not
			and: [ans asUrl = NmUrl local])
		ifTrue: [^ PopUpMenu inform: 'Cannot set local url to remote' translated].
	((NmWorldMap default worldNamesExcluding: point)
			includes: ans)
		ifTrue: [^ PopUpMenu inform: 'Duplicate name' translated].
	originalEntry := self mapEntry.
	tmpEntry := originalEntry copy.
	self setEntry: tmpEntry.
	tmpEntry name: ans.
	(isLocal
			and: [originalEntry destination ~= tmpEntry destination])
		ifTrue: [(PopUpMenu confirm: 'Local name changed. Store now?' translated)
				ifTrue: [
					originalEntry name: tmpEntry name.
					self setEntry: originalEntry.
					self worldMapMorph
						ifNotNilDo: [:wmm | wmm store]]]! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 3/16/2005 01:13'!
resetBorderColor
	self borderColor: self computeColor! !

!NmWorldMapEntryMorph methodsFor: 'private' stamp: 'mu 3/16/2005 02:02'!
resetColor
	| col |
	col _ self computeColor.
	self borderColor: col.
	self exists
		ifFalse: [self color: col]! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 3/8/2005 00:34'!
rowMorph
	^ (self owner isMemberOf: NmWorldMapRowMorph)
		ifTrue: [self owner]! !

!NmWorldMapEntryMorph methodsFor: 'menu-actions' stamp: 'mu 1/15/2005 02:13'!
setAsLocal
	| newId |
	newId _ self id.
	newId isEmpty
		ifFalse: [NmWorldMap default resetLocalTo: newId]! !

!NmWorldMapEntryMorph methodsFor: 'actions' stamp: 'mu 5/13/2005 20:32'!
setEntry: aNmMapEntry 
	| destStr oldMapEntry |
	aNmMapEntry isNil
		ifTrue: [^ self].
	destStr _ aNmMapEntry destination asString.
	self name: destStr.
	aNmMapEntry removeDependent: self.
	aNmMapEntry addDependent: self.
	oldMapEntry _ mapEntry.
	self mapEntry: aNmMapEntry.
	oldMapEntry isNil
		ifTrue: [self update: aNmMapEntry]! !

!NmWorldMapEntryMorph methodsFor: 'stepping' stamp: 'mu 7/12/2005 21:31'!
step
	self text: self destination.
	self resetColor! !

!NmWorldMapEntryMorph methodsFor: 'stepping' stamp: 'mu 7/12/2005 21:33'!
stepTime
	^1200! !

!NmWorldMapEntryMorph methodsFor: 'menu-actions' stamp: 'mu 7/23/2005 00:36'!
takeAPicture
	| connector form morph |
	[connector _ NmRemoteConnector connect: self ip port: self port.
	form _ connector callTakeAPicture: NmBaseSettings pictureShrunkBySize.
	morph _SketchMorph withForm: form.
	morph addDropShadow.
	morph shadowColor: Color gray.
	morph  openInHand]
		on: RmtNetworkError
		do: [:ex | NmShortMessageMorph contents: ex messageText for: self]! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 13:50'!
text
	^ textMorph contents asString! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 3/2/2005 00:57'!
text: destinationString 
	| dest |
	dest _ self computeDestinationFrom: destinationString asString.
	textMorph contents: dest.
	self
		extent: (textMorph extent + (borderWidth + 3) max: self defaultCellWidth @ self defaultCellHeight).
	textMorph position: bounds center - (textMorph extent // 2).
	textMorph lock.
	self setBalloonText: dest.
	self name: destinationString asString! !

!NmWorldMapEntryMorph methodsFor: 'updating' stamp: 'mu 4/28/2005 22:36'!
update: anObject 
	(anObject isMemberOf: NmWorldMapEntry)
		ifTrue: [self resetColor.
			self rowMorph
				ifNotNilDo: [:row | row update: anObject]]! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 1/9/2005 01:25'!
url
	mapEntry isNil ifTrue: [^nil].
	^mapEntry destination asUrl! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 6/21/2005 16:08'!
wantsDroppedMorph: aMorph event: evt
	aMorph isWarpable ifFalse: [^false].
	(aMorph isKindOf: NmWorldMapRowMorph) ifTrue: [^false].
	^(aMorph isKindOf: self class) not
	
	! !

!NmWorldMapEntryMorph methodsFor: 'dropping/grabbing' stamp: 'mu 4/15/2003 03:02'!
wantsToBeDroppedInto: aMorph 
	^(aMorph isKindOf: NmWorldMapRowMorph) or: [aMorph isKindOf: TrashCanMorph]
		! !

!NmWorldMapEntryMorph methodsFor: 'accessing' stamp: 'mu 4/26/2005 02:00'!
worldMapMorph
	^self ownerThatIsA: NmWorldMapMorph! !

!EToyProjectDetailsMorph methodsFor: '*NetMorph-actions' stamp: 'mu 6/18/2005 23:43'!
doCancel
	super doCancel.
	self project world setProperty: #NetMorph:ProjectPublishCancel toValue: true.! !

!EToyProjectDetailsMorph methodsFor: '*NetMorph-accessing' stamp: 'mu 6/18/2005 23:38'!
project
	^theProject! !

!SystemWindow methodsFor: '*NetMorph-override-events' stamp: 'mu 1/2/2003 21:31'!
mouseDown: evt

	self stopKeepMoving.
	self setProperty: #clickPoint toValue: evt cursorPoint.
	TopWindow == self ifFalse:
		[evt hand releaseKeyboardFocus.
		self activate].
	model windowActiveOnFirstClick ifTrue:
		["Normally window keeps control of first click.
		Need explicit transmission for first-click activity."
		submorphs do: [:m | (m containsPoint: evt cursorPoint) ifTrue: [m mouseDown: evt]]]

! !

!SystemWindow methodsFor: '*NetMorph-private' stamp: 'KY 1/18/2004 17:11'!
restoreAttributesAfterWarp
	(self hasProperty: #projectWindow)
		ifTrue: [| projViewMorph | 
			projViewMorph _ self findA: ProjectViewMorph.
			projViewMorph restoreAttributesAfterWarp.
			self model: projViewMorph project]! !

!SystemWindow methodsFor: '*NetMorph-private' stamp: 'KY 1/18/2004 17:10'!
trimAttributesBeforeWarp
	(self hasProperty: #projectWindow)
		ifTrue: [(self findA: ProjectViewMorph) trimAttributesBeforeWarp.
			self model: nil]! !

!StandardScriptingSystem methodsFor: '*NetMorph-override-font & color choices' stamp: 'mu 12/13/2004 00:24'!
statusColorSymbolFor: statusSymbol
	#(	(normal					green)
		(ticking					blue)
		(paused					red)
		(mouseDown				yellow)
		(mouseStillDown			lightYellow)
		(mouseUp				lightBlue)
		(mouseEnter				lightBrown)
		(mouseLeave			lightRed)
		(mouseEnterDragging	lightGray)
		(mouseLeaveDragging	darkGray)
		(keyStroke				lightGreen)
		(warpingOut			magenta)
		(warpedIn				magenta)
		) do:

			[:pair | statusSymbol == pair first ifTrue: [^ pair second]].

		^ #blue! !

!StandardScriptingSystem methodsFor: '*NetMorph-override-utilities' stamp: 'mu 12/13/2004 00:27'!
wordingForOperator: aString
	"Answer the wording to be seen by the user for the given operator symbol/string"

	| toTest |
	toTest _ aString asString.
	#(	(append:				'include at end')
		(arrowheadsOnAllPens	'arrowheads on all pens')
		(beep:					'make sound')
		(bounce:				'bounce')
		(clearTurtleTrails		'clear pen trails')
		(clearOwnersPenTrails	'clear all pen trails')
		(colorSees				'color  sees')
		(color:sees:				'color sees')
		(doMenuItem:			'do menu item')
		(doScript:				'do')
		(forward:				'forward by')
		(goToRightOf:			'align after')
		(includeAtCursor:		'include at cursor')
		(isDivisibleBy:			'is divisible by')
		(liftAllPens				'lift all pens')
		(lowerAllPens			'lower all pens')
		(makeNewDrawingIn:	'start painting in')
		(max:					'max')
		(min:					'min')
		(moveToward:			'move toward')
		(noArrowheadsOnAllPens	'no arrowheads on pens')
		(overlapsAny			'overlaps any')
		(pauseAll:				'pause all')
		(pauseScript:			'pause script')
		(prepend:				'include at beginning')
		(seesColor:				'is over color')
		(startAll:				'start all')
		(startScript:				'start script')
		(stopProgramatically	'stop')
		(stopAll:					'stop all')
		(stopScript:				'stop script')
		(tellAllSiblings:			'tell all siblings')
		(tellSelfAndAllSiblings:	'send to all')
		(turn:					'turn by')
		(turnToward:				'turn toward')
		(wearCostumeOf:		'look like')
			
		"NetMorph"
		(warp:					'warp')
		(warpTo:				'warp to')
		(isTouched				'near to')
		(head:					'head')
		(effects:				'effect'))

	do:
		[:pair | toTest = pair first ifTrue: [^ pair second]].

	^ toTest

	"StandardScriptingSystem initialize"

! !

!Viewer methodsFor: '*NetMorph-special phrases' stamp: 'kuri-t 12/13/2002 14:11'!
nearToPhrase
	"Answer a conjured-up nearTo phrase in classic tile"

	| outerPhrase |
	outerPhrase _ PhraseTileMorph new setOperator: #+ "temp dummy" 
				type: #Boolean rcvrType: #Player argType: #Player.

	(outerPhrase submorphs at: 2) delete.	"operator"
	outerPhrase addMorphBack: (TileMorph new setOperator: #nearTo:).
	(outerPhrase submorphs at: 2) goBehind.		"Make it third"

	outerPhrase submorphs last addMorph: scriptedPlayer tileToRefer.
	^ outerPhrase! !

!UniclassScript methodsFor: '*NetMorph-serializing' stamp: 'kuri-t 12/5/2002 17:21'!
prepareForWarp
	currentScriptEditor ifNotNil:
		[currentScriptEditor prepareForWarp].
	formerScriptingTiles isEmptyOrNil ifFalse:
		[formerScriptingTiles _ OrderedCollection new]! !

!WorldState methodsFor: '*NetMorph-override-stepping' stamp: 'mu 12/13/2004 00:50'!
stopStepping: aMorph selector: aSelector 
	"Remove the given morph from the step list."
	lastStepMessage
		ifNotNil: [(lastStepMessage receiver == aMorph
					and: [lastStepMessage selector == aSelector])
				ifTrue: [lastStepMessage _ nil]].
	stepList copy
		do: [:stepMsg | (stepMsg receiver == aMorph
					and: [stepMsg selector == aSelector])
				ifTrue: [stepList
						remove: stepMsg
						ifAbsent: []]]! !

!CompositeTransform methodsFor: '*NetMorph-accessing' stamp: ''!
withOffset: aPoint 
	^ localTransform _ localTransform withOffset: aPoint! !

!Presenter methodsFor: '*NetMorph-override-intialize' stamp: 'mu 5/15/2005 02:07'!
allExtantPlayers
	"The initial intent here was to produce a list of Player objects associated with any Morph in the tree beneath the receiver's associatedMorph.  whether it is the submorph tree or perhaps off on unseen bookPages.  We have for the moment moved away from that initial intent, and in the current version we only deliver up players associated with the submorph tree only.  <-- this note dates from 4/21/99

Call #flushPlayerListCache; to force recomputation."

	| fullList objectsReferredToByTiles |
	playerList ifNotNil:
		[^ playerList].

	fullList _ associatedMorph allMorphs select: 
		[:m | m player ~~ nil and: [m player isProxy not]] thenCollect: [:m | m player]. "<---NetMorph"
	fullList copy do:
		[:aPlayer |
			aPlayer class scripts do:
				[:aScript |  aScript isTextuallyCoded ifFalse:
					[aScript currentScriptEditor ifNotNilDo: [:ed |
						objectsReferredToByTiles _ ed allMorphs
							select:
								[:aMorph | (aMorph isKindOf: TileMorph) and: [aMorph type == #objRef]]
							thenCollect:
								[:aMorph | aMorph actualObject].
						fullList addAll: objectsReferredToByTiles]]]].

	^ playerList _ (fullList asSet asSortedCollection:
			[:a :b | a externalName < b externalName]) asArray! !

!Presenter methodsFor: '*NetMorph-override-viewer' stamp: 'kuri-t 1/9/2003 14:17'!
viewMorph: aMorph
	| aPlayer aViewer aPalette aRect aPoint nominalHeight aFlapTab topItem flapLoc |
	Sensor leftShiftDown ifFalse:
		[((aPalette _ aMorph standardPalette) ~~ nil and: [aPalette isInWorld])
			ifTrue:	[^ aPalette viewMorph: aMorph]].

	aPlayer _ (topItem _ aMorph topRendererOrSelf) assuredPlayer.
	topItem isFlexMorph ifTrue: [topItem renderedMorph player: aPlayer].
	aViewer _ self nascentPartsViewer.
	self cacheSpecs: topItem.		"redo the spec cache once in a while"

	"19 sept 2000 - allow flaps in any paste up"
	flapLoc _ associatedMorph "world".
	Preferences viewersInFlaps ifTrue:
		[aViewer setProperty: #noInteriorThumbnail toValue: true.
		aViewer initializeFor: aPlayer barHeight: 0.
		aViewer enforceTileColorPolicy.
		aViewer fullBounds. "force layout"
		"associatedMorph addMorph: aViewer."		"why???"
		flapLoc hideViewerFlapsOtherThanFor: aPlayer.
		aFlapTab _ flapLoc viewerFlapTabFor: topItem.
		aFlapTab referent submorphs do: 
			[:m | (m isKindOf: Viewer) ifTrue: [m delete]].

		aViewer visible: true.
		aFlapTab applyThickness: aViewer width + 25.
		aFlapTab spanWorld.
		aFlapTab showFlap. 
		aViewer position: aFlapTab referent position.
		aFlapTab referent addMorph: aViewer beSticky.		"moved"
		flapLoc startSteppingSubmorphsOf: aFlapTab.
		flapLoc startSteppingSubmorphsOf: aViewer.
		^ aFlapTab].
		
	aViewer initializeFor: aPlayer barHeight: 6.
	aViewer enforceTileColorPolicy.
	aViewer fullBounds. "force layout"
	Preferences automaticViewerPlacement ifTrue:
		[aPoint _ aMorph bounds right @ 
			(aMorph center y - ((nominalHeight _ aViewer initialHeightToAllow) // 2)).
		aRect _ (aPoint extent: (aViewer width @ nominalHeight)) translatedToBeWithin: flapLoc bounds.
		aViewer position: aRect topLeft.
		aViewer visible: true.
		associatedMorph addMorph: aViewer.
		flapLoc startSteppingSubmorphsOf: aViewer.
		"it's already in the world, somewhat coincidentally"
		^ aViewer].
	aMorph primaryHand attachMorph: (aViewer visible: true).
	^ aViewer! !

!ScrollBar methodsFor: '*NetMorph-submorphs-add/remove' stamp: 'KY 1/15/2004 18:33'!
delete
	"Remove the receiver as a submorph of its owner and make its 
	new owner be nil."

	| aWorld |
	aWorld := self world ifNil: [World].
	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little 
	protection - raa "
	" This happens when we are in an MVC project and open
	  a morphic window. - BG "
	aWorld ifNotNil:
	  [self activeHand ifNil: [self halt].
		self disableSubmorphFocusForHand: self activeHand.
	  self activeHand releaseKeyboardFocus: self;
		  releaseMouseFocus: self.].
	owner ifNotNil:[ self privateDelete.
		self player ifNotNilDo: [ :player |
			"Player must be notified"
			player noteDeletionOf: self fromWorld: aWorld]].! !

RbtServer subclass: #NmWorldMapLocationListener
	instanceVariableNames: 'availableLocations locationClearProcess clearingIntervalSeconds trimServerProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Client'!

NmWorldMapLocationListener class
	instanceVariableNames: 'default'!

!NmWorldMapLocationListener class methodsFor: 'accessing' stamp: 'mu 5/30/2005 19:36'!
default
	default isNil ifTrue: [default _ self new].
	^default! !

!NmWorldMapLocationListener class methodsFor: 'constants' stamp: 'mu 6/21/2005 18:40'!
defaultClearingIntervalSeconds
	^30! !

!NmWorldMapLocationListener class methodsFor: 'class initialization' stamp: 'mu 5/30/2005 19:31'!
initialize
	"NmWorldMapLocationListener initialize"
	super initialize.
	self release! !

!NmWorldMapLocationListener class methodsFor: 'actions' stamp: 'mu 5/31/2005 00:03'!
mapServerUrl
	"NmWorldMapLocationListener mapServerUrl"
	^self default mapServerUrl! !

!NmWorldMapLocationListener class methodsFor: 'actions' stamp: 'mu 6/15/2005 01:35'!
refresh
	"NmWorldMapLocationListener refresh"
	^self default refresh! !

!NmWorldMapLocationListener class methodsFor: 'class initialization' stamp: 'mu 5/30/2005 19:32'!
release.
	"NmWorldMapLocationListener relealse"
	default ifNotNilDo: [:inst | inst release].
	default _ nil.! !

!NmWorldMapLocationListener methodsFor: 'accessing' stamp: 'mu 5/31/2005 01:15'!
availableLocations
	availableLocations ifNil: [availableLocations _ Dictionary new].
	^availableLocations! !

!NmWorldMapLocationListener methodsFor: 'accessing' stamp: 'mu 5/31/2005 01:43'!
checkingIntervalSeconds
	^10! !

!NmWorldMapLocationListener methodsFor: 'accessing' stamp: 'mu 5/31/2005 01:13'!
clearingIntervalSeconds
	clearingIntervalSeconds ifNil: [clearingIntervalSeconds _ self class defaultClearingIntervalSeconds].
	^clearingIntervalSeconds! !

!NmWorldMapLocationListener methodsFor: 'accessing' stamp: 'mu 5/31/2005 01:15'!
clearingIntervalSeconds: seconds
	clearingIntervalSeconds _ seconds! !

!NmWorldMapLocationListener methodsFor: 'receiving' stamp: 'mu 6/15/2005 01:29'!
handleReceived: messageObject
	self availableLocations at: messageObject put: DateAndTime totalSeconds.! !

!NmWorldMapLocationListener methodsFor: 'initialize-release' stamp: 'mu 8/22/2005 11:09'!
initLocationClearProcess
	| clearer |
	locationClearProcess notNil
		ifTrue: [locationClearProcess terminate.
			locationClearProcess := nil].
	clearer := [[self removeLocationsNotUpdated.
			(Delay forSeconds: self checkingIntervalSeconds) wait] repeat].
	locationClearProcess := clearer forkAt: Processor userSchedulingPriority - 2.
	locationClearProcess name: self name, ':LocationClear'.! !

!NmWorldMapLocationListener methodsFor: 'initialize-release' stamp: 'mu 8/22/2005 11:10'!
initTrimServerProcess
	| trimmer |
	trimServerProcess notNil
		ifTrue: [trimServerProcess terminate.
			trimServerProcess := nil].
	trimmer := [[(Delay forSeconds: self checkingIntervalSeconds * 3) wait.
			self trimMapServers] repeat].
	trimServerProcess := trimmer forkAt: Processor userSchedulingPriority - 2.
	trimServerProcess name: self name, ':TrimServer'.! !

!NmWorldMapLocationListener methodsFor: 'actions' stamp: 'mu 5/31/2005 01:58'!
mapServerUrl
	| locations |
	(locations _ self availableLocations keys) ifEmpty: [^ nil].
	^ 'http://' , locations asSortedCollection first , '/' , NmSettings defaultMapServerTargetName! !

!NmWorldMapLocationListener methodsFor: 'actions' stamp: 'mu 6/15/2005 01:33'!
refresh
	availableLocations _ nil! !

!NmWorldMapLocationListener methodsFor: 'private' stamp: 'mu 5/31/2005 20:05'!
removeLocationsNotUpdated
	| seconds currentTime |
	seconds _ self clearingIntervalSeconds.
	currentTime _ DateAndTime totalSeconds.
	self availableLocations copy
		keysAndValuesDo: [:msg :time | (currentTime - time) abs > seconds
				ifTrue: [self availableLocations
						removeKey: msg
						ifAbsent: []]]! !

!NmWorldMapLocationListener methodsFor: 'actions-startup' stamp: 'mu 6/15/2005 01:33'!
sleep
	super sleep.
	self refresh! !

!NmWorldMapLocationListener methodsFor: 'actions' stamp: 'mu 8/12/2005 12:36'!
start
	"NmWorldMapLocationListener default start"
	self isRunning ifTrue: [self stop].
	self initLocationClearProcess.
	self initTrimServerProcess.
	self startOn: NmSettings warpPort - NmSettings defaultWarpPortOffset! !

!NmWorldMapLocationListener methodsFor: 'actions' stamp: 'mu 8/12/2005 12:36'!
stop
	super stop.
	self initLocationClearProcess.
	self initTrimServerProcess.
	self removeLocationsNotUpdated.
	! !

!NmWorldMapLocationListener methodsFor: 'private' stamp: 'mu 6/21/2005 18:21'!
trimMapServers
	NmSettings autoTrimMapServers
		ifFalse: [^ self].
	self availableLocations isEmpty
		ifTrue: [^ NmServerManager startMapServerWithBroadcaster].
	self availableLocations size > NmSettings mapServerCountInSegment
		ifTrue: ["Too many MapServer in one segment"
			^ NmServerManager stopMapServerWithBroadcaster]! !

!TheWorldMenu methodsFor: '*NetMorph-override-construction' stamp: 'mu 12/10/2003 20:11'!
buildWorldMenu
	"Build the menu that is put up when the screen-desktop is clicked on"

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu commandKeyHandler: self.
	self colorForDebugging: menu.
	menu addStayUpItem.
	self fillIn: menu from: {
		{'previous project' . { #myWorld . #goBack }. 'return to the most-recently-visited project'}.
		{'jump to project...' . { #myWorld . #jumpToProject }. 'put up a list of all projects, letting me choose one to go to' }.
		{'save project on file...' . { #myWorld  . #saveOnFile }. 'save this project on a file' }.
		{'load project from file...' . { self  . #loadProject }. 'load a project from a file' }.
		nil}.
	myWorld addUndoItemsTo: menu.

		self fillIn: menu from: {
		{'restore display (r)' . { World . #restoreMorphicDisplay }. 'repaint the screen -- useful for removing unwanted display artifacts, lingering cursors, etc.' }.
		nil}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'open...' . { self  . #openWindow } }.
			{'windows...' . { self  . #windowsDo } }.
			{'changes...' . { self  . #changesDo } }}].
	self fillIn: menu from: { 
		{'help...' . { self  . #helpDo }.  'puts up a menu of useful items for updating the system, determining what version you are running, and much else'}.
		{'appearance...' . { self  . #appearanceDo }. 'put up a menu offering many controls over appearance.' }}.

	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: {
			{'do...' . { Utilities . #offerCommonRequests} . 'put up an editible list of convenient expressions, and evaluate the one selected.' }}].

	self fillIn: menu from: { 
		nil.
		{'objects (o)' . { #myWorld . #activateObjectsTool } . 'A tool for finding and obtaining many kinds of objects'}.
		{'new morph...' . { self  . #newMorph }. 'Offers a variety of ways to create new objects'}.
		nil.
		{'authoring tools...' . { self  . #scriptingDo } . 'A menu of choices useful for authoring'}.
		{'playfield options...' . { self  . #playfieldDo } . 'A menu of options pertaining to this object as viewed as a playfield' }.
		{'flaps...'. { self . #flapsDo } . 'A menu relating to use of flaps.  For best results, use "keep this menu up"' }.
		{'projects...' . { self  . #projectDo }. 'A menu of commands relating to use of projects' }}.
	Preferences simpleMenus ifFalse:
		[self fillIn: menu from: { 
			{'print PS to file...' . { self  . #printWorldOnFile } . 'write the world into a postscript file'}.
			{'debug...' . { self  . #debugDo } . 'a menu of debugging items' }}].
	self fillIn: menu from: { 
		nil.
		{'save' . { SmalltalkImage current  . #saveSession } . 'save the current version of the image on disk' }.
		{'save as...' . { SmalltalkImage current . #saveAs }. 'save the current version of the image on disk under a new name.'}.
		{'save as new version' . { SmalltalkImage current . #saveAsNewVersion }. 'give the current image a new version-stamped name and save it under that name on disk.' }.
		{'save as neighbors' . { self . #saveAsNeighbors }. '(NetMorph) set map loading setting to local and save two neighbor images. Local WorldMap.csv will be created.' }.
		{'save and quit' . { self  . #saveAndQuit } . 'save the current image on disk, and quit out of Squeak.'}.
		{'quit' . { self  . #quitSession } . 'quit out of Squeak.' }}.

	^ menu! !

!TheWorldMenu methodsFor: '*NetMorph-override-commands' stamp: 'mu 12/11/2003 23:01'!
readMorphFromAFile
	"Produce a morph from a file -- either a saved .morph file or a graphics file"

	| morphOrList ff aName f m |
	aName _ Utilities chooseFileWithSuffixFromList:
(#('.morph'), Utilities graphicsFileSuffixes) withCaption: 'Choose a file
to load' translated.
	aName ifNil: [^ self].  "User made no choice"
	aName == #none ifTrue: [^ self inform: 
'Sorry, no suitable files found
(names should end with .morph, .gif,
.bmp, .jpeg, .jpe, .jp, or .form)' translated].

	(aName asLowercase endsWith: '.morph')
		ifTrue:
			[ff _ FileStream readOnlyFileNamed: aName.
			morphOrList _ ff fileInObjectAndCode.		"code filed in is the Model class"
			"the file may contain either a single morph or an array of morphs"
			(ActiveWorld allMorphs
					detect: [:morph | morph identifier = morphOrList identifier]
					ifNone: [])
					= nil
				ifFalse: [morphOrList _ morphOrList copy].
			myWorld addMorphsAndModel: morphOrList]
		ifFalse:
			[f _ Form fromFileNamed: aName.
			f ifNil: [^ self error: 'unrecognized image file format' translated].
			m _ myWorld drawingClass new form: f.
			myHand attachMorph: m]
! !

!TheWorldMenu methodsFor: '*NetMorph-commands' stamp: 'mu 5/19/2003 20:25'!
saveAsNeighbors
	NmUtil makeNeighborImages! !

!ClassCategoryReader methodsFor: '*NetMorph-fileIn/Out' stamp: 'ka 10/17/2002 19:35'!
scanFrom: aStream logged: logFlag 
	"File in methods from the stream, aStream."
	| methodText |
	[methodText _ aStream nextChunkText.
	methodText size > 0]
		whileTrue: [class
				compile: methodText
				classified: category
				withStamp: changeStamp
				notifying: (SyntaxError new category: category)
				logged: logFlag]! !

!FlapTab methodsFor: '*NetMorph-accessing' stamp: 'mu 6/19/2005 00:52'!
referent
	^referent! !

!FileList methodsFor: '*NetMorph-override-file list menu' stamp: 'mu 12/12/2004 00:41'!
openMorphFromFile
	"Reconstitute a Morph from the selected file, presumed to be represent a Morph saved
	via the SmartRefStream mechanism, and open it in an appropriate Morphic world"

 	| aFileStream morphOrList |
	Smalltalk verifyMorphicAvailability ifFalse: [^ self].
	aFileStream _ (MultiByteBinaryOrTextStream with: ((FileStream readOnlyFileNamed: self fullName) binary contentsOfEntireFile)) binary reset.

	morphOrList _ aFileStream fileInObjectAndCode.
	(morphOrList isKindOf: SqueakPage) ifTrue: [morphOrList _ morphOrList contentsMorph].
	(ActiveWorld allMorphs
			detect: [:morph | morph identifier = morphOrList identifier]
			ifNone: [])
			= nil
		ifFalse: [morphOrList _ morphOrList copy].
	Smalltalk isMorphic
		ifTrue: [ActiveWorld addMorphsAndModel: morphOrList]
		ifFalse:
			[morphOrList isMorph ifFalse: [^ self errorMustBeMorph].
			morphOrList openInWorld]! !

RmtRpcAcceptor subclass: #NmServiceHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-RPC'!

NmServiceHandler class
	instanceVariableNames: 'catcher dispatcher finder projectServer'!

!NmServiceHandler class methodsFor: 'accessing' stamp: 'MU 11/29/2002 16:52'!
catcher
	^catcher! !

!NmServiceHandler class methodsFor: 'private' stamp: 'mu 7/23/2005 19:50'!
classNamed: className
	^Smalltalk at: className asSymbol ifAbsent:[]! !

!NmServiceHandler class methodsFor: 'private' stamp: 'mu 8/4/2005 07:48'!
create: className 
	| cls |
	cls := self classNamed: className.
	^ cls
		ifNil: [NmError signal: 'No such class: ' translated , className]
		ifNotNil: [cls new]! !

!NmServiceHandler class methodsFor: 'accessing' stamp: 'MU 11/29/2002 16:52'!
dispatcher 
	^dispatcher! !

!NmServiceHandler class methodsFor: 'accessing' stamp: 'MU 11/29/2002 16:52'!
finder   
	^finder  ! !

!NmServiceHandler class methodsFor: 'class initialization' stamp: 'mu 7/23/2005 19:54'!
initialize
	"NmServiceHandler initialize"
	NmServerManager isMapServerOnlyImage ifTrue: [^self].
	catcher _ self create: #NmCatcher.
	dispatcher _ self create: #NmDispatcher.
	finder _ self create: #NmFinder.
	projectServer _ self create: #NmProjectServer.! !

!NmServiceHandler class methodsFor: 'class initialization' stamp: 'mu 7/23/2005 19:54'!
initializeForDebug
	"NmServiceHandler initializeForDebug"
	catcher _ self create: #NmMockCatcher.
	dispatcher _ self create: #NmMockDispatcher.
	finder _ self create: #NmMockFinder.
	projectServer _ self create: #NmMockProjectServer.! !

!NmServiceHandler class methodsFor: 'accessing' stamp: 'mu 6/16/2005 22:57'!
projectServer
	^projectServer! !

!NmServiceHandler methodsFor: 'service warp' stamp: 'kuri-t 1/24/2003 15:49'!
catchAndGo: morphByteArray 
	^ self class catcher catchAndGo: morphByteArray! !

!NmServiceHandler methodsFor: 'service warp' stamp: 'mu 12/6/2002 10:29'!
catchAndGo: morphByteArray x: x y: y 
	
	^self class catcher catchAndGo: morphByteArray x: x y: y ! !

!NmServiceHandler methodsFor: 'service dispatch' stamp: 'mu 12/6/2002 10:30'!
dispatch: uuidString to: target selector: selector
	^self class dispatcher dispatch: uuidString to: target selector: selector
	! !

!NmServiceHandler methodsFor: 'service dispatch' stamp: 'mu 12/6/2002 10:30'!
dispatch: uuidString to: target selector: selector withArguments: arguments 
	^self class dispatcher dispatch: uuidString to: target selector: selector withArguments: arguments ! !

!NmServiceHandler methodsFor: 'private' stamp: 'mu 7/24/2005 13:20'!
efficientEncoderForReturn: object
	object isProxy ifTrue: [^#DataStream].
	object isForm ifTrue: [^#DataStream].
	^super efficientEncoderForReturn: object! !

!NmServiceHandler methodsFor: 'service find' stamp: 'mu 12/6/2002 10:30'!
findBy: uuidString
	^self class finder findBy: uuidString! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 7/2/2005 22:12'!
getNumberOfProjectsMatches: matchString matchOptions: matchOptionString
	^ self class projectServer getNumberOfProjectsMatches: matchString matchOptions: matchOptionString! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 6/20/2005 01:42'!
getProjectInfo: projectName
	^ self class projectServer getProjectInfo: projectName! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 7/2/2005 22:00'!
getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString
	^ self class projectServer getProjectNamesFrom: start to: end matches: matchString matchOptions: matchOptionString sortOptions: sortOptionString! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 6/20/2005 01:42'!
getProjectThumbnail: projectName
	^ self class projectServer getProjectThumbnail: projectName ! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 6/20/2005 01:42'!
getProject: projectName 
	^ self class projectServer getProject: projectName ! !

!NmServiceHandler methodsFor: 'receiving' stamp: 'mu 7/2/2005 22:24'!
handleReceived: messageLikeObject 
	"Override if you wish"
	RmtDebug crShow: #handleReceived.
	RmtDebug crShow: messageLikeObject.
	"messageLikeObject inspect".
	
	^self perform: messageLikeObject first withArguments: messageLikeObject second.
	! !

!NmServiceHandler methodsFor: 'factory' stamp: 'mu 5/29/2004 18:52'!
messageClass
	^NmRpcMessage! !

!NmServiceHandler methodsFor: 'service find' stamp: 'mu 8/3/2005 10:02'!
redirectIpAndPortOf: uuidString
	^self class finder redirectIpAndPortOf: uuidString! !

!NmServiceHandler methodsFor: 'service project' stamp: 'mu 6/16/2005 23:37'!
takeAPicture: shrunkBySize
	^ self class projectServer takeAPicture: shrunkBySize! !

AlignmentMorph subclass: #NmBuilderMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

NmBuilderMorph subclass: #NmAbstractSettingsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmAbstractSettingsMorph class methodsFor: 'instance creation' stamp: 'mu 7/20/2005 21:50'!
createWindow
	| insts inst |
	insts _ self existingOn: self settingClass.
	inst _ insts isEmpty
				ifTrue: [self new createWindow]
				ifFalse: [insts first].
	^ inst! !

!NmAbstractSettingsMorph class methodsFor: 'instance creation' stamp: 'mu 7/20/2005 23:40'!
existingOn: settingClass 
	| existing |
	existing _ ActiveWorld submorphs
				select: [:each | (each isKindOf: SystemWindow)
						and: [each lastSubmorph isKindOf: self]].
	^ existing! !

!NmAbstractSettingsMorph class methodsFor: 'instance creation' stamp: 'ns 1/22/2003 16:52'!
open
	"NmSettingMorph open"
	^ self createWindow openInWorldExtent: self windowExtent! !

!NmAbstractSettingsMorph class methodsFor: 'factory' stamp: 'ns 1/22/2003 16:41'!
settingClass
	self subclassResponsibility! !

!NmAbstractSettingsMorph class methodsFor: 'constants' stamp: 'mu 5/29/2003 12:54'!
windowExtent
	self subclassResponsibility! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 20:54'!
allMorphsMatches: matchString
	^self allMorphs select: [:each | matchString match: each knownName asString].
	! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 23:08'!
buildResetDefaultButtonRow
	| default row |
	default _ (PluggableButtonMorph on: self getState: #isOn action: #resetDefaults) label: 'Reset to default values'.

	default
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'set NmSettings to default values'.

	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		addAllMorphs: (Array with: default );
		extent: 120@35.
	
	^row! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 4/3/2005 23:50'!
buildTextField: selector 
	^ self buildTextField: selector on: self settingClass! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 21:22'!
buildTextField: selector help: helpString
	^ self buildTextField: selector on: self settingClass help: helpString! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 23:15'!
createResetDefaultButtonRow
	| row |
	row _ self buildResetDefaultButtonRow.
	self addMorphBack: row.
	^ row! !

!NmAbstractSettingsMorph methodsFor: 'initialization' stamp: 'mu 4/4/2005 00:15'!
createSystemWindow
	|  window |
	self listDirection: #topToBottom.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	window _ (SystemWindow labelled: self class labelString)
				model: Model new.
	window
		addMorph: self
		frame: (0 @ 0 corner: 1 @ 1).
	window extent: self class windowExtent.
	^ window! !

!NmAbstractSettingsMorph methodsFor: 'initialization' stamp: 'mu 4/4/2005 00:04'!
createWindow
	"NmAbstractSettingMorph createSystemWindow openInWorld."
	^self createSystemWindow! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 21:17'!
disableMorphsMatches: matchString 
	(self allMorphsMatches: matchString)
		do: [:each | 
			each lock.
			each submorphs
				do: [:sub | (sub isKindOf: PluggableTextMorph)
						ifTrue: [sub textMorph color: Color gray]
						ifFalse: [sub color: Color gray]]]! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 21:18'!
enableMorphsMatches: matchString 
	(self allMorphsMatches: matchString)
		do: [:each | 
			each unlock.
			each submorphs
				do: [:sub | (sub isKindOf: PluggableTextMorph)
						ifTrue: [sub textMorph color: sub textMorph defaultColor]
						ifFalse: [sub color: sub defaultColor]]]! !

!NmAbstractSettingsMorph methodsFor: 'actions' stamp: 'mu 2/19/2003 15:55'!
resetDefaults
	self settingClass resetDefaults.
	"self delete"! !

!NmAbstractSettingsMorph methodsFor: 'actions' stamp: 'ns 1/22/2003 17:23'!
save
	self settingClass store! !

!NmAbstractSettingsMorph methodsFor: 'factory' stamp: 'mu 4/4/2005 00:12'!
settingClass
	^ self class settingClass! !

!NmAbstractSettingsMorph methodsFor: 'private' stamp: 'mu 4/29/2005 23:53'!
viewMapOn: aNmWorldMap
	NmWorldMapMorph openSingleOn: aNmWorldMap! !

NmAbstractSettingsMorph subclass: #NmServerSettingsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

!NmServerSettingsMorph class methodsFor: 'defaluts' stamp: 'ns 1/22/2003 17:19'!
labelString
	^ 'NetMorph Server setting'! !

!NmServerSettingsMorph class methodsFor: 'factory' stamp: 'ns 1/22/2003 16:41'!
settingClass
	^ NmServerSettings! !

!NmServerSettingsMorph class methodsFor: 'constants' stamp: 'mu 7/20/2005 20:09'!
windowExtent
	^ 500 @ 160! !

!NmServerSettingsMorph methodsFor: 'actions' stamp: 'mu 7/20/2005 20:52'!
allocateByRandom
	^self settingClass allocateByRandom! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 6/2/2005 22:06'!
buildListButtonRow
	| button |
	button _  self
		buildButtonOn: self
		action: #viewMaps
		label: 'view'
		help: 'view maps'.
	^button! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 21:26'!
createAllocationPolicyRow
	| first checkBox second textField third fourth row |
	first _ self buildRowLabeled: 'allocate by random: '.
	checkBox _ self
				buildCheckBoxOn: self
				action: #toggleAllocateByRandom
				getSelector: #allocateByRandom
				help: 'Allocate map enty point by random'.
	first addMorphBack: checkBox.
	
	second _ self buildRowLabeled: 'grid 1:'.
	textField _ self buildTextField: #level1Matrix help: 'set map entry minimal level groups grid'.
	second name: 'grid1'.
	second addMorphBack: textField.

	third _ self buildRowLabeled: 'grid 2:'.
	textField _ self buildTextField: #level2Matrix help: 'set map entry middle level groups grid'.
	third name: 'grid2'.
	third addMorphBack: textField.

	fourth _ self buildRowLabeled: 'grid 3:'.
	textField _ self buildTextField: #level3Matrix help: 'set map entry largest level groups grid'.
	fourth name: 'grid3'.
	fourth addMorphBack: textField.
	
	row _ self
				buildRow: first
				with: second
				with: third
				with: fourth.
	self addMorphBack: row.
	^ row! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 23:07'!
createMapPathRow
	| row textField |
	row _ self buildRowLabeled: 'map path: '.
	textField _ self buildTextField: #mapPath.
	row addMorphBack: textField.
	self addMorphBack: row.
	^row! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 6/3/2005 09:24'!
createMapServerRow
	| first checkBox second third textField row fourth |
	first _ self buildRowLabeled: 'run map server: '.
	checkBox _ self
				buildCheckBoxOn: self settingClass
				action: #toggleMapServerRunning
				getSelector: #isMapServerRunning
				help: 'Run the map server'.
	first addMorphBack: checkBox.
	NmServerManager isMapServerOnlyImage 
		ifFalse: [second _ self buildRowLabeled: 'auto run: '.
			checkBox _ self
						buildCheckBoxOn: self settingClass
						action: #toggleAutoTrimMapServers
						getSelector: #autoTrimMapServers
						help: 'Auto run map server if not available'.
			second addMorphBack: checkBox]
		ifTrue: [second _ nil].
	third _ self buildRowLabeled: 'save port: '.
	checkBox _ self
				buildCheckBoxOn: self settingClass
				action: #toggleSaveMapServerPort
				getSelector: #saveMapServerPort
				help: 'Port number is saved through snapshots'.
	third addMorphBack: checkBox.
	fourth _ self buildRowLabeled: 'port: '.
	textField _ self buildTextField: #mapServerPort.
	fourth addMorphBack: textField.
	row _ self
				buildRow: first
				with: second
				with: third
				with: fourth.
	self addMorphBack: row.
	^ row! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 6/3/2005 02:03'!
createViewMapsRow
	| row |
	row _ self buildRowLabeled: 'view all maps:'.
	row addMorphBack: (self buildListButtonRow).
	self addMorphBack: row.
	^row! !

!NmServerSettingsMorph methodsFor: 'initialization' stamp: 'mu 7/20/2005 21:06'!
createWindow
	| window |
	window _ super createWindow.
	self createMapServerRow.
	self createViewMapsRow.
	self createMapPathRow.
	self createAllocationPolicyRow.
	self createResetDefaultButtonRow.
	self resetGridFields.
	^ window! !

!NmServerSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 21:14'!
resetGridFields
	self allocateByRandom
		ifTrue: [self disableMorphsMatches: 'grid*']
		ifFalse: [self enableMorphsMatches: 'grid*']! !

!NmServerSettingsMorph methodsFor: 'actions' stamp: 'mu 7/20/2005 21:14'!
toggleAllocateByRandom
	self settingClass toggleAllocateByRandom.
	self resetGridFields! !

!NmServerSettingsMorph methodsFor: 'actions' stamp: 'mu 6/3/2005 02:05'!
viewMaps
	| mapServer mapNames mapEntries  sele map |
	mapServer _ NmWorldMapServer default.
	mapEntries _ mapServer worldMaps.
	mapEntries isEmpty ifTrue: [^self inform: 'No maps on this server'].
	mapNames _ mapEntries keys asArray.
	sele _ (SelectionMenu labelList:  ( mapNames collect: [:each | FileDirectory baseNameFor: each ] ) selections: mapNames) startUp.
	map _ mapServer worldMaps at: sele ifAbsent:[].
	map ifNotNilDo: [:m | self viewMapOn: m].! !

NmAbstractSettingsMorph subclass: #NmSettingsMorph
	instanceVariableNames: 'mapUrlField mapPathField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Client'!

!NmSettingsMorph class methodsFor: 'defaults' stamp: 'ns 1/22/2003 17:19'!
labelString
	^ 'NetMorph setting'! !

!NmSettingsMorph class methodsFor: 'factory' stamp: 'ns 1/22/2003 16:40'!
settingClass
	^ NmSettings! !

!NmSettingsMorph class methodsFor: 'constants' stamp: 'mu 5/29/2003 12:55'!
windowExtent
	^ 410 @ 240! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 23:26'!
buildListButtonRow
	| button |
	button _  self
		buildButtonOn: self
		action: #listAllMaps
		label: 'list'
		help: 'list all Map names'.
	button extent:40@20.
	button hResizing: #rigid.
	^button! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 22:57'!
buildMapButtonRow

	| store load viewMap row |
	store _ self buildButtonOn: self action: #storeMap label: 'Store Map' help: 'store WorldMap' .
	load _ self buildButtonOn: self action: #loadMap label: 'Load Map' help: 'load WorldMap' .
	viewMap _ self buildButtonOn: self action: #viewMap label: 'View Map' help: 'open WorldMap' .
		
	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		addAllMorphs: (Array with: store with: load with: viewMap);
		extent: 100@35.
	
	^row! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 22:55'!
buildResetSystemButtonRow
	| button |
	button _  self
		buildButtonOn: self
		action: #resetSystem
		label: 'reset system'
		help: 'reset NetMorph system'.
	button extent:100@20.
	button hResizing: #rigid.
	^button! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 4/7/2005 22:55'!
buildSetGlobalIpButtonRow
	| button |
	button _  self
		buildButtonOn: self
		action: #setGlobalIp
		label: 'set ip'
		help: 'set globally accessible ip address'.
	button extent:40@20.
	button hResizing: #rigid.
	^button! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 5/31/2005 17:19'!
createIntervalRow
	| left textField right row |
	left _ self buildRowLabeled: 'update:   '.
	textField _ self buildTextField: #intervalSeconds.
	left addMorphBack: textField.
	left
		addMorphBack: (self buildRowLabeled: '(seconds)').
	right _ self buildResetSystemButtonRow.
	row _ self buildRow: left with: right.
	self addMorphBack: row.
	^row! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 20:41'!
createMapFromInternetRow
	|  row checkBox mapButtons |
	row _ self buildRowLabeled: 'map from internet: ' translated.
	checkBox _ self buildCheckBoxOn: self settingClass action: #toggleMapFromInternet getSelector: #mapFromInternet help: 'Toggle getting WorldMap data via internet'.
	row addMorphBack: checkBox.
	mapButtons _ self buildMapButtonRow.
	row addMorphBack: mapButtons.
	self addMorphBack: row.
	^row! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 20:41'!
createMapNameRow
	| row textField |
	row _ self buildRowLabeled: 'map name:' translated.
	textField _ self buildTextField: #mapName on: self worldMap.
	row addMorphBack: textField.
	row addMorphBack: (self buildListButtonRow).
	self addMorphBack: row.
	^row! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 20:41'!
createMapPathRow 
	| row textField |
	NmServerManager isMapServerInstalled
		ifFalse: [row _ self buildRowLabeled: 'map path: ' translated.
			textField _ self buildTextField: #mapPath.
			self mapPathField: textField.
			row addMorphBack: textField.
			self addMorphBack: row.
	^row].
	^nil! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 20:41'!
createMapUrlRow
	| row textField |
	row _ self buildRowLabeled: 'map url:   ' translated.
	textField _ self buildTextField: #mapServerUrl.
	self mapUrlField: textField.
	row addMorphBack: textField.
	self addMorphBack: row.
	^ row! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 20:41'!
createUseAvailabilityCheckerRow
	| left checkBox right row |
	left _ self buildRowLabeled: 'use availability checker: ' translated.
	checkBox _ self
				buildCheckBoxOn: self settingClass
				action: #toggleUseAvailabilityChecker
				getSelector: #useAvailabilityChecker
				help: 'Toggle using AvailabilityChecker to know dead NetMorph images' translated.
	left addMorphBack: checkBox.
	right _ self buildRowLabeled: 'use drag warp: ' translated.
	checkBox _ self
				buildCheckBoxOn: self settingClass
				action: #toggleUseKeepMoving
				getSelector: #useKeepMoving
				help: 'If on, you can shift-drag the brown move handle to warp-out morph' translated.
	right addMorphBack: checkBox.
	row _ self buildRow: left with: right.
	self addMorphBack: row.
	^row! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 7/20/2005 20:42'!
createWarpPortRow
	| row textField |
	row _ self buildRowLabeled: 'warp port:' translated.
	textField _ self buildTextField: #warpPort.
	row addMorphBack: textField.
	row addMorphBack: (self buildSetGlobalIpButtonRow).
	self addMorphBack: row.
	^ row! !

!NmSettingsMorph methodsFor: 'initialization' stamp: 'mu 6/13/2005 22:27'!
createWindow
	| window |
	window _ super createWindow.
	self createMapFromInternetRow.
	self createMapUrlRow.
	self createMapNameRow.
	self createWarpPortRow.
	self createMapPathRow.
	self createIntervalRow.
	self createUseAvailabilityCheckerRow.
	self createResetDefaultButtonRow.
	^ window! !

!NmSettingsMorph methodsFor: 'initialization' stamp: 'mu 8/17/2005 08:33'!
delete
	self unregisterDependent.
	super delete! !

!NmSettingsMorph methodsFor: 'initialization' stamp: 'mu 8/17/2005 08:32'!
initialize
	super initialize.
	self registerDependent! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'mu 4/1/2005 00:09'!
inspectMap
	self worldMap map inspect.! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'mu 5/10/2005 17:30'!
listAllMaps
	| mapNames sele |
	mapNames _ self worldMap listLoadableMapNames.
	mapNames isEmpty ifTrue: [^self].
	sele _ (SelectionMenu selections: mapNames) startUp.
	self worldMap mapName: sele.	
	self worldMap load
		 ! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'mu 4/1/2005 00:09'!
loadMap

	self worldMap load.! !

!NmSettingsMorph methodsFor: 'accessing' stamp: 'mu 5/19/2003 15:33'!
mapPathField
	^mapPathField! !

!NmSettingsMorph methodsFor: 'accessing' stamp: 'mu 5/19/2003 15:33'!
mapPathField: aMorph
	mapPathField _ aMorph! !

!NmSettingsMorph methodsFor: 'accessing' stamp: 'mu 5/19/2003 15:33'!
mapUrlField
	^mapUrlField! !

!NmSettingsMorph methodsFor: 'accessing' stamp: 'mu 5/19/2003 15:33'!
mapUrlField: aMorph
	mapUrlField _ aMorph! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 6/3/2005 19:54'!
markMapUrlField
	mapUrlField ifNotNil: [mapUrlField color: Color red].! !

!NmSettingsMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 08:32'!
registerDependent
	NmWorldMap default addDependent: self! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'mu 5/19/2003 15:27'!
resetSystem
	NmUtil resetSystem! !

!NmSettingsMorph methodsFor: 'actions' stamp: ''!
save
	NmSettings store! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'mu 7/20/2005 20:42'!
setGlobalIp
	| ipAddress |
	ipAddress _ FillInTheBlank request: 'What is this machine''s global ip address?
 This may be wrong...' initialAnswer: NmUtil localAddress.
	ipAddress isEmptyOrNil ifTrue: [^nil].
	[NmSettings explicitGlobalAddress: ipAddress] on: Error
		do: [NmSettings explicitGlobalAddress: nil]! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'mu 4/1/2005 00:09'!
storeMap
	self worldMap store.! !

!NmSettingsMorph methodsFor: 'private' stamp: 'mu 5/19/2003 16:10'!
unmarkMapUrlField
	mapUrlField ifNotNil: [mapUrlField color: Color transparent].! !

!NmSettingsMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 08:32'!
unregisterDependent
	NmWorldMap default removeDependent: self! !

!NmSettingsMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 08:35'!
update: anAspect 
	anAspect == #worldMapLoadFailed
		ifTrue: [self markMapUrlField].
	anAspect == #worldMapLoaded
		ifTrue: [self unmarkMapUrlField]! !

!NmSettingsMorph methodsFor: 'actions' stamp: 'mu 4/8/2005 00:02'!
viewMap
	self viewMapOn: self worldMap! !

!NmSettingsMorph methodsFor: 'accessing' stamp: 'mu 4/1/2005 00:08'!
worldMap
	^NmWorldMap default! !

NmBuilderMorph subclass: #NmBookMorph
	instanceVariableNames: 'findString currentPageNumber matchOptions sortOptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Client'!

!NmBookMorph class methodsFor: 'interface opening' stamp: 'mu 7/25/2005 14:31'!
open
	^self new openInWorld! !

!NmBookMorph methodsFor: 'building' stamp: 'mu 7/27/2005 20:19'!
buildActionButtonPanel
	| panel |
	panel _ AlignmentMorph newRow cellInset: 2;
				 hResizing:  #shrinkWrap;
				vResizing:  #shrinkWrap;
				 color: Color transparent.
	panel addMorphBack: (self buttonName: '<<' action: #firstPage ).
	panel addMorphBack: (self buttonName: '<' action: #prevPage ).
	

	self buildActionButtonsTo: panel.

	panel addMorphBack: (self buttonName: '>' action: #nextPage).
	panel addMorphBack: (self buttonName: '>>' action: #lastPage).

	panel setBorderStyle: #complexAltInset.
	panel borderWidth: 4.
	^panel.

	! !

!NmBookMorph methodsFor: 'building' stamp: 'mu 7/27/2005 20:19'!
buildActionButtonsTo: panel 
	panel
		addMorphBack: (self buttonName: 'Reload' translated action: #reload).
	panel
		addMorphBack: (self buttonName: 'Sort' translated action: #sort).
	panel
		addMorphBack: (self buttonName: 'Close' translated action: #delete).
	^ panel! !

!NmBookMorph methodsFor: 'building' stamp: 'mu 7/25/2005 14:30'!
buildFindPanel
	| panel textField |
	panel _ self buildRowLabeled: 'find:'.
	textField _ self buildTextField: #findString on: self.
	textField extent: 10 @ 10.
	panel color: Color transparent.
	panel addMorphBack: textField.
	^ panel! !

!NmBookMorph methodsFor: 'building' stamp: 'mu 7/25/2005 14:30'!
buildInfoBar
	| infoBar nameField |
	infoBar _ AlignmentMorph newRow cellInset: 2;
				 hResizing: #shrinkWrap;
				 vResizing: #shrinkWrap;
				 color: Color transparent.
	nameField _ UpdatingStringMorph on: self selector: #statusString.
	nameField useStringFormat.

	infoBar addMorphBack: nameField.
	infoBar setBorderStyle: #complexAltInset.
	infoBar borderWidth: 4.
	infoBar lock.
	^infoBar! !

!NmBookMorph methodsFor: 'building' stamp: 'mu 7/25/2005 14:30'!
buildRoundButton: action label: label help: help
	| button |
	button _  (self buildButtonOn: self action: action label: label help: help).
	button useRoundedCorners.
	button hResizing: #rigid.
	^button! !

!NmBookMorph methodsFor: 'building' stamp: 'mu 7/25/2005 14:30'!
buildSpacer
	^AlignmentMorph newSpacer: Color transparent! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:30'!
currentPageNumber
	^currentPageNumber! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:30'!
currentPageNumber: anInteger
	currentPageNumber _ (anInteger max: 1)! !

!NmBookMorph methodsFor: 'constants' stamp: 'mu 7/27/2005 21:24'!
defaultMaxItemsPerPage
	^5! !

!NmBookMorph methodsFor: 'constants' stamp: 'mu 7/25/2005 14:30'!
defaultSortOptionList
	^{'Date'. 'Name'}! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:30'!
findString
	findString ifNil:[findString _ ''].
	^findString! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:30'!
findString: aString
	findString _ aString asString.
	self changed: #findString.
	self reload! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 01:51'!
firstPage
	self currentPageNumber = 1 ifTrue: [^ self].
	self currentPageNumber: 1.
		
	self initItemsFrom: 1 to: self defaultMaxItemsPerPage! !

!NmBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/28/2005 01:50'!
initItemsFrom: start to: end! !

!NmBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/25/2005 15:13'!
initialize
	super initialize.
	self initPageCounter.

	self useRoundedCorners.
	self borderWidth: 1.
	self fillStyle: self backgroundFillStyle.

	self initLayout.
	! !

!NmBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/25/2005 14:34'!
initLayout
	! !

!NmBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/25/2005 14:35'!
initPageCounter
	currentPageNumber _ 1.
	! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 02:06'!
lastPage
	| max |
	self currentPageNumber = self maxPageNumber
		ifTrue: [^ self].
	max _ self maxPageNumber.
	self currentPageNumber: max.
	self
		initItemsFrom: (max - 1 * self defaultMaxItemsPerPage + 1 max: 1)
		to: max * self defaultMaxItemsPerPage! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:51'!
matchOptions
	matchOptions ifNil: [matchOptions _ ''].
	^matchOptions! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:51'!
matchOptions: optionString
	matchOptions _ optionString! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/25/2005 14:30'!
matchString
	^self findString isEmpty ifTrue: ['*'] ifFalse: ['*', self findString, '*']! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 02:13'!
maxPageNumber
	self numberOfItems = 0 ifTrue: [^1].
	^(self numberOfItems / self defaultMaxItemsPerPage) ceiling! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 01:52'!
nextPage
	self currentPageNumber = self maxPageNumber ifTrue: [^ self].
	self currentPageNumber: self currentPageNumber + 1.
	
	self initItemsFrom: self currentPageNumber - 1 * self defaultMaxItemsPerPage + 1 to: self currentPageNumber * self defaultMaxItemsPerPage
	! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/28/2005 00:13'!
numberOfItems
	^0! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 01:53'!
openPage
	self currentPageNumber: 1.
	self initItemsFrom: 1 to: self defaultMaxItemsPerPage! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 01:53'!
prevPage
	self currentPageNumber = 1 ifTrue: [^ self].
	self currentPageNumber: self currentPageNumber - 1.
	
	self initItemsFrom: self currentPageNumber - 1 * self defaultMaxItemsPerPage + 1 to: self currentPageNumber * self defaultMaxItemsPerPage
	! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/25/2005 14:35'!
reload! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/25/2005 14:30'!
sort
	| menu |
	menu _ MenuMorph new.
	self defaultSortOptionList
		do: [:each | 
			|enabler|
			enabler _ each asLowercase = self sortOptions ifTrue: ['<on>'] ifFalse: ['    '].
			menu
				add: enabler, each translated
				target: self
				selector: #sortOptions:
				argumentList: {each}].
	menu popUpInWorld! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:51'!
sortOptions
	sortOptions ifNil: [sortOptions _ 'name'].
	^sortOptions! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:51'!
sortOptions: optionString
	sortOptions _ optionString asString asLowercase.
	self reload! !

!NmBookMorph methodsFor: 'actions' stamp: 'mu 7/25/2005 14:30'!
statusString
	^ self knownName asString , ': ' , self currentPageNumber asString , '/' , self maxPageNumber asString! !

!NmBookMorph methodsFor: 'accessing' stamp: 'mu 7/25/2005 14:30'!
window
	^self ownerThatIsA: SystemWindow! !

NmBookMorph subclass: #NmMarkerDockMorph
	instanceVariableNames: 'markers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Marker'!

!NmMarkerDockMorph class methodsFor: 'instance creation' stamp: 'mu 7/28/2005 22:50'!
createWindow
	| inst |
	inst _ ActiveWorld markerDock.
	^inst! !

!NmMarkerDockMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 23:20'!
addMarker: aNmMarkerMorph 
	(aNmMarkerMorph isMemberOf: NmMarkerMorph)
		ifFalse: [^ self].
	(self markers includes: aNmMarkerMorph) ifTrue: [^self].
	self markers add: aNmMarkerMorph.
	self
		initItemsFrom: self currentPageNumber
		to: (self defaultMaxItemsPerPage min: self markers size)! !

!NmMarkerDockMorph methodsFor: 'building' stamp: 'mu 7/27/2005 20:42'!
buildActionButtonsTo: panel 
	panel
		addMorphBack: (self buttonName: 'Remove lost' translated action: #removeLosts).
	panel
		addMorphBack: (self buttonName: 'Sort' translated action: #sort).
	panel
		addMorphBack: (self buttonName: 'Close' translated action: #delete).
	^ panel! !

!NmMarkerDockMorph methodsFor: 'building' stamp: 'mu 7/28/2005 02:33'!
buildCentralPanel
	| panel |
	panel _ AlignmentMorph newColumn.
	panel listDirection: #topToBottom.
	panel listCentering: #justified.
	panel layoutInset: 5 @ 5.
	panel cellInset: 3.
	panel hResizing: #shrinkWrap.
	panel vResizing: #shrinkWrap.
	panel name: #centralPanel.
	panel color: Color transparent.
	^ panel! !

!NmMarkerDockMorph methodsFor: 'constants' stamp: 'mu 7/27/2005 21:26'!
defaultMaxItemsPerPage	
	^10! !

!NmMarkerDockMorph methodsFor: 'initialize-release' stamp: 'mu 7/28/2005 02:43'!
initItemsFrom: start to: end
	| startIndex endIndex |
	startIndex _ start min: self markers size  max: 1.
	endIndex _ end min: self markers size  max: 1.
	Transcript cr; show: {startIndex. endIndex} asString.
	^self initMarkersFrom: startIndex to: endIndex
	! !

!NmMarkerDockMorph methodsFor: 'initialize-release' stamp: 'mu 7/28/2005 02:48'!
initialize
	super initialize.
	self initMarkers.
	self removeAllMorphs.
	self addMorph: self buildActionButtonPanel.
	self addMorphBack: self buildCentralPanel.
	self addMorphBack: self buildInfoBar.
	self extent: 256@512.	
	self name: 'Footprints' translated.
	sortOptions _ 'date'

	
	
	! !

!NmMarkerDockMorph methodsFor: 'initialize-release' stamp: 'mu 7/28/2005 02:33'!
initLayout
	self changeTableLayout.
	self listDirection: #topToBottom.
	self listCentering: #justified.
	self layoutInset: 5@5.
	self cellInset: 3.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.

	
	
	! !

!NmMarkerDockMorph methodsFor: 'initialize-release' stamp: 'mu 7/27/2005 20:29'!
initMarkers
	markers _ nil! !

!NmMarkerDockMorph methodsFor: 'initialize-release' stamp: 'mu 7/30/2005 00:02'!
initMarkersFrom: start to: end 
	self panel
		ifNotNilDo: [:p | 
			p removeAllMorphs; extent: 0@0.
			self
				markersDo: [:each | p addMorphBack: (each color: Color white)]
				from: start
				to: end.
			p layoutChanged]! !

!NmMarkerDockMorph methodsFor: 'accessing' stamp: 'mu 7/28/2005 21:28'!
markerMorphs
	"currently displayed marker morphs"
	^self panel submorphs! !

!NmMarkerDockMorph methodsFor: 'accessing' stamp: 'mu 7/27/2005 21:21'!
markers
	markers
		ifNil: [markers _ SortedCollection sortBlock: self sortBlock].
	^ markers! !

!NmMarkerDockMorph methodsFor: 'private' stamp: 'mu 7/28/2005 21:39'!
markersDo: aBlock from: start to: end
	| startIndex endIndex |
	startIndex _ start min: end.
	endIndex _ end min: self markers size.
	startIndex
		to: endIndex
		do: [:idx | 
			| item | 
			item _ self markers at: idx.
			aBlock value: item]! !

!NmMarkerDockMorph methodsFor: 'accessing' stamp: 'mu 7/28/2005 22:05'!
numberOfItems
	^self markers size! !

!NmMarkerDockMorph methodsFor: 'accessing' stamp: 'mu 7/27/2005 19:50'!
panel
	^self submorphNamed: #centralPanel
	! !

!NmMarkerDockMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 21:56'!
reload
	self markers sortBlock: self sortBlock.
	
	self currentPageNumber: 1.
	self initItemsFrom: 1 to: self defaultMaxItemsPerPage.
	

		! !

!NmMarkerDockMorph methodsFor: 'actions' stamp: 'mu 7/28/2005 21:53'!
removeLosts
	self markers removeAllSuchThat: [:e | e isLost].
	self reload.
	! !

!NmMarkerDockMorph methodsFor: 'private' stamp: 'mu 7/28/2005 23:24'!
sortBlock
	self sortOptions = 'name'
		ifTrue: [^ [:a :b | a externalName < b externalName]].
	^ [:a :b | a createdTime > b createdTime].! !

NmBookMorph subclass: #NmProjectBookMorph
	instanceVariableNames: 'loader mapEntryMorph numberOfProjects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectBookMorph class methodsFor: 'interface opening' stamp: 'mu 7/15/2005 00:17'!
on: aMapEntryMorph
	^self new 
		mapEntryMorph: aMapEntryMorph;
		loader: (NmProjectLoader on: aMapEntryMorph mapEntry)! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/3/2005 23:11'!
existingOn: aMapEntryMorph
	| existing |
	existing _ ActiveWorld submorphs
				select: [:each | (each isKindOf: self class)
						and: [each mapEntryMorph = self mapEntryMorph]].
	^existing! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/28/2005 01:55'!
initItemsFrom: start to: end 
	^ self pageMorph
		initSubmorphsFrom: start
		to: end
		matches: self matchString
		matchOptions: self matchOptions
		sortOptions: self sortOptions! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/25/2005 14:46'!
initialize
	super initialize.
	
	self addMorphBack: self buildActionButtonPanel.
	self addMorphBack: self buildFindPanel.
	self addMorphBack: NmProjectPageMorph new.
	self addMorphBack: self buildInfoBar
	! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/25/2005 15:13'!
initLayout
	self changeTableLayout; listDirection: #topToBottom; wrapCentering: #center.
	self hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	self layoutInset: 3 @ 3.
	self cellInset: 3.
	! !

!NmProjectBookMorph methodsFor: 'testing' stamp: 'mu 7/1/2005 20:33'!
isWarpable
	^false! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:25'!
loader
	^loader! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:25'!
loader: aProjectLoader
	loader _ aProjectLoader! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:25'!
mapEntryMorph
	^mapEntryMorph! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 20:25'!
mapEntryMorph: aMapEntryMorph
	mapEntryMorph _ aMapEntryMorph! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/28/2005 01:45'!
numberOfItems
	^self numberOfProjects
		! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/26/2005 01:53'!
numberOfProjects
	numberOfProjects
		ifNil: [numberOfProjects _ self loader getNumberOfProjectsMatches: self matchString matchOptions: ''].
	^ numberOfProjects! !

!NmProjectBookMorph methodsFor: 'initialize-release' stamp: 'mu 7/16/2005 21:04'!
openInHand
	| existing |
	existing _ self existingOn: self mapEntryMorph.
	existing isEmpty
		ifTrue: [super openInHand.
			self openPage]
		ifFalse: [ActiveWorld addMorphFront: existing first lastPage]! !

!NmProjectBookMorph methodsFor: 'accessing' stamp: 'mu 7/1/2005 19:48'!
pageMorph
	^self findA: NmProjectPageMorph! !

!NmProjectBookMorph methodsFor: 'actions' stamp: 'mu 7/25/2005 15:16'!
reload
	numberOfProjects _ nil.
	self openPage.! !

!NmProjectBookMorph methodsFor: 'stepping' stamp: 'mu 7/15/2005 15:32'!
step
	self mapEntryMorph ifNil: [^self].
	self setNameTo: self mapEntryMorph mapEntry destination , '''s Projects'.
	self window ifNotNilDo: [:w | w setLabel: self knownName].
	! !

!NmProjectBookMorph methodsFor: 'stepping' stamp: 'mu 7/1/2005 20:33'!
stepTime
	^2000! !

!NmBuilderMorph class methodsFor: 'instance creation' stamp: 'mu 6/30/2005 22:45'!
open
	"self open"
	^ self new openInWorld! !

!NmBuilderMorph methodsFor: 'constants' stamp: 'mu 7/2/2005 00:17'!
backgroundFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.355
							g: 0.548
							b: 1.0). 1.0
					-> (Color
							r: 0.774
							g: 0.935
							b: 1.0)}.
	fill origin: self bounds topLeft + (61 @ 7).
	fill direction: 33 @ 37.
	fill radial: false.
	^ fill! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildButtonOn: morph action: selector label: labelString help: helpString 
	| button |
	button _ (PluggableButtonMorph
				on: morph
				getState: #isOn
				action: selector)
				label: labelString.
	button hResizing: #spaceFill;
		 vResizing: #spaceFill;
		 setBalloonText: helpString.
	^ button! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildCheckBoxOn: morph action: actionSelector getSelector: getSelector help: helpString 
	^ UpdatingThreePhaseButtonMorph checkBox target: morph;
		 actionSelector: actionSelector;
		 getSelector: getSelector;
		 setBalloonText: helpString! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildRowLabeled: labelName 
	| rowMorph label |
	rowMorph _ AlignmentMorph newRow vResizing: #shrinkWrap.
	label _ TextMorph new contents: labelName;
				 lock.
	rowMorph addMorphBack: label.
	^ rowMorph! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildRow: leftMorph with: rightMorph
	^self buildRow: leftMorph with: rightMorph with: nil with: nil! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildRow: firstMorph with: secondMorph with: thirdMorph
	^self buildRow: firstMorph with: secondMorph with: thirdMorph with: nil! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 6/30/2005 22:41'!
buildRow: firstMorph with: secondMorph with: thirdMorph with: fourthMorph 
	| rowMorph |
	rowMorph _ AlignmentMorph newRow.
	firstMorph notNil
		ifTrue: [rowMorph addMorphBack: firstMorph].
	secondMorph notNil
		ifTrue: [rowMorph addMorphBack: secondMorph].
	thirdMorph notNil
		ifTrue: [rowMorph addMorphBack: thirdMorph].
	fourthMorph notNil
		ifTrue: [rowMorph addMorphBack: fourthMorph].
	^ rowMorph! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 7/20/2005 21:21'!
buildTextField: selector on: target
	^self buildTextField: selector on: target help: ''! !

!NmBuilderMorph methodsFor: 'building' stamp: 'mu 7/20/2005 21:20'!
buildTextField: selector on: target help: helpString
	| getter setter textField |
	getter _ selector.
	setter _ (getter , ':') asSymbol.
	textField _ PluggableTextMorph
				on: target
				text: getter
				accept: setter.
	textField acceptOnCR: true.
	textField hideScrollBarIndefinitely.
	textField borderWidth: 1.
	textField extent: 600@20.
	textField hResizing: #spaceFill;
		 vResizing: #spaceFill.
	textField setBalloonText: helpString.
	^ textField! !

!NmBuilderMorph methodsFor: 'constants' stamp: 'mu 7/2/2005 00:07'!
buttonFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.742
							g: 0.903
							b: 1.0). 1.0
					-> (Color
							r: 0.516
							g: 0.71
							b: 1.0)}.
	fill origin: self bounds topLeft + (14 @ 3).
	fill direction: 8 @ 6.
	fill radial: false.
	^ fill! !

!NmBuilderMorph methodsFor: 'private' stamp: 'mu 7/2/2005 00:07'!
buttonName: aString action: aSymbol 
	^ self defaultButtonClass new target: self;
		 label: aString;
		 actionSelector: aSymbol;
		
		color: (Color gray: 0.8);
		 fillStyle: self buttonFillStyle;
		 borderWidth: 4;
		 borderColor: #complexAltRaised;
		 cornerStyle: #square! !

!NmBuilderMorph methodsFor: 'initialization' stamp: 'mu 6/30/2005 22:41'!
createSystemWindow
	|  window |
	self listDirection: #topToBottom.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	window _ (SystemWindow labelled: self class labelString)
				model: Model new.
	window
		addMorph: self
		frame: (0 @ 0 corner: 1 @ 1).
	window extent: self class windowExtent.
	^ window! !

!NmBuilderMorph methodsFor: 'initialization' stamp: 'mu 6/30/2005 22:41'!
createWindow
	"NmAbstractSettingMorph createSystemWindow openInWorld."
	^self createSystemWindow! !

!NmBuilderMorph methodsFor: 'constants' stamp: 'mu 7/2/2005 00:06'!
defaultButtonClass
	^ SimpleButtonMorph! !

!NmBuilderMorph methodsFor: 'testing' stamp: 'mu 6/30/2005 22:41'!
isOn
	^false! !

NmBuilderMorph subclass: #NmWorldMapMorph
	instanceVariableNames: 'worldMap updateIgnored'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 8/17/2005 08:49'!
createWindow
	| insts inst |
	insts _ self existingOn: NmWorldMap default.
	inst _ insts isEmpty
				ifTrue: [self new createWindow]
				ifFalse: [insts first].
	inst registerDependent.
	^ inst! !

!NmWorldMapMorph class methodsFor: 'constants' stamp: 'ka 1/10/2003 12:26'!
defaulfRowExtent
	^ 93 @ 58! !

!NmWorldMapMorph class methodsFor: 'constants' stamp: 'ka 1/10/2003 12:05'!
defaultInset
	^ 16! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 4/29/2005 23:56'!
existingOn: aNmWorldMap
	| existing |
	existing _ ActiveWorld submorphs
				select: [:each | (each isKindOf: NmWorldMapMorph)
						and: [each worldMap = aNmWorldMap]].
	^existing! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 3/4/2005 01:19'!
open
	^self openOn: NmWorldMap default! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 4/16/2005 00:07'!
openOn: aWorldMap 
	"self openOn: NmWorldMap new"
	^ self new setWorldMap: aWorldMap;
		 createWindow;
		 openInWorld! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'mu 8/2/2005 08:53'!
openSingleOn: aNmWorldMap 
	| world existing inst |
	world _ ActiveWorld.
	existing _ self existingOn: aNmWorldMap.
	existing isEmpty
		ifTrue: [inst _ (self openOn: aNmWorldMap)
						center: world center]
		ifFalse: [world addMorphFront: (inst _ existing first)].
	^ inst! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 7/2/2005 00:22'!
addButtonRow
	| buttonBar |
	buttonBar _ AlignmentMorph newRow cellInset: 2;
				 hResizing:  #shrinkWrap;
				vResizing:  #shrinkWrap;
				 color: Color transparent.
	buttonBar
		addMorphBack: (self buttonName: 'Store' action: #store).
	buttonBar
		addMorphBack: (self buttonName: 'Load' action: #load).
	buttonBar
		addMorphBack: (self buttonName: 'Init' action: #initAllInfo).
	buttonBar
		addMorphBack: (self buttonName: 'Inspect' action: #inspectMap).
	buttonBar
		addMorphBack: (self buttonName: 'Close' action: #close).
	buttonBar setBorderStyle: #complexAltInset.
	buttonBar borderWidth: 4.
	self addMorphBack: buttonBar! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 8/11/2005 13:15'!
addInfoRow
	| infoBar |
	infoBar _ AlignmentMorph newRow cellInset: 2;
				 hResizing: #shrinkWrap;
				 vResizing: #shrinkWrap;
				 color: Color transparent.
	infoBar addMorphBack: NmWorldMapInfoMorph new.
	infoBar setBorderStyle: #complexAltInset.
	infoBar borderWidth: 4.
	infoBar lock.
	self addMorphBack: infoBar! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 09:51'!
addMap
	| panel |
	panel _ self makePanel.
	panel load: self worldMap.
	self addMorphBack: panel! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'mu 8/16/2005 14:23'!
basicLoad
	[self worldMap load.
	self worldMap allUnchanged]
		on: Error
		do: [self inform: 'WorldMap loading failed!!' translated.
			^ self]! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 8/2/2005 08:27'!
cells
	| cells |
	self panel ifNil: [^#()].
	cells := OrderedCollection new.
	self panel rows do: [:each | cells addAll: each cells].
	^cells
	! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 8/17/2005 08:50'!
close
	self hasChanged
		ifTrue: [(PopUpMenu confirm: 'Store to server?')
				ifTrue: [self store]].
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [self unregisterDependent.
			self owner closeBoxHit]
		ifFalse: [self delete]! !

!NmWorldMapMorph methodsFor: 'initialize-release' stamp: 'mu 4/29/2005 23:58'!
createWindow
	self initSubPanels! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ka 1/10/2003 12:05'!
defaultInset
	^ self class defaultInset! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:21'!
defaultOwnerClass
	^ SystemWindow! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 11:35'!
handleLoaded
	self panelLoad! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 11:36'!
handleLocalEntryUpdated
	self panelLoad

 ! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 11:36'!
handleStored
	self panelLoad! !

!NmWorldMapMorph methodsFor: 'events' stamp: 'ns 9/11/2002 18:59'!
handlesMouseDown: evt 
	^ true! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 10:11'!
handleVersionUp: voteBox 
	self hasChanged
		ifTrue: [| loadOrNot | 
			loadOrNot _ PopUpMenu confirm: 'Version up from remote. Load anyway?' translated.
			voteBox add: loadOrNot]! !

!NmWorldMapMorph methodsFor: 'testing' stamp: 'mu 8/18/2005 12:48'!
hasChanged
	self updateIgnored ifTrue: [^true].
	^ (self worldMap entries
			anySatisfy: [:each | each hasChanged])
		or: [self panel hasChanged]! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 8/18/2005 12:38'!
initAllInfo
	(PopUpMenu confirm: 'Really initialize the world map?' translated)
		ifFalse: [^ self].
	self worldMap initMap.
	NmServerManager isMapServerOnlyImage
		ifTrue: [self worldMap incrementVersion.
			^ self changed; initSubmorphs].
	self worldMap isLocal
		ifTrue: [self worldMap
				forceRegister: (NmWorldMapEntry
						id: Smalltalk id
						point: 0 @ 0
						name: '')].
	self initSubmorphs.
	self updateIgnored: false.
	WorldState
		addDeferredUIMessage: [self panel
				ifNotNilDo: [:p | p borderColorEdited]].
	(PopUpMenu confirm: 'WorldMap was initialized. Store now?' translated)
				ifTrue: [self  store]! !

!NmWorldMapMorph methodsFor: 'initialize-release' stamp: 'mu 7/12/2005 21:28'!
initialize
	super initialize.
	self fillStyle: self backgroundFillStyle.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	borderWidth _ 1.
	self listDirection: #topToBottom.
	self cornerStyle: #square.
	self layoutInset: 4.

	self useRoundedCorners.
	! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 22:49'!
initSubmorphs
	self submorphsDo: [:each | each delete].
	self initSubPanels.
	! !

!NmWorldMapMorph methodsFor: 'initialize-release' stamp: 'mu 4/5/2005 01:41'!
initSubPanels
	self addButtonRow.
	self addMap.
	self addInfoRow.
	! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 1/14/2005 01:05'!
inspectMap
	self worldMap inspect! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 8/22/2005 09:05'!
load
	(self hasChanged)
		ifTrue: [(self confirm:  'Not stored. Load anyway?') ifFalse: [^self]]. 
	self updateIgnored: false.
	self basicLoad.
	
	! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 09:07'!
makePanel
	| panel |
	panel _ NmWorldMapPanelMorph inset: self defaultInset.
	panel reset.
	^ panel! !

!NmWorldMapMorph methodsFor: 'testing' stamp: 'mu 4/29/2005 00:00'!
mapIsLocal
	^self worldMap isLocal! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:22'!
minimumExtent
	| width height |
	width _ height _ 0.
	self submorphs
		do: [:each | 
			width _ width max: each extent x.
			height _ height + each extent y].
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [height _ height + self owner labelHeight + 20.
			width _ width + 20].
	^ width @ height! !

!NmWorldMapMorph methodsFor: 'events' stamp: 'ka 1/10/2003 15:07'!
morphToGrab: event
	| morphs morph |
	morphs _ self morphsAt: event position.
	morphs isEmpty
		ifTrue: [^ nil].
	morph _ morphs first.
	(morph isKindOf: TextMorph)
		ifTrue: [^ morph owner].
	(morph isMemberOf: BorderedMorph)
		ifTrue: [^ morph].
	(morph isKindOf: AlignmentMorph)
		ifTrue: [(morph submorphOfClass: self defaultButtonClass) notNil
				ifTrue: [^ nil]
				ifFalse: [(morph submorphOfClass: AlignmentMorph) notNil
						ifTrue: [^ nil]
						ifFalse: [^ morph]]].
	^ nil! !

!NmWorldMapMorph methodsFor: 'events' stamp: 'mu 2/4/2005 00:17'!
mouseDown: evt 
	"Handle a mouse down event."
	| grabbedMorph |
	grabbedMorph _ self morphToGrab: evt.
	grabbedMorph
		ifNotNil: [| result | 
			grabbedMorph isSticky
				ifTrue: [^ self].
			result _ evt hand grabMorph: grabbedMorph.
			^ result].
	(super handlesMouseDown: evt)
		ifTrue: [^ super mouseDown: evt].
	evt hand halo: nil.
	"shake off halos"
	evt hand releaseKeyboardFocus.
	"shake of keyboard foci"
	evt shiftPressed
		ifTrue: [^ evt hand
				waitForClicksOrDrag: self
				event: evt
				selectors: {#'findWindow:'. nil. nil. #'dragThroughOnDesktop:'}
				threshold: 5].
	evt wasHandled: false! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 4/29/2005 09:06'!
panel
	^self findA: NmWorldMapPanelMorph! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 4/29/2005 09:45'!
panelDo: aBlock
	^self panel ifNotNilDo: aBlock! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 11:35'!
panelLoad
	self isInWorld
		ifFalse: [^ self delete].
	self
		panelDo: [:p | p load: worldMap]! !

!NmWorldMapMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 8/17/2005 08:50'!
privateDelete
	super privateDelete.
	self unregisterDependent.! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 08:38'!
registerDependent
	self worldMap ifNil: [^self].
	self worldMap addDependent: self! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 8/17/2005 08:49'!
setWorldMap: aNmWorldMap
	self unregisterDependent.
	self worldMap: aNmWorldMap.
	(self findDeeplyA: NmWorldMapInfoMorph) ifNotNilDo: [:infoMorph | infoMorph worldMap: aNmWorldMap].
	self registerDependent.! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/18/2005 11:34'!
shouldIgnoreChanged
	(ActiveHand findA: NmWorldMapEntryMorph) ifNotNil: [^true].
	(ActiveHand findA: NmWorldMapRowMorph) ifNotNil: [^true].
	(ActiveWorld findA: MVCMenuMorph) ifNotNil: [^true].
	^false
	
! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 8/2/2005 09:33'!
showLocationOf: morph
	| addressEntry detection |
	addressEntry := morph path last.
	detection := self cells detect: [:entryMorph | entryMorph mapEntry = addressEntry] ifNone:[].
	detection ifNil: [^self].
	detection blink! !

!NmWorldMapMorph methodsFor: 'stepping' stamp: 'mu 8/18/2005 12:24'!
step
	NmServerManager isMapServerOnlyImage
		ifTrue: [self tryRecoverWorldMap.
				self worldMap isEmpty ifTrue: [self delete].
			^ self].
	self mapIsLocal
		ifFalse: [self setWorldMap: NmWorldMap default.
			self basicLoad].
	self updateLazilyForIgnoredChange! !

!NmWorldMapMorph methodsFor: 'stepping' stamp: 'mu 8/11/2005 12:58'!
stepTime
	NmServerManager isMapServerOnlyImage
		ifTrue: [^6000].
	^1500! !

!NmWorldMapMorph methodsFor: 'actions' stamp: 'mu 8/22/2005 09:06'!
store
	self updateIgnored: false.
	self panelDo: [:p | p store: self worldMap].
	

	! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'mu 8/11/2005 13:03'!
tryRecoverWorldMap
	| originalName newMap |
	
	NmServerManager isMapServerOnlyImage ifFalse: [^self].
	self worldMap isEmpty ifFalse: [^self].

	originalName := self worldMap mapName.
	newMap := NmWorldMapServer default worldMaps at: originalName ifAbsent: [^self].

	self setWorldMap: newMap.
	self basicLoad! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 08:39'!
unregisterDependent
	worldMap ifNil: [^self].
	self worldMap removeDependent: self! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 8/18/2005 12:05'!
updateIgnored
	updateIgnored ifNil: [updateIgnored _ false].
	^updateIgnored! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 8/18/2005 12:05'!
updateIgnored: aBoolean
	updateIgnored _ aBoolean == true! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/22/2005 09:06'!
updateLazilyForIgnoredChange
	self updateIgnored
		ifFalse: [^ self].
	self shouldIgnoreChanged not
		ifTrue: [| loadOrNot | 
			loadOrNot := PopUpMenu confirm: 'Version up from remote. Load anyway?' translated.
			^ loadOrNot
				ifTrue: [self updateIgnored: false.
					self panelLoad]
				ifFalse: [self]]! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/17/2005 10:29'!
update: anAspect 
	self update: anAspect with: nil

	
! !

!NmWorldMapMorph methodsFor: 'updating' stamp: 'mu 8/18/2005 12:07'!
update: anAspect with: parameter
	anAspect isString ifFalse: [^self].
	self shouldIgnoreChanged ifTrue: [self updateIgnored: true. ^self].
	NmTranscript crShow: self class name, {anAspect. parameter} asString.
	anAspect == #worldMapLoaded
		ifTrue: [self handleLoaded].
	anAspect == #worldMapStored
		ifTrue: [self handleStored].
	anAspect == #localEntryUpdated
		ifTrue: [self handleLocalEntryUpdated].
	anAspect == #worldMapVersionUp
		ifTrue: [self handleVersionUp: parameter].

	
! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 8/11/2005 11:40'!
worldMap
	worldMap isNil
		ifTrue: [worldMap := NmWorldMap default].
	^ worldMap! !

!NmWorldMapMorph methodsFor: 'accessing' stamp: 'mu 8/11/2005 08:35'!
worldMap: aNmWorldMap
	worldMap := aNmWorldMap! !

AlignmentMorph subclass: #NmWorldMapPanelMorph
	instanceVariableNames: 'lastDescriptionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapPanelMorph class methodsFor: 'instance creation' stamp: 'mu 3/16/2005 23:57'!
inset: inset
	| inst |
	inst _ self newColumn.
	inst cellInset: inset;
		 layoutInset: inset.
	inst enableDragNDrop; vResizing: #shrinkWrap; hResizing: #shrinkWrap; layoutInset: inset; borderColor: Color black; borderWidth: 1; wrapCentering: #left; cellPositioning: #topLeft.
	inst borderWidth: 4.
	^ inst! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 6/4/2004 23:18'!
backgroundColor
	^ Color gray: 0.9! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 5/8/2005 23:01'!
basicLoad: aNmWorldMap 
	| points yValues minY maxY xValues minX maxX |
	self submorphsDo:[:each | each delete].
	points _ aNmWorldMap allPoints.
	yValues _ points
				collect: [:each | each y].
	yValues isEmpty ifTrue: [^self].
	minY _ yValues min.
	maxY _ yValues max.
	xValues _ points
				collect: [:each | each x].
	xValues isEmpty ifTrue: [^self].
	minX _ xValues min.
	maxX _ xValues max.
	minY
		to: maxY
		do: [:idxY | 
			| row existingCells | 
			row _ self makeRow.
			self addMorph: row.
			existingCells _ points
						select: [:each | each y = idxY].
			existingCells isEmpty
				ifFalse: [minX
						to: maxX
						do: [:idxX | 
							| destMorph destEntry | 
							destMorph _ NmWorldMapEntryMorph new.
							row addMorphBack: destMorph.
							destEntry _ aNmWorldMap atPoint: idxX @ idxY.
							destMorph setEntry: destEntry].
					row reset]].
	! !

!NmWorldMapPanelMorph methodsFor: 'updating' stamp: 'mu 4/28/2005 23:22'!
basicUpdate: anObject 
	self resetColor.
	! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 3/16/2005 01:09'!
borderColorEdited
	self borderColor: self defaultEditedColor! !

!NmWorldMapPanelMorph methodsFor: 'private' stamp: 'mu 4/27/2005 01:49'!
computeColor
	self mapMorph ifNil: [^self backgroundColor].
	^self mapMorph hasChanged
		ifTrue: [self defaultEditedColor]
		ifFalse: [self backgroundColor]! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:08'!
defaultConflictsColor
	^ Color yellow! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:08'!
defaultEditedColor
	^ Color red! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 3/17/2005 00:59'!
defaultFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0 -> (Color
							r: 0.9
							g: 0.9
							b: 0.9). 1.0
					-> (Color
							r: 0.46
							g: 0.86
							b: 0.86)}.
	fill origin: self bounds topLeft + (4 @ 10).
	fill direction: 50 @ 6.
	fill radial: false.
	^ fill! !

!NmWorldMapPanelMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:01'!
defaultNotStoredColor
	^ Color red! !

!NmWorldMapPanelMorph methodsFor: 'describing state' stamp: 'mu 1/23/2005 05:03'!
descriptionString
	^self rows inject: String new into: [:inj :each | inj, each descriptionString]! !

!NmWorldMapPanelMorph methodsFor: 'testing' stamp: 'mu 3/15/2005 01:06'!
hasChanged
	^ (self rows
			anySatisfy: [:each | each hasChanged])
		or: [| currentDescriptionString | 
			currentDescriptionString _ self descriptionString.
			currentDescriptionString ~= self lastDescriptionString]! !

!NmWorldMapPanelMorph methodsFor: 'initialize-release' stamp: 'mu 3/17/2005 00:55'!
initialize
	super initialize.
	self fillStyle: self defaultFillStyle! !

!NmWorldMapPanelMorph methodsFor: 'describing state' stamp: 'mu 3/15/2005 01:10'!
lastDescriptionString
	lastDescriptionString
		ifNil: [lastDescriptionString _ self descriptionString].
	^ lastDescriptionString! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 8/17/2005 11:24'!
load: aNmWorldMap 
	| entries |
	aNmWorldMap ifNil: [^self].
	entries _ aNmWorldMap entries.
	(entries isEmpty and: [NmServerManager isMapServerOnlyImage not])
		ifTrue: [self inform: 'WorldMap is empty!! Use "save as..." and open multi images' translated.
			^ self].
	WorldState
		addDeferredUIMessage: [self basicLoad: aNmWorldMap.
			self resetColor]! !

!NmWorldMapPanelMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/29/2005 09:52'!
makeRow
	"self basicNew makeRow openInHand"
	| row |
	row _ NmWorldMapRowMorph newRow.
	^ row! !

!NmWorldMapPanelMorph methodsFor: 'accessing' stamp: 'mu 4/14/2005 00:50'!
mapMorph
	^ (self owner isMemberOf: NmWorldMapMorph)
		ifTrue: [self owner]! !

!NmWorldMapPanelMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/14/2005 00:31'!
privateAddMorph: aMorph atIndex: index 
	self lastDescriptionString.
	super privateAddMorph: aMorph atIndex: index.
	self basicUpdate: self! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 4/14/2005 00:47'!
reset
	self resetColor.
	self rows
		do: [:e | e reset]! !

!NmWorldMapPanelMorph methodsFor: 'private' stamp: 'mu 4/14/2005 00:39'!
resetBorderColor
	self borderColor: self computeColor! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 4/14/2005 00:48'!
resetColor
	self resetBorderColor! !

!NmWorldMapPanelMorph methodsFor: 'accessing' stamp: 'mu 12/31/2004 04:55'!
rows
	^self submorphs select: [:each | each isKindOf: NmWorldMapRowMorph]! !

!NmWorldMapPanelMorph methodsFor: 'actions' stamp: 'mu 8/18/2005 13:06'!
store: aWorldMap
	| panelSize rows entries |
	panelSize := self rows size.
	rows := self rows reverse.
	entries := OrderedCollection new.
	1
		to: panelSize
		do: [:y | 
			| cells cellSize | 
			cells := (rows at: y) cells.
			cellSize := cells size.
			1
				to: cellSize
				do: [:x | 
					| destinationMorph point | 
					destinationMorph := cells at: x.
					point := x @ y - (1 @ 1).
					destinationMorph exists
						ifTrue: [| entry | 
							entry := destinationMorph mapEntry.
							entry isNil
								ifFalse: [entries add: (entry point: point)]]]].
	aWorldMap initWithEntries: entries.
	aWorldMap store. 
	self resetColor.

	! !

!NmWorldMapPanelMorph methodsFor: 'updating' stamp: 'mu 4/14/2005 00:34'!
update: anObject 
	(anObject isMemberOf: NmWorldMapRowMorph)
		ifTrue: [self basicUpdate: anObject.
			lastDescriptionString _ nil]! !

!NmWorldMapPanelMorph methodsFor: 'dropping/grabbing' stamp: 'mu 5/19/2003 13:40'!
wantsDroppedMorph: aMorph event: evt
	^aMorph isKindOf: NmWorldMapRowMorph! !

AlignmentMorph subclass: #NmWorldMapRowMorph
	instanceVariableNames: 'lastDescriptionString destinationEdited'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapRowMorph class methodsFor: 'constants' stamp: 'mu 4/10/2005 03:33'!
defaulfExtent
	^ 60 @ 30! !

!NmWorldMapRowMorph class methodsFor: 'constants' stamp: 'mu 4/8/2005 00:56'!
defaultInset
	^ 16! !

!NmWorldMapRowMorph class methodsFor: 'instance creation' stamp: 'mu 4/8/2005 00:57'!
newRow
	| row |
	row _ super newRow.
	row enableDragNDrop; vResizing: #shrinkWrap; hResizing: #shrinkWrap; layoutInset: 8; borderWidth: 2; wrapCentering: #left; cellPositioning: #topLeft.
	row cellInset: self defaultInset;
		 layoutInset: self defaultInset.
	row extent: self defaulfExtent.
	row borderColor: Color transparent.
	^ row! !

!NmWorldMapRowMorph methodsFor: 'updating' stamp: 'mu 3/17/2005 01:20'!
basicUpdate: anObject 
	self resetColor.
	self panel
		ifNotNilDo: [:p | p update: self]! !

!NmWorldMapRowMorph methodsFor: 'accessing' stamp: 'mu 4/8/2005 00:17'!
cells
	^self submorphs select: [:each | each isKindOf: NmWorldMapEntryMorph]! !

!NmWorldMapRowMorph methodsFor: 'private' stamp: 'mu 4/14/2005 00:39'!
computeColor
	^self hasChanged
		ifTrue: [NmWorldMapEntryMorph defaultEditedColor]
		ifFalse: [self defaultColor]! !

!NmWorldMapRowMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 01:27'!
defaultColor
	^Color lightGray lighter! !

!NmWorldMapRowMorph methodsFor: 'constants' stamp: 'mu 3/16/2005 23:50'!
defaultFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.7
							g: 0.7
							b: 0.7). 1.0
					-> (Color
							r: 0.5
							g: 0.6
							b: 0.7)}.
	fill origin: self bounds topLeft + (20 @ 30).
	fill direction: 30 @ 9.
	fill radial: false.
	^ fill! !

!NmWorldMapRowMorph methodsFor: 'describing state' stamp: 'mu 2/3/2005 23:36'!
descriptionString
	self cells isEmpty ifTrue: [^''].
	^self cells inject: String new into: [:inj :each | inj, each descriptionString]! !

!NmWorldMapRowMorph methodsFor: 'testing' stamp: 'mu 3/8/2005 01:25'!
destinationEdited
	destinationEdited ifNil: [destinationEdited _ false].
	^destinationEdited! !

!NmWorldMapRowMorph methodsFor: 'testing' stamp: 'mu 3/8/2005 01:12'!
hasChanged
	^ self destinationEdited
		or: [self layoutEdited]! !

!NmWorldMapRowMorph methodsFor: 'initialization' stamp: 'mu 4/10/2005 03:32'!
initialize
	super initialize.
	self fillStyle: self defaultFillStyle.
	! !

!NmWorldMapRowMorph methodsFor: 'describing state' stamp: 'mu 4/10/2005 03:02'!
lastDescriptionString
	lastDescriptionString
		ifNil: [lastDescriptionString _ self descriptionString].
	^ lastDescriptionString! !

!NmWorldMapRowMorph methodsFor: 'testing' stamp: 'mu 4/10/2005 03:48'!
layoutEdited
	| currentDescriptionString |
	currentDescriptionString _ self descriptionString.
	^currentDescriptionString ~= self lastDescriptionString! !

!NmWorldMapRowMorph methodsFor: 'accessing' stamp: 'mu 3/17/2005 01:11'!
panel
	^ (self owner isMemberOf: NmWorldMapPanelMorph)
		ifTrue: [self owner]! !

!NmWorldMapRowMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/10/2005 03:19'!
privateAddMorph: aMorph atIndex: index 
	self lastDescriptionString.
	super privateAddMorph: aMorph atIndex: index.
	self basicUpdate: self! !

!NmWorldMapRowMorph methodsFor: 'submorphs-add/remove' stamp: 'mu 4/25/2005 00:25'!
privateRemove: aMorph 
	super privateRemove: aMorph.
	self lastDescriptionString.
	self basicUpdate: self! !

!NmWorldMapRowMorph methodsFor: 'initialization' stamp: 'mu 4/14/2005 00:47'!
reset
	lastDescriptionString _ nil.
	destinationEdited _ false.
	self resetColor! !

!NmWorldMapRowMorph methodsFor: 'private' stamp: 'mu 4/14/2005 00:39'!
resetBorderColor
	self borderColor: self computeColor! !

!NmWorldMapRowMorph methodsFor: 'private' stamp: 'mu 3/17/2005 01:09'!
resetColor
	self resetBorderColor! !

!NmWorldMapRowMorph methodsFor: 'stepping' stamp: 'mu 4/10/2005 03:34'!
step
	self cells isEmpty
		ifTrue: [self borderColor: self defaultColor.
			self extent: self class defaulfExtent]! !

!NmWorldMapRowMorph methodsFor: 'stepping' stamp: 'mu 4/10/2005 03:26'!
stepTime
	^2000! !

!NmWorldMapRowMorph methodsFor: 'updating' stamp: 'mu 4/10/2005 03:51'!
update: anObject 
	(anObject isMemberOf: NmWorldMapEntry)
		ifTrue: [destinationEdited _ anObject hasChanged.
			destinationEdited ifFalse: [lastDescriptionString _ self descriptionString].
			self basicUpdate: self]! !

!NmWorldMapRowMorph methodsFor: 'dropping/grabbing' stamp: 'mu 4/8/2005 00:17'!
wantsDroppedMorph: aMorph event: evt
	^aMorph isKindOf: NmWorldMapEntryMorph! !

!NmWorldMapRowMorph methodsFor: 'dropping/grabbing' stamp: 'mu 1/22/2005 02:50'!
wantsToBeDroppedInto: aMorph 
	(aMorph isKindOf: TrashCanMorph) ifTrue: [^true].
	(aMorph isKindOf: self class) ifTrue: [^false].
	^false
		! !

!ImageMorph methodsFor: '*NetMorph-geometry' stamp: 'mu 7/14/2005 21:59'!
scaledToSize: anExtent
	self image: (self image scaledToSize: anExtent)! !

!UUID class methodsFor: '*NetMorph-override-instance creation' stamp: 'mu 7/29/2005 19:07'!
fromString: aString
	| object |
	aString size ~= 36 ifTrue: [Error signal: 'Invalid string for uuid: ', aString asString].
	object := self nilUUID. 
	object asUUID: aString.
	^object! !

!Workspace methodsFor: '*NetMorph-user edits' stamp: 'MU 1/20/2004 16:42'!
okToChange

	(self dependents detect: [:each | each isWarping] ifNone: []) ifNotNil: [^true].
	^super okToChange! !

!Project class methodsFor: '*NetMorph-accessing' stamp: 'mu 6/20/2005 22:44'!
infoFileExtension
	^'info'! !

!Project class methodsFor: '*NetMorph-instance creation' stamp: 'MU 1/15/2004 23:16'!
loadFrom: bytes
	| readWriteStream |
	readWriteStream _ (RWBinaryOrTextStream with: bytes) reset.
	^ProjectLoading loadFrom: readWriteStream! !

!Project class methodsFor: '*NetMorph-accessing' stamp: 'mu 6/18/2005 22:50'!
netMorphPublishDirectory
	| directoryName |
	directoryName _ NmBaseUtil shortImagePrefix, '.Projects'.
	(FileDirectory default directoryExists: directoryName) ifFalse: [
		FileDirectory default createDirectory: directoryName
	].
	^FileDirectory default directoryNamed: directoryName! !

!Project class methodsFor: '*NetMorph-accessing' stamp: 'mu 6/11/2004 01:19'!
saveOriginatingWorld
	^SaveOriginatingWorld! !

!Project class methodsFor: '*NetMorph-accessing' stamp: 'mu 6/11/2004 03:23'!
saveOriginatingWorld: aWorld
	SaveOriginatingWorld _ aWorld! !

!Project class methodsFor: '*NetMorph-actions' stamp: 'mu 6/11/2004 03:32'!
savingWorldDo: aBlock 
	[self saveOriginatingWorld: (self current ifNotNilDo: [:proj | proj world]).
	aBlock value]
		ensure: [self saveOriginatingWorld: nil]! !

!Project class methodsFor: '*NetMorph-accessing' stamp: 'mu 6/20/2005 22:55'!
thumbnailFileExtension
	^'png'! !

!Project class methodsFor: '*NetMorph-actions' stamp: 'mu 8/22/2005 16:05'!
trimNetMorphPublishDirectory
	self netMorphPublishDirectory entries
		ifEmpty: [self netMorphPublishDirectory recursiveDelete]! !

!Project methodsFor: '*NetMorph-entering' stamp: 'mu 8/7/2005 19:35'!
adjustForNetMorph
	world savedImageId
		ifNil: [^ self].
	world savedImageId = NmImageId current
		ifTrue: [^ self].
	
	self adjustMorphIdentifiers.
	self adjustReferredIdentifiers.
	self adjustHomeEntries
	! !

!Project methodsFor: '*NetMorph-entering' stamp: 'mu 8/7/2005 19:42'!
adjustHomeEntries
	world
		allMorphsDo: [:mo | mo basicPath isEmpty
				ifFalse: [mo basicPath first beDeferredLocal]]! !

!Project methodsFor: '*NetMorph-entering' stamp: 'mu 7/13/2005 17:05'!
adjustMorphIdentifiers
	world morphIdentifierAlreadyAdjusted
		ifTrue: [world flushMorphIdentifierAlreadyAdjusted.
			^ self].
	world flushMorphIdentifierRenameList.
	world
		allMorphsDo: [:mo | mo extension
				ifNotNilDo: [:ext | 
					| oldId newId | 
					oldId _ ext basicIdentifier.
					oldId
						ifNotNil: [ext resetIdentifier.
							newId _ ext identifier.
							world morphIdentifierRenameList at: oldId asString put: newId asString]]]! !

!Project methodsFor: '*NetMorph-entering' stamp: 'mu 8/3/2005 08:00'!
adjustReferredIdentifiers
	self adjustReferredIdentifiersOfPlayers.
	self adjustReferredIdentifiersOfMarkerDock! !

!Project methodsFor: '*NetMorph-entering' stamp: 'mu 8/3/2005 07:52'!
adjustReferredIdentifiersOfMarkerDock
	world markerDock
		ifNotNilDo: [:dock | dock markers
				do: [:each | 
					| targetIdString | 
					targetIdString _ each targetMorphIdentifier asString.
					(world morphIdentifierRenameList includesKey: targetIdString)
						ifTrue: [each
								targetMorphIdentifier: (UUID
										fromString: (world morphIdentifierRenameList at: targetIdString))]]].
	(world allMorphs
		select: [:each | (each isMemberOf: NmMarkerMorph)
				and: [(each owner isMemberOf: NmMarkerDockMorph) not]])
		do: [:each | 
			| targetIdString | 
			targetIdString _ each targetMorphIdentifier asString.
			(world morphIdentifierRenameList includesKey: targetIdString)
				ifTrue: [each
						targetMorphIdentifier: (UUID
								fromString: (world morphIdentifierRenameList at: targetIdString))]]! !

!Project methodsFor: '*NetMorph-entering' stamp: 'mu 8/3/2005 07:29'!
adjustReferredIdentifiersOfPlayers
	world
		allMorphsDo: [:mo | mo
				playerNotNilDo: [:pl | 
					| sources | 
					sources := pl scriptSources.
					sources
						do: [:eachSrc | 
							| eachNewSrc | 
							eachNewSrc := eachSrc. 
							world morphIdentifierRenameList
								keysAndValuesDo: [:oldIdString :newIdString | 
									eachNewSrc := eachNewSrc copyReplaceAll: oldIdString with: newIdString.].
								eachNewSrc = eachSrc
									ifFalse: [pl compileScript: eachNewSrc]]]]! !

!Project methodsFor: '*NetMorph-storing/loading' stamp: 'mu 6/11/2004 03:29'!
asLoadableData
	self class savingWorldDo: [
	| dirAndFileName dir fileName stream data |
	dirAndFileName := self storeOnLocal.
	dirAndFileName isEmpty
		ifTrue: [^ nil].
	dir := dirAndFileName first.
	fileName := dirAndFileName second.
	[stream := dir readOnlyFileNamed: fileName.
	stream binary.
	data := stream contents]
		ensure: [stream
				ifNotNil: [stream close]].
	dir deleteFileNamed: fileName.
	^ data]! !

!Project methodsFor: '*NetMorph-override-menu messages' stamp: 'mu 8/7/2005 11:47'!
enter: returningFlag revert: revertFlag saveForRevert: saveForRevert
	"Install my ChangeSet, Transcript, and scheduled views as current globals. If returningFlag is true, we will return to the project from whence the current project was entered; don't change its previousProject link in this case.
	If saveForRevert is true, save the ImageSegment of the project being left.
	If revertFlag is true, make stubs for the world of the project being left.
	If revertWithoutAsking is true in the project being left, then always revert."

	| showZoom recorderOrNil old forceRevert response seg newProcess |

	(world isKindOf: StringMorph) ifTrue: [
		self inform: 'This project is not all here. I will try to load a complete version.' translated.
		^self loadFromServer: true	"try to get a fresh copy"
	].
	self isCurrentProject ifTrue: [^ self].
	"Check the guards"
	guards ifNotNil:
		[guards := guards reject: [:obj | obj isNil].
		guards do: [:obj | obj okayToEnterProject ifFalse: [^ self]]].
	CurrentProject world triggerEvent: #aboutToLeaveWorld.
	forceRevert := false.
	CurrentProject rawParameters 
		ifNil: [revertFlag ifTrue: [^ self inform: 'nothing to revert to' translated]]
		ifNotNil: [saveForRevert ifFalse: [
				forceRevert := CurrentProject projectParameters 
								at: #revertWithoutAsking ifAbsent: [false]]].
	forceRevert not & revertFlag ifTrue: [
		response := SelectionMenu confirm: 'Are you sure you want to destroy this Project\ and revert to an older version?\\(From the parent project, click on this project''s thumbnail.)' translated withCRs
			trueChoice: 'Revert to saved version' translated
			falseChoice: 'Cancel' translated.
		response ifFalse: [^ self]].

	revertFlag | forceRevert 
		ifTrue: [seg := CurrentProject projectParameters at: #revertToMe ifAbsent: [
					^ self inform: 'nothing to revert to' translated]]
		ifFalse: [
			CurrentProject finalExitActions.
			CurrentProject makeThumbnail.
			returningFlag == #specialReturn
				ifTrue:
					[ProjectHistory forget: CurrentProject.		"this guy is irrelevant"
					Project forget: CurrentProject]
				ifFalse:
					[ProjectHistory remember: CurrentProject]].

	(revertFlag | saveForRevert | forceRevert) ifFalse:
		[(Preferences valueOfFlag: #projectsSentToDisk) ifTrue:
			[self storeToMakeRoom]].

	CurrentProject abortResourceLoading.
	Smalltalk isMorphic ifTrue: [CurrentProject world triggerClosingScripts].

	CurrentProject saveProjectPreferences.

	"Update the display depth and make a thumbnail of the current project"
	CurrentProject displayDepth: Display depth.
	old := CurrentProject.		"for later"

	"Show the project transition.
	Note: The project zoom is run in the context of the old project,
		so that eventual errors can be handled accordingly"
	displayDepth == nil ifTrue: [displayDepth := Display depth].
	self installNewDisplay: Display extent depth: displayDepth.
	(showZoom := self showZoom) ifTrue: [
		self displayZoom: CurrentProject parent ~~ self].

	(world isMorph and: [world hasProperty: #letTheMusicPlay])
		ifTrue: [world removeProperty: #letTheMusicPlay]
		ifFalse: [Smalltalk at: #ScorePlayer ifPresentAndInMemory:
					[:playerClass | playerClass allSubInstancesDo:
						[:player | player pause]]].

	returningFlag == #specialReturn ifTrue: [
		old removeChangeSetIfPossible.	"keep this stuff from accumulating"
		nextProject := nil
	] ifFalse: [
		returningFlag
			ifTrue: [nextProject := CurrentProject]
			ifFalse: [previousProject := CurrentProject].
	].

	CurrentProject saveState.
	CurrentProject isolationHead == self isolationHead ifFalse:
		[self invokeFrom: CurrentProject].
	CurrentProject := self.
	self installProjectPreferences.
	ChangeSet  newChanges: changeSet.
	TranscriptStream newTranscript: transcript.
	Sensor flushKeyboard.
	Smalltalk isMorphic ifTrue: [recorderOrNil := World pauseEventRecorder].

	ProjectHistory remember: CurrentProject.

	world isMorph
		ifTrue:
			[World := world.  "Signifies Morphic"
			world install.
			world transferRemoteServerFrom: old world.
			"(revertFlag | saveForRevert | forceRevert) ifFalse: [
				(Preferences valueOfFlag: #projectsSentToDisk) ifTrue: [
					self storeSomeSegment]]."
			recorderOrNil ifNotNil: [recorderOrNil resumeIn: world].
			self adjustForNetMorph.	"NetMorph"
			world triggerOpeningScripts]
		ifFalse:
			[World := nil.  "Signifies MVC"
			Smalltalk at: #ScheduledControllers put: world].

	saveForRevert ifTrue: [
		Smalltalk garbageCollect.	"let go of pointers"
		old storeSegment.
		"result _" old world isInMemory 
			ifTrue: ['Can''t seem to write the project.']
			ifFalse: [old projectParameters at: #revertToMe put: 
					old world xxxSegment clone].
				'Project written.'].
			"original is for coming back in and continuing."

	revertFlag | forceRevert ifTrue: [
		seg clone revert].	"non-cloned one is for reverting again later"
	self removeParameter: #exportState.

	"Complete the enter: by launching a new process"
	world isMorph ifTrue: [
		self finalEnterActions.
		world repairEmbeddedWorlds.
		world triggerEvent: #aboutToEnterWorld.
		Project spawnNewProcessAndTerminateOld: true
	] ifFalse: [
		SystemWindow clearTopWindow.	"break external ref to this project"
		newProcess := [	
			ScheduledControllers resetActiveController.	"in case of walkback in #restore"
			showZoom ifFalse: [ScheduledControllers restore].
			ScheduledControllers searchForActiveController
		] fixTemps newProcess priority: Processor userSchedulingPriority.
		newProcess resume.		"lose the current process and its referenced morphs"
		Processor terminateActive.
	]! !

!Project methodsFor: '*NetMorph-fine in/out' stamp: 'mu 7/2/2005 23:46'!
exportProjectInfoFileName: newName directory: dir 
	| info infoFileName |
	info _ self world valueOfProperty: #ProjectDetails.
	info ifEmpty: [^ self].
	info at: #projecttimestamp put: TimeStamp now printString.
	infoFileName _ (newName
				copyFrom: 1
				to: (newName lastIndexOf: $.))
				, self class infoFileExtension.
	NmBaseUtil store: info to: dir named: infoFileName! !

!Project methodsFor: '*NetMorph-fine in/out' stamp: 'mu 6/20/2005 23:00'!
exportThumbnailFileName: newName directory: dir
	| form formFileName stream |
	form _ self thumbnail.
	form ifNil: [^ self].
	formFileName _ (newName
				copyFrom: 1
				to: (newName lastIndexOf: $.))
				, self class thumbnailFileExtension.
	[stream _ dir forceNewFileNamed: formFileName.
	PNGReadWriter putForm: form onStream: stream]
		ensure: [stream close]! !

!Project methodsFor: '*NetMorph-override-file in/out' stamp: 'mu 6/18/2005 22:37'!
findAFolderToStoreProjectIn

	"Alan wants something prettier with a default"
	
	self world isNetMorphProjectPublishing ifTrue: [^#localOnly]. "NetMorph"

	self couldOpenInMorphic ifTrue: [
		^FileList2 modalFolderSelectorForProject: self
	] ifFalse: [
		^PluggableFileList getFolderDialog openLabel: 'Select a folder on a server:'
	]! !

!Project methodsFor: '*NetMorph-entering' stamp: 'mu 7/13/2005 17:59'!
inheritAdjustmentFrom: aProject 
	| originalRenameList |
	originalRenameList _ aProject world morphIdentifierRenameList.
	originalRenameList
		keysAndValuesDo: [:oldName :newName | world
				allMorphsDo: [:mo | mo extension
						ifNotNilDo: [:ext | 
							| oldId | 
							oldId _ ext basicIdentifier.
							(oldId notNil
									and: [oldId asString = oldName])
								ifTrue: [ext
										basicIdentifier: (UUID fromString: newName)]]]].
	world flushMorphIdentifierRenameList.
	originalRenameList
		keysAndValuesDo: [:k :v | world morphIdentifierRenameList at: k put: v].
	world morphIdentifierAlreadyAdjusted: true! !

!Project methodsFor: '*NetMorph-override-initialization' stamp: 'mu 12/12/2004 01:52'!
initMorphic
	"Written so that Morphic can still be removed.  Note that #initialize is never actually called for a morphic project -- see the senders of this method."

	Smalltalk verifyMorphicAvailability ifFalse: [^ nil].
	changeSet := ChangeSet new.
	transcript := TranscriptStream new.
	displayDepth := Display depth.
	parentProject := CurrentProject.
	isolatedHead := false.
	world := PasteUpMorph newWorldForProject: self.
	world fenceEnabled: CurrentProject world fenceEnabled.
	Locale switchToID: CurrentProject localeID.
	self initializeProjectPreferences "Do this *after* a world is installed so that the project will be recognized as a morphic one."


! !

!Project methodsFor: '*NetMorph-testing' stamp: 'mu 6/11/2004 01:48'!
isDead
	^(self name beginsWith: '<no name')! !

!Project methodsFor: '*NetMorph-testing' stamp: 'mu 6/18/2005 22:33'!
isNetMorphProjectPublishing
	self world ifNil: [^false].
	^self world isNetMorphProjectPublishing! !

!Project methodsFor: '*NetMorph-testing' stamp: 'mu 6/18/2005 02:29'!
isNetMorphPublished
	self world ifNil: [^false].
	^self world isNetMorphPublished! !

!Project methodsFor: '*NetMorph-accessing' stamp: 'mu 6/18/2005 22:48'!
netMorphPublishDirectory
	^self class netMorphPublishDirectory! !

!Project methodsFor: '*NetMorph-override-release' stamp: 'KY 1/19/2004 02:16'!
okToChange
	"Answer whether the window in which the project is housed can be dismissed -- which is destructive. We never clobber a project without confirmation"

	| ok |
	self subProjects size  >0 ifTrue:
		[self inform: 
('The project {1}
contains sub-projects.  You must remove these
explicitly before removing their parent.' translated format:{self name}).
		^ false].
	ok _ world isMorph not and: [world scheduledControllers size <= 1].
	ok ifFalse: [self isMorphic ifTrue:
		[self parent == CurrentProject 
			ifFalse: [^ true]]].  "view from elsewhere.  just delete it."
		
	ok _ (self confirm:
('Really delete the project
{1}
and all its windows?' translated format:{self name})).
		
	ok ifFalse: [^ false].
	self purge.
	^true! !

!Project methodsFor: '*NetMorph-release' stamp: 'mu 6/11/2004 01:48'!
purge
	| is list |
	(self isDead not and: [world isMorph])
		ifTrue: [Smalltalk
				at: #WonderlandCameraMorph
				ifPresent: [:aClass | world submorphs
						do: [:m | "special release for wonderlands"
							(m isKindOf: aClass)
								and: [m getWonderland release]]].
			"Remove Player classes and metaclasses owned by project"
			is _ ImageSegment new
						arrayOfRoots: (Array with: self).
			(list _ is rootsIncludingPlayers)
				ifNotNil: [list
						do: [:playerCls | (playerCls respondsTo: #isMeta)
								ifTrue: [playerCls isMeta
										ifFalse: [playerCls removeFromSystemUnlogged]]]]].
	self removeChangeSetIfPossible.
	"do this last since it will render project inaccessible to 
	#allProjects and their ilk"
	ProjectHistory forget: self.
	Project deletingProject: self! !

!Project methodsFor: '*NetMorph-storing/loading' stamp: 'mu 8/4/2005 07:28'!
storeOnLocal
	"Save to disk as an Export Segment. Then put that file on the server I 
	came from, as a new version. Version is literal piece of file name. 
	Mime encoded and http encoded."
	| newName localDirectory |
	self isDead	ifTrue: [^ #()].
	self world savedImageId: NmImageId current. 
	self world flushNetMorphProxyCache.
	self world flushMorphIdentifierWarpedList.
	"Find out what version"
	localDirectory := self squeakletDirectory.
	version := self bumpVersion: 0.
	"write locally - now zipped automatically"
	newName := self versionedFileName.
	lastSavedAtSeconds := Time totalSeconds.
	newName := lastSavedAtSeconds asString , '-' , 999 atRandom asString , self versionedFileName.
	self exportSegmentFileName: newName directory: localDirectory.
		
	^ {localDirectory. newName}! !

!Project methodsFor: '*NetMorph-override-file in/out' stamp: 'mu 8/4/2005 07:28'!
storeOnServerInnards
	"Save to disk as an Export Segment.  Then put that file on the server I came from, as a new version.  Version is literal piece of file name.  Mime encoded and http encoded."

	| resp newName primaryServerDirectory serverVersionPair localDirectory localVersionPair myVersionNumber warning maxNumber suppliedPassword oldResourceUrl |
	self assureIntegerVersion.

	self world savedImageId: NmImageId current. "NetMorph"
	self world flushNetMorphProxyCache. 
	self world flushMorphIdentifierWarpedList.

	"Find out what version"
	primaryServerDirectory := self primaryServerIfNil: [
		(primaryServerDirectory := self findAFolderToStoreProjectIn) ifNil: [^self].
		oldResourceUrl := self resourceUrl.
		primaryServerDirectory == #localOnly ifTrue: [
			self storeNewPrimaryURL: FileDirectory default url.
			nil
		] ifFalse: [
			self storeNewPrimaryURL: primaryServerDirectory downloadUrl.
			primaryServerDirectory
		].
	].

	localDirectory := self world isNetMorphProjectPublishing ifTrue:[self netMorphPublishDirectory] ifFalse: [self squeakletDirectory].	"NetMorph"

	serverVersionPair := self class mostRecent: self name onServer: primaryServerDirectory.
	localVersionPair := self class mostRecent: self name onServer: localDirectory.
	maxNumber := myVersionNumber := self currentVersionNumber.

	ProgressNotification signal: '2:versionsDetected'.

	warning := ''.
	myVersionNumber < serverVersionPair second ifTrue: [
		warning := warning,'\There are newer version(s) on the server' translated.
		maxNumber := maxNumber max: serverVersionPair second.
	].
	myVersionNumber < localVersionPair second ifTrue: [
		warning := warning,'\There are newer version(s) in the local directory' translated.
		maxNumber := maxNumber max: localVersionPair second.
	].
	"8 Nov 2000 - only check on the first attempt to publish"
	myVersionNumber = 0 ifTrue: [
		warning isEmpty ifFalse: [
			myVersionNumber = 0 ifTrue: [
				warning := warning,'\THIS PROJECT HAS NEVER BEEN SAVED' translated.
			].
			warning := 'WARNING' translated, '\Project: ' translated, self name,warning.
			resp := (PopUpMenu labels: 'Store anyway\Cancel' translated withCRs) startUpWithCaption: 
				(warning, '\Please cancel, rename this project, and see what is there.' translated) withCRs.
				resp ~= 1 ifTrue: [^ nil]
		].
	].
	version := self bumpVersion: maxNumber.

	oldResourceUrl
		ifNotNil: [self resourceManager adjustToNewServer: self resourceUrl from: oldResourceUrl].

	"write locally - now zipped automatically"
	newName := self versionedFileName.
	lastSavedAtSeconds := Time totalSeconds.
	self exportSegmentFileName: newName directory: localDirectory.
	(localDirectory readOnlyFileNamed: newName) setFileTypeToObject; close.

	self world isNetMorphProjectPublishing ifTrue: [
		self exportThumbnailFileName: newName directory: localDirectory.
		self exportProjectInfoFileName: newName directory: localDirectory].	"NetMorph"

	ProgressNotification signal: '4:localSaveComplete'.	"3 is deep in export logic"

	primaryServerDirectory ifNotNil: [
		suppliedPassword := ''.
		Preferences passwordsOnPublish ifTrue: [
			suppliedPassword := FillInTheBlank requestPassword: 'Project password' translated
		].
		[
		primaryServerDirectory
			writeProject: self
			inFileNamed: newName asFileName
			fromDirectory: localDirectory.
		] on: ProjectPasswordNotification do: [ :ex |
			ex resume: (suppliedPassword ifNil: [''])
		].
	].
	ProgressNotification signal: '9999 save complete'.

	"Later, store with same name on secondary servers.  Still can be race conditions.  All machines will go through the server list in the same order."
	"2 to: servers size do: [:aServer | aServer putFile: local named: newName]."
! !

!ObjectScanner methodsFor: '*NetMorph-actions' stamp: 'mu 1/6/2005 01:36'!
lookAhead: aChunk logged: logFlag
	| pieces sup oldName existing newName newDefn |
	aChunk size < 90 ifTrue: [^ aChunk].		"class defn is big!!"
	(aChunk at: 1) == $!! ifTrue: [^ aChunk].	"method def, fast exit"
	pieces _ (aChunk copyFrom: 1 to: (300 min: aChunk size)) findTokens: ' #	\' withCRs.
	pieces size < 3 ifTrue: [^ aChunk].	"really bigger, but just took front"
	(pieces at: 2) = 'subclass:' ifFalse: [^ aChunk].
	sup _ Smalltalk at: (pieces at: 1) asSymbol ifAbsent: [^ aChunk].
	sup class class == Metaclass ifFalse: [^ aChunk].
	((oldName _ pieces at: 3) at: 1) canBeGlobalVarInitial ifFalse: [^ aChunk].
	oldName _ oldName asSymbol.
	(Smalltalk includesKey: oldName) ifFalse: [^ aChunk].	"no conflict"
	existing _ Smalltalk at: oldName.
	(existing isKindOf: Class) ifFalse: [^ aChunk].	"Write over non-class global"
	existing isSystemDefined ifTrue: [^ aChunk].	"Go ahead and redefine it!!"
	"Is a UniClass"
	newName _ sup chooseUniqueClassName.
	newDefn _ aChunk copyReplaceAll: oldName with: newName.
	Compiler evaluate: newDefn for: self logged: logFlag.	"Create the new class"
	self rename: oldName toBe: newName.
	^ newName asString		"to be evaluated"
! !

!ObjectScanner methodsFor: '*NetMorph-actions' stamp: 'ka 10/17/2002 19:38'!
scanFrom: aByteStream logged: logFlag 
	| valWithOddName47 scannerNamed53 chunkNamed117 |
	pvt3SmartRefStrm _ SmartRefStream on: aByteStream.
	aByteStream ascii.
	[aByteStream atEnd]
		whileFalse: [aByteStream skipSeparators.
			valWithOddName47 _ (aByteStream peekFor: $!!)
						ifTrue: [chunkNamed117 _ aByteStream nextChunk.
							"debug"
							scannerNamed53 _ Compiler
										evaluate: chunkNamed117
										for: self
										logged: logFlag.
							scannerNamed53 class == self class
								ifFalse: [scannerNamed53 scanFrom: aByteStream logged: logFlag]]
						ifFalse: [chunkNamed117 _ aByteStream nextChunk.
							chunkNamed117 _ self lookAhead: chunkNamed117 logged: logFlag.
							Compiler
								evaluate: chunkNamed117
								for: self
								logged: logFlag].
			aByteStream skipStyleChunk].
	^ valWithOddName47! !

TileMorph subclass: #NmEffectTile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-eToys'!

!NmEffectTile methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self addArrows; setLiteral: 'none'.
	self labelMorph useStringFormat! !

!NmEffectTile methodsFor: 'user interface' stamp: ''!
mouseDown: evt 
	| aPoint index isUp effectChoices adjustment |
	upArrow
		ifNotNil: [((isUp _ upArrow containsPoint: (aPoint _ evt cursorPoint))
					or: [downArrow containsPoint: aPoint])
				ifTrue: [effectChoices _ Morph effectSymbols.
					index _ effectChoices indexOf: literal.
					index > 0
						ifTrue: [adjustment _ isUp
										ifTrue: [1]
										ifFalse: [-1].
							self
								literal: (effectChoices atWrap: index + adjustment)]].
			^ self].
	super mouseStillDown: evt! !

!NmEffectTile methodsFor: 'user interface' stamp: ''!
mouseMove: evt 
	"overridden so as NOT to keep scrolling"
	^ self! !

!NmEffectTile methodsFor: 'type' stamp: ''!
resultType
	"Answer the result type of the receiver"
	^ #Effect! !

!NmEffectTile methodsFor: 'user interface' stamp: ''!
wantsKeyboardFocusFor: aSubmorph 
	^ false! !

!TileMorph methodsFor: '*NetMorph-serializing' stamp: 'kuri-t 12/13/2002 15:27'!
prepareForWarp
	type ~~ #objRef ifTrue: [^ self].
	actualObject isProxy ifTrue: [^ self].
	actualObject isPlayerLike ifFalse: [^ self].
	self topEditor playerScripted == actualObject ifTrue: [^ self].

	actualObject _ actualObject asProxy! !

!TileMorph methodsFor: '*NetMorph-testing' stamp: 'kuri-t 12/10/2002 14:44'!
shouldPrepareForWarp
	^ true! !

!PluggableTextMorph methodsFor: '*NetMorph-override-model access' stamp: 'ka 2/25/2003 18:37'!
getText
	"Retrieve the current model text"
	| newText modelValue |
	getTextSelector == nil
		ifTrue: [^ Text new].
	modelValue _ model perform: getTextSelector.
	newText _ (modelValue respondsTo: #asText)
				ifTrue: [modelValue asText]
				ifFalse: [modelValue asString asText].
	^ newText shallowCopy! !

!PluggableTextMorph methodsFor: '*NetMorph-accessing' stamp: 'mu 7/20/2005 20:34'!
textMorph
	^textMorph! !

!Morph class methodsFor: '*NetMorph-override-scripting' stamp: 'mu 12/13/2004 01:10'!
additionsToViewerCategoryMiscellaneous
	"Answer viewer additions for the 'miscellaneous' category"

	^#(
		miscellaneous 
		(
			(command doMenuItem: 'do the menu item' Menu)
			(command show 'make the object visible')
			(command hide 'make the object invisible')
			(command wearCostumeOf: 'wear the costume of...' Player)

			(command fire 'trigger any and all of this object''s button actions')
			(slot copy 'returns a copy of this object' Player readOnly Player getNewClone	 unused unused)
			(slot elementNumber 'my index in my container' Number readWrite Player getIndexInOwner Player setIndexInOwner:)
			(slot holder 'the object''s container' Player readOnly Player getHolder Player setHolder:)
			(command stamp 'add my image to the pen trails')
			(command erase 'remove this object from the screen')
			(command stampAndErase 'add my image to the pen trails and go away')
			(command effects: 'add an Mugi Mugi effect on me' Effect)
		)
	)

! !

!Morph class methodsFor: '*NetMorph-override-scripting' stamp: 'mu 12/13/2004 01:11'!
additionsToViewerCategoryMotion
	"Answer viewer additions for the 'motion' category"

	^#(
		motion 
		(
			(slot x 'The x coordinate' Number readWrite Player getX Player setX:)
			(slot y  	'The y coordinate' Number readWrite Player 	getY Player setY:)
			(slot heading  'Which direction the object is facing.  0 is straight up' Number readWrite Player getHeading Player setHeading:)
			(command forward: 'Moves the object forward in the direction it is heading' Number)
			(slot obtrudes 'whether the object sticks out over its container''s edge' Boolean readOnly Player getObtrudes unused unused) 
			(command turnToward: 'turn toward the given object' Player) 
			(command moveToward: 'move toward the given object' Player) 
			(command turn: 'Change the heading of the object by the specified amount' Number)
			(command bounce: 'bounce off the edge if hit' Sound) 
			(command wrap 'wrap off the edge if appropriate') 
			(command followPath 'follow the yellow brick road') 
			(command goToRightOf: 'place this object to the right of another' Player)
			(command head: 'turn my head' Direction)
		)
	)

! !

!Morph class methodsFor: '*NetMorph-scripting' stamp: 'ka 1/15/2003 17:51'!
additionsToViewerCategoryNetMorph
	"Answer viewer additions for the 'NetMorph' category"

	^#(
		NetMorph 
		(
			(slot home 'my home' WarpDestination readOnly Player getHome Player unused)
			(slot address 'my address' WarpDestination readOnly Player getAddress Player unused)
			"(slot identifier 'my identifier' String readOnly Player getIdentifier Player unused)"
			(command warp 'engage warp drive')
			(command warp: 'engage warp drive' Warp)
			(command warpTo: 'warp to the specified address' WarpDestination)
		)
	)
! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
canvasAll: aMorph 
	| wholeCanvas visible baseCanvas |
	visible _ aMorph visible.
	visible
		ifFalse: [aMorph visible: true].
	wholeCanvas _ FormCanvas extent: ActiveWorld bounds extent.
	wholeCanvas fullDraw: ActiveWorld.
	visible
		ifFalse: [aMorph visible: false].
	baseCanvas _ FormCanvas extent: aMorph bounds extent.
	baseCanvas drawImage: wholeCanvas form at: aMorph bounds topLeft negated.
	^ baseCanvas! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
canvasBelow: aMorph 
	| wholeCanvas intersectsWindows bgMorph baseCanvas |
	wholeCanvas _ FormCanvas extent: ActiveWorld bounds extent.
	(bgMorph _ ActiveWorld backgroundSketch) isNil
		ifTrue: [wholeCanvas fillColor: ActiveWorld color]
		ifFalse: [wholeCanvas drawOn: bgMorph].
	wholeCanvas fillColor: Color white.
	wholeCanvas drawMorph: ActiveWorld.
	intersectsWindows _ self intersectsWindows: aMorph bounds below: aMorph.
	intersectsWindows
		do: [:each | wholeCanvas fullDraw: each].
	baseCanvas _ FormCanvas extent: aMorph bounds extent.
	baseCanvas drawImage: wholeCanvas form at: aMorph bounds topLeft negated.
	^ baseCanvas! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
canvasWithout: aMorph 
	| wholeCanvas visible baseCanvas |
	visible _ aMorph visible.
	visible
		ifTrue: [aMorph visible: false].
	wholeCanvas _ FormCanvas extent: ActiveWorld bounds extent.
	wholeCanvas fullDraw: ActiveWorld.
	visible
		ifTrue: [aMorph visible: true].
	baseCanvas _ FormCanvas extent: aMorph bounds extent.
	baseCanvas drawImage: wholeCanvas form at: aMorph bounds topLeft negated.
	^ baseCanvas! !

!Morph class methodsFor: '*NetMorph-support' stamp: 'ns 9/18/2002 17:57'!
effectExample
	"Morph effectExample."
	| savedDepth rectangleMorph1 rectangleMorph2 ellipseMorph starMorph selectors |
	(savedDepth _ Display depth) < 32
		ifTrue: [Display newDepth: 32].
	rectangleMorph1 _ RectangleMorph new.
	rectangleMorph1 position: 100 @ 100.
	rectangleMorph1 extent: 200 @ 300.
	rectangleMorph1 color: Color red.
	rectangleMorph2 _ RectangleMorph new.
	rectangleMorph2 position: 250 @ 125.
	rectangleMorph2 extent: 200 @ 300.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 200 @ 200.
	ellipseMorph position: 150 @ 150.
	starMorph _ StarMorph new.
	starMorph extent: 200 @ 200.
	starMorph color: Color red.
	starMorph position: 150 @ 150.
	starMorph borderWidth: 4.
	starMorph addHandles.
	starMorph setBorderStyle: #complexAltRaised.
	starMorph useGradientFill.
	starMorph fillStyle radial: true.
	starMorph fillStyle
		lastColor: (Color
				r: 0.972
				g: 0.972
				b: 0.066)
		forMorph: starMorph
		hand: ActiveHand.
	starMorph toggleDropShadow.
	rectangleMorph1 openInWorld.
	ellipseMorph openInWorld.
	starMorph openInWorld.
	rectangleMorph2
		color: (TranslucentColor
				r: 1.0
				g: 0.452
				b: 0.645
				alpha: 0.447).
	rectangleMorph2 openInWorld.
	ActiveWorld refreshWorld.
	selectors _ #(#poofIn #fadeImageSquares #appearImageSquares #curtainFall #curtainRise #pageOut #pageIn #zoomOut #zoomIn #frenchDoorClose #frenchDoorOpen #frenchWindowClose #frenchWindowOpen #poofOut #dissolve ).
	Display
		restoreAfter: [selectors
				do: [:selector | 
					Transcript cr; show: selector.
					ellipseMorph perform: selector.
					(Delay forMilliseconds: 500) wait].
			ellipseMorph dismissMorph: nil.
			rectangleMorph1 dismissMorph: nil.
			rectangleMorph2 dismissMorph: nil.
			starMorph dismissMorph: nil.
			Smalltalk garbageCollect.
			ActiveWorld refreshWorld].
	savedDepth ~= Display depth
		ifTrue: [Display newDepth: savedDepth]! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
effectSymbols
	"Morph effectSymbols."
	| effectSymbols defaultSymbol |
	defaultSymbol _ #none.
	effectSymbols _ (self organization
				listAtCategoryNamed: (Morph organization categoryOfElement: defaultSymbol)) asOrderedCollection.
	effectSymbols
		remove: defaultSymbol
		ifAbsent: [].
	effectSymbols addFirst: defaultSymbol.
	^ effectSymbols asArray! !

!Morph class methodsFor: '*NetMorph-instance creation' stamp: 'mu 7/29/2005 09:00'!
fromUUIDString: anUUIDString 
	^self fromUUIDString: anUUIDString retry: 1! !

!Morph class methodsFor: '*NetMorph-instance creation' stamp: 'mu 7/29/2005 09:00'!
fromUUIDString: anUUIDString retry: retry
	| anUUID |
	anUUID _ UUID fromString: anUUIDString.
	^ self fromUUID: anUUID retry: retry! !

!Morph class methodsFor: '*NetMorph-instance creation' stamp: 'mu 7/29/2005 09:01'!
fromUUID: anUUID 
	 ^self fromUUID: anUUID retry: 1! !

!Morph class methodsFor: '*NetMorph-instance creation' stamp: 'mu 7/29/2005 09:01'!
fromUUID: anUUID retry: retry
	"Morph fromUUID: UUID new"
	"Morph fromUUID: ActiveWorld allMorphs first identifier"
	| detection netMorphProxy morphProxy |
	detection _ (ActiveWorld allMorphs reject: [:each | each isRenderer])
				detect: [:morph | morph identifier = anUUID]
				ifNone: [].
	detection isNil
		ifFalse: [^ detection].
	netMorphProxy _ ActiveWorld netMorphProxyCache
				at: anUUID
				ifAbsent: [].
	netMorphProxy isNil
		ifFalse: [^ netMorphProxy]. 
	morphProxy _ NmRemoteConnector callFindBy: anUUID retry: retry.
	morphProxy isNil
		ifFalse: [ActiveWorld netMorphProxyCache at: anUUID put: morphProxy.
			^ morphProxy].
	^ nil! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
imageAll: aMorph 
	^ (self canvasAll: aMorph) form! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
imageBelow: aMorph 
	^ (self canvasBelow: aMorph) form! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
imageWithout: aMorph 
	^ (self canvasWithout: aMorph) form! !

!Morph class methodsFor: '*NetMorph-override-class initialization' stamp: 'mu 12/13/2004 00:53'!
initialize
	"Morph initialize"

	"this empty array object is shared by all morphs with no submorphs:"
	EmptyArray _ Array new.
	FileList registerFileReader: self.

	WarpProtect _ Semaphore forMutualExclusion.! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
intersectsWindows: aRectangle below: targetMorph 
	| windows |
	windows _ OrderedCollection new.
	ActiveWorld submorphs reverse
		do: [:morph | 
			morph == targetMorph
				ifTrue: [^ windows].
			(morph bounds intersects: targetMorph bounds)
				ifTrue: [windows add: morph]].
	^ windows! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
intersectsWindows: aRectangle with: targetMorph 
	^ (ActiveWorld submorphs reverse
		reject: [:morph | morph == targetMorph])
		select: [:morph | morph bounds intersects: targetMorph bounds]! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
outsideBelowAndAboveWindows: aRectangle with: targetMorph 
	| intersectsWindows windows |
	intersectsWindows _ self intersectsWindows: aRectangle below: targetMorph.
	windows _ ActiveWorld submorphs asOrderedCollection.
	windows removeAll: intersectsWindows.
	windows
		remove: targetMorph
		ifAbsent: [].
	^ windows! !

!Morph class methodsFor: '*NetMorph-support' stamp: ''!
outsideWindows: aRectangle with: targetMorph 
	| intersectsWindows windows |
	intersectsWindows _ self intersectsWindows: aRectangle with: targetMorph.
	windows _ ActiveWorld submorphs asOrderedCollection.
	windows removeAll: intersectsWindows.
	windows
		remove: targetMorph
		ifAbsent: [].
	^ windows! !

!Morph class methodsFor: '*NetMorph-instance creation' stamp: 'ka 10/17/2002 19:46'!
readFrom: aStream 
	| object logFlag |
	logFlag _ false.
	aStream reset.
	[[aStream atEnd]
		whileFalse: [aStream skipSeparators.
			[(aStream peekFor: $!!)
				ifTrue: [(Compiler evaluate: aStream nextChunk logged: logFlag)
						scanFrom: aStream
						logged: logFlag]
				ifFalse: [| chunk | 
					chunk _ aStream nextChunk.
					aStream checkForPreamble: chunk.
					Compiler evaluate: chunk logged: logFlag]]
				on: InMidstOfFileinNotification
				do: [:ex | ex resume: true].
			aStream skipStyleChunk]]
		ensure: [aStream close].
	object _ SmartRefStream scannedObject.
	SmartRefStream scannedObject: nil.
	^ object! !

!Morph class methodsFor: '*NetMorph-class initialization' stamp: 'mu 5/19/2003 15:23'!
resetWarpProtect
	"Morph resetWarpProtect"
	WarpProtect isSignaled
		ifFalse: [[WarpProtect isEmpty]
				whileFalse: [WarpProtect terminateProcess].
			WarpProtect initSignals.
			WarpProtect signal]! !

!Morph methodsFor: '*NetMorph-override-rotate scale and flex' stamp: 'kuri-t 2/18/2003 14:36'!
addFlexShell
	"Wrap a rotating and scaling shell around this morph."
	| oldHalo flexMorph myWorld |
	myWorld _ self world.
	oldHalo _ self halo.
	self owner isFlexMorph
		ifTrue: [flexMorph _ self owner]
		ifFalse: [self owner addMorph: (flexMorph _ self newTransformationMorph asFlexOf: self)].
	self transferStateToRenderer: flexMorph.
	oldHalo
		ifNotNil: [oldHalo setTarget: flexMorph].
	myWorld
		ifNotNil: [myWorld startSteppingSubmorphsOf: flexMorph].
	^ flexMorph! !

!Morph methodsFor: '*NetMorph-menu' stamp: 'mu 8/2/2005 07:29'!
addMarkerMenuItemsTo: aMenu hand: aHandMorph 

	aMenu 
		add: 'leave footprint here...' translated
		action: #leaveMarkerAttached.
	aMenu 
		add: 'leave footprint to dock...' translated
		action: #leaveMarkerToDock.

	! !

!Morph methodsFor: '*NetMorph-menu' stamp: 'mu 8/2/2005 07:32'!
addNetMorphMenuItemsTo: aMenu hand: aHandMorph 
	| selectorWithArguments subMenu |
	subMenu := MenuMorph new defaultTarget: self.

	selectorWithArguments := OrderedCollection new.
	selectorWithArguments
		add: (Array
				with: 'address' translated
				with: #showContentsOf:
				with: #address).
	selectorWithArguments
		add: (Array
				with: 'home' translated
				with: #showContentsOf:
				with: #home).
	selectorWithArguments
		add: (Array
				with: 'identifier' translated
				with: #showContentsOf:
				with: #identifier).
	selectorWithArguments
		add: (Array
				with: 'guruguru warp' translated
				with: #guruguruWarp
				with: nil).
	selectorWithArguments
		do: [:each | subMenu perform: #add:selector:argument: withArguments: each].

	subMenu addLine.
	self addMarkerMenuItemsTo: subMenu hand: aHandMorph.

	subMenu addLine.
	subMenu
		add: 'warp to ' translated
		subMenu: (self addWarpToMenuItemsTo: subMenu hand: aHandMorph).

	aMenu add: 'NetMorph' translated subMenu: subMenu.

	^ subMenu! !

!Morph methodsFor: '*NetMorph-example' stamp: 'kuri-t 1/6/2003 12:39'!
addPhrase: aPhrase to: aScriptor 
	| i slideMorph p1 p2 |
	aScriptor prepareToUndoDropOf: aPhrase.
	i _ aScriptor submorphs size.
	slideMorph _ aPhrase imageForm offset: 0 @ 0.
	p1 _ aPhrase screenRectangle topLeft.
	aPhrase delete.
	aScriptor stopSteppingSelector: #trackDropZones.
	aScriptor world displayWorld.
	(aPhrase isKindOf: PhraseTileMorph)
		ifTrue: [aPhrase justGrabbedFromViewer: false].
	aPhrase tileRows
		do: [:tileList | 
			aScriptor
				insertTileRow: (Array
						with: (tileList first rowOfRightTypeFor: owner forActor: aPhrase associatedPlayer))
				after: i.
			i _ i + 1].
	aScriptor removeSpaces.
	aScriptor enforceTileColorPolicy.
	aScriptor layoutChanged.
	aScriptor fullBounds.
	p2 _ (aScriptor submorphs
				atPin: (i - 1
						max: (aScriptor instVarNamed: 'firstTileRow'))) screenRectangle topLeft.
	slideMorph
		slideFrom: p1
		to: p2
		nSteps: 5
		delay: 50
		andStay: true.
	aScriptor playSoundNamed: 'scritch'.
	aScriptor topEditor install! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'mu 5/12/2003 18:51'!
address
	"ADDRESS may be confusing - but for end user, NmUrl is address"
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension address! !

!Morph methodsFor: '*NetMorph-menu' stamp: 'mu 8/2/2005 07:32'!
addWarpToMenuItemsTo: aMenu hand: aHandMorph 
	| availableUrls subMenu selectorWithArguments selector |
	selector := #warpFromMenuTo:.
	availableUrls := NmWorldMap default worldNamesWithoutLocal
				asSortedCollection: [:x :y | x asString < y asString].
	selectorWithArguments := OrderedCollection new.
	availableUrls
		do: [:each | selectorWithArguments
				add: (Array
						with: each asString
						with: selector
						with: each)].
	subMenu := MenuMorph new defaultTarget: self.
	selectorWithArguments
		do: [:each | subMenu perform: #add:selector:argument: withArguments: each].
	subMenu addLine.
	subMenu
		add: 'Home' translated
		action: #warpToHome.
	subMenu addLine.
	subMenu
		add: 'other ...' translated
		selector: selector
		argument: nil.
	^ subMenu! !

!Morph methodsFor: '*NetMorph-callback' stamp: 'mu 6/13/2004 00:02'!
afterWarpActions
	self extension == nil
		ifTrue: [self assureExtension].
	^ self valueOfProperty: #afterWarpActions ifAbsent: [#()]! !

!Morph methodsFor: '*NetMorph-callback' stamp: 'mu 6/13/2004 00:02'!
afterWarpActions: arrayOfSymbols
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #afterWarpActions toValue: arrayOfSymbols! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
appearImageSquares
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: false.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageAll: morph.
	self fadeImageSquares: newDisplay at: self bounds topLeft.
	morph visible: true! !

!Morph methodsFor: '*NetMorph-menu' stamp: 'mu 8/2/2005 07:32'!
askWarpDestination
	| answer |
	answer := FillInTheBlankMorph
				request: 'Where do you wanna go? (hostname:port)' translated
				initialAnswer: 'hostname:port'
				centerAt: (ActiveHand
						ifNil: [Sensor]) cursorPoint
				inWorld: ActiveWorld
				onCancelReturn: nil.
	(NmUtil ipAndPortFromString: answer)
		ifNil: [self inform: 'bad input.' translated.
			^ nil].
	^ answer! !

!Morph methodsFor: '*NetMorph-converting' stamp: 'kuri-t 12/13/2002 15:06'!
asProxy
	^ NmMorphProxy on: self! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 12/16/2004 00:31'!
assureNetMorphExtension
	self identifier; path! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'mu 8/7/2005 10:19'!
basicPath
	self extension == nil
		ifTrue: [^#()].
	^ self extension path! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'mu 8/7/2005 10:32'!
basicPath: visitedLocationCollection 
	self extension == nil
		ifTrue: [^self].
	self extension path: visitedLocationCollection! !

!Morph methodsFor: '*NetMorph-callback' stamp: 'mu 6/13/2004 00:02'!
beforeWarpActions
	self extension == nil
		ifTrue: [self assureExtension].
	^ self valueOfProperty: #beforeWarpActions ifAbsent: [#()]! !

!Morph methodsFor: '*NetMorph-callback' stamp: 'mu 6/13/2004 00:02'!
beforeWarpActions: arrayOfSymbols
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #beforeWarpActions toValue: arrayOfSymbols! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 8/4/2005 12:04'!
beWarpFailed: messageText
	self topRendererOrSelf openInWorld.
	self warping: #warpFailed.
	self notifyWarpFailed.
	self lastWarpTime: Time totalSeconds.
	self player ifNotNilDo:[:p | p stopProgramatically].
	self poofIn.
	
	! !

!Morph methodsFor: '*NetMorph-override-meta-actions' stamp: 'ns 12/10/2002 14:19'!
buildHandleMenu: aHand
	"Build the morph menu for the given morph's halo's menu handle. This menu has two sections. The first section contains commands that are interpreted by the hand; the second contains commands provided by the target morph. This method allows the morph to decide which items should be included in the hand's section of the menu."

	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu addLine.
	self addStandardHaloMenuItemsTo: menu hand: aHand.
	menu defaultTarget: aHand.
	self addAddHandMenuItemsForHalo: menu  hand: aHand.
	menu defaultTarget: self.
	self addCustomHaloMenuItems: menu hand: aHand.
	menu defaultTarget: aHand.

	menu addLine.
	self addNetMorphMenuItemsTo: menu hand: aHand.
	menu addLine.

	^ menu! !

!Morph methodsFor: '*NetMorph-override-meta-actions' stamp: 'dgd 11/15/2003 19:29'!
buildMetaMenu: evt
	"Build the morph menu. This menu has two sections. The first section contains commands that are handled by the hand; the second contains commands handled by the argument morph."
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu addStayUpItem.
	menu add: 'grab' translated action: #grabMorph:.
	menu add: 'copy to paste buffer' translated action: #copyToPasteBuffer:.
	self maybeAddCollapseItemTo: menu.
	menu add: 'delete' translated action: #dismissMorph:.
	menu addLine.
	menu add: 'copy text' translated action: #clipText.
	menu add: 'copy Postscript' translated action: #clipPostscript.
	menu add: 'print Postscript to file...' translated action: #printPSToFile.
	menu addLine.
	menu add: 'go behind' translated action: #goBehind.
	menu add: 'add halo' translated action: #addHalo:.
	menu add: 'duplicate' translated action: #maybeDuplicateMorph:.

	self addEmbeddingMenuItemsTo: menu hand: evt hand.

	menu add: 'resize' translated action: #resizeMorph:.
	"Give the argument control over what should be done about fill styles"
	self addFillStyleMenuItems: menu hand: evt hand.
	self addDropShadowMenuItems: menu hand: evt hand.
	self addLayoutMenuItems: menu hand: evt hand.
	menu addUpdating: #hasClipSubmorphsString target: self selector: #changeClipSubmorphs argumentList: #().
	menu addLine.

	(self morphsAt: evt position) size > 1 ifTrue:
		[menu add: 'submorphs...' translated
			target: self
			selector: #invokeMetaMenuAt:event:
			argument: evt position].
	menu addLine.
	menu add: 'inspect' translated selector: #inspectAt:event: argument: evt position.
	menu add: 'explore' translated action: #explore.
	menu add: 'browse hierarchy' translated action: #browseHierarchy.
	menu add: 'make own subclass' translated action: #subclassMorph.
	menu addLine.
	menu add: 'set variable name...' translated action: #choosePartName.
	(self isMorphicModel) ifTrue:
		[menu add: 'save morph as prototype' translated action: #saveAsPrototype.
		(self ~~ self world modelOrNil) ifTrue:
			 [menu add: 'become this world''s model' translated action: #beThisWorldsModel]].
	menu add: 'save morph in file' translated action: #saveOnFile.
	(self hasProperty: #resourceFilePath)
		ifTrue: [((self valueOfProperty: #resourceFilePath) endsWith: '.morph')
				ifTrue: [menu add: 'save as resource' translated action: #saveAsResource].
				menu add: 'update from resource' translated action: #updateFromResource]
		ifFalse: [menu add: 'attach to resource' translated action: #attachToResource].
	menu add: 'show actions' translated action: #showActions.
	menu addLine.
	self addDebuggingItemsTo: menu hand: evt hand.

	menu addLine.
	self addNetMorphMenuItemsTo: menu hand: evt hand.
	menu addLine.

	self addCustomMenuItems: menu hand: evt hand.
	^ menu
! !

!Morph methodsFor: '*NetMorph-example' stamp: 'mu 12/15/2004 01:23'!
buildPhraseForSelector: selector
	| methodInterface player aDocString resultType cmd universal aPhrase argType argTile balloonTextSelector tileBearingHelp selfTile |
	methodInterface _ self methodInterfaceNamed: selector.
	player _ self assuredPlayer.
	aDocString _ methodInterface documentation.
	resultType _ methodInterface resultType.
	cmd _ methodInterface selector.
	(universal _ player isUniversalTiles)
		ifTrue: [aPhrase _ player universalTilesForInterface: methodInterface]
		ifFalse: [cmd numArgs == 0
				ifTrue: [aPhrase _ PhraseTileMorph new vocabulary: self currentVocabulary.
					aPhrase
						setOperator: cmd
						type: resultType
						rcvrType: #Player]
				ifFalse: ["only one arg supported in classic tiles, so if this 
					is fed 
					with a selector with > 1 arg, results will be very 
					strange "
					argType _ methodInterface typeForArgumentNumber: 1.
					aPhrase _ PhraseTileMorph new vocabulary: self currentVocabulary.
					aPhrase
						setOperator: cmd
						type: resultType
						rcvrType: #Player
						argType: argType.
					argTile _ ScriptingSystem tileForArgType: argType.
					argTile position: aPhrase lastSubmorph position.
					aPhrase lastSubmorph addMorph: argTile]].
	(player slotInfo includesKey: cmd)
		ifTrue: [balloonTextSelector _ #userSlot].
	(player belongsToUniClass
			and: [player class includesSelector: cmd])
		ifTrue: [aDocString
				ifNil: [aDocString _ (player class userScriptForPlayer: player selector: cmd) documentationOrNil].
			aDocString
				ifNil: [balloonTextSelector _ #userScript]].
	tileBearingHelp _ universal
				ifTrue: [aPhrase submorphs second]
				ifFalse: [aPhrase operatorTile].
	aDocString
		ifNil: [balloonTextSelector
				ifNil: [tileBearingHelp setProperty: #inherentSelector toValue: cmd.
					balloonTextSelector _ #methodComment].
			tileBearingHelp balloonTextSelector: balloonTextSelector]
		ifNotNil: [tileBearingHelp setBalloonText: aDocString].
	aPhrase markAsPartsDonor.
	cmd == #emptyScript
		ifTrue: [aPhrase setProperty: #newPermanentScript toValue: true.
			aPhrase setProperty: #newPermanentPlayer toValue: player.
			aPhrase submorphs second setBalloonText: 'drag and drop to 
add a new script'].
	universal
		ifFalse: [selfTile _ player tileToRefer.
			selfTile position: aPhrase firstSubmorph position.
			aPhrase firstSubmorph addMorph: selfTile].
	^ aPhrase duplicate! !

!Morph methodsFor: '*NetMorph-serialization' stamp: 'mu 6/13/2004 00:06'!
clearExtensionBeforeWarp
	| renderer |
	renderer _ self topRendererOrSelf.
	#(#formerOwner #formerPosition #undoGrabCommand )
		do: [:each | renderer extension removeProperty: each]! !

!Morph methodsFor: '*NetMorph-e-toy support' stamp: 'kuri-t 12/17/2002 15:35'!
costumeState
	| costumeState |
	costumeState _ NmCostumeState new.
	costumeState imageForm: self imageForm.
	costumeState rotationCenter: self rotationCenter.
	costumeState rotationStyle:  self rotationStyle.
	costumeState referencePosition: self referencePosition.
	costumeState forwardDirection: self forwardDirection.
	costumeState shouldRememberCostumes: self shouldRememberCostumes.
	^ costumeState! !

!Morph methodsFor: '*NetMorph-marker' stamp: 'mu 7/28/2005 22:44'!
createMarker
	| markerMorph |
	markerMorph _ self markerMorphClass on: self.
	^markerMorph
	
	! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 12/28/2004 00:17'!
currentPointInTheMap
	^NmWorldMap default localPoint
	
	! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
curtainFall
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: true.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageWithout: morph.
	self
		curtainImage: newDisplay
		at: self bounds topLeft
		delta: 0 @ 2.
	morph visible: false! !

!Morph methodsFor: '*NetMorph-effects-private' stamp: ''!
curtainImage: newDisplay at: topLeft delta: delta 
	| boundingBox wipeRect nSteps |
	boundingBox _ newDisplay boundingBox.
	wipeRect _ delta x = 0
				ifTrue: [delta y = 0
						ifTrue: [nSteps _ 1.
							boundingBox]
						ifFalse: [nSteps _ boundingBox height // delta y abs + 1.
							delta y > 0
								ifTrue: [boundingBox topLeft extent: boundingBox width @ delta y]
								ifFalse: [boundingBox bottomLeft + delta extent: boundingBox width @ delta y negated]]]
				ifFalse: [nSteps _ boundingBox width // delta x abs + 1.
					delta x > 0
						ifTrue: [boundingBox topLeft extent: delta x @ boundingBox height]
						ifFalse: [boundingBox topRight + delta extent: delta x negated @ boundingBox height]].
	Display
		wipeImage: newDisplay
		at: topLeft
		clippingBox: nil
		rectForIndex: [:i | 
			(Delay forMilliseconds: 3) wait.
			i <= nSteps
				ifTrue: [wipeRect translateBy: delta * (i - 1)]]! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
curtainRise
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: false.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageAll: morph.
	self
		curtainImage: newDisplay
		at: self bounds topLeft
		delta: 0 @ -2.
	morph visible: true! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'kuri-t 2/6/2003 14:48'!
deferWarpToNeighbor: destination 
	self warping: #prepareWarp.
	WorldState
		addDeferredUIMessage: [self warpToNeighbor: destination]! !

!Morph methodsFor: '*NetMorph-override-submorphs-add/remove' stamp: 'KY 1/2/2004 23:57'!
delete
	"Remove the receiver as a submorph of its owner and make its 
	new owner be nil."

	| aWorld |
	aWorld := self world ifNil: [World].
	"Terminate genie recognition focus"
	"I encountered a case where the hand was nil, so I put in a little 
	protection - raa "
	" This happens when we are in an MVC project and open
	  a morphic window. - BG "
	aWorld ifNotNil:
	  [self activeHand ifNil: [self halt].
		self disableSubmorphFocusForHand: self activeHand.
	  self activeHand releaseKeyboardFocus: self;
		  releaseMouseFocus: self.].
	owner ifNotNil:[ self privateDelete.
		self player ifNotNilDo: [ :player |
			"Player must be notified"
			player noteDeletionOf: self fromWorld: aWorld]].! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 5/29/2004 20:24'!
deleteRecursive
	"current delete does not delete submorphs viewers"
	self topRendererOrSelf dismissMorph: nil.! !

!Morph methodsFor: '*NetMorph-override-meta-actions' stamp: 'ka 12/11/2002 17:45'!
dismissMorph: evt 
	| world haloMorphs |
	world _ self world
				ifNil: [^ self].
	haloMorphs _ world haloMorphs
				select: [:haloMorph | haloMorph target == self].
	haloMorphs
		do: [:haloMorph | 
			(self isKindOf: SelectionMorph)
				ifTrue: [haloMorph target delete].
			haloMorph delete].
	world stopStepping: self.
	self submorphs
		do: [:submorph | submorph dismissMorph: evt].
	self delete! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
dissolve
	| afterForm beforeForm copyForm morph lead startTime minTime |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageAll: morph.
	afterForm _ Morph imageWithout: morph.
	copyForm _ beforeForm deepCopy.
	minTime _ 500.
	startTime _ Time millisecondClockValue.
	0.0
		to: 1.0
		by: 1.0 / 32
		do: [:factor | 
			copyForm _ beforeForm deepCopy.
			copyForm
				copyBits: afterForm
				at: 0 @ 0
				translucent: factor.
			copyForm displayAt: self bounds topLeft.
			Display forceDisplayUpdate.
			lead _ startTime + (factor * 32 - 1 * minTime // 32) - Time millisecondClockValue.
			lead > 10
				ifTrue: [(Delay forMilliseconds: lead) wait]].
	morph visible: false! !

!Morph methodsFor: '*NetMorph-override-viewer' stamp: 'mu 7/30/2005 01:26'!
externalName
	self isFlexed ifTrue: [^self owner externalName].
	^ self knownName ifNil: [self innocuousName]! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
fadeImageSquares
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	newDisplay _ Morph imageWithout: morph.
	self fadeImageSquares: newDisplay at: self bounds topLeft.
	morph visible: false! !

!Morph methodsFor: '*NetMorph-effects-private' stamp: ''!
fadeImageSquares: newDisplay at: topLeft 
	Display
		fadeImage: newDisplay
		at: topLeft
		indexAndMaskDo: [:i :mask | 
			mask
				fill: ((16 - i) asPoint extent: (i * 2) asPoint)
				fillColor: Color black.
			(Delay forMilliseconds: 5) wait.
			i <= 16]! !

!Morph methodsFor: '*NetMorph-private' stamp: 'kuri-t 2/6/2003 14:47'!
forceRemoveHalo
	| halo |
	(halo _ self halo)
		ifNotNil: [halo forceDelete]! !

!Morph methodsFor: '*NetMorph-example' stamp: 'kuri-t 1/4/2003 12:18'!
forwardPhrase
	^ self buildPhraseForSelector: #forward:.! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
frenchDoorClose
	| afterForm beforeForm morph innerForm outerForm |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageWithout: morph.
	afterForm _ Morph imageAll: morph.
	innerForm _ beforeForm.
	outerForm _ afterForm.
	self
		french: self
		InnerForm: innerForm
		outerForm: outerForm
		stepFrom: self extent
		to: 0 @ self height.
	morph visible: false! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
frenchDoorOpen
	| afterForm beforeForm morph innerForm outerForm |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageWithout: morph.
	afterForm _ Morph imageAll: morph.
	innerForm _ beforeForm.
	outerForm _ afterForm.
	self
		french: self
		InnerForm: innerForm
		outerForm: outerForm
		stepFrom: 0 @ self height
		to: self extent.
	morph visible: true! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
frenchWindowClose
	| afterForm beforeForm morph innerForm outerForm |
	morph _ self topRendererOrSelf.
	afterForm _ Morph imageWithout: morph.
	beforeForm _ Morph imageAll: morph.
	innerForm _ afterForm.
	outerForm _ beforeForm.
	self
		french: self
		InnerForm: innerForm
		outerForm: outerForm
		stepFrom: self extent
		to: self width @ 0.
	morph visible: false! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
frenchWindowOpen
	| afterForm beforeForm morph innerForm outerForm |
	morph _ self topRendererOrSelf.
	beforeForm _ Morph imageWithout: morph.
	afterForm _ Morph imageAll: morph.
	innerForm _ beforeForm.
	outerForm _ afterForm.
	self
		french: self
		InnerForm: innerForm
		outerForm: outerForm
		stepFrom: self width @ 0
		to: self extent.
	morph visible: true! !

!Morph methodsFor: '*NetMorph-effects-private' stamp: ''!
french: aMorph InnerForm: innerForm outerForm: outerForm stepFrom: stepFromPoint to: toPoint 
	| nSteps aCanvas boxExtent box lead startTime minTime |
	nSteps _ 30.
	aCanvas _ FormCanvas extent: aMorph bounds extent.
	aCanvas drawImage: outerForm at: 0 @ 0.
	minTime _ 500.
	startTime _ Time millisecondClockValue.
	1
		to: 30
		do: [:stepNumber | 
			boxExtent _ self
						stepFrom: stepFromPoint
						to: toPoint
						stepNumber: stepNumber
						nSteps: nSteps.
			aCanvas drawImage: innerForm at: 0 @ 0.
			box _ Rectangle center: aCanvas form boundingBox center extent: boxExtent.
			aCanvas
				drawImage: outerForm
				at: box topLeft
				sourceRect: box.
			aCanvas form displayAt: self bounds topLeft.
			Display forceDisplayUpdate.
			lead _ startTime + (stepNumber - 1 * minTime // 30) - Time millisecondClockValue.
			lead > 10
				ifTrue: [(Delay forMilliseconds: lead) wait]]! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 6/18/2004 19:17'!
getMoveDelta
	| delta |
	delta _ self valueOfProperty: #moveDelta
				ifAbsent: [| end start | 
					end _ self valueOfProperty: #moveEndPoint
								ifAbsent: [^ 0 @ 0].
					start _ self valueOfProperty: #moveStartPoint
								ifAbsent: [^ 0 @ 0].
					delta _ end - start.
					self setProperty: #moveDelta toValue: delta.
					delta].
	^ delta! !

!Morph methodsFor: '*NetMorph-example' stamp: 'kuri-t 1/6/2003 12:42'!
guruguruWarp
	| scriptEditor basePhrase |
	self openViewerForArgument.
	basePhrase _ self forwardPhrase.
	scriptEditor _ basePhrase morphToDropInPasteUp: ActiveWorld.
	basePhrase justGrabbedFromViewer: false.
	scriptEditor openInWorld.
	HandMorph attach: scriptEditor.
	self addPhrase: self turnPhrase to: scriptEditor.
	self addPhrase: self warpPhrase to: scriptEditor.
	ActiveWorld restoreDisplay.! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 5/30/2004 02:50'!
handleWarpErrorMessage: aString 
	self beWarpFailed: aString.
	^ NmShortMessageMorph contents: aString for: self! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 7/29/2005 19:20'!
handleWarpError: anException 
	self beWarpFailed: anException messageText asString.
	(anException isKindOf: RmtNetworkError)
		ifTrue: [| message | 
			message _ NmBaseSettings isDebugging
						ifTrue: [anException messageText asString]
						ifFalse: ['Warp failed!!' translated].
			^ NmShortMessageMorph contents: message for: self].
	(anException isKindOf: MessageNotUnderstood)
		ifTrue: [^ NmShortMessageMorph contents: anException description for: self].
	anException pass! !

!Morph methodsFor: '*NetMorph-extension' stamp: ''!
home
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension home! !

!Morph methodsFor: '*NetMorph-extension' stamp: ''!
identifier
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension identifier! !

!Morph methodsFor: '*NetMorph-effects-support' stamp: ''!
imageAll: aMorph 
	^ self class imageAll: aMorph! !

!Morph methodsFor: '*NetMorph-effects-support' stamp: ''!
imageBelow: aMorph 
	^ self class imageBelow: aMorph! !

!Morph methodsFor: '*NetMorph-accessing' stamp: 'mu 7/24/2005 13:07'!
imageFormForThumbnail
	^self topRendererOrSelf imageForm scaledToSize: 25@25! !

!Morph methodsFor: '*NetMorph-effects-support' stamp: ''!
imageWithout: aMorph 
	^ self class imageWithout: aMorph! !

!Morph methodsFor: '*NetMorph-effects-support' stamp: ''!
intersectsWindows: aRectangle below: targetMorph 
	^ self class intersectsWindows: aRectangle below: targetMorph! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 12/28/2004 00:33'!
ipAndPortArrayFor: destination
	^NmWorldMap default ipAndPortArrayFor: destination! !

!Morph methodsFor: '*NetMorph-private' stamp: 'kuri-t 2/17/2003 12:32'!
isArrivedAtBottomBound
	| morphRect worldRect warpType |
	ActiveWorld bottomFenceEnabled
		ifTrue: [^ false].
	warpType _ self warpType.
	morphRect _ self bounds.
	worldRect _ ActiveWorld bounds.
	warpType = #ifOutOfWorldBounds
		ifTrue: [^ morphRect top > worldRect bottom].
	warpType = #ifCrossingWorldBounds
		ifTrue: [^ morphRect center y > worldRect bottom].
	warpType = #ifTouchedWorldBounds
		ifTrue: [^ morphRect bottom > worldRect bottom]! !

!Morph methodsFor: '*NetMorph-private' stamp: 'kuri-t 2/17/2003 12:32'!
isArrivedAtLeftBound
	| morphRect worldRect warpType |
	ActiveWorld leftFenceEnabled
		ifTrue: [^ false].
	warpType _ self warpType.
	morphRect _ self bounds.
	worldRect _ ActiveWorld bounds.
	warpType = #ifOutOfWorldBounds
		ifTrue: [^ morphRect right < worldRect left].
	warpType = #ifCrossingWorldBounds
		ifTrue: [^ morphRect center x < worldRect left].
	warpType = #ifTouchedWorldBounds
		ifTrue: [^ morphRect left < worldRect left]! !

!Morph methodsFor: '*NetMorph-private' stamp: 'kuri-t 2/17/2003 12:33'!
isArrivedAtRightBound
	| morphRect worldRect warpType |
	ActiveWorld rightFenceEnabled
		ifTrue: [^ false].
	warpType _ self warpType.
	morphRect _ self bounds.
	worldRect _ ActiveWorld bounds.
	warpType = #ifOutOfWorldBounds
		ifTrue: [^ morphRect left > worldRect right].
	warpType = #ifCrossingWorldBounds
		ifTrue: [^ morphRect center x > worldRect right].
	warpType = #ifTouchedWorldBounds
		ifTrue: [^ morphRect right > worldRect right]! !

!Morph methodsFor: '*NetMorph-private' stamp: 'kuri-t 2/17/2003 12:33'!
isArrivedAtTopBound
	| morphRect worldRect warpType |
	ActiveWorld topFenceEnabled
		ifTrue: [^ false].
	warpType _ self warpType.
	morphRect _ self bounds.
	worldRect _ ActiveWorld bounds.
	warpType = #ifOutOfWorldBounds
		ifTrue: [^ morphRect bottom < worldRect top].
	warpType = #ifCrossingWorldBounds
		ifTrue: [^ morphRect center y < worldRect top].
	warpType = #ifTouchedWorldBounds
		ifTrue: [^ morphRect top < worldRect top]! !

!Morph methodsFor: '*NetMorph-testing' stamp: 'mu 6/4/2004 19:21'!
isWarpable
	self owner
		ifNil: [^ false].
	^ self isWarpableTime! !

!Morph methodsFor: '*NetMorph-testing' stamp: 'mu 5/30/2004 02:44'!
isWarpableTime
	| previousTotalSec currentTotalSec |
	previousTotalSec _ self lastWarpTime ifNil: [0].
	currentTotalSec _ Time totalSeconds.
	^ ((currentTotalSec - previousTotalSec) abs)  > NmSettings warpableInterval! !

!Morph methodsFor: '*NetMorph-testing' stamp: 'mu 8/7/2005 22:53'!
isWarping
	(#(#prepareWarp #warp #warpToLocal #warpedOut ) includes: self warping)
		ifTrue: [^ true].
	^ self owner ifNil: [false]
		ifNotNil: [self owner isWarping]! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:08'!
lastWarpTime
	self extension == nil
		ifTrue: [self assureExtension].
	^ self
		valueOfProperty: #lastWarpTime
		ifAbsent: []! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:21'!
lastWarpTime: millisecond 
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #lastWarpTime toValue: millisecond! !

!Morph methodsFor: '*NetMorph-marker' stamp: 'mu 7/28/2005 22:44'!
leaveMarker
	| markerMorph |
	markerMorph _ self createMarker.
	markerMorph openInWorld.
	markerMorph position: self topRendererOrSelf position.
	^markerMorph
	
	! !

!Morph methodsFor: '*NetMorph-marker' stamp: 'mu 7/28/2005 22:44'!
leaveMarkerAttached
	
	self currentHand attachMorph: self leaveMarker.
	
	! !

!Morph methodsFor: '*NetMorph-marker' stamp: 'mu 7/29/2005 01:26'!
leaveMarkerToDock
	NmSettings leaveMarker
		ifTrue: [ActiveWorld markerDock addMarker: self createMarker]! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/19/2004 23:09'!
leaveProxyDo: aBlock
	"experimental"
	| id |
	id _ self identifier.
	aBlock value.
	^self morphOf: id! !

!Morph methodsFor: '*NetMorph-marker' stamp: 'mu 6/13/2004 00:25'!
markerMorphClass
	^NmMarkerMorph! !

!Morph methodsFor: '*NetMorph-example' stamp: 'kuri-t 1/4/2003 11:34'!
methodInterfaceNamed: selector 
	| player vocabulary |
	player _ self assuredPlayer.
	vocabulary _ (CategoryViewer new initializeFor: player) currentVocabulary.
	^ vocabulary
		methodInterfaceAt: selector
		ifAbsent: []! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/13/2004 01:20'!
morphOf: identifier
	| id |
	id _ identifier isString ifTrue: [UUID fromString: identifier] ifFalse: [identifier].
	^Morph fromUUID: id! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 7/8/2005 01:23'!
moveALittleToCenter
	| delta |
	delta _ ActiveWorld center - self topRendererOrSelf center.
	self topRendererOrSelf position: self topRendererOrSelf position + (delta // 50)! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 7/8/2005 01:31'!
moveALittleToCenterUntilInWorld
	[ActiveWorld bounds intersects: ((self topRendererOrSelf bounds) insetBy: 20)]
		whileFalse: [self moveALittleToCenter]! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 1/2/2003 20:01'!
moveEndPoint: aPoint
	self setProperty: #moveEndPoint toValue: aPoint! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 1/2/2003 20:01'!
moveStartPoint: aPoint
	self setProperty: #moveStartPoint toValue: aPoint! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
none
	"noop"
	^ self! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 6/12/2004 23:52'!
notifyAfterWarp
	self onAfterWarp.
	self submorphs do: [:each | each notifyAfterWarp]! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 6/12/2004 23:52'!
notifyBeforeWarp
	self onBeforeWarp.
	self submorphs do: [:each | each notifyBeforeWarp]! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 6/12/2004 23:52'!
notifyWarpFailed
	self onWarpFailed.
	self submorphs do: [:each | each notifyWarpFailed]! !

!Morph methodsFor: '*NetMorph-callback' stamp: 'mu 6/12/2004 23:52'!
onAfterWarp
	"default do nothing"! !

!Morph methodsFor: '*NetMorph-callback' stamp: 'mu 6/10/2004 01:45'!
onBeforeWarp
	"default do nothing"! !

!Morph methodsFor: '*NetMorph-callback' stamp: 'mu 6/10/2004 01:45'!
onWarpFailed
	"default do nothing"! !

!Morph methodsFor: '*NetMorph-effects-support' stamp: ''!
outsideBelowAndAboveWindows: aRectangle with: targetMorph 
	^ self class outsideBelowAndAboveWindows: aRectangle with: targetMorph! !

!Morph methodsFor: '*NetMorph-effects-support' stamp: ''!
outsideWindows: aRectangle with: targetMorph 
	^ self class outsideWindows: aRectangle with: targetMorph! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
pageIn
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: false.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageAll: morph.
	self
		curtainImage: newDisplay
		at: self bounds topLeft
		delta: 2 @ 0.
	morph visible: true! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
pageOut
	| newDisplay morph |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: true.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageWithout: morph.
	self
		curtainImage: newDisplay
		at: self bounds topLeft
		delta: -2 @ 0.
	morph visible: false! !

!Morph methodsFor: '*NetMorph-extension' stamp: ''!
path
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension path! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'mu 7/13/2005 18:34'!
pathNames
	self extension == nil
		ifTrue: [self assureExtension].
	^ self extension pathNames! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:21'!
path: visitedLocationCollection 
	self extension == nil
		ifTrue: [self assureExtension].
	self extension path: visitedLocationCollection! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'MU 1/16/2004 01:44'!
performActionsAfterWarp
	self afterWarpActions do: [:each | [self perform: each] on: MessageNotUnderstood do: [:ex|]].
	self afterWarpActions: #()! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 7/23/2005 20:20'!
performActionsBeforeWarp
	self beforeWarpActions do: [:each | [self perform: each] on: MessageNotUnderstood do: [:ex|]].
	self beforeWarpActions: #().! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/13/2004 01:09'!
perform: selector of: identifier 
	^self perform: selector withArguments: #() of: identifier ! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 7/30/2005 22:50'!
perform: selector withArguments: arguments of: identifier 
	| morph |
	morph := self morphOf: identifier.
	^ morph isNil
		ifTrue: [NmNoSuchMorphWarning signalWithUuidString: identifier asString]
		ifFalse: [morph perform: selector withArguments: arguments]! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/13/2004 01:08'!
perform: selector with: argument of: identifier 
	^self perform: selector withArguments: (Array with: argument) of: identifier ! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/13/2004 01:09'!
perform: selector with: argument with: argument2 of: identifier 
	^self perform: selector withArguments: (Array with: argument with: argument2) of: identifier ! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/13/2004 01:10'!
perform: selector with: argument with: argument2 with: argument3 of: identifier 
	^self perform: selector withArguments: (Array with: argument with: argument2 with: argument3) of: identifier ! !

!Morph methodsFor: '*NetMorph-testing' stamp: 'mu 7/30/2005 17:59'!
ping
	"no-op, just make sure morph is available on remote"
	^nil! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 7/10/2005 01:38'!
playerNotNil
	^ self player notNil! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 7/10/2005 01:37'!
playerNotNilDo: aBlock 
	^ self player ifNotNilDo: aBlock! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
poofIn
	| morph |
	morph _ self topRendererOrSelf.
	NmPoofs
		showInBounds: (morph bounds outsetBy: 20 @ 20).
	morph visible: true! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
poofOut
	| morph |
	morph _ self topRendererOrSelf.
	NmPoofs
		showInBounds: (morph bounds outsetBy: 20 @ 20).
	morph visible: false! !

!Morph methodsFor: '*NetMorph-serialization' stamp: 'mu 8/7/2005 10:32'!
prepareWarpSerialized
	| morphByteArray |
	self forceRemoveHalo.
	morphByteArray := self toWarpByteArray.
	self
		playerNotNilDo: [:p | p
				instantiatedUserScriptsDo: [:scriptInstantiation | scriptInstantiation stopTicking]].
	NmProcessManager terminateAllOf: self identifier.
	self stopKeepMoving.
	^ morphByteArray! !

!Morph methodsFor: '*NetMorph-override-private' stamp: 'mu 12/12/2003 00:08'!
privateAddMorph: aMorph atIndex: index

	| oldIndex myWorld itsWorld oldOwner |
	((index >= 1) and: [index <= (submorphs size + 1)])
		ifFalse: [^ self error: 'index out of range'].
	myWorld _ self world.
	oldOwner _ aMorph owner.
	(oldOwner == self and: [(oldIndex _ submorphs indexOf: aMorph) > 0]) ifTrue:[
		"aMorph's position changes within in the submorph chain"
		oldIndex < index ifTrue:[
			"moving aMorph to back"
			submorphs replaceFrom: oldIndex to: index-2 with: submorphs startingAt: oldIndex+1.
			submorphs at: index-1 put: aMorph.
		] ifFalse:[
			"moving aMorph to front"
			oldIndex-1 to: index by: -1 do:[:i|
				submorphs at: i+1 put: (submorphs at: i)].
			submorphs at: index put: aMorph.
		].
	] ifFalse:[
		"adding a new morph"
		oldOwner ifNotNil:[
			itsWorld _ aMorph world.
			itsWorld ifNotNil: [self privateInvalidateMorph: aMorph].
			(itsWorld == myWorld) ifFalse: [aMorph outOfWorld: itsWorld].
			oldOwner privateRemove: aMorph.
			oldOwner removedMorph: aMorph.
		].
		aMorph privateOwner: self.
		submorphs _ submorphs copyReplaceFrom: index to: index-1 with: (Array with: aMorph).
		(itsWorld == myWorld) ifFalse: [aMorph intoWorld: myWorld].
	].
	myWorld ifNotNil:[self privateInvalidateMorph: aMorph].
	aMorph layoutChanged. "NetMorph"
	self layoutChanged.
	oldOwner == self ifFalse: [
		self addedMorph: aMorph.
		aMorph noteNewOwner: self ].
! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 7/13/2005 18:59'!
reinstallAllScripts
	self allMorphs
		do: [:each | 
			| playerClass selectors | 
			each path addLast: NmWorldMap localEntry.
			playerClass _ each player class.
			selectors _ playerClass organization listAtCategoryNamed: #scripts.
			selectors
				do: [:selector | 
					| editor | 
					editor _ each scriptEditorFor: selector.
					editor install]]! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 6/18/2004 19:36'!
rememberMoveEndPoint
	self moveEndPoint: self topRendererOrSelf position! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 6/18/2004 19:20'!
rememberMoveStartPoint
	self moveStartPoint: self topRendererOrSelf position! !

!Morph methodsFor: '*NetMorph-delegate' stamp: 'kuri-t 10/16/2002 18:36'!
rendererBounds
	^ self topRendererOrSelf bounds! !

!Morph methodsFor: '*NetMorph-delegate' stamp: 'kuri-t 10/16/2002 18:36'!
rendererReferencePosition
	^ self topRendererOrSelf referencePosition! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/15/2003 12:13'!
resetIdentifier
	self extension
		ifNotNil: [self extension resetIdentifier]! !

!Morph methodsFor: '*NetMorph-private' stamp: 'mu 8/7/2005 22:54'!
resetIdentifierIfDuplicated: anUUID 
	| detection |
	self warping == #warpToLocal ifTrue: [^ self].
	detection := (ActiveWorld allMorphs
				reject: [:each | each isRenderer])
				detect: [:morph | morph identifier = anUUID]
				ifNone: [].
	detection notNil
		ifTrue: [self resetIdentifier]! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'kuri-t 2/18/2003 14:55'!
resetKeepMovingStatus
	self removeProperty: #moveStartPoint.
	self removeProperty: #moveEndPoint.
	self removeProperty: #moveDelta! !

!Morph methodsFor: '*NetMorph-serialization' stamp: 'mu 7/13/2005 18:59'!
restoreAfterWarp
	self lastWarpTime: Time totalSeconds.
	self restoreAttributesAfterWarp.
	self currentWorld addMorph: self.
	self warpedIn: NmWorldMap localEntry.! !

!Morph methodsFor: '*NetMorph-serialization' stamp: 'mu 6/13/2004 00:07'!
restoreAttributesAfterWarp
	"default do nothing"
	! !

!Morph methodsFor: '*NetMorph-override-fileIn/out' stamp: 'mu 12/12/2004 01:12'!
saveOnFile
	"Ask the user for a filename and save myself on a SmartReferenceStream file.  Writes out the version and class structure.  The file is fileIn-able.  UniClasses will be filed out."

	| aFileName fileStream ok topRendererOrSelf |
	aFileName _ ('my {1}' translated format: {self class name}) asFileName.	"do better?"
	aFileName _ FillInTheBlank request: 'File name? (".morph" will be added to end)' translated 
			initialAnswer: aFileName.
	aFileName isEmpty ifTrue: [^ Beeper beep].
	topRendererOrSelf _ self topRendererOrSelf.
	topRendererOrSelf
		allMorphsDo: [:m | m prepareToBeSaved].
	
	ok _ aFileName endsWith: '.morph'.	"don't double them"
	ok _ ok | (aFileName endsWith: '.sp').
	ok ifFalse: [aFileName _ aFileName,'.morph'].
	fileStream _ FileStream newFileNamed: aFileName asFileName.
	fileStream fileOutClass: nil andObject: topRendererOrSelf.	"Puts UniClass definitions out anyway"! !

!Morph methodsFor: '*NetMorph-copying' stamp: ''!
shallowCopy
	| shallowCopyObject |
	shallowCopyObject _ super shallowCopy.
	shallowCopyObject assureExtension instVarNamed: 'identifier' put: UUID new.
	^ shallowCopyObject! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 1/2/2003 19:57'!
shouldKeepMoving
	^ self valueOfProperty: #shouldKeepMoving
		ifAbsent: [false]! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 1/2/2003 19:57'!
shouldKeepMoving: aBoolean 
	self setProperty: #shouldKeepMoving toValue: aBoolean! !

!Morph methodsFor: '*NetMorph-testing' stamp: 'kuri-t 12/13/2002 15:03'!
shouldPassAsProxy
	^ true.! !

!Morph methodsFor: '*NetMorph-testing' stamp: 'kuri-t 12/10/2002 14:44'!
shouldPrepareForWarp
	^ false! !

!Morph methodsFor: '*NetMorph-menu' stamp: 'ns 12/10/2002 15:19'!
showContentsOf: selector 
	| stringMorph anObject |
	anObject _ self perform: selector.
	stringMorph _ StringMorph contents: anObject asString.
	stringMorph name: selector.
	self player currentHand attachMorph: stringMorph! !

!Morph methodsFor: '*NetMorph-override-dropping/grabbing' stamp: ''!
slideToTrash: evt
	"Perhaps slide the receiver across the screen to a trash can and make it disappear into it.  In any case, remove the receiver from the screen."

	| aForm trash startPoint endPoint |
	((self renderedMorph == Utilities scrapsBook) or: [self renderedMorph isKindOf: TrashCanMorph]) ifTrue:
		[self delete.  ^ self].
	Preferences slideDismissalsToTrash ifTrue:
		[aForm _ self imageForm offset: 0@0.
		trash _ ActiveWorld
			findDeepSubmorphThat:
				[:aMorph | (aMorph isKindOf: TrashCanMorph) and:
					[aMorph topRendererOrSelf owner == ActiveWorld]]
			ifAbsent:
				[trash _ TrashCanMorph new.
				trash position: ActiveWorld bottomLeft - (0 @ (trash extent y + 26)).
				trash openInWorld.
				trash].
		endPoint _ trash fullBoundsInWorld center - (self topRendererOrSelf extent // 2).
		startPoint _ self topRendererOrSelf topLeft].
	self topRendererOrSelf delete.
	ActiveWorld displayWorld.
	Preferences slideDismissalsToTrash ifTrue:
		[aForm slideFrom: startPoint to: endPoint nSteps: 12 delay: 15].
	Utilities addToTrash: self! !

!Morph methodsFor: '*NetMorph-effects' stamp: 'mu 5/1/2005 19:05'!
softFlash
	| c w |
	c _ self color.
	self color: color muchDarker.
	(w _ self world) ifNotNil: [w displayWorldSafely].
	self color: c! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 6/18/2004 20:36'!
startKeepMoving
	(self getMoveDelta = (0 @ 0))
		ifTrue: [^ self].
	self shouldKeepMoving: true.
	self
		startStepping: #stepMove
		at: Time millisecondClockValue
		arguments: nil
		stepTime: 800! !

!Morph methodsFor: '*NetMorph-effects-private' stamp: ''!
stepFrom: p1 to: p2 stepNumber: stepNumber nSteps: nSteps 
	^ p2 - p1 * stepNumber // nSteps + p1! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 1/4/2003 18:49'!
stepMove
	self shouldKeepMoving
		ifTrue: [self topRendererOrSelf position: self topRendererOrSelf position + self getMoveDelta.
			self topRendererOrSelf warp.
			self topRendererOrSelf owner == HandMorph
				ifTrue: [self stopKeepMoving]]! !

!Morph methodsFor: '*NetMorph-geometry keep moving' stamp: 'kuri-t 2/18/2003 14:38'!
stopKeepMoving
	self resetKeepMovingStatus.
	self shouldKeepMoving: false.
	self stopSteppingSelector: #stepMove! !

!Morph methodsFor: '*NetMorph-serialization' stamp: 'mu 8/7/2005 18:17'!
toWarpByteArray
	| wStr |
	wStr := RWBinaryOrTextStream on: String new.
	Cursor write
		showWhile: [self
				playerNotNilDo: [:p | p class scripts
						valuesDo: [:script | script prepareForWarp]].
			self trimAttributesBeforeWarp.
			self clearExtensionBeforeWarp.
			self warpWriteOn: wStr].
	^ NmUtil gzippedFrom: wStr contents asByteArray! !

!Morph methodsFor: '*NetMorph-serialization' stamp: 'mu 6/13/2004 00:06'!
trimAttributesBeforeWarp
	"default do nothing"
	! !

!Morph methodsFor: '*NetMorph-example' stamp: 'kuri-t 1/4/2003 12:19'!
turnPhrase
	^ self buildPhraseForSelector: #turn:.! !

!Morph methodsFor: '*NetMorph-testing' stamp: 'mu 8/2/2005 07:59'!
warnIfPingFailed
	[self ping] on: NmNoSuchMorphWarning do: [:ex | ex defaultActionAt: self center].! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/12/2004 23:48'!
warp
	self warp: #ifOutOfWorldBounds! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/22/2003 15:33'!
warpDirection
	self extension == nil
		ifTrue: [self assureExtension].
	^ self
		valueOfProperty: #warpDirection
		ifAbsent: []! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:21'!
warpDirection: warpDirection 
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #warpDirection toValue: warpDirection! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 8/7/2005 18:23'!
warpedIn: destinationEntry 
	| netMorphProxy |
	self warping: #warpedIn.
	self path addLast: destinationEntry asDeferredUpdate.
	self performActionsAfterWarp.
	self
		playerNotNilDo: [:p | p runAllWarpedInScripts].
	self notifyAfterWarp.
	self shouldKeepMoving
		ifTrue: [self startKeepMoving].
	netMorphProxy := ActiveWorld netMorphProxyCache
				at: self identifier
				ifAbsent: [].
	netMorphProxy
		ifNotNil: [ActiveWorld netMorphProxyCache removeKey: self identifier.
			(netMorphProxy player isNil not
					and: [self player notNil])
				ifTrue: [netMorphProxy player becomeForward: self player].
			netMorphProxy becomeForward: self]! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 8/7/2005 10:22'!
warpedOut: destinationEntry 
	| playerClass identifier className |
	self warping: #warpedOut.
	identifier := self identifier.
	self world morphIdentifierWarpedList at: identifier asString put: destinationEntry id.
	className := self renderedMorph class name.
	self
		playerNotNilDo: [:p | p runAllWarpingOutScripts].
	self purgeAllCommands.
	self resetIdentifier.
	submorphs
		do: [:submorph | submorph resetIdentifier].
	self deleteRecursive.
	self presenter flushPlayerListCache.
	playerClass := self player class.
	self
		playerNotNilDo: [:player | player becomeForward: (NmMorphProxy
					className: className
					uuid: identifier
					ipAndPortArray: destinationEntry ipAndPortArray) player].
	(#(#UnscriptedPlayer #UndefinedObject ) includes: playerClass name)
		ifFalse: [playerClass removeFromSystemUnlogged].
	NmWarpedOutNotification signal.! !

!Morph methodsFor: '*NetMorph-menu' stamp: 'mu 6/10/2004 23:10'!
warpFromMenuTo: destination 
	| whereIGo |
	destination
		ifNil: [whereIGo _ self askWarpDestination.
			whereIGo
				ifNil: [^ self]]
		ifNotNil: [whereIGo _ destination].
	self warpTo: whereIGo! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/14/2003 14:00'!
warping
	self extension == nil
		ifTrue: [self assureExtension].
	^ self valueOfProperty: #warping! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:21'!
warping: statusSymbol
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #warping toValue: statusSymbol! !

!Morph methodsFor: '*NetMorph-example' stamp: 'kuri-t 1/4/2003 12:19'!
warpPhrase
	^ self buildPhraseForSelector: #warp.! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 5/10/2005 19:19'!
warpToBottom
	| destinationEntry |
	destinationEntry _ NmWorldMap default bottomDestination.
	destinationEntry notNil
		ifTrue: [self warpDirection: #bottomWarp.
			self deferWarpToNeighbor: destinationEntry]! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 8/4/2005 08:50'!
warpToHome
	| homeDest |
	homeDest := self home.
	"(url := homeDest asNmUrl ifTrue: [self warp: url host port: url port]."
	^self warpTo: homeDest.
	! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 5/10/2005 19:19'!
warpToLeft
	| destinationEntry |
	destinationEntry _ NmWorldMap default leftDestination.
	destinationEntry notNil
		ifTrue: [self warpDirection: #leftWarp.
			self deferWarpToNeighbor: destinationEntry]! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'KY 1/15/2004 19:04'!
warpToLocal 
	self
		warp: '127.0.0.1'
		port: NmSettings warpPort
		! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 7/29/2005 01:37'!
warpToNeighbor: destinationEntry 
	| morphByteArray connector host port |
	self isWarpable
		ifFalse: [^ self].
	host _ destinationEntry ip.
	port _ destinationEntry port.
	self owner
		ifNil: [^ self].
	self isWarpable
		ifFalse: [^ self].
	WarpProtect
		critical: [[self warping: #warp.
			self notifyBeforeWarp.
			self performActionsBeforeWarp.
			morphByteArray _ self prepareWarpSerialized.
			connector _ NmRemoteConnector connect: host port: port.
			connector callCatchAndGo: morphByteArray.
			self leaveMarkerToDock.
			self warpedOut: destinationEntry]
				on: Error
				do: [:ex | 
					connector
						ifNotNil: [connector close].
					self handleWarpError: ex.
					self moveALittleToCenterUntilInWorld]]! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 5/10/2005 19:19'!
warpToRight
	| destinationEntry |
	destinationEntry _ NmWorldMap default rightDestination.
	destinationEntry notNil
		ifTrue: [self warpDirection: #rightWarp.
			self deferWarpToNeighbor: destinationEntry]! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 5/10/2005 19:19'!
warpToTop
	| destinationEntry |
	destinationEntry _ NmWorldMap default topDestination.
	destinationEntry notNil
		ifTrue: [self warpDirection: #topWarp.
			self deferWarpToNeighbor: destinationEntry]! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 5/10/2005 19:52'!
warpTo: destinationEntry 
	| topLeft |
	topLeft _ self topRendererOrSelf topLeft.
	self
		warpTo: destinationEntry
		x: topLeft x
		y: topLeft y! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 8/4/2005 08:54'!
warpTo: destinationEntry x: x y: y 
	| ipAndPortArray host port |
	self isWarpable ifFalse: [^ self].
	ipAndPortArray := self ipAndPortArrayFor: destinationEntry asDestination.
	(ipAndPortArray isNil and: [destinationEntry isString])
		ifTrue: [ipAndPortArray := NmUtil ipAndPortFromString: destinationEntry.
			ipAndPortArray
				ifNil: [^ self handleWarpErrorMessage: 'Could not resolve the server named: ' translated , destinationEntry]].
	host := ipAndPortArray first.
	port := ipAndPortArray last.
	^ self
		warp: host
		port: port
		x: x
		y: y! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/22/2003 14:42'!
warpType
	self extension == nil
		ifTrue: [self assureExtension].
	^ self
		valueOfProperty: #warpType
		ifAbsent: []! !

!Morph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:21'!
warpType: warpType 
	self extension == nil
		ifTrue: [self assureExtension].
	self setProperty: #warpType toValue: warpType! !

!Morph methodsFor: '*NetMorph-serialization' stamp: 'mu 12/16/2004 00:35'!
warpWriteOn: aStream
	self assureNetMorphExtension.
	self writeOn: aStream! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/12/2004 23:49'!
warp: warpType 
	self warpType: warpType.
	self isArrivedAtLeftBound
		ifTrue: [^ self warpToLeft].
	self isArrivedAtRightBound
		ifTrue: [^ self warpToRight].
	self isArrivedAtBottomBound
		ifTrue: [^ self warpToBottom].
	self isArrivedAtTopBound
		ifTrue: [^ self warpToTop]! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/12/2004 23:48'!
warp: ipAddressString port: portNumber
	self isWarpable ifFalse: [^ self].
	self
		warp: ipAddressString
		port: portNumber
		x: self topRendererOrSelf bounds left
		y: self topRendererOrSelf bounds top! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 6/12/2004 23:48'!
warp: ipAddressString port: portNumber x: x y: y 
	self
		warp: ipAddressString
		port: portNumber
		x: x
		y: y
		onError: [:ex | self handleWarpError: ex]! !

!Morph methodsFor: '*NetMorph-warp-support' stamp: 'mu 8/7/2005 23:00'!
warp: ipAddressString port: portNumber x: x y: y onError: errorBlock 
	WarpProtect
		critical: [| morphByteArray connector | [self warping: #warp.
			self notifyBeforeWarp.
			self performActionsBeforeWarp.
			(NmBaseUtil isLocal: ipAddressString port: portNumber) ifTrue: [self warping: #warpToLocal.].
			morphByteArray := self prepareWarpSerialized.
			connector := NmRemoteConnector connect: ipAddressString port: portNumber.
			connector
				callCatchAndGo: morphByteArray
				x: x
				y: y.
			self leaveMarkerToDock.
			self
				warpedOut: (NmWorldMap default
						atAddress: {ipAddressString. portNumber asNumber}
						ifAbsent: [NmWorldMapEntry ip: ipAddressString port: portNumber])]
				on: Error
				do: [:ex | 
					connector
						ifNotNil: [connector close].
					errorBlock value: ex]]! !

!Morph methodsFor: '*NetMorph-api' stamp: 'mu 12/28/2004 00:17'!
worldMap
	^NmWorldMap default! !

!Morph methodsFor: '*NetMorph-fileIn/out' stamp: ''!
writeOn: aStream 
	| topRendererOrSelf srefStream savedState |
	topRendererOrSelf _ self topRendererOrSelf.
	topRendererOrSelf
		allMorphsDo: [:m | m prepareToBeSaved].
	srefStream _ SmartRefStream on: aStream.
	savedState _ srefStream isDisplayProgress.
	[srefStream isDisplayProgress: false.
	srefStream nextPut: topRendererOrSelf]
		ensure: [srefStream close.
			srefStream isDisplayProgress: savedState]! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
zoomIn
	| newDisplay morph vanishingPoint |
	morph _ self topRendererOrSelf.
	morph visible
		ifTrue: [morph visible: false.
			morph renderedMorph refreshWorld].
	newDisplay _ Morph imageAll: morph.
	vanishingPoint _ morph width // 2 @ (morph height // 2).
	Display
		zoomIn: true
		orOutTo: newDisplay
		at: morph bounds topLeft
		vanishingPoint: vanishingPoint.
	morph visible: true! !

!Morph methodsFor: '*NetMorph-effects' stamp: ''!
zoomOut
	| newDisplay morph vanishingPoint |
	morph _ self topRendererOrSelf.
	newDisplay _ Morph imageWithout: morph.
	vanishingPoint _ morph width // 2 @ (morph height // 2).
	Display
		zoomIn: false
		orOutTo: newDisplay
		at: morph bounds topLeft
		vanishingPoint: vanishingPoint.
	morph visible: false! !

RmtTcpService subclass: #NmRemoteService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-RPC'!

!NmRemoteService methodsFor: 'factory' stamp: 'mu 5/17/2004 01:42'!
defaultAcceptorClass
	^ Smalltalk at: #NmServiceHandler ifAbsent: []! !

SymbolListTile subclass: #NmSymbolListTile
	instanceVariableNames: 'model getChoicesSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-eToys'!

!NmSymbolListTile methodsFor: 'user interface' stamp: 'mu 5/10/2005 20:58'!
acceptNewLiteral: newLiteral 
	| aLiteral |
	aLiteral _ newLiteral = 'other...'
				ifTrue: [| dest | 
					dest _ self askWarpDestination.
					dest
						ifNil: [^ self].
					dest].
	newLiteral = 'home'
		ifTrue: [aLiteral _ (self ownerThatIsA: PhraseTileMorph) actualObject getHome].
	aLiteral
		ifNil: [aLiteral _ newLiteral].
	self literal: aLiteral asString.
	self labelMorph
		setBalloonText: (ScriptingSystem helpStringForOperator: literal).
	self acceptNewLiteral.
	self labelMorph informTarget! !

!NmSymbolListTile methodsFor: 'initialization' stamp: 'ka 1/15/2003 16:52'!
arrowAction: delta 
	^ self offerAllChoicesInAPopUp! !

!NmSymbolListTile methodsFor: 'user interface' stamp: 'ka 1/15/2003 16:00'!
choices
	^ model perform: getChoicesSelector! !

!NmSymbolListTile methodsFor: 'initialization' stamp: 'ka 1/15/2003 15:51'!
model: listType getChoicesSelector: selectorSymbol dataType: aDataType 
	model _ listType.
	getChoicesSelector _ selectorSymbol.
	dataType _ aDataType.
	literal _ self choices first! !

!NmSymbolListTile methodsFor: 'user interface' stamp: 'ka 1/15/2003 16:19'!
offerAllChoicesInAPopUp
	| aMenu |
	owner
		ifNil: [^ self].
	aMenu _ MenuMorph new defaultTarget: self.
	self choices
		do: [:aSym | aMenu
				add: aSym
				target: self
				selector: #acceptNewLiteral:
				argument: aSym].
	aMenu popUpInWorld: ActiveWorld! !

StringMorph subclass: #NmShortMessageMorph
	instanceVariableNames: 'showing messageOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmShortMessageMorph class methodsFor: 'instance creation' stamp: 'mu 4/21/2005 01:10'!
contents: aMessage at: point
	"NmShortMessageMorph contents: 'HERE' at: ActiveHand position"
	^self contents: aMessage at: point color: Color red! !

!NmShortMessageMorph class methodsFor: 'instance creation' stamp: 'mu 7/26/2005 01:56'!
contents: aMessage at: point color: aColor
	"NmShortMessageMorph contents: 'HERE' at: ActiveHand position color: Color random"
	| inst |
	inst _ self new.
	inst contents: aMessage.
	inst emphasis: 1.
	inst color: aColor.
	inst openInWorld.
	inst position: (point - (inst extent //2)).
	^inst! !

!NmShortMessageMorph class methodsFor: 'instance creation' stamp: 'mu 5/28/2003 19:13'!
contents: aMessage for: aMorph
	| inst |
	inst _ self contents: aMessage at: aMorph topRendererOrSelf center.
	inst messageOwner: aMorph.
	^inst! !

!NmShortMessageMorph methodsFor: 'initialization' stamp: 'mu 5/28/2003 18:31'!
initialize
	super initialize.
	showing _ true! !

!NmShortMessageMorph methodsFor: 'accessing' stamp: 'mu 5/28/2003 19:12'!
messageOwner
	^messageOwner! !

!NmShortMessageMorph methodsFor: 'accessing' stamp: 'mu 5/28/2003 19:12'!
messageOwner: aMorph
	messageOwner _ aMorph! !

!NmShortMessageMorph methodsFor: 'stepping and presenter' stamp: 'mu 5/28/2003 18:36'!
step
	showing
		ifFalse: [self dissolve; delete].
	showing _ false! !

!NmShortMessageMorph methodsFor: 'stepping and presenter' stamp: 'mu 5/28/2003 18:55'!
stepTime
	^1000! !

StringMorph subclass: #NmWorldMapInfoMorph
	instanceVariableNames: 'worldMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-WorldMap'!

!NmWorldMapInfoMorph methodsFor: 'private' stamp: 'mu 7/2/2005 00:46'!
localInfoString
	| map localNameInfo localPointInfo |
	map _ self worldMap.
	map isLocal ifFalse:[^''].
	localNameInfo _ '[', map localName asString,']'.
	localPointInfo _ '@[', map localPoint asString, ']'.
	^localNameInfo, localPointInfo! !

!NmWorldMapInfoMorph methodsFor: 'stepping and presenter' stamp: 'mu 7/2/2005 00:48'!
step
	self contents: self localInfoString , ': ', self worldMap mapName.

! !

!NmWorldMapInfoMorph methodsFor: 'stepping and presenter' stamp: 'mu 5/29/2003 15:14'!
stepTime
	^2000! !

!NmWorldMapInfoMorph methodsFor: 'accessing' stamp: 'mu 4/8/2005 00:12'!
worldMap
	worldMap
		ifNil: [worldMap _ self worldMapMorph
						ifNotNilDo: [:mo | mo worldMap]].
	^ worldMap! !

!NmWorldMapInfoMorph methodsFor: 'accessing' stamp: 'mu 4/8/2005 00:11'!
worldMapMorph
	^self ownerThatIsA: NmWorldMapMorph! !

!NmWorldMapInfoMorph methodsFor: 'accessing' stamp: 'mu 4/5/2005 01:43'!
worldMap: aNmWorldMap
	worldMap _ aNmWorldMap! !

Notification subclass: #NmNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

NmNotification subclass: #NmWarpedOutNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

!PaintBoxMorph methodsFor: '*NetMorph-override-recent colors' stamp: 'ka 1/16/2003 15:40'!
fixUpRecentColors
	| inner outer border box form newImage canvas morph |
	self fixUpColorPicker.
	recentColors _ WriteStream on: Array new.
	form _ image.
	newImage _ Form extent: form extent + (0@41) depth: form depth.
	form displayOn: newImage.
	newImage copy: ((0@(form height-10)) extent: form width @ (newImage height - form height + 10)) 
		from: 0 @ (form height - (newImage height - form height + 10))
		in: form rule: Form over.
	canvas _ newImage getCanvas.
	canvas line: 12@(form height-10) to: 92@(form height-10) width: 1 color: Color black.
	canvas _ canvas copyOffset: 12@(form height-9).

	inner _ (Color r: 0.677 g: 0.71 b: 0.968).
	outer _ inner darker darker.
	border _  (Color r: 0.194 g: 0.258 b: 0.194).
	0 to: 1 do:[:y|
		0 to: 3 do:[:x|
			box _ (x*20) @ (y*20) extent: 20@20.
			morph _ BorderedMorph new bounds: ((box insetBy: 1) translateBy: canvas origin + bounds origin).
			morph borderWidth: 1; borderColor: border.
			morph color: Color white.
			morph on: #mouseDown send: #mouseDownRecent:with: to: self.
			morph on: #mouseMove send: #mouseStillDownRecent:with: to: self.
			morph on: #mouseUp send: #mouseUpRecent:with: to: self.
			self addMorphFront: morph.
			recentColors nextPut: morph.
			canvas fillRectangle: box color: Color white.
			canvas frameRectangle: (box insetBy: 1) color: border.
			canvas frameRectangle: (box) color: inner.
			box _ box insetBy: 1.
			canvas line: box topRight to: box bottomRight width: 1 color: outer.
			canvas line: box bottomLeft to: box bottomRight width: 1 color: outer.
	]].
	recentColors _ recentColors contents.
	(RecentColors == nil or:[RecentColors size ~= recentColors size]) ifTrue:[
		RecentColors _ #(#red #magenta #yellow #green #cyan #blue #white #black )
						collect: [:each | Color perform: each]
	] ifFalse:[
		RecentColors keysAndValuesDo:[:idx :aColor| (recentColors at: idx) color: aColor].
	].
	self image: newImage.
	self toggleStamps.
	self toggleStamps.! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 15:40'!
bottomFenceEnabled
	^ self
		valueOfProperty: #bottomFenceEnabled
		ifAbsent: [Preferences fenceEnabled]! !

!PasteUpMorph methodsFor: '*NetMorph-menu & halo' stamp: 'ka 12/18/2002 16:07'!
bottomFenceEnabledString
	^ self bottomFenceEnabled
		ifTrue: ['<on>bottom fence enabled']
		ifFalse: ['<off>bottom fence enabled']! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 15:30'!
bottomFenceEnabled: aBoolean 
	self setProperty: #bottomFenceEnabled toValue: aBoolean! !

!PasteUpMorph methodsFor: '*NetMorph-override-options' stamp: 'ka 12/18/2002 15:36'!
fenceEnabled
	self leftFenceEnabled
		ifFalse: [^ false].
	self rightFenceEnabled
		ifFalse: [^ false].
	self topFenceEnabled
		ifFalse: [^ false].
	self bottomFenceEnabled
		ifFalse: [^ false].
	^ true! !

!PasteUpMorph methodsFor: '*NetMorph-override-options' stamp: 'ka 12/18/2002 15:31'!
fenceEnabled: aBoolean 
	self leftFenceEnabled: aBoolean.
	self rightFenceEnabled: aBoolean.
	self topFenceEnabled: aBoolean.
	self bottomFenceEnabled: aBoolean! !

!PasteUpMorph methodsFor: '*NetMorph-actions' stamp: 'mu 7/28/2005 22:49'!
flushMarkerDock
	self isWorldMorph ifFalse: [^ self].
	self removeProperty: #NetMorph:MarkerDock! !

!PasteUpMorph methodsFor: '*NetMorph-actions' stamp: 'mu 7/13/2005 17:05'!
flushMorphIdentifierAlreadyAdjusted
	self isWorldMorph ifFalse: [^ self].
	self removeProperty: #NetMorph:MorphIdentifierAlreadyAdjusted! !

!PasteUpMorph methodsFor: '*NetMorph-actions' stamp: 'mu 7/13/2005 16:31'!
flushMorphIdentifierRenameList
	self isWorldMorph ifFalse: [^ self].
	self removeProperty: #NetMorph:IdentifierRenameList! !

!PasteUpMorph methodsFor: '*NetMorph-actions' stamp: 'mu 8/3/2005 08:07'!
flushMorphIdentifierWarpedList
	self isWorldMorph ifFalse: [^ self].
	self removeProperty: #NetMorph:IdentifierWarpedList! !

!PasteUpMorph methodsFor: '*NetMorph-actions' stamp: 'mu 7/13/2005 16:30'!
flushNetMorphProxyCache
	self isWorldMorph ifFalse: [^ self].
	self removeProperty: #NetMorph:ProxyCache! !

!PasteUpMorph methodsFor: '*NetMorph-testing' stamp: 'mu 6/18/2005 23:55'!
isNetMorphProjectPublishCancelled
	^ self hasProperty: #NetMorph:ProjectPublishCancel! !

!PasteUpMorph methodsFor: '*NetMorph-testing' stamp: 'mu 6/18/2005 22:33'!
isNetMorphProjectPublishing
	^ self hasProperty: #NetMorph:ProjectPublishing! !

!PasteUpMorph methodsFor: '*NetMorph-testing' stamp: 'mu 6/18/2005 22:34'!
isNetMorphPublished
	^ self hasProperty: #NetMorph:PublishedProject! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 15:39'!
leftFenceEnabled
	^ self
		valueOfProperty: #leftFenceEnabled
		ifAbsent: [Preferences fenceEnabled]! !

!PasteUpMorph methodsFor: '*NetMorph-menu & halo' stamp: 'ka 12/18/2002 16:07'!
leftFenceEnabledString
	^ self leftFenceEnabled
		ifTrue: ['<on>left fence enabled']
		ifFalse: ['<off>left fence enabled']! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 15:30'!
leftFenceEnabled: aBoolean 
	self setProperty: #leftFenceEnabled toValue: aBoolean! !

!PasteUpMorph methodsFor: '*NetMorph-accessing' stamp: 'mu 7/28/2005 22:49'!
markerDock
	self isWorldMorph ifFalse: [^nil].
	^self valueOfProperty: #NetMorph:MarkerDock ifAbsentPut: [NmMarkerDockMorph new].
	 ! !

!PasteUpMorph methodsFor: '*NetMorph-options' stamp: 'mu 7/13/2005 17:02'!
morphIdentifierAlreadyAdjusted
	self isWorldMorph ifFalse: [^ false].
	^self valueOfProperty: #NetMorph:MorphIdentifierAlreadyAdjusted ifAbsentPut: [false].! !

!PasteUpMorph methodsFor: '*NetMorph-options' stamp: 'mu 7/13/2005 17:03'!
morphIdentifierAlreadyAdjusted: aBoolean
	self isWorldMorph ifFalse: [^ self].
	^self setProperty: #NetMorph:MorphIdentifierAlreadyAdjusted toValue: aBoolean == true ! !

!PasteUpMorph methodsFor: '*NetMorph-accessing' stamp: 'mu 7/13/2005 16:31'!
morphIdentifierRenameList
	self isWorldMorph ifFalse: [^nil].
	^self valueOfProperty: #NetMorph:IdentifierRenameList ifAbsentPut: [Dictionary new].
	 ! !

!PasteUpMorph methodsFor: '*NetMorph-accessing' stamp: 'mu 8/3/2005 08:07'!
morphIdentifierWarpedList
	self isWorldMorph ifFalse: [^nil].
	^self valueOfProperty: #NetMorph:IdentifierWarpedList ifAbsentPut: [Dictionary new].
	 ! !

!PasteUpMorph methodsFor: '*NetMorph-accessing' stamp: 'mu 7/13/2005 16:31'!
netMorphProxyCache
	self isWorldMorph ifFalse: [^nil].
	^self valueOfProperty: #NetMorph:ProxyCache ifAbsentPut: [Dictionary new].
	 ! !

!PasteUpMorph methodsFor: '*NetMorph-override-menu & halo' stamp: 'mu 5/15/2005 01:55'!
playfieldOptionsMenu
	"Answer an auxiliary menu with options specific to playfields -- too many to be housed in the main menu"

	| aMenu isWorld |
	isWorld _ self isWorldMorph.
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	aMenu add: 'save on file...' translated action: #saveOnFile.
	aMenu add: 'save as SqueakPage at url...' translated action: #saveOnURL.
	aMenu add: 'update all from resources' translated action: #updateAllFromResources.
	(self valueOfProperty: #classAndMethod) ifNotNil:
		[aMenu add: 'broadcast as documentation' translated action: #saveDocPane].
	aMenu add: 'round up strays' translated action: #roundUpStrays.
	aMenu balloonTextForLastItem:  'Bring back all objects whose current coordinates keep them from being visible, so that at least a portion of each of my interior objects can be seen.' translated.
	aMenu add: 'show all players' translated action: #showAllPlayers.
	aMenu balloonTextForLastItem:  'Make visible the viewers for all players which have user-written scripts in this playfield.' translated.
	aMenu add: 'hide all players' translated action: #hideAllPlayers.
	aMenu balloonTextForLastItem:  'Make invisible the viewers for all players in this playfield. This will save space before you publish this project' translated.


	aMenu addLine.
	aMenu add: 'shuffle contents' translated action: #shuffleSubmorphs.
	aMenu balloonTextForLastItem: 'Rearranges my contents in random order' translated.
	self griddingOn
		ifTrue: [aMenu add: 'turn gridding off' translated action: #griddingOnOff.
				aMenu add: (self gridVisible ifTrue: ['hide'] ifFalse: ['show']) translated, ' grid' translated
						action: #gridVisibleOnOff.
				aMenu add: 'set grid spacing...' translated action: #setGridSpec]
		ifFalse: [aMenu add: 'turn gridding on' translated action: #griddingOnOff].
	aMenu addLine.

	#(	(autoLineLayoutString	toggleAutoLineLayout
			'whether submorphs should automatically be laid out in lines')
		(indicateCursorString	toggleIndicateCursor
			'whether the "current" submorph should be indicated with a dark black border')
		(isPartsBinString		toggleIsPartsBin
			'whether dragging an object from the interior should produce a COPY of the object')
		(isOpenForDragNDropString	toggleDragNDrop
			'whether objects can be dropped into and dragged out of me')
		(mouseOverHalosString	toggleMouseOverHalos
			'whether objects should put up halos when the mouse is over them')
		(autoExpansionString	toggleAutomaticPhraseExpansion
			'whether tile phrases, dropped on me, should automatically sprout Scriptors around them')
		(originAtCenterString	toggleOriginAtCenter
			'whether the cartesian origin of the playfield should be at its lower-left corner or at the center of the playfield')
		(showThumbnailString	toggleAlwaysShowThumbnail
			'whether large objects should be represented by thumbnail miniatures of themselves')
		(fenceEnabledString	toggleFenceEnabled
			'whether moving objects should stop at the edge of their container')

		(leftFenceEnabledString	toggleLeftFenceEnabled
			'whether moving objects should stop at the left edge of their container')
		(rightFenceEnabledString	toggleRightFenceEnabled
			'whether moving objects should stop at the right edge of their container')
		(topFenceEnabledString	toggleTopFenceEnabled
			'whether moving objects should stop at the top edge of their container')
		(bottomFenceEnabledString	toggleBottomFenceEnabled
			'whether moving objects should stop at the bottom edge of their container')


		(batchPenTrailsString	toggleBatchPenTrails 
			'if true, detailed movement of pens between display updates is ignored.  Thus multiple line segments drawn within a script may not be seen individually.')

	) do:

			[:triplet |
				(isWorld and: [#(toggleAutoLineLayout toggleIndicateCursor toggleIsPartsBin toggleAlwaysShowThumbnail) includes: triplet second]) ifFalse:
					[aMenu addUpdating: triplet first action: triplet second.
					aMenu balloonTextForLastItem: triplet third translated]]. 

	aMenu addUpdating: #autoViewingString action: #toggleAutomaticViewing.
	aMenu balloonTextForLastItem:  'governs whether, when an object is touched inside me, a viewer should automatically be launched for it.' translated.

	((isWorld not or: [self backgroundSketch notNil]) or: [presenter isNil])
		ifTrue:
			[aMenu addLine].

	isWorld ifFalse:
		[aMenu add: 'set thumbnail height...' translated action: #setThumbnailHeight.
		aMenu balloonTextForLastItem: 'if currently showing thumbnails governs the standard height for them' translated.
		aMenu add: 'behave like a Holder' translated action: #becomeLikeAHolder.
		aMenu balloonTextForLastItem: 'Set properties to make this object nicely set up to hold frames of a scripted animation.' translated].

	self backgroundSketch ifNotNil:
		[aMenu add: 'delete background painting' translated action: #deleteBackgroundPainting.
		aMenu balloonTextForLastItem: 'delete the graphic that forms the background for this me.' translated].
	presenter ifNil:
		[aMenu add: 'make detachable' translated action: #makeDetachable.
		aMenu balloonTextForLastItem: 'Allow this area to be separately governed by its own controls.' translated].

	aMenu addLine.
	aMenu add: 'use standard texture' translated action: #setStandardTexture.
	aMenu balloonTextForLastItem: 'use a pale yellow-and-blue background texture here.' translated.
	aMenu add: 'make graph paper...' translated action: #makeGraphPaper.
	aMenu balloonTextForLastItem: 'Design your own graph paper and use it as the background texture here.' translated.
	aMenu addTitle: 'playfield options...' translated.

	^ aMenu
! !

!PasteUpMorph methodsFor: '*NetMorph-override-menu & halo' stamp: 'mu 12/11/2003 23:19'!
presentViewMenu
	"Answer an auxiliary menu with options specific to viewing playfields -- this is put up from the provisional 'view' halo handle, on pasteup morphs only."

	| aMenu isWorld |
	isWorld _ self isWorldMorph.
	aMenu _ MenuMorph new defaultTarget: self.
	aMenu addStayUpItem.
	self addViewingItemsTo: aMenu.

	#(	"(autoLineLayoutString	toggleAutoLineLayout
			'whether submorphs should automatically be laid out in lines')"
		(indicateCursorString	toggleIndicateCursor
			'whether the "current" submorph should be indicated with a dark black border')
		(resizeToFitString		toggleResizeToFit
			'whether I should automatically strive exactly to fit my contents')
		(behaveLikeAHolderString	toggleBehaveLikeAHolder
			'whether auto-line-layout, resize-to-fit, and indicate-cursor should be set to true; useful for animation control, etc.')
		(isPartsBinString		toggleIsPartsBin
			'whether dragging an object from the interior should produce a COPY of the object')
		(isOpenForDragNDropString	toggleDragNDrop
			'whether objects can be dropped into and dragged out of me')
		(mouseOverHalosString	toggleMouseOverHalos
			'whether objects should put up halos when the mouse is over them')
		(autoExpansionString	toggleAutomaticPhraseExpansion
			'whether tile phrases, dropped on me, should automatically sprout Scriptors around them')
		(originAtCenterString	toggleOriginAtCenter
			'whether the cartesian origin of the playfield should be at its lower-left corner or at the center of the playfield')
		(showThumbnailString	toggleAlwaysShowThumbnail
			'whether large objects should be represented by thumbnail miniatures of themselves')
		(fenceEnabledString	toggleFenceEnabled
			'whether moving objects should stop at the edge of their container')
		(leftFenceEnabledString	toggleLeftFenceEnabled
			'whether moving objects should stop at the left edge of their container')
		(rightFenceEnabledString	toggleRightFenceEnabled
			'whether moving objects should stop at the right edge of their container')
		(topFenceEnabledString	toggleTopFenceEnabled
			'whether moving objects should stop at the top edge of their container')
		(bottomFenceEnabledString	toggleBottomFenceEnabled
			'whether moving objects should stop at the bottom edge of their container')
		(autoViewingString		toggleAutomaticViewing
			'governs whether, when an object is touched inside me, a viewer should automatically be launched for it.')
		(griddingString			griddingOnOff
			'whether gridding should be used in my interior')
		(gridVisibleString		gridVisibleOnOff
			'whether the grid should be shown when gridding is on')


	) do:

			[:triplet |
				(isWorld and: [#(toggleAutoLineLayout toggleIndicateCursor toggleIsPartsBin toggleAlwaysShowThumbnail toggleAutomaticViewing ) includes: triplet second]) ifFalse:
					[aMenu addUpdating: triplet first action: triplet second.
					aMenu balloonTextForLastItem: triplet third translated]]. 

	aMenu addLine.
	aMenu add: 'round up strays' translated action: #roundUpStrays.
	aMenu balloonTextForLastItem:  'Bring back all objects whose current coordinates keep them from being visible, so that at least a portion of each of my interior objects can be seen.' translated.
	aMenu add: 'shuffle contents' translated action: #shuffleSubmorphs.
	aMenu balloonTextForLastItem: 'Rearranges my contents in random order' translated.
	aMenu add: 'set grid spacing...' translated action: #setGridSpec.
	aMenu balloonTextForLastItem: 'Set the spacing to be used when gridding is on' translated.

	isWorld ifFalse:
		[aMenu add: 'set thumbnail height...' translated action: #setThumbnailHeight.
		aMenu balloonTextForLastItem: 'if currently showing thumbnails governs the standard height for them' translated].

	self backgroundSketch ifNotNil:
		[aMenu add: 'delete background painting' translated action: #deleteBackgroundPainting.
		aMenu balloonTextForLastItem: 'delete the graphic that forms the background for this me.' translated].
	aMenu addLine.
	self addPenTrailsMenuItemsTo: aMenu.
	aMenu addLine.
	aMenu add: 'use standard texture' translated action: #setStandardTexture.
	aMenu balloonTextForLastItem: 'use a pale yellow-and-blue background texture here.' translated.
	aMenu add: 'make graph paper...' translated action: #makeGraphPaper.
	aMenu balloonTextForLastItem: 'Design your own graph paper and use it as the background texture here.' translated.
	aMenu addTitle: ('viewing options for "{1}"' translated format: {self externalName}).

	aMenu popUpForHand: self activeHand in: self world
! !

!PasteUpMorph methodsFor: '*NetMorph-actions' stamp: 'mu 8/4/2005 07:29'!
resetWorldForNetMorph
	self isWorldMorph
		ifFalse: [^ self].
	self flushNetMorphProxyCache.
	self flushMorphIdentifierWarpedList.
	self flushMorphIdentifierRenameList.
	self flushMarkerDock.
	self
		allMorphsDo: [:each | each extension
				ifNotNilDo: [:ext | ext resetIdAndPath]]! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 15:39'!
rightFenceEnabled
	^ self
		valueOfProperty: #rightFenceEnabled
		ifAbsent: [Preferences fenceEnabled]! !

!PasteUpMorph methodsFor: '*NetMorph-menu & halo' stamp: 'ka 12/18/2002 16:07'!
rightFenceEnabledString
	^ self rightFenceEnabled
		ifTrue: ['<on>right fence enabled']
		ifFalse: ['<off>right fence enabled']! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 15:30'!
rightFenceEnabled: aBoolean 
	self setProperty: #rightFenceEnabled toValue: aBoolean! !

!PasteUpMorph methodsFor: '*NetMorph-options' stamp: 'mu 7/13/2005 16:31'!
savedImageId
	self isWorldMorph ifFalse: [^ nil].
	^self valueOfProperty: #NetMorph:SavedImageId ifAbsentPut: [nil].! !

!PasteUpMorph methodsFor: '*NetMorph-options' stamp: 'mu 7/13/2005 16:31'!
savedImageId: anUUID
	self isWorldMorph ifFalse: [^ self].
	^self setProperty: #NetMorph:SavedImageId toValue: anUUID ! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 16:10'!
toggleBottomFenceEnabled
	self bottomFenceEnabled: self bottomFenceEnabled not! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 16:09'!
toggleLeftFenceEnabled
	self leftFenceEnabled: self leftFenceEnabled not! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 16:10'!
toggleRightFenceEnabled
	self rightFenceEnabled: self rightFenceEnabled not! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 16:10'!
toggleTopFenceEnabled
	self topFenceEnabled: self topFenceEnabled not! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 15:39'!
topFenceEnabled
	^ self
		valueOfProperty: #topFenceEnabled
		ifAbsent: [Preferences fenceEnabled]! !

!PasteUpMorph methodsFor: '*NetMorph-menu & halo' stamp: 'ka 12/18/2002 16:07'!
topFenceEnabledString
	^ self topFenceEnabled
		ifTrue: ['<on>top fence enabled']
		ifFalse: ['<off>top fence enabled']! !

!PasteUpMorph methodsFor: '*NetMorph-fence-options' stamp: 'ka 12/18/2002 15:30'!
topFenceEnabled: aBoolean 
	self setProperty: #topFenceEnabled toValue: aBoolean! !

!ProjectEntryNotification methodsFor: '*NetMorph-override-as yet unclassified' stamp: 'ka 10/21/2002 20:28'!
defaultAction
	projectToEnter world reinstallAllScripts.
	self resume: projectToEnter enter! !

!Socket methodsFor: '*NetMorph-override-receiving' stamp: 'mu 10/14/2003 23:28'!
receiveDataTimeout: timeout into: aStringOrByteArray startingAt: aNumber
	"Receive data into the given buffer and return the number of bytes received. 
	Note the given buffer may be only partially filled by the received data.
	Wait for data once for the specified nr of seconds.  The answer may be 
	zero (indicating that there was no data available within the given timeout)."

	self waitForDataFor: timeout ifClosed: [^0] ifTimedOut: [^0].
	^self primSocket: socketHandle
		receiveDataInto: aStringOrByteArray
		startingAt: aNumber
		count: aStringOrByteArray size-aNumber+1
! !

!HaloMorph methodsFor: '*NetMorph-override-handles' stamp: 'mu 6/18/2004 19:31'!
addDragHandle: haloSpec
	(self addHandle: haloSpec on: #mouseDown send: #startDrag:with: to: self)
		on: #mouseMove send: #doDrag:with: to: self;
			on: #mouseUp send: #endDrag:with: to: self


! !

!HaloMorph methodsFor: '*NetMorph-override-initialization' stamp: 'kuri-t 2/6/2003 12:43'!
delete
	"Delete the halo.  Tell the target that it no longer has the halo; accept any pending edits to the name; and then either actually delete myself or start to fade out"

	self prepareToDelete.
	Preferences haloTransitions
		ifTrue:
			[self stopStepping; startStepping.
			self startSteppingSelector: #fadeOutFinally]
		ifFalse:
			[super delete]! !

!HaloMorph methodsFor: '*NetMorph-private' stamp: 'mu 6/18/2004 19:37'!
endDrag: evt with: dragHandle 
	NmSettings useKeepMoving
		ifTrue: [target rememberMoveEndPoint.
			target startKeepMoving]! !

!HaloMorph methodsFor: '*NetMorph-initialization' stamp: 'kuri-t 2/6/2003 12:44'!
forceDelete
	self prepareToDelete.
	super delete! !

!HaloMorph methodsFor: '*NetMorph-override-stepping' stamp: ''!
localHaloBoundsFor: aMorph

	"aMorph may be in the hand and perhaps not in our world"

	| r |

	r _ aMorph topRendererOrSelf worldBoundsForHalo truncated.
	aMorph world = self world ifTrue: [^r].
	^((self transformFromOutermostWorld) globalBoundsToLocal: r) truncated! !

!HaloMorph methodsFor: '*NetMorph-initialization' stamp: 'kuri-t 2/6/2003 12:42'!
prepareToDelete
	target
		ifNotNil: [target hasHalo: false].
	self acceptNameEdit.
	self isMagicHalo: false! !

!HaloMorph methodsFor: '*NetMorph-override' stamp: 'mu 6/18/2004 19:39'!
startDrag: evt with: dragHandle
	"Drag my target without removing it from its owner."

	| itsOwner |
	self obtainHaloForEvent: evt andRemoveAllHandlesBut: dragHandle.
	positionOffset _ dragHandle center - (target point: target position in: owner).
	
	(evt shiftPressed and: [NmSettings useKeepMoving] ) ifTrue: [target rememberMoveStartPoint.].

	 ((itsOwner _ target topRendererOrSelf owner) notNil and:
			[itsOwner automaticViewing]) ifTrue:
				[target openViewerForArgument]! !

!Symbol methodsFor: '*NetMorph-override-printing' stamp: 'ka 1/15/2003 19:03'!
storeOn: aStream 
	aStream nextPut: $#.
	(Scanner isLiteralSymbol: self)
		ifFalse: [^ super storeOn: aStream].
	(self includes: $:)
		ifTrue: [^ super storeOn: aStream].
	aStream nextPutAll: self! !

!Vocabulary class methodsFor: '*NetMorph-override-class initialization' stamp: 'mu 12/13/2004 01:17'!
initializeStandardVocabularies
	"Initialize a few standard vocabularies and place them in the AllStandardVocabularies list."

	AllStandardVocabularies _ nil.

	
self addStandardVocabulary: EToyVocabulary new.
	self addStandardVocabulary: EToyVectorVocabulary new.

	self addStandardVocabulary: self newPublicVocabulary.
	self addStandardVocabulary: FullVocabulary new.

	self addStandardVocabulary: self newQuadVocabulary.

	self addStandardVocabulary: ColorType new.
	self addStandardVocabulary: BooleanType new.
	self addStandardVocabulary: GraphicType new.
	self addStandardVocabulary: PlayerType new.
	self addStandardVocabulary: SoundType new.
	self addStandardVocabulary: StringType new.
	self addStandardVocabulary: MenuType new.
	self addStandardVocabulary: UnknownType new.
	self addStandardVocabulary: ScriptNameType new.

	"NetMorph->"
	self addStandardVocabulary: NmEffectType new.
	self addStandardVocabulary: NmWarpType new.
	self addStandardVocabulary: NmDirectionType new.
	self addStandardVocabulary: NmWarpDestinationType new.
	"<-NetMorph"

	self addStandardVocabulary: (SymbolListType new symbols: #(simple raised inset complexFramed complexRaised complexInset complexAltFramed complexAltRaised complexAltInset); vocabularyName: #BorderStyle; yourself).
	self addStandardVocabulary: (SymbolListType new symbols: #(lines arrows arrowheads dots); vocabularyName: #TrailStyle; yourself).
	self addStandardVocabulary: (SymbolListType new symbols: #(leftToRight rightToLeft topToBottom bottomToTop); vocabularyName: #ListDirection; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(topLeft bottomRight center justified); vocabularyName: #ListCentering; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(buttonDown whilePressed buttonUp); vocabularyName: #ButtonPhase; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(rotate #'do not rotate' #'flip left right' #'flip up down'); vocabularyName: #RotationStyle; yourself).

	self addStandardVocabulary: (SymbolListType new symbols: #(rigid spaceFill shrinkWrap); vocabularyName: #Resizing; yourself).

	self addStandardVocabulary: self newSystemVocabulary.  "A custom vocabulary for Smalltalk -- still under development)"

	self numberVocabulary.  		"creates and adds it"
	self wonderlandVocabulary.  	"creates and adds it"
	self vocabularyForClass: Time.   "creates and adds it"

	"Vocabulary initialize"! !

!ProjectLoading class methodsFor: '*NetMorph-actions' stamp: 'mu 6/11/2004 02:51'!
loadFrom: preStream 
	
	| projStream trusted morphOrList baseChangeSet mgr proj archive |
	preStream isZipArchive 
		ifTrue:[	archive _ ZipArchive new readFrom: preStream.
				projStream _ self projectStreamFromArchive: archive]
		ifFalse:[projStream _ preStream].
	trusted _ SecurityManager default positionToSecureContentsOf: projStream.
	trusted ifFalse:[(SecurityManager default enterRestrictedMode) ifFalse:[
		(projStream respondsTo: #close) ifTrue:[projStream close].
		^self]].
	morphOrList _ projStream asUnZippedStream.
	
	ResourceCollector current: ResourceCollector new.
	baseChangeSet _ ChangeSet current.
	self useTempChangeSet.		"named zzTemp"
	"The actual reading happens here"
	[morphOrList _ morphOrList fileInObjectAndCode] ensure: [ | zzTemp |
				ChangeSet  newChanges: baseChangeSet.
				zzTemp _ ChangeSorter changeSetNamed: 'zzTemp'.
				zzTemp ifNotNil: [ChangeSorter removeChangeSet: zzTemp]
				].
	mgr _ ResourceManager new initializeFrom: ResourceCollector current.
	mgr registerUnloadedResources.
	(projStream respondsTo: #close) ifTrue:[projStream close].
	
	ResourceCollector current: nil.
	
	(morphOrList isKindOf: ImageSegment) ifTrue: [
		proj _ morphOrList arrayOfRoots 
			detect: [:mm | mm isKindOf: Project] 
			ifNone: [^self inform: 'No project found in this file'].
		proj resourceManager: mgr.
		proj lastDirectory: nil.
		CurrentProjectRefactoring currentBeParentTo: proj.
		
		Smalltalk isMorphic ifFalse: [
				ChangeSorter allChangeSets add: proj changeSet.
				ProjectView openAndEnter: proj.
				"Note: in MVC we get no further than the above"
			].
		
		ChangeSorter allChangeSets add: proj changeSet.
		^ proj
	].

	(morphOrList isKindOf: SqueakPage) ifTrue: [
		morphOrList _ morphOrList contentsMorph
	].
	(morphOrList isKindOf: PasteUpMorph) ifFalse: [
		^ self inform: 'This is not a PasteUpMorph or exported Project.'
	].
	^(Project newMorphicOn: morphOrList) ! !

!UserScript methodsFor: '*NetMorph-serializing' stamp: 'kuri-t 12/4/2002 17:04'!
prepareForWarp 
	self
		allScriptVersionsDo: [:v | v prepareForWarp]! !

SimpleButtonMorph subclass: #NmProjectCellMorph
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectCellMorph class methodsFor: 'instance creation' stamp: 'mu 6/21/2005 16:27'!
form: form label: labelString
	^self new setForm: form label: labelString! !

!NmProjectCellMorph methodsFor: 'constants' stamp: 'mu 6/21/2005 16:51'!
defaultColor
	^ (Color r: 1.0 g: 0.79 b: 0.485)! !

!NmProjectCellMorph methodsFor: 'menu-actions' stamp: 'mu 7/6/2005 21:09'!
diveProject: projectName 
	self inform: 'Not implemented yet. Please wait for SeeThroughTalk'! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 7/14/2005 22:08'!
formExtent
	self imageMorph ifNil: [^0@0].
	^self imageMorph extent! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 7/14/2005 22:02'!
imageMorph
	^self findA: ImageMorph! !

!NmProjectCellMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 16:55'!
initialize
	super initialize.
	self initLayout.
	
	self color: self defaultColor.
	self borderColor:  self color darker.
	
	! !

!NmProjectCellMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 14:48'!
initLayout
	
	self changeTableLayout.
	self listDirection: #topToBottom.
	self wrapCentering: #center.
	self listCentering: #center.
	self layoutInset: 5@5.
	self cellInset: 3.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.

	self useRoundedCorners! !

!NmProjectCellMorph methodsFor: 'initialize-release' stamp: 'mu 7/13/2005 00:00'!
initTarget
	
	self actionSelector: #enterNewProject:.
	self target: self target.
	self arguments: {self label}! !

!NmProjectCellMorph methodsFor: 'testing' stamp: 'mu 7/1/2005 20:33'!
isWarpable
	^false! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 6/21/2005 15:09'!
label
	^label! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 6/21/2005 15:10'!
label: aString
	label _ aString! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 6/30/2005 19:48'!
loader
	| parent |
	parent _ (self ownerThatIsA: NmProjectPageMorph) ifNil: [^nil].
	^parent loader! !

!NmProjectCellMorph methodsFor: 'menu-actions' stamp: 'mu 7/13/2005 00:00'!
loadProject: projectName 
	self loader enterNewProject: projectName ! !

!NmProjectCellMorph methodsFor: 'event handling' stamp: 'mu 7/6/2005 21:01'!
mouseDown: evt 
	evt yellowButtonPressed ifTrue: [^self popupYellowButtonMenu: evt].
	super mouseDown: evt ! !

!NmProjectCellMorph methodsFor: 'menu-actions' stamp: 'mu 7/15/2005 01:46'!
openProject: projectName 
	| window view |
	view _ self loader openProjectView: projectName.
	window _ view ownerThatIsA: SystemWindow.
	window
		ifNil: [window _ view openInWindow.
			"window setLabel: projectName."
			window model: view project.
			window update: #relabel.
			window setProperty: #projectWindow toValue: true]
		ifNotNil: [ActiveWorld addMorphFront: window]! !

!NmProjectCellMorph methodsFor: 'menu' stamp: 'mu 7/14/2005 23:15'!
popupYellowButtonMenu: evt
	| menu |
	menu _ MenuMorph new defaultTarget: self.
	menu add: 'load' translated selector: #loadProject: argument: self label.
	menu add: 'open' translated selector: #openProject: argument: self label.
	menu addLine.
	menu add: 'dive' translated selector: #diveProject: argument: self label.
	menu popUpInWorld! !

!NmProjectCellMorph methodsFor: 'geometry' stamp: 'mu 7/14/2005 22:03'!
scaledToSize: anExtent
	self imageMorph ifNotNilDo: [:im | im scaledToSize: anExtent].! !

!NmProjectCellMorph methodsFor: 'initialize-release' stamp: 'mu 6/21/2005 16:59'!
setForm: form label: labelString
	self removeAllMorphs.
	self addMorphFront: form asMorph.
	self addMorphBack: labelString asMorph.
	
	self label: labelString asString.
	! !

!NmProjectCellMorph methodsFor: 'accessing' stamp: 'mu 6/21/2005 16:30'!
target
	^self loader ifNil: [super target] ifNotNil: [self loader]! !

!MorphTest methodsFor: '*NetMorph-Testing' stamp: ''!
testDismissMorph
	| rectangle rectangleId ellipse ellipseId ellipseExist rectangleExist |
	rectangle _ RectangleMorph new.
	rectangleId _ rectangle identityHash.
	ellipse _ EllipseMorph new.
	ellipseId _ ellipse identityHash.
	rectangle addMorph: ellipse.
	rectangle openInWorld.
	rectangle topRendererOrSelf dismissMorph: nil.
	rectangle _ ellipse _ nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	ellipseExist _ EllipseMorph allInstances
				detect: [:each | each identityHash == ellipseId]
				ifNone: [].
	rectangleExist _ RectangleMorph allInstances
				detect: [:each | each identityHash == rectangleId]
				ifNone: [].
	self
		should: [ellipseExist isNil].
	self
		should: [rectangleExist isNil]! !

!MorphTest methodsFor: '*NetMorph-Testing' stamp: ''!
testDismissMorphForTransformation
	| rectangle rectangleId ellipse ellipseId ellipseExist rectangleExist |
	rectangle _ RectangleMorph new.
	rectangleId _ rectangle identityHash.
	rectangle openInWorld.
	rectangle heading: 100.
	ellipse _ EllipseMorph new.
	ellipseId _ ellipse identityHash.
	rectangle addMorph: ellipse.
	rectangle topRendererOrSelf dismissMorph: nil.
	rectangle _ ellipse _ nil.
	3 timesRepeat: [Smalltalk garbageCollect].
	ellipseExist _ EllipseMorph allInstances
				detect: [:each | each identityHash == ellipseId]
				ifNone: [].
	rectangleExist _ RectangleMorph allInstances
				detect: [:each | each identityHash == rectangleId]
				ifNone: [].
	self
		should: [ellipseExist isNil].
	self
		should: [rectangleExist isNil]! !

!MorphTest methodsFor: '*NetMorph-Testing' stamp: ''!
testLocalHaloBoundsFor
	| rectangleMorph halo befor after |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.

	halo _ HaloMorph new setTarget: rectangleMorph.
	befor _	 halo localHaloBoundsFor: rectangleMorph.

	rectangleMorph heading: 90.

	halo _ HaloMorph new setTarget: rectangleMorph.
	after _	 halo localHaloBoundsFor: rectangleMorph topRendererOrSelf.
	self should: [befor width == (after height - 2)].
	self should: [befor height == (after width - 2)].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: '*NetMorph-Testing' stamp: ''!
testPrivateAddMorphAtIndex
	| rectangleMorph ellipseMorph event |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	"event type: #dropEvent."
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	self
		should: [rectangleMorph submorphs includes: ellipseMorph topRendererOrSelf].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: '*NetMorph-Testing' stamp: ''!
testSaveOnFile
	| rectangleMorph ellipseMorph event aStream theMorph submorph savingBlock aFileName |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	"rectangleMorph saveOnFile."
	aFileName _ 'zzText.morph'.
	FileDirectory default deleteFileNamed: aFileName.
	savingBlock _ [:mor | 
			| fileStream topRendererOrSelf | 
			topRendererOrSelf _ mor topRendererOrSelf.
			topRendererOrSelf
				allMorphsDo: [:m | m prepareToBeSaved].
			fileStream _ FileStream newFileNamed: aFileName.
			fileStream fileOutClass: nil andObject: topRendererOrSelf].
	savingBlock value: rectangleMorph.
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	aStream _ FileStream oldFileNamed: 'zzText.morph'.
	theMorph _ Morph readFrom: aStream.
	theMorph openInWorld.
	submorph _ theMorph renderedMorph submorphs
				detect: [:each | each isKindOf: TransformationMorph]
				ifNone: [].
	self
		should: [submorph notNil].
	self
		should: [submorph renderedMorph isKindOf: EllipseMorph].
	theMorph topRendererOrSelf dismissMorph: nil.
	FileDirectory default deleteFileNamed: aFileName.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: '*NetMorph-Testing' stamp: ''!
testScaleToMatch
	| rectangleMorph ellipseMorph event before after |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	ellipseMorph _ EllipseMorph new.
	ellipseMorph extent: 50 @ 100.
	ellipseMorph openInWorld.
	ellipseMorph position: 100 @ 130.
	ellipseMorph heading: 90.
	event _ DropEvent new.
	"event type: #dropEvent."
	event
		setPosition: -100.0 @ 24.0
		contents: ellipseMorph topRendererOrSelf
		hand: HandMorph new.
	rectangleMorph acceptDroppingMorph: ellipseMorph topRendererOrSelf event: event.
	ellipseMorph topRendererOrSelf position: -45 @ -40.
	before _ ellipseMorph topRendererOrSelf bounds area.
	ellipseMorph topRendererOrSelf scaleToMatch: 246 @ 310.
	after _ ellipseMorph topRendererOrSelf bounds area.
	self
		should: [before == 5304].
	self
		should: [after == 6160].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: '*NetMorph-Testing' stamp: ''!
testWithOffsetOfCompositeTransform
	| compositeTransform rectangleMorph |
	rectangleMorph _ RectangleMorph new.
	rectangleMorph position: 100 @ 100.
	rectangleMorph extent: 200 @ 300.
	rectangleMorph openInWorld.
	rectangleMorph dropEnabled: true.
	rectangleMorph enableDrop: true.
	rectangleMorph enableDragNDrop: true.
	rectangleMorph heading: 90.
	compositeTransform _ rectangleMorph topRendererOrSelf transform composedWith: rectangleMorph topRendererOrSelf transform.
	self
		should: [compositeTransform respondsTo: #withOffset:].
	self
		should: [compositeTransform offset = (50.0 @ -450.0)].
	self
		should: [compositeTransform scale = 1.0].
	self
		should: [compositeTransform angle = -3.141592653589793].
	compositeTransform withOffset: 1 @ 1.
	self
		should: [compositeTransform offset = (-201.0 @ -249.0)].
	self
		should: [compositeTransform scale = 1.0].
	self
		should: [compositeTransform angle = -3.141592653589793].
	rectangleMorph topRendererOrSelf dismissMorph: nil.
	Smalltalk garbageCollect! !

!MorphTest methodsFor: '*NetMorph-Testing' stamp: ''!
testWithOffsetOfDisplayTransform
	| displayTransform |
	displayTransform _ DisplayTransform new.
	self
		should: [displayTransform respondsTo: #withOffset:].
	self
		should: [[displayTransform withOffset: 2 @ 2.
			false]
				on: Error
				do: [:ex | true]]! !

!PolygonMorph methodsFor: '*NetMorph-override-halo control' stamp: ''!
addFlexShellIfNecessary
	^ super addFlexShellIfNecessary! !

!PolygonMorph methodsFor: '*NetMorph-override-halo control' stamp: ''!
heading: newHeading 
	super heading: newHeading! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/14/2003 17:08'!
address
	^ self renderedMorph address! !

!TransformationMorph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 5/7/2003 17:05'!
getMoveDelta
	^ self renderedMorph isNil
		ifTrue: [0 @ 0]
		ifFalse: [self renderedMorph getMoveDelta]! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/15/2003 12:02'!
home
	^ self renderedMorph home! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/14/2003 17:08'!
identifier
	^ self renderedMorph identifier! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:20'!
lastWarpTime
	^ self renderedMorph lastWarpTime! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:21'!
lastWarpTime: millisecond
	self renderedMorph lastWarpTime: millisecond! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/15/2003 12:01'!
path
	^ self renderedMorph path! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'mu 7/13/2005 18:39'!
pathNames
	^ self renderedMorph pathNames! !

!TransformationMorph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 5/7/2003 17:04'!
rememberMoveEndPoint
	self renderedMorph
		ifNotNil: [self renderedMorph rememberMoveEndPoint]! !

!TransformationMorph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 5/7/2003 17:04'!
rememberMoveStartPoint
	self renderedMorph
		ifNotNil: [self renderedMorph rememberMoveStartPoint]! !

!TransformationMorph methodsFor: '*NetMorph-override-menu' stamp: 'kuri-t 1/9/2003 14:10'!
removeFlexShell
	^ self! !

!TransformationMorph methodsFor: '*NetMorph-support' stamp: 'mu 5/7/2003 16:58'!
renderedMorph
	submorphs size = 0
		ifTrue: [NmNoSubmorphs signal: self printString on: self. ^nil].
	^ self firstSubmorph renderedMorph! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/15/2003 12:13'!
resetIdentifier
	^ self renderedMorph resetIdentifier! !

!TransformationMorph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 5/7/2003 17:04'!
resetKeepMovingStatus
	self renderedMorph
		ifNotNil: [self renderedMorph resetKeepMovingStatus]! !

!TransformationMorph methodsFor: '*NetMorph-override-accessing' stamp: 'mu 12/13/2004 00:34'!
scaleToMatch: aPoint
	| scaleFactor tfm originalScale |
	tfm _ transform withScale: 1.0.
	originalScale _ ((tfm localBoundsToGlobal: self renderedMorph fullBounds) corner -
		(tfm localPointToGlobal: self renderedMorph referencePosition)) r.
	"Catch cases where the reference point is on fullBounds corner"
	originalScale := originalScale max: 1.0.
	scaleFactor _ ((self globalPointToLocal: aPoint)
				- self referencePosition) r / originalScale.
	scaleFactor _ scaleFactor < 1.0
		ifTrue: [scaleFactor detentBy: 0.05 atMultiplesOf: 0.25 snap: false]
		ifFalse: [scaleFactor detentBy: 0.1 atMultiplesOf: 0.5 snap: false].
	self adjustAfter:[self scale: ((scaleFactor min: 8.0) max: 0.1)].! !

!TransformationMorph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 5/8/2003 16:08'!
shouldKeepMoving
	^self renderedMorph isNil
		ifTrue: [false]
		ifFalse: [self renderedMorph shouldKeepMoving]! !

!TransformationMorph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 5/7/2003 17:03'!
shouldKeepMoving: aBoolean 
	self renderedMorph isNil
		ifFalse: [self renderedMorph shouldKeepMoving: aBoolean]! !

!TransformationMorph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 5/7/2003 17:01'!
startKeepMoving
	self renderedMorph
		ifNotNil: [self renderedMorph startKeepMoving]! !

!TransformationMorph methodsFor: '*NetMorph-override-stepping and presenter' stamp: 'ka 12/12/2002 16:02'!
stepTime
	"Answer the stepTime of my rendered morph if posible"
	| rendered |
	rendered _ [self renderedMorph]
				on: NmNoSubmorphs
				do: [:ex | ex return: self].
	rendered == self
		ifTrue: [^ super stepTime].
	"Hack to avoid infinite recursion"
	^ rendered stepTime! !

!TransformationMorph methodsFor: '*NetMorph-geometry keep moving' stamp: 'mu 5/7/2003 17:01'!
stopKeepMoving
	self renderedMorph
		ifNotNil: [self renderedMorph stopKeepMoving]! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/22/2003 15:34'!
warpDirection
	^ self renderedMorph warpDirection! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:22'!
warpDirection: warpDirection
	self renderedMorph warpDirection: warpDirection! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/14/2003 17:13'!
warping
	^ self renderedMorph warping! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:22'!
warping: statusSymbol
	self renderedMorph warping: statusSymbol! !

!TransformationMorph methodsFor: '*NetMorph-support' stamp: 'mu 5/10/2005 20:00'!
warpTo: destinationEntry x: x y: y 
	submorphs isEmpty
		ifTrue: [RmtDebug crShow:  '##Real morph was warped. So just ignoring warpting request...'.
			^ self].
	^ super
		warpTo: destinationEntry
		x: x
		y: y! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 1/22/2003 14:41'!
warpType
	^ self renderedMorph warpType! !

!TransformationMorph methodsFor: '*NetMorph-extension' stamp: 'kuri-t 2/7/2003 12:22'!
warpType: warpType
	self renderedMorph warpType: warpType! !

SimpleButtonDelayedMenuMorph subclass: #NmProjectPublishButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectPublishButtonMorph class methodsFor: 'actions' stamp: 'mu 6/17/2005 16:53'!
open
	"NmProjectPublisherMorph open"
	^self new openInWorld! !

!NmProjectPublishButtonMorph methodsFor: 'private' stamp: 'mu 6/17/2005 17:21'!
canPublish
	self world paintBoxOrNil
		ifNotNil: [self confirm: 'You seem to be painting a sketch.
Do you continue and publish the project with the paint tool?' translated].
	^ true! !

!NmProjectPublishButtonMorph methodsFor: 'private' stamp: 'mu 6/18/2005 22:41'!
computeColor
	^ self project isNetMorphPublished
				ifTrue: [self defaultPublishedColor]
				ifFalse: [self defaultColor]! !

!NmProjectPublishButtonMorph methodsFor: 'constants' stamp: 'mu 6/18/2005 22:44'!
defaultColor
	^ (Color r: 1.0 g: 0.79 b: 0.485)! !

!NmProjectPublishButtonMorph methodsFor: 'constants' stamp: 'mu 6/18/2005 22:39'!
defaultLabel
	^'Publish!!'! !

!NmProjectPublishButtonMorph methodsFor: 'constants' stamp: 'mu 6/18/2005 22:44'!
defaultPublishedColor
	^ Color red muchLighter! !

!NmProjectPublishButtonMorph methodsFor: 'initialize-release' stamp: 'mu 6/18/2005 22:39'!
initialize
	super initialize.
	self target: self;
		borderColor: #raised;
		 label: self defaultLabel font: TextStyle defaultFont;
		 setBalloonText: 'Publish this project' translated;
		 actionSelector: #publish! !

!NmProjectPublishButtonMorph methodsFor: 'accessing' stamp: 'mu 6/17/2005 18:33'!
project
	^Project current! !

!NmProjectPublishButtonMorph methodsFor: 'actions' stamp: 'mu 8/12/2005 13:10'!
publish
	| world saveOwner oldVersion |
	self canPublish
		ifFalse: [^ self].
	world _ self world
				ifNil: [^ Beeper beep].
	oldVersion _ self project currentVersionNumber.
	EToyProjectDetailsMorph
		getFullInfoFor: self project
		ifValid: [world setProperty: #'NetMorph:ProjectPublishing' toValue: true.
			saveOwner _ owner.
			self delete.
			[world project storeOnServerShowProgressOn: self forgetURL: true]
				ensure: [saveOwner addMorphFront: self]]
		expandedFormat: true.
	[[(self project currentVersionNumber > oldVersion
			and: [world setProperty: #'NetMorph:PublishedProject' toValue: true.
				true])
		or: [world isNetMorphProjectPublishCancelled]]
		whileFalse: [(Delay forSeconds: 3) wait].
	(world isNetMorphProjectPublishCancelled
			and: [world isNetMorphPublished not])
		ifTrue: [world setProperty: #'NetMorph:PublishedProject' toValue: false].
	world setProperty: #'NetMorph:ProjectPublishCancel' toValue: false.
	world setProperty: #'NetMorph:ProjectPublishing' toValue: false]
		forkAt: Processor userBackgroundPriority! !

!NmProjectPublishButtonMorph methodsFor: 'actions' stamp: 'mu 6/17/2005 18:30'!
showMenuFor:selector event: event
	
	| menu selection |
	menu _ CustomMenu new.
	menu 
		add: 'Stop Publishing' translated action: [self stopPublish].
	selection _ menu build startUpCenteredWithCaption: 'Publish options' translated.
	selection ifNil: [^self].
	selection value.

	^true! !

!NmProjectPublishButtonMorph methodsFor: 'stepping' stamp: 'mu 6/18/2005 22:39'!
step
	self
		color: self computeColor.
	! !

!NmProjectPublishButtonMorph methodsFor: 'stepping' stamp: 'mu 6/17/2005 18:43'!
stepTime
	^1500! !

!NmProjectPublishButtonMorph methodsFor: 'actions' stamp: 'mu 6/18/2005 22:31'!
stopPublish
	| world |
	world _ self world ifNil: [^Beeper beep].
	world setProperty: #NetMorph:PublishedProject toValue: false.
	
	
	! !

!HandMorph methodsFor: '*NetMorph-override-grabbing/dropping' stamp: 'mu 1/4/2003 17:29'!
attachMorph: m
	"Position the center of the given morph under this hand, then grab it.
	This method is used to grab far away or newly created morphs."
	| delta |
	m stopKeepMoving.
	self releaseMouseFocus. "Break focus"
	delta _ m bounds extent // 2.
	m position: (self position - delta).
	m formerPosition: m position.
	targetOffset _ m position - self position.
	self addMorphBack: m.
! !

!HandMorph methodsFor: '*NetMorph-override-grabbing/dropping' stamp: 'mu 1/4/2003 17:29'!
grabMorph: aMorph
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner) without changing its position. This is used to pick up a morph under the hand's current position, versus attachMorph: which is used to pick up a morph that may not be near this hand."
	| grabbed |
	aMorph stopKeepMoving.
	self releaseMouseFocus. "Break focus"
	grabbed _ aMorph aboutToBeGrabbedBy: self.
	grabbed ifNil:[^self].
	grabbed _ grabbed topRendererOrSelf.
	^self grabMorph: grabbed from: grabbed owner! !

!HandMorph methodsFor: '*NetMorph-override-private' stamp: ''!
objectForDataStream: refStrm
	| dp |
	"I am about to be written on an object file.  Write a path to me in the other system instead."
	refStrm project isNil ifFalse: [
		(refStrm project world hands includes: self) ifTrue: [
			^ self]].	"owned by the project"
	dp _ DiskProxy global: #World selector: #primaryHand args: #().
	refStrm replace: self with: dp.
	^ dp
	"Note, when this file is loaded in an MVC project, this will return nil.  The MenuItemMorph that has this in a field will have that item not work.  Maybe warn the user at load time?"! !

Error subclass: #NmError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

NmError subclass: #NmDispatchFailed
	instanceVariableNames: 'selector arguments target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Network-Services'!

!NmDispatchFailed methodsFor: 'accessing' stamp: 'mu 7/29/2005 19:24'!
arguments
	^arguments! !

!NmDispatchFailed methodsFor: 'accessing' stamp: 'mu 7/29/2005 19:24'!
arguments: anObject
	arguments _ anObject! !

!NmDispatchFailed methodsFor: 'exceptionBuilder' stamp: 'mu 7/29/2005 19:30'!
messageText
	^ super messageText
		ifNil: ['target: ' , self target asString , 'selector: ' , self selector asString , 'arguments: ' , self arguments asString]! !

!NmDispatchFailed methodsFor: 'accessing' stamp: 'mu 7/29/2005 19:24'!
selector
	^selector! !

!NmDispatchFailed methodsFor: 'accessing' stamp: 'mu 7/29/2005 19:24'!
selector: anObject
	selector _ anObject! !

!NmDispatchFailed methodsFor: 'accessing' stamp: 'mu 7/29/2005 19:24'!
target
	^target! !

!NmDispatchFailed methodsFor: 'accessing' stamp: 'mu 7/29/2005 19:24'!
target: anObject
	target _ anObject! !

NmError subclass: #NmLockFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

NmError subclass: #NmNoSubmorphs
	instanceVariableNames: 'originatorMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

!NmNoSubmorphs class methodsFor: 'exceptionInstantiator' stamp: 'mu 8/4/2005 12:02'!
signal: signalerText on: originatorMorph
	"Signal the occurrence of an exceptional condition with a specified textual description."

	| ex |
	ex := self new.
	ex originatorMorph: originatorMorph.
	^ex signal: signalerText! !

!NmNoSubmorphs methodsFor: 'actions' stamp: 'mu 5/13/2003 17:28'!
cleanUp
	"Dump the stack trace to a log file, then exit the program (image)."

	NmTranscript crShow: self class name.	
	
	"file := FileStream forceNewFileNamed: (self class name, 'Error', Utilities dateTimeSuffix, FileDirectory dot, 'log') asFileName.
	Smalltalk timeStamp: file.
	(thisContext sender stackOfSize: 20) do: [:ctx | file cr. ctx printOn: file].
	file close."
	
	"Silently delete the problem morph"
	originatorMorph ifNotNil: [originatorMorph delete].
	^nil! !

!NmNoSubmorphs methodsFor: 'exceptionDescription' stamp: 'mu 8/4/2005 11:23'!
defaultAction
	NmBaseSettings isDebugging
		ifTrue: [^ super defaultAction]
		ifFalse: [originatorMorph
				ifNotNilDo: [:mo | ActiveWorld privateRemove: mo].
			^ nil]! !

!NmNoSubmorphs methodsFor: 'accessing' stamp: 'mu 5/7/2003 15:19'!
originatorMorph
	^originatorMorph! !

!NmNoSubmorphs methodsFor: 'accessing' stamp: 'mu 5/7/2003 15:19'!
originatorMorph: aMorph
	originatorMorph _ aMorph! !

NmError subclass: #NmNoSuchMorph
	instanceVariableNames: 'uuidString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

!NmNoSuchMorph class methodsFor: 'instance creation' stamp: 'mu 7/30/2005 14:55'!
signalWithUuidString: uuidString 
	| inst |
	inst _ self new.
	inst uuidString: uuidString.
	^ inst signal: 'Morph(' , uuidString , ') is not found'! !

!NmNoSuchMorph methodsFor: 'exceptionDescription' stamp: 'mu 7/30/2005 14:58'!
defaultAction
	^ NmBaseSettings isDebugging
		ifTrue: [super defaultAction]
		ifFalse: [NmShortMessageMorph contents: self messageText at: ActiveWorld center.
			nil]! !

!NmNoSuchMorph methodsFor: 'exceptionDescription' stamp: 'mu 7/30/2005 14:56'!
messageText
	self uuidString ifNil: [^super messageText].
	^'Morph(' , self uuidString , ') is not found' translated! !

!NmNoSuchMorph methodsFor: 'accessing' stamp: 'mu 7/30/2005 14:53'!
uuidString
	^uuidString! !

!NmNoSuchMorph methodsFor: 'accessing' stamp: 'mu 7/30/2005 14:54'!
uuidString: aString
	uuidString _ aString! !

NmError subclass: #NmUnlockFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

Error subclass: #NmProjectSortFailed
	instanceVariableNames: 'sortOptionString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Project'!

!NmProjectSortFailed class methodsFor: 'instance creation' stamp: 'mu 7/3/2005 23:04'!
sortOptionString: aString 
	^ self new sortOptionString: aString; signal! !

!NmProjectSortFailed methodsFor: 'printing' stamp: 'mu 7/3/2005 23:02'!
messageText
	messageText ifNil: [messageText _ self sortOptionString].
	^messageText
	! !

!NmProjectSortFailed methodsFor: 'accessing' stamp: 'mu 7/3/2005 22:58'!
sortOptionString
	^sortOptionString! !

!NmProjectSortFailed methodsFor: 'accessing' stamp: 'mu 7/3/2005 23:07'!
sortOptionString: aString
	sortOptionString _ aString asString capitalized! !

HttpUrl subclass: #NmUrl
	instanceVariableNames: 'isLocal ipAddress triedResolveIp triedResolveHost'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

NmUrl class
	instanceVariableNames: 'local'!

!NmUrl class methodsFor: 'instance creation-sixx' stamp: 'mu 12/29/2004 22:51'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self absoluteFromText: (SixxXmlUtil characterDataFrom: sixxElement)! !

!NmUrl class methodsFor: 'instance creation' stamp: 'mu 8/18/2005 09:09'!
createLocal
	"NmUrl createLocal"
	| url |
	url _ (self protocolIdentifier , NmBaseUtil localHostname , ':' , NmSettings warpPort printString) asUrl.
	^ url! !

!NmUrl class methodsFor: 'instance creation' stamp: 'mu 12/29/2004 22:40'!
fromCsvString: aString 
	"NmUrl fromCsvString: 'nm://localhost:37458/'"
	^self readFrom: (ReadStream on: aString).
	! !

!NmUrl class methodsFor: 'instance creation' stamp: 'mu 1/12/2005 02:24'!
host: hostname port: portNumber 
	| inst portPart urlStr |
	inst _ self basicNew.
	portPart _ self trimmedPortNumber:  portNumber.
	urlStr _ self protocolIdentifier , hostname , ':' , portPart asString.
	inst privateInitializeFromText: urlStr.
	^ inst! !

!NmUrl class methodsFor: 'class initialization' stamp: 'MU 10/3/2002 12:44'!
initialize
	"NmUrl initialize"
	local _ nil! !

!NmUrl class methodsFor: 'accessing' stamp: 'MU 10/3/2002 10:19'!
local
	local isNil ifTrue: [local _ self createLocal].
	^local! !

!NmUrl class methodsFor: 'instance creation' stamp: 'MU 10/2/2002 20:26'!
new
	^super new initialize! !

!NmUrl class methodsFor: 'constants' stamp: 'mu 1/11/2005 00:35'!
protocolIdentifier
	^ 'nm://'.! !

!NmUrl class methodsFor: 'instance creation' stamp: 'mu 1/12/2005 02:12'!
readFrom: aStream
	"NmUrl readFrom: 'nm://localhost:37458/' readStream"
	"NmUrl readFrom: 'localhost:37458/' readStream"
	"NmUrl readFrom: 'auau' readStream"
	| str tokens port hostIndex host  |
	str _ aStream contents.
	(str beginsWith: self protocolIdentifier) ifTrue: [^str asUrl].
	tokens _ str findTokens: '/:'.
	port _ tokens detect: [:each | each isAllDigits] ifNone: [NmSettings defaultWarpPort asString].
	hostIndex _ tokens indexOf: port.
	host _ hostIndex = 0 ifTrue: [tokens last] ifFalse: [tokens at: ((hostIndex -1) max: 1)].
	^self host: host port: port
	! !

!NmUrl class methodsFor: 'constants' stamp: 'mu 12/29/2004 22:51'!
scheme
	^ 'nm'.! !

!NmUrl class methodsFor: 'private' stamp: 'mu 1/12/2005 02:29'!
trimmedPortNumber: portNumber 
	"NmUrl trimmedPortNumber: 99999"
	"NmUrl trimmedPortNumber: -100"
	"NmUrl trimmedPortNumber: 200"
	^ (portNumber asNumber between: 0 and: 65535)
		ifTrue: [portNumber]
		ifFalse: [NmSettings defaultWarpPort]! !

!NmUrl methodsFor: 'converting' stamp: 'mu 5/10/2005 20:29'!
asDestination
	^self asString! !

!NmUrl methodsFor: 'converting' stamp: 'mu 12/29/2004 22:48'!
asNmUrl
	^self! !

!NmUrl methodsFor: 'printing' stamp: 'MU 11/11/2002 15:55'!
csvString
	"'nm://localhost:37458' asUrl csvString"
	| stream |
	stream _ WriteStream on: String new.
	stream nextPutAll: self printString.
	^ stream contents! !

!NmUrl methodsFor: 'printing' stamp: 'mu 4/12/2003 19:37'!
displayString
	^ (self host isNil
			or: [self port isNil])
		ifTrue: [String new]
		ifFalse: [super toText]! !

!NmUrl methodsFor: 'comparing' stamp: 'MU 10/3/2002 10:33'!
hash
	^ (self port hash hashMultiply + self path hash hashMultiply + self hostId hash hashMultiply) 




! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 15:35'!
host
	self authority isNil ifTrue: [authority _  ''].
	^self authority	! !

!NmUrl methodsFor: 'comparing' stamp: 'MU 11/11/2002 16:07'!
hostId

	^ self hostOrIpAddress asString, ':', self port asString! !

!NmUrl methodsFor: 'actions' stamp: 'mu 3/23/2003 13:15'!
hostOrIpAddress
	^ self host isNil
		ifTrue: [self ipAddress]
		ifFalse: [self host]! !

!NmUrl methodsFor: 'comparing' stamp: 'mu 1/11/2005 00:55'!
hostOrIpEquals: otherNmUrl 
	self class = otherNmUrl class
		ifFalse: [^ false].
	self host = otherNmUrl host
		ifTrue: [^ true].
	self ipAddress = otherNmUrl ipAddress
		ifTrue: [true].
	^ false! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 6/22/2005 22:30'!
host: aString 
	
	authority _ aString asString.! !

!NmUrl methodsFor: 'initialize-release' stamp: 'mu 1/10/2005 01:19'!
initialize
	path _ #().
	self initResolved! !

!NmUrl methodsFor: 'initialize-release' stamp: 'mu 1/10/2005 01:19'!
initResolved
	triedResolveIp _ triedResolveHost _ false! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 3/23/2003 13:01'!
ipAddress
	^ ipAddress! !

!NmUrl methodsFor: 'actions' stamp: 'mu 3/23/2003 13:14'!
ipAddressOrHost
	^ self ipAddress isNil
		ifTrue: [self host]
		ifFalse: [self ipAddress]! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/11/2005 00:23'!
ipAddress: aString
	ipAddress _ aString.
	! !

!NmUrl methodsFor: 'testing' stamp: 'mu 8/7/2005 22:45'!
isLocal
	^NmBaseUtil isLocal: self ipAddressOrHost port: self port! !

!NmUrl methodsFor: 'testing' stamp: 'mu 4/15/2003 16:38'!
isNmUrl
	^true! !

!NmUrl methodsFor: 'actions' stamp: 'mu 6/22/2005 22:32'!
parsedIp
	self host = 'localhost'
		ifTrue: [self ipAddress: '127.0.0.1'.
			^ self ipAddress].
	(NetNameResolver addressFromString: self host) notNil
		ifTrue: [self ipAddress: self host asString].
	^ self ipAddress! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 3/23/2003 15:56'!
port
	port ifNil: [port _ NmSettings defaultWarpPort].
	^ port.! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/12/2005 02:25'!
port: anInteger
	port _ self class trimmedPortNumber: anInteger! !

!NmUrl methodsFor: 'initialize-release' stamp: 'mu 1/10/2005 01:31'!
privateInitializeFromText: aString 
	super privateInitializeFromText: aString.
	"set host if possible"
	authority := authority asLowercase.
	authority = '127.0.0.1'
		ifTrue: [authority := 'localhost']
		ifFalse: [| addressStr | 
			addressStr := NetNameResolver addressFromString: authority.
			addressStr notNil
				ifTrue: [| hostname | 
					ipAddress := authority.
					hostname := NetNameResolver nameForAddress: addressStr timeout: 1.
					authority := hostname isNil
								ifTrue: [authority]
								ifFalse: [hostname asLowercase]]]! !

!NmUrl methodsFor: 'actions' stamp: 'mu 1/11/2005 00:19'!
resolvedHost
	| host |
	self triedResolveHost
		ifTrue: [^ self host].
	host := NetNameResolver nameForAddress: self ipAddress timeout: 3.
	triedResolveHost := true.
	host isNil
		ifFalse: [self host: host].
	^ self host! !

!NmUrl methodsFor: 'actions' stamp: 'mu 8/4/2005 08:47'!
resolvedIp
	| ip |
	(self triedResolveIp or: [self ipAddress notNil])
		ifTrue: [^ self ipAddress].
	ip := (NmWorldMap default atName: self asDestination)
				ifNotNilDo: [:ent | ent ip]. 
	ip isNil
		ifTrue: [| address | 
			address := [NetNameResolver addressForName: self host timeout: 3]
						on: NameLookupFailure
						do: [:ex | ex return: nil].
			address
				ifNotNilDo: [:addr | ip := NetNameResolver stringFromAddress: addr]].
	triedResolveIp := true.
	ip isNil
		ifFalse: [self ipAddress: ip].
	^ self ipAddress! !

!NmUrl methodsFor: 'printing' stamp: 'mu 3/10/2003 17:42'!
shortPrintString
	"'nm://localhost:37459' asUrl shortPrintString"
	"'nm://localhost:37458' asUrl shortPrintString"
	| stream |
	stream _ WriteStream on: String new.
	stream nextPutAll: self host.
	self port = NmSettings defaultWarpPort
		ifFalse: [stream nextPut: $:.
			stream nextPutAll: self port printString].
	^ stream contents! !

!NmUrl methodsFor: 'printing-sixx' stamp: ''!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self toText.! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/10/2005 01:20'!
triedResolveHost
	triedResolveHost ifNil: [triedResolveHost _ false].
	^triedResolveHost! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/10/2005 01:20'!
triedResolveIp
	triedResolveIp ifNil: [triedResolveIp _ false].
	^triedResolveIp! !

!NmUrl methodsFor: 'comparing' stamp: 'mu 4/12/2003 19:38'!
truelyEquals: otherNmUrl 
	self class = otherNmUrl class
		ifFalse: [^ false].
	self host = otherNmUrl host
		ifFalse: [^ false].
	self port = otherNmUrl port
		ifFalse: [^ false].
	self path = otherNmUrl path
		ifFalse: [^ false].
	self ipAddress = otherNmUrl ipAddress
		ifFalse: [^ false].
	^ true! !

!NmUrl methodsFor: 'comparing' stamp: 'mu 3/23/2003 13:15'!
= otherNmUrl 
	"'nm://localhost' asUrl = 'nm://127.0.0.1' asUrl"
	self class = otherNmUrl class ifFalse: [^ false].
	self port = otherNmUrl port ifFalse: [^ false].
	self path = otherNmUrl path ifFalse: [^ false].
	^ self hostId = otherNmUrl hostId! !

!DiskProxy methodsFor: '*NetMorph-stepping' stamp: ''!
step
	"no-op"
	^ self! !

!Player class methodsFor: '*NetMorph-instance creation' stamp: ''!
fromUUIDString: anUUIDString 
	| morph |
	morph _ Morph fromUUIDString: anUUIDString.
	morph isNil
		ifTrue: [^ nil].
	^ morph player! !

!Player methodsFor: '*NetMorph-converting' stamp: 'kuri-t 12/13/2002 15:21'!
asProxy
	^ NmPlayerProxy on: self! !

!Player methodsFor: '*NetMorph-compiling' stamp: 'mu 7/10/2005 18:43'!
compileScript: aString
	self class compile: aString classified: 'scripts'! !

!Player methodsFor: '*NetMorph-scripts' stamp: ''!
effects: effectString 
	self costume perform: effectString asSymbol! !

!Player methodsFor: '*NetMorph-override-scripts-standard' stamp: 'ka 12/18/2002 16:37'!
forward: dist 
	"Move forward (viz. in the direction of my heading) by the given 
	amount "
	| rho radians delta didStray p aCostume aPlayfield |
	(aCostume _ self costume) isInWorld
		ifFalse: [^ self].
	aCostume isWorldOrHandMorph
		ifTrue: [^ self].
	aCostume owner isHandMorph
		ifTrue: [^ self].
	rho _ (aCostume asNumber: dist) asFloat.
	radians _ (self getHeadingUnrounded asFloat - 90.0) degreesToRadians.
	delta _ radians cos @ radians sin * rho.
	aPlayfield _ aCostume pasteUpMorph.
	didStray _ false.
	aPlayfield leftFenceEnabled
		ifTrue: [(aCostume left < aPlayfield left
					and: [delta x < 0])
				ifTrue: [delta _ delta x negated @ delta y.
					didStray _ true]].
	aPlayfield rightFenceEnabled
		ifTrue: [(aCostume right > aPlayfield right
					and: [delta x > 0])
				ifTrue: [delta _ delta x negated @ delta y.
					didStray _ true]].
	aPlayfield topFenceEnabled
		ifTrue: [(aCostume top < aPlayfield top
					and: [delta y < 0])
				ifTrue: [delta _ delta x @ delta y negated.
					didStray _ true]].
	aPlayfield bottomFenceEnabled
		ifTrue: [(aCostume bottom > aPlayfield bottom
					and: [delta y > 0])
				ifTrue: [delta _ delta x @ delta y negated.
					didStray _ true]].
	(didStray
			and: [Preferences fenceSoundEnabled])
		ifTrue: [aCostume makeFenceSound].
	"use and record the fractional position"
	p _ aCostume referencePosition + delta.
	aCostume referencePosition: p! !

!Player methodsFor: '*NetMorph-slots' stamp: 'mu 5/30/2003 16:50'!
getAddress
	^ self costume renderedMorph address asString! !

!Player methodsFor: '*NetMorph-slots' stamp: 'ns 9/17/2002 15:57'!
getAuthority
	^ self costume renderedMorph url authority asString! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:36'!
getFragment
	^ self costume renderedMorph url fragment! !

!Player methodsFor: '*NetMorph-slots' stamp: 'mu 5/10/2005 20:58'!
getHome
	^ self costume renderedMorph home! !

!Player methodsFor: '*NetMorph-slots' stamp: ''!
getIdentifier
	^ self costume renderedMorph identifier! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 10/8/2002 15:57'!
getIpAddress
	^ self costume renderedMorph url ipAddress! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:58'!
getPath
	| collection stream |
	collection _ self costume renderedMorph url path.
	stream _ WriteStream on: '/'.
	collection
		do: [:each | stream nextPutAll: '/' , each].
	^ stream contents! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:36'!
getPort
	^ self costume renderedMorph url port! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:36'!
getQuery
	^ self costume renderedMorph url query! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:36'!
getRealm
	^ self costume renderedMorph url realm! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:36'!
getScheme
	^ self costume renderedMorph url schemeName! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:36'!
getUrl
	^ self costume renderedMorph url toText! !

!Player methodsFor: '*NetMorph-heading' stamp: ''!
head: aSymbol 
	aSymbol == #up
		ifTrue: [^ self headUp].
	aSymbol == #down
		ifTrue: [^ self headDown].
	aSymbol == #left
		ifTrue: [^ self headLeft].
	aSymbol == #right
		ifTrue: [^ self headRight]! !

!Player methodsFor: '*NetMorph-misc' stamp: 'kuri-t 12/13/2002 14:13'!
nearTo: anotherPlayer 
	| envelope myBounds trueNeighbor trueGoal trueSelf |
	anotherPlayer
		ifNil: [^ false].
	envelope _ costume owner
				ifNil: [^ false].
	myBounds _ costume bounds.
	trueSelf _ costume renderedMorph.
	trueGoal _ anotherPlayer costume renderedMorph.
	envelope submorphs
		do: [:each | 
			trueNeighbor _ each renderedMorph.
			(trueNeighbor == trueGoal
					and: [trueNeighbor ~~ trueSelf])
				ifTrue: [(myBounds intersects: each bounds)
						ifTrue: [^ true]]].
	^ false! !

!Player methodsFor: '*NetMorph-message handling' stamp: 'mu 8/2/2005 07:20'!
perform: selector 
	[^ super perform: selector]
		on: MessageNotUnderstood
		do: [:ex | 
			| message | 
			RmtDebug crShow: ex messageText asString, ' at: Player>>perform:#' , selector.
			self stopProgramatically.
			message := NmBaseSettings isDebugging
						ifTrue: [ex messageText]
						ifFalse: ['Morph(' , self costume identifier asString , ') is not found' translated].
			NmShortMessageMorph contents: message for: self costume]! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:36'!
privateSetUrl: anUrl 
	^ self costume renderedMorph url: anUrl! !

!Player methodsFor: '*NetMorph-scripts-execution' stamp: ''!
runAllWarpedInScripts
	"Run all the receiver's scripts marked as #warpedIn. Return a 
	boolean indicating whether any such scripts were encountered 
	and run"

	| any |
	any _ false.
	self
		instantiatedUserScriptsDo: [:aScriptInstantiation | aScriptInstantiation runIfWarpedIn
				ifTrue: [any _ true]].
	^ any! !

!Player methodsFor: '*NetMorph-scripts-execution' stamp: ''!
runAllWarpingOutScripts
	"Run all the receiver's scripts marked as #warpingOut. Return a 
	boolean indicating whether any such scripts were encountered 
	and run"

	| any |
	any _ false.
	self
		instantiatedUserScriptsDo: [:aScriptInstantiation | aScriptInstantiation runIfWarpingOut
				ifTrue: [any _ true]].
	^ any! !

!Player methodsFor: '*NetMorph-compiling' stamp: 'mu 7/10/2005 18:41'!
scriptSources
	| selectors |
	selectors _ self class organization listAtCategoryNamed: #scripts.
	^selectors collect: [:each | self class sourceCodeAt: each].! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'mu 1/11/2005 00:35'!
setAuthority: aValue 
	| url port authority |
	url _ self costume renderedMorph url.
	port _ url port isNil
				ifTrue: [NmSettings port asString]
				ifFalse: [url port asString].
	authority _ aValue.
	^ self privateSetUrl: (NmUrl protocolIdentifier , authority , ':' , port) asUrl! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:35'!
setFragment: newFragment 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl withFragment: newFragment.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: '*NetMorph-override-slot getters/setters' stamp: 'mu 5/15/2005 01:58'!
setHeading: newHeading
	"Set the heading as indicated"

	| aCostume |
	aCostume _ self costume.
	aCostume isWorldMorph ifTrue: [^ self].
	(newHeading closeTo: aCostume heading) ifTrue: [^ self].
	aCostume heading: newHeading.
	aCostume _ self costume. "in case we just got flexed for no apparent reason"

	"(aCostume isFlexMorph and:[aCostume hasNoScaleOrRotation]) 
		ifTrue:	[aCostume removeFlexShell]" "<---commented out for NetMorph"! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:48'!
setPath: pathString 
	| path newUrl |
	path _ pathString findTokens: $/.
	path isEmpty
		ifTrue: [path _ #('/' ) asOrderedCollection].
	newUrl _ self costume renderedMorph url.
	newUrl
		schemeName: newUrl schemeName
		authority: newUrl authority
		path: path asArray
		query: newUrl query.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 12:16'!
setPort: aNumber 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl instVarNamed: #port put: aNumber.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:35'!
setQuery: aQuery 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl
		schemeName: newUrl schemeName
		authority: newUrl authority
		path: newUrl path
		query: aQuery.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:35'!
setRealm: aValue 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl instVarNamed: #realm put: aValue.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: '*NetMorph-override-slot getters/setters' stamp: 'mu 5/15/2005 02:00'!
setScaleFactor: aNumber
	"Set the scale factor to be the given value"

	| cost |
	cost _ self costume.
	cost isWorldMorph ifTrue: [^ self].
	cost isFlexMorph ifFalse: [cost addFlexShell]. "<---NetMorph"
	cost scaleFactor: ((aNumber asFloat max: 0.1) min: 10.0)! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:35'!
setScheme: schemeName 
	| newUrl |
	newUrl _ self costume renderedMorph url.
	newUrl
		schemeName: "schemeName" 'nm'
		authority: newUrl authority
		path: newUrl path
		query: newUrl query.
	^ self privateSetUrl: newUrl! !

!Player methodsFor: '*NetMorph-slots-url' stamp: 'ns 9/20/2002 11:35'!
setUrl: aValue 
	| newUrl |
	newUrl _ (aValue notNil
					and: [aValue isEmpty not])
				ifTrue: [aValue asUrl]
				ifFalse: [NmUrl new].
	^ self privateSetUrl: newUrl! !

!Player methodsFor: '*NetMorph-testing' stamp: 'kuri-t 12/13/2002 15:03'!
shouldPassAsProxy
	^ true.! !

!Player methodsFor: '*NetMorph-override-scripts-standard' stamp: 'mu 5/15/2005 02:04'!
turnToward: aPlayer
	"Turn to the direction of the given player."
	| angle myCostume otherCostume toPoint deltaPoint |
	(aPlayer == nil or: [aPlayer == self]) ifTrue: [^ self].
	myCostume _ self costume.
	myCostume isWorldMorph ifTrue: [^ self].
	otherCostume _ aPlayer costume.
	toPoint _ otherCostume currentPointInTheMap.
	myCostume currentPointInTheMap = toPoint
		ifTrue: [(myCostume rendererBounds intersects: otherCostume rendererBounds)
				ifTrue: [^ self]].
	deltaPoint _ NmWorldMap default deltaPointTo: toPoint.
	angle _ myCostume referencePosition bearingToPoint: otherCostume rendererReferencePosition + deltaPoint.

	self setHeading: angle.
! !

!Player methodsFor: '*NetMorph-override-name' stamp: 'ka 9/25/2002 18:33'!
uniqueNameForReference
	"Answer a unique name for referring to the receiver"

	"| itsReferent |
	self flag: #deferred.  ""The once-and-maybe-future ObjectRepresentativeMorph scheme is for the moment disenfranchised""

	""(costume isKindOf: ObjectRepresentativeMorph) ifTrue:
		[((itsReferent _ costume objectRepresented) isKindOf: Class)
			ifTrue:
				[^ itsReferent name].
		itsReferent == Smalltalk ifTrue: [^ #Smalltalk].
		itsReferent == ScriptingSystem ifTrue: [^ #ScriptingSystem]].""

	^  super uniqueNameForReference"

	^ '(Player fromUUIDString: ', self costume renderedMorph identifier asString printString, ')'

! !

!Player methodsFor: '*NetMorph-scripts' stamp: ''!
warp
	self costume warp! !

!Player methodsFor: '*NetMorph-scripts' stamp: 'mu 5/10/2005 19:52'!
warpTo: destinationEntry 
	self costume warpTo: destinationEntry! !

!Player methodsFor: '*NetMorph-scripts' stamp: 'kuri-t 1/10/2003 16:01'!
warp: warpType
	self costume warp: warpType asSymbol! !

!Player methodsFor: '*NetMorph-override-costume' stamp: 'kuri-t 12/17/2002 15:36'!
wearCostumeOf: anotherPlayer
	"Put on a costume similar to the one currently worn by anotherPlayer"

	| targetMorph anotherPlayerCostumeState |
	anotherPlayerCostumeState _ anotherPlayer costume costumeState.
	targetMorph _ SketchMorph withForm: anotherPlayerCostumeState imageForm.
	targetMorph copyCostumeStateFrom: anotherPlayerCostumeState.
	targetMorph extension instVarNamed: 'identifier' put: costume identifier.
	costume extension instVarNamed: 'identifier' put: nil.
	self renderedCostume: targetMorph remember: anotherPlayerCostumeState shouldRememberCostumes! !

!Form class methodsFor: '*NetMorph-image reading/writing' stamp: 'ns 1/9/2003 17:34'!
formFromStream: aBinaryStream 
	| form |
	[form _ self new readResourceFrom: aBinaryStream]
		ensure: [aBinaryStream close].
	^ form! !

!Form class methodsFor: '*NetMorph-image reading/writing' stamp: 'ns 1/9/2003 11:37'!
putForm: aForm onStream: aWriteStream 
	[aForm storeResourceOn: aWriteStream]
		ensure: [aWriteStream close]! !

!Form methodsFor: '*NetMorph-converting' stamp: 'mu 6/16/2005 21:55'!
thumbnailShrunkBy: size 
	| viewSize thumbnail |
	viewSize _ Display extent // size.
	thumbnail _ Form extent: viewSize depth: Display depth.
	(WarpBlt current toForm: thumbnail)
			sourceForm: self;
			cellSize: 2;  "installs a colormap"
			combinationRule: Form over;
			copyQuad: (self boundingBox) innerCorners
			toRect: (0@0 extent: viewSize).
	^thumbnail! !

SymbolListType subclass: #NmDirectionType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-eToys'!

!NmDirectionType methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	self vocabularyName: #Direction.
	symbols _ #(#up #down #left #right )! !

SymbolListType subclass: #NmEffectType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-eToys'!

!NmEffectType methodsFor: 'initialization' stamp: ''!
initialize
	"Vocabulary initialize."
	super initialize.
	self vocabularyName: #Effect.
	symbols _ Morph effectSymbols! !

SymbolListType subclass: #NmWarpDestinationType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-eToys'!

!NmWarpDestinationType methodsFor: 'tiles' stamp: 'mu 12/28/2004 00:19'!
choices
	| choices |
	choices _ NmWorldMap default allWorldNames
				collect: [:each | each asString].
	choices _ choices asSortedCollection asOrderedCollection.
	choices add: 'home'.
	choices add: 'other...'.
	^ choices! !

!NmWarpDestinationType methodsFor: 'initialization' stamp: 'ka 1/15/2003 15:20'!
initialize
	"Vocabulary initialize."
	super initialize.
	self vocabularyName: #WarpDestination! !

SymbolListType subclass: #NmWarpType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-eToys'!

!NmWarpType methodsFor: 'initialization' stamp: 'kuri-t 1/14/2003 15:23'!
initialize
	"Vocabulary initialize."
	super initialize.
	self vocabularyName: #Warp.
	symbols _ #(#ifOutOfWorldBounds #ifTouchedWorldBounds #ifCrossingWorldBounds)! !

!SymbolListType methodsFor: '*NetMorph-override-tiles' stamp: 'ka 1/15/2003 16:07'!
defaultArgumentTile
	"Answer a tile to represent the type"
	| aTile |
	aTile _ NmSymbolListTile new
				model: self
				getChoicesSelector: #choices
				dataType: self vocabularyName.
	aTile addArrows.
	aTile setLiteral: self choices first.
	^ aTile! !

!SmartRefStream methodsFor: '*NetMorph-accessing' stamp: ''!
isDisplayProgress
	DisplayProgress isNil
		ifTrue: [DisplayProgress _ true].
	^ DisplayProgress! !

!SmartRefStream methodsFor: '*NetMorph-accessing' stamp: ''!
isDisplayProgress: boolean 
	DisplayProgress _ boolean ~~ false! !

!SmartRefStream methodsFor: '*NetMorph-override-read write' stamp: ''!
nextPut: anObject 
	"Really write three objects: (version, class structure, object). But  
	only when called from the outside. If any instance-specific  
	classes are present, prepend their source code. byteStream will  
	be in fileOut format.  
	You can see an analysis of which objects are written out by  
	doing:  
	(SmartRefStream statsOfSubObjects: anObject)  
	(SmartRefStream tallyOfSubObjects: anObject)  
	(SmartRefStream subObjects: anObject ofClass: aClass)"
	| info during |
	topCall == nil
		ifTrue: [topCall _ anObject.
			during _ [:bar | info _ self instVarInfo: anObject].
			self isDisplayProgress
				ifTrue: ['Please wait while objects are counted'
						displayProgressAt: Sensor cursorPoint
						from: 0
						to: 10
						during: during]
				ifFalse: [during value: nil].
			self appendClassDefns.
			"For instance-specific classes"
			during _ [:bar | 
					"estimate"
					objCount _ 0.
					progressBar _ bar.
					self setStream: byteStream reading: false.
					"set basePos, but keep any class renames"
					super nextPut: ReferenceStream versionCode.
					super nextPut: info.
					super nextPut: anObject.
					"<- the real writing"
					classInstVars size > 0
						ifTrue: [super nextPut: classInstVars]].
			self isDisplayProgress
				ifTrue: ['Writing an object file'
						displayProgressAt: Sensor cursorPoint
						from: 0
						to: objCount * 4
						during: during]
				ifFalse: [during value: nil].
			"Note: the terminator, $!!, is not doubled inside object  
			data"
			"references is an IDict of every object that got written"
			byteStream ascii.
			byteStream nextPutAll: '!!';
				 cr;
				 cr.
			byteStream padToEndWith: $ .
			"really want to truncate file, but can't"
			topCall _ progressBar _ nil
			"reset it"]
		ifFalse: [super nextPut: anObject.
			progressBar
				ifNotNil: [progressBar value: (objCount _ objCount + 1)]]! !

!SmartRefStream methodsFor: '*NetMorph-read write' stamp: 'ka 10/17/2002 19:36'!
scanFrom: aByteStream logged: logFlag 
	self setStream: aByteStream reading: true.
	ScannedObject _ self next.
	byteStream ascii.
	byteStream next == $!!
		ifFalse: [byteStream close.
			self error: 'Object did not end correctly']! !

!ResourceCollector methodsFor: '*NetMorph-override-resource writing' stamp: 'ns 1/9/2003 11:30'!
writeResourceForm: aForm locator: aLocator
	"Store the given form on a file. Return an array with the name and the size of the file"
	| fName fStream fullSize result |
	aLocator ifNotNil:[
		result _ self writeResourceForm: aForm fromLocator: aLocator.
		result ifNotNil:[^result]
		"else fall through"
	].
	fName _ localDirectory nextNameFor:'resource' extension:'form'.
	fStream _ localDirectory newFileNamed: fName.
	fStream binary.
	"aForm storeResourceOn: fStream."
	(self writerClassFor: aForm)
		putForm: aForm
		onStream: fStream.
	fStream open.
	fullSize _ fStream size.
	fStream close.

	"Compress contents here"
"		fStream position: 0.
		fStream compressFile.
		localDirectory deleteFileNamed: fName.
		localDirectory rename: fName, FileDirectory dot, 'gz' toBe: fName.
		fStream _ localDirectory readOnlyFileNamed: fName.
		fullSize _ fStream size.
		fStream close.
"
	^{fName. fullSize}! !

!ResourceCollector methodsFor: '*NetMorph-private' stamp: 'ns 1/15/2003 15:12'!
writerClassFor: aForm 
	| writerClass |
	writerClass _ aForm colorsUsed size < 256
				ifTrue: [GIFReadWriter]
				ifFalse: [(aForm colorsUsed includes: Color transparent)
						ifTrue: [aForm class]
						ifFalse: [| tmpForm | 
							tmpForm _ Form
										extent: aForm extent
										depth: aForm depth
										bits: aForm bits copy.
							tmpForm hibernate bits byteSize * 5 < aForm bits byteSize
								ifTrue: [aForm class]
								ifFalse: [JPEGReadWriter2 new isPluginPresent
										ifTrue: [JPEGReadWriter2]
										ifFalse: [aForm class]]]].
	^ writerClass! !

!CategoryViewer methodsFor: '*NetMorph-entries' stamp: 'kuri-t 12/13/2002 14:12'!
addNearToDetailTo: aRow 
	aRow addMorphBack: (Morph new color: self color;
			 extent: 2 @ 10).
	aRow addMorphBack: self tileForSelf.
	aRow addMorphBack: AlignmentMorph new beTransparent! !

!DisplayTransform methodsFor: '*NetMorph-accessing' stamp: ''!
withOffset: aPoint
	^ self subclassResponsibility! !

ProtoObject subclass: #NmProxy
	instanceVariableNames: 'className'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

NmProxy subclass: #NmMorphProxy
	instanceVariableNames: 'uuid ip port player'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

!NmMorphProxy class methodsFor: 'instance creation' stamp: 'mu 12/29/2004 23:58'!
className: className uuid: uuid destination: destString 
	^ self
		className: className
		uuid: uuid
		ipAndPortArray: (NmWorldMap default ipAndPortArrayFor: destString)! !

!NmMorphProxy class methodsFor: 'instance creation' stamp: 'mu 12/30/2004 00:02'!
className: className uuid: uuid ipAndPortArray: ipAndPortArray 
	^ self new
		xxxInitClassName: className
		uuid: uuid
		ipAndPortArray: ipAndPortArray! !

!NmMorphProxy class methodsFor: 'instance creation' stamp: 'mu 7/30/2005 02:50'!
on: aMorph 
	^self
		className: aMorph class name
		uuid: aMorph identifier
		ipAndPortArray: {NmBaseUtil localAddress. NmBaseSettings warpPort}
		
		
	! !

!NmMorphProxy class methodsFor: 'instance creation' stamp: 'mu 5/12/2003 18:36'!
on: aMorph destination: destString
	^ self
		className: aMorph class name
		uuid: aMorph identifier
		destination: destString! !

!NmMorphProxy methodsFor: 'accessing' stamp: 'mu 5/10/2005 20:09'!
address
	"ADDRESS may be confusing - meaning logical address in WorldMap (not ip address)"
	| dest |
	dest _ NmWorldMap default destinationNameAt: {ip. port}.
	^dest! !

!NmMorphProxy methodsFor: 'converting' stamp: 'KY 12/20/2003 01:52'!
asObjectReference
	^NmMorphReference className: className uuid: uuid ip: ip port: port! !

!NmMorphProxy methodsFor: 'system primitives' stamp: 'mu 8/2/2005 07:21'!
doesNotUnderstand: aMessage 
	| return detection subject |
	super doesNotUnderstand: aMessage.
	detection := self xxxFindMorphInLocalWorld.
	return := detection isNil
				ifTrue: [[self xxxCallDispatch: aMessage target: #morph]
						on: RmtNetworkError , NmError
						do: [:ex | self xxxHandleError: ex]]
				ifFalse: [subject := self xxxBackToReal: detection.
					subject perform: aMessage selector withArguments: aMessage arguments].
	^ return! !

!NmMorphProxy methodsFor: 'accessing' stamp: 'kuri-t 12/3/2002 18:04'!
identifier
	^ uuid! !

!NmMorphProxy methodsFor: 'classification' stamp: 'mu 12/11/2002 14:54'!
isMorph
	^true! !

!NmMorphProxy methodsFor: 'player accessing' stamp: 'mu 9/20/2002 18:04'!
player
	player isNil
		ifTrue: [player _ NmPlayerProxy for: self].
	^ player! !

!NmMorphProxy methodsFor: 'private' stamp: 'kuri-t 1/20/2003 19:04'!
xxxBackToReal: aMorph 
	self becomeForward: aMorph.
	^ aMorph! !

!NmMorphProxy methodsFor: 'friends-delegate' stamp: 'mu 8/2/2005 07:19'!
xxxCallDispatch: aMessage target: targetString 
	| result |
	result := [aMessage arguments isEmpty
				ifTrue: [self xxxCallNoArgumentsDispatch: aMessage target: targetString]
				ifFalse: [self xxxCallWithArgumentsDispatch: aMessage target: targetString]]
				on: NmNoSuchMorph
				do: [:ex | self xxxTryToUpdateIpAndPort
						ifTrue: [(self xxxHandlerOf: targetString)
								perform: aMessage selector
								withArguments: aMessage arguments]
						ifFalse: [ActiveWorld netMorphProxyCache
								removeKey: uuid
								ifAbsent: [].
							ex pass]].
	^ result! !

!NmMorphProxy methodsFor: 'friends-delegate' stamp: 'MU 1/22/2004 21:35'!
xxxCallNoArgumentsDispatch: aMessage target: targetString 
	| connector |
	connector _ NmRemoteConnector connect: ip port: port.

	^ connector
		callDispatch: uuid asString
		to: targetString
		selector: aMessage selector! !

!NmMorphProxy methodsFor: 'friends-delegate' stamp: 'MU 1/22/2004 21:36'!
xxxCallWithArgumentsDispatch: aMessage target: targetString 
	| connector arguments |
	arguments _ aMessage arguments.
	arguments
		withIndexDo: [:arg :idx | arg shouldPassAsProxy
				ifTrue: [arguments at: idx put: arg asProxy]].
	connector _ NmRemoteConnector connect: ip port: port.
	^ connector
		callDispatch: uuid asString
		to: targetString
		selector: aMessage selector
		withArguments: aMessage arguments! !

!NmMorphProxy methodsFor: 'debugging' stamp: 'KY 12/20/2003 01:01'!
xxxDebugRepresentation
	^ (Array
		with: 'NmMorphProxy of: ', className
		with: uuid
		with: ip
		with: port)! !

!NmMorphProxy methodsFor: 'private' stamp: 'mu 8/2/2005 07:19'!
xxxHandleError: anException 
	super xxxHandleError: anException.
	(anException isKindOf: RmtNetworkError)
		ifTrue: [| message | 
			NmProcessManager releaseAllLockedProcesses.
			message := NmBaseSettings isDebugging
						ifTrue: [anException messageText asString]
						ifFalse: ['Morph does not respond!!' translated].
			NmShortMessageMorph contents: message at: ActiveWorld center.
			^ nil].
	(anException isKindOf: NmNoSuchMorph)
		ifTrue: [NmNoSuchMorphWarning new uuidString: self identifier asString;
				 signal.
			^ nil].
	^ anException pass! !

!NmMorphProxy methodsFor: 'private' stamp: 'kuri-t 1/9/2003 17:24'!
xxxHandlerOf: targetString 
	targetString == #morph ifTrue: [^ self].
	targetString == #player ifTrue: [^ self player]! !

!NmMorphProxy methodsFor: 'initialize-release' stamp: 'mu 12/30/2004 00:02'!
xxxInitClassName: classNameSymbol uuid: uuidObj ipAndPortArray: ipAndPortArray
	className _ classNameSymbol.
	uuid _ uuidObj.
	ip _ ipAndPortArray first asString.
	port _ ipAndPortArray second asNumber! !

!NmMorphProxy methodsFor: 'private' stamp: 'KY 12/20/2003 01:29'!
xxxIp
	^ip! !

!NmMorphProxy methodsFor: 'private' stamp: 'kuri-t 11/29/2002 17:44'!
xxxNewObjectReference
	^ NmMorphReference new.! !

!NmMorphProxy methodsFor: 'private' stamp: 'KY 12/20/2003 01:29'!
xxxPort
	^port! !

!NmMorphProxy methodsFor: 'private' stamp: 'mu 8/3/2005 10:34'!
xxxTryToUpdateIpAndPort
	| connector ipAndPortString ipAndPort morphProxy |
	[connector _ NmRemoteConnector connect: ip port: port.
	ipAndPortString _ connector callRedirectIpAndPortOf: uuid]
		on: RmtNetworkError
		do: [:ex | 
			NmTranscript crShow: 'xxxTryToUpdateIpAndPort: ' , ex messageText.
			ipAndPortString _ nil].
	ipAndPort _ NmBaseUtil ipAndPortFromString: ipAndPortString.
	ipAndPort
		ifNotNil: [ip _ ipAndPort first.
			port _ ipAndPort last.
			^ true].
	morphProxy _ NmRemoteConnector callFindBy: uuid retry: 3.
	^ morphProxy isNil
		ifTrue: [false]
		ifFalse: [ip _ morphProxy xxxIp.
			port _ morphProxy xxxPort.
			true]! !

NmProxy subclass: #NmPlayerProxy
	instanceVariableNames: 'costume'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Morphic-Network'!

!NmPlayerProxy class methodsFor: 'instance creation' stamp: 'mu 9/20/2002 18:08'!
for: aMorphProxy
	| inst |
	inst _ self new.
	inst xxxCostume: aMorphProxy.
	^inst! !

!NmPlayerProxy class methodsFor: 'instance creation' stamp: 'kuri-t 12/13/2002 15:23'!
on: aPlayer 
	| morphProxy |
	morphProxy _ aPlayer costume isProxy
				ifTrue: [aPlayer costume]
				ifFalse: [aPlayer costume asProxy].
	^ self for: morphProxy! !

!NmPlayerProxy methodsFor: 'converting' stamp: 'kuri-t 11/21/2002 14:35'!
asObjectReference
	^NmPlayerReference costume: costume! !

!NmPlayerProxy methodsFor: 'costume accessing' stamp: 'mu 9/20/2002 16:46'!
costume
	^costume! !

!NmPlayerProxy methodsFor: 'costume accessing' stamp: 'mu 1/15/2005 00:33'!
costumesDo: aBlock 
	| cos |
	cos _ self costume.
	cos ifNotNil: [ aBlock value: cos renderedMorph ].
	cos
		ifNil: [^ self].
	cos
		do: [:aCostume | aCostume ~~ cos
				ifTrue: [aBlock value: aCostume renderedMorph]]! !

!NmPlayerProxy methodsFor: 'system primitives' stamp: 'mu 11/22/2003 03:07'!
doesNotUnderstand: aMessage 
	| return detection subject |
	super doesNotUnderstand: aMessage.
	detection _ self xxxFindMorphInLocalWorld.
	return _ detection isNil
				ifTrue: [[self costume xxxCallDispatch: aMessage target: #player]
						on: RmtNetworkError , NmError
						do: [:ex | self costume xxxHandleError: ex]]
				ifFalse: [subject _ self xxxBackToReal: detection.
					subject perform: aMessage selector withArguments: aMessage arguments].
	^ return! !

!NmPlayerProxy methodsFor: 'costume accessing' stamp: 'kuri-t 1/20/2003 19:01'!
identifier
	^ costume identifier! !

!NmPlayerProxy methodsFor: 'specials-scripts-kernel' stamp: 'mu 1/15/2005 00:31'!
instantiatedUserScriptsDo: aBlock
	"Copied from original Player to avoid sending a Block"

	| aState aCostume |
	((aCostume _ self costume) notNil and: [(aState _ aCostume actorStateOrNil) notNil]) ifTrue:
		[aState instantiatedUserScriptsDictionary do: aBlock]! !

!NmPlayerProxy methodsFor: 'misc' stamp: 'mu 5/13/2003 19:10'!
isMorph
	^false! !

!NmPlayerProxy methodsFor: 'misc' stamp: 'kuri-t 12/3/2002 16:34'!
isPlayerLike
	^ true! !

!NmPlayerProxy methodsFor: 'name' stamp: 'kuri-t 12/3/2002 18:05'!
uniqueNameForReference
	^ '(Player fromUUIDString: ', self costume identifier asString printString, ')'
! !

!NmPlayerProxy methodsFor: 'private' stamp: 'kuri-t 1/20/2003 19:02'!
xxxBackToReal: aMorph 
	self becomeForward: aMorph player.
	^ aMorph player! !

!NmPlayerProxy methodsFor: 'friends' stamp: 'mu 9/20/2002 18:07'!
xxxCostume: aMorphProxy
	costume := aMorphProxy! !

!NmPlayerProxy methodsFor: 'debugging' stamp: 'kuri-t 10/24/2002 14:52'!
xxxDebugRepresentation
	^ Array
		with: 'NmPlayerProxy of: ' , costume printString
		! !

!NmPlayerProxy methodsFor: 'private' stamp: 'kuri-t 11/29/2002 17:44'!
xxxNewObjectReference
	^ NmPlayerReference new.! !

!NmProxy methodsFor: 'system primitives' stamp: 'MU 12/28/2002 02:52'!
becomeForward: otherObject 
	(Array with: self)
		elementsForwardIdentityTo:
			(Array with: otherObject)! !

!NmProxy methodsFor: 'objects from disk' stamp: 'kuri-t 11/29/2002 17:41'!
comeFullyUpOnReload: smartRefStream
	^ self! !

!NmProxy methodsFor: 'system primitives' stamp: 'mu 4/11/2003 15:24'!
doesNotUnderstand: aMessage 
	NmTranscript crShow: self class name.
	NmTranscript show: ' message: ' , aMessage printString.
	! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 12/11/2002 15:53'!
halt
	Halt signal! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 9/20/2002 16:29'!
inspect
	Inspector
		openOn: self xxxDebugRepresentation
		withEvalPane: true
		withLabel: 'a NmProxy'! !

!NmProxy methodsFor: 'testing' stamp: 'mu 8/14/2005 23:57'!
isBehavior
	^false! !

!NmProxy methodsFor: 'shortcuts' stamp: 'mu 9/20/2002 16:30'!
isKindOf: otherClass
	| cls |
	cls _ Smalltalk
				at: className
				ifAbsent: [^ false].
	^ cls isKindOf: otherClass! !

!NmProxy methodsFor: 'testing' stamp: 'kuri-t 11/21/2002 17:31'!
isProxy
	^ true! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 12/11/2002 16:18'!
longPrintOn: aStream limitedTo: sizeLimit indent: indent
	
	self class allInstVarNames doWithIndex:
		[:title :index |
		indent timesRepeat: [aStream tab].
		aStream nextPutAll: title;
		 nextPut: $:;
		 space;
		 tab;
		 nextPutAll: 
			((self instVarAt: index) printStringLimitedTo: (sizeLimit -3 -title size max: 1));
		 cr]! !

!NmProxy methodsFor: 'objects from disk' stamp: 'kuri-t 11/29/2002 17:41'!
objectForDataStream: refStrm
    ^ self! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 9/20/2002 16:26'!
printOn: aStream 
	aStream nextPutAll: self xxxDebugRepresentation printString
		! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 9/20/2002 16:26'!
printString
	| wstr |
	wstr _ WriteStream on: (String new: 64).
	self printOn: wstr.
	^wstr contents! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 12/10/2002 18:12'!
printStringLimitedTo: limit
	| limitedString |
	limitedString _ String streamContents: [:s | self printOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , '...etc...'! !

!NmProxy methodsFor: 'objects from disk' stamp: 'kuri-t 11/29/2002 17:45'!
readDataFrom: aDataStream size: varsOnDisk
	| cntInstVars cntIndexedVars objectReference |
	objectReference _ self xxxNewObjectReference.
	cntInstVars _ objectReference class instSize.
	cntIndexedVars _ 0.
	cntInstVars _ varsOnDisk.

	aDataStream beginReference: self.
	1 to: cntInstVars do:
		[:i | objectReference instVarAt: i put: aDataStream next].
	1 to: cntIndexedVars do:
		[:i | objectReference basicAt: i put: aDataStream next].
	^ objectReference asProxy! !

!NmProxy methodsFor: 'testing' stamp: 'kuri-t 1/6/2003 16:28'!
shouldPassAsProxy
	^ false.! !

!NmProxy methodsFor: 'objects from disk' stamp: 'kuri-t 11/29/2002 17:40'!
storeDataOn: aDataStream
	| cntInstVars cntIndexedVars objectReference |
	objectReference _ self asObjectReference.
	cntInstVars _ objectReference class instSize.
	cntIndexedVars _ objectReference basicSize.
	aDataStream
		beginInstance: self class
		size: cntInstVars + cntIndexedVars.
	1 to: cntInstVars do:
		[:i | aDataStream nextPut: (objectReference instVarAt: i)].

	((aDataStream byteStream class == DummyStream) and: [objectReference class isBits]) ifFalse: [
		1 to: cntIndexedVars do:
			[:i | aDataStream nextPut: (objectReference basicAt: i)]].
! !

!NmProxy methodsFor: 'private' stamp: 'kuri-t 1/20/2003 19:00'!
xxxBackToReal: aMorph 
	^ Error new signal: 'My subclass should have overridden one of my messages.'! !

!NmProxy methodsFor: 'private' stamp: 'kuri-t 12/13/2002 15:43'!
xxxClassName
	^className! !

!NmProxy methodsFor: 'private' stamp: 'mu 9/20/2002 16:41'!
xxxClassName: aSymbol
	className := aSymbol! !

!NmProxy methodsFor: 'debugging' stamp: 'mu 4/10/2005 16:18'!
xxxDebugRepresentation
	^ Array
		with: 'NmProxy of: ',  className asString
		! !

!NmProxy methodsFor: 'private' stamp: 'kuri-t 1/20/2003 19:00'!
xxxFindMorphInLocalWorld
	^ (ActiveWorld allMorphs
		reject: [:each | each isRenderer])
		detect: [:morph | morph identifier = self identifier]
		ifNone: []! !

!NmProxy methodsFor: 'private' stamp: 'mu 7/29/2005 19:16'!
xxxHandleError: anException
	NmTranscript crShow: 'Dispatch failed: ' , anException description , ' in ' , self class name.! !

!NmProxy methodsFor: 'shortcuts' stamp: 'mu 9/20/2002 16:30'!
yourself
	^self! !

!Url class methodsFor: '*NetMorph-override-parsing' stamp: 'mu 12/29/2004 22:51'!
absoluteFromText: aString
	"Url absoluteFromText: 'http://chaos.resnet.gatech.edu:8000/docs/java/index.html?A%20query%20#part'" 
	"Url absoluteFromText: 'msw://chaos.resnet.gatech.edu:9000/testbook?top'"
	"Url absoluteFromText: 'telnet:chaos.resnet.gatech.edu'"
	"Url absoluteFromText: 'file:/etc/passwd'"
	"Url absoluteFromText: 'nm://dvorak/auau'" 

	| remainder scheme fragment ind newUrl |

	"trim surrounding whitespace"
	remainder _ aString withBlanksTrimmed.	

	"extract the fragment, if any"
	ind _ remainder indexOf: $#.
	ind > 0 ifTrue: [
		fragment _ remainder copyFrom: ind+1 to: remainder size.
		remainder _ remainder copyFrom: 1 to: ind-1 ].

	"choose class based on the scheme name, and let that class do the bulk of the parsing"
	scheme _ self schemeNameForString: remainder.

	scheme = nil ifTrue: [
		newUrl _ HttpUrl new privateInitializeFromText: remainder ].

	(scheme = 'http') ifTrue: [ newUrl _ HttpUrl new privateInitializeFromText: remainder ].
	(scheme = 'msw') ifTrue: [ newUrl _ MswUrl new privateInitializeFromText: remainder ]. 
	(scheme = 'ftp') ifTrue:[ newUrl _ FtpUrl new privateInitializeFromText: remainder ].
	(scheme = 'file') ifTrue: [newUrl _ FileUrl new privateInitializeFromText: remainder ].
	
	(scheme = NmUrl scheme) ifTrue: [newUrl _ NmUrl new privateInitializeFromText: remainder ].
	
	(scheme = 'browser') ifTrue: [ newUrl _ BrowserUrl new privateInitializeFromText: remainder ].
	(scheme = 'mailto') ifTrue: [ newUrl _ MailtoUrl new privateInitializeFromText: remainder ].
	(scheme = 'sqpkg' and: [Smalltalk includesKey: #KomPackageUrl]) ifTrue: 
		[newUrl _ (Smalltalk at: #KomPackageUrl) new privateInitializeFromText: remainder].
	(scheme = 'sqmap' and: [Smalltalk includesKey: #KomSqueakMapUrl]) ifTrue: 
		[newUrl _ (Smalltalk at: #KomSqueakMapUrl) new privateInitializeFromText: remainder].

	newUrl ifNil: [  newUrl _ GenericUrl new privateInitializeFromText: remainder ].


	"set the fragment"
	newUrl privateFragment: fragment.


	"all done"
	^newUrl! !

!Url methodsFor: '*NetMorph-testing' stamp: 'mu 4/15/2003 16:39'!
isNmUrl
	^false! !

!CommandHistory class methodsFor: '*NetMorph-override-system startup' stamp: 'mu 12/11/2002 16:30'!
forgetAllGrabCommandsFrom: starter
	"Forget all the commands that might be held on to in the properties dicitonary of various morphs for various reasons."

	| object |
	object _ starter.
	[
		[0 == object] whileFalse: [
			(object isMorph and: [object isProxy not] ) ifTrue: [object removeProperty: #undoGrabCommand].
			object _ object nextObject].
		] ifError: [:err :rcvr | "object is obsolete"
			self forgetAllGrabCommandsFrom: object nextObject].

	"CommandHistory forgetAllGrabCommandsFrom: true someObject"
! !

Model subclass: #NmBaseSettings
	instanceVariableNames: ''
	classVariableNames: 'Properties'
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/1/2005 00:40'!
autoTrimMapServers
	"self autoTrimMapServers"
	^ self properties at: #autoTrimMapServers ifAbsentPutValue: true! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/1/2005 00:40'!
autoTrimMapServers: boolean 
	boolean == self autoTrimMapServers
		ifTrue: [^ self].
	self properties at: #autoTrimMapServers put: boolean == true.
	! !

!NmBaseSettings class methodsFor: 'actions' stamp: 'mu 6/3/2005 03:20'!
availableWarpPorts
	^self defaultWarpPort to: self defaultWarpPort + self defaultWarpPortRange -1.! !

!NmBaseSettings class methodsFor: 'changing' stamp: 'mu 6/3/2005 20:06'!
changed: anAspect
	super changed: anAspect.
	self subclasses do: [:e | e changed: anAspect].
	! !

!NmBaseSettings class methodsFor: 'changing' stamp: 'mu 6/3/2005 20:11'!
changed: anAspect with: param
	super changed: anAspect with: param.
	self subclasses do: [:e | e changed: anAspect with: param].
	! !

!NmBaseSettings class methodsFor: 'changing' stamp: 'mu 6/3/2005 20:11'!
changed: anAspect with: param with: param2
	super changed: anAspect with: param with: param2.
	self subclasses do: [:e | e changed: anAspect with: param with: param2].
	! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/1/2005 17:16'!
defaultExternalMapServerPort
	^ 80! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/13/2005 22:09'!
defaultExternalMapServerUrl
	"self defaultExternalMapServerUrl"
	^ 'http://swikis.ddo.jp:8823/', self defaultMapServerTargetName.! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 4/28/2005 21:56'!
defaultMapPath
	| subDirName homeDir |
	subDirName _ 'worldMaps'.
	homeDir _ FileDirectory default.
	homeDir assureExistenceOfPath: subDirName.
	^homeDir fullPathFor: subDirName

! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/1/2005 17:14'!
defaultMapServerPort
	^ self notUsedPort! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 5/29/2005 03:11'!
defaultMapServerTargetName
	^'NetMorphMapServer'! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/13/2005 22:07'!
defaultMapServerUrl
	"self defaultMapServerUrl"
	^ 'http://MapServer:8823/', self defaultMapServerTargetName.! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 7/23/2005 00:45'!
defaultPictureShrunkBySize
	^ 4! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/3/2005 03:20'!
defaultWarpPort
	^ 37458! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/3/2005 03:25'!
defaultWarpPortOffset
	^ 100! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/3/2005 03:26'!
defaultWarpPortRange
	^ 6! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/2/2005 22:50'!
explicitGlobalAddress
	^ self properties at: #explicitGlobalAddress ifAbsentPutValue: nil! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 8/18/2005 11:20'!
explicitGlobalAddress: ipAddressString 
	"NmSettings explicitGlobalAddress: '123.2.4.5'"
	"NmSettings explicitGlobalAddress: ''"
	| correctAddress correctAddressString |
	ipAddressString
		ifNil: [NmUrl local ipAddress: nil.
			self properties at: #explicitGlobalAddress put: nil.
			self changed: #explicitGlobalAddress.
			^ true].
	correctAddress := NetNameResolver addressFromString: ipAddressString.
	correctAddress isNil
		ifTrue: [self error: 'Invalid IP address:' , ipAddressString.
			^ false].
	correctAddressString := NetNameResolver stringFromAddress: correctAddress.

	NmUrl local ipAddress: correctAddressString.
	self properties at: #explicitGlobalAddress put: correctAddressString.
	self changed: #explicitGlobalAddress.
	^ true! !

!NmBaseSettings class methodsFor: 'constants' stamp: 'mu 6/15/2005 23:54'!
iniFileName
	"self iniFileName"
	| imageName |
	imageName _ NmBaseUtil shortImageName.
	imageName _ imageName copyReplaceAll: 'image' with: 'NetMorph'.
	^imageName, '.ini'! !

!NmBaseSettings class methodsFor: 'class initialization' stamp: 'mu 5/29/2005 03:26'!
initialize
	"NmBaseSettings initialize"
	Properties _ nil.
	self resetDefaults! !

!NmBaseSettings class methodsFor: 'class initialization' stamp: 'mu 8/12/2005 12:28'!
initializeForWarp
	NmUrl initialize.
	NmWorldMap localEntry ifNotNilDo: [:ent | ent resetLocalPort: self warpPort].
	NmServerManager startWarpServer.
	Smalltalk at: #NmWorldMapLocationListener ifPresent:[:p | p default start].! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 7/8/2005 01:38'!
isDebugging
	^ self properties at: #isDebugging ifAbsentPutValue: false! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 7/8/2005 01:38'!
isDebugging: aBoolean 
	 self properties at: #isDebugging put: aBoolean! !

!NmBaseSettings class methodsFor: 'storing/loading' stamp: 'mu 6/15/2005 23:35'!
load
	"NmBaseSettings load"
	| loaded |
	loaded _ NmBaseUtil loadFrom: FileDirectory default named: self iniFileName.
	loaded notNil
		ifTrue: [Properties _ loaded.
			NmTranscript crShow: '## NmSetting was loaded: ' , self iniFileName]! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/13/2005 22:26'!
mapFromInternet
	^ self properties at: #mapFromInternet ifAbsentPutValue: false! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/13/2005 22:26'!
mapFromInternet: aBoolean 
	 self properties at: #mapFromInternet put: aBoolean! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 3/10/2003 18:15'!
mapPath
	| mapPath |
	mapPath _ self properties
				at: #mapPath
				ifAbsent: [].
	(mapPath isNil
			or: [mapPath isEmpty])
		ifTrue: [mapPath _ self properties at: #mapPath put: self defaultMapPath].
	^ mapPath! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 3/10/2003 18:16'!
mapPath: aValue 
	(aValue isNil
			or: [aValue asString isEmpty])
		ifTrue: [^ false].
	self properties at: #mapPath put: aValue asString.
	self changed: #mapPath.
	^ true! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 5/30/2005 23:55'!
mapServerUrl
	"NmBaseSettings mapServerUrl"
	^ self properties at: #mapServerUrl ifAbsentPutValue: self defaultMapServerUrl! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 5/29/2005 03:15'!
mapServerUrl: aValue 
	self properties at: #mapServerUrl put: aValue asString.
	self changed: #mapServerUrl.
	^ true! !

!NmBaseSettings class methodsFor: 'private' stamp: 'mu 6/3/2005 03:31'!
notUsedPort
	"NmBaseSettings notUsedPort"
	[| so po | 
	so _ Socket newUDP.
	so setPort: Socket wildcardPort.
	po _ so port.
	so close.
	^ po]
		on: Error
		do: [:ex | ^ self defaultExternalMapServerPort]! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 7/23/2005 00:35'!
pictureShrunkBySize
	^ self properties at: #pictureShrunkBySize ifAbsentPutValue: self defaultPictureShrunkBySize! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 7/23/2005 00:36'!
pictureShrunkBySize: aValue 
	self properties at: #pictureShrunkBySize put: aValue asInteger! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 5/12/2005 23:58'!
properties
	Properties ifNil: [Properties _ NmProperties new].
	^Properties! !

!NmBaseSettings class methodsFor: 'class initialization' stamp: 'kuri-t 2/20/2003 16:13'!
resetDefaults
	| keys |
	keys _ self properties keys.
	keys
		do: [:eachKey | self properties removeKey: eachKey].
	keys
		do: [:eachKey | self perform: #changed: with: eachKey asSymbol]! !

!NmBaseSettings class methodsFor: 'storing/loading' stamp: 'mu 6/15/2005 23:38'!
store
	"NmBaseSettings store"
	NmBaseUtil
		store: self properties
		to: FileDirectory default
		named: self iniFileName! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 6/3/2005 14:32'!
warpPort
	^ self properties at: #warpPort ifAbsentPutValue: self defaultWarpPort! !

!NmBaseSettings class methodsFor: 'accessing' stamp: 'mu 8/18/2005 08:34'!
warpPort: aValue 
	"NmSettings warpPort: 37459"
	"NmSettings warpPort: 40000." "<-Not allowed"
	| aNumber |
	[aNumber _ aValue asNumber]
		on: Error
		do: [^ false].
	(self availableWarpPorts  rangeIncludes: aNumber) ifFalse: [aNumber _ self defaultWarpPort] .
	self warpPort = aNumber ifTrue: [^true].
	self properties at: #warpPort put: aNumber.
	self changed: #warpPort with: aNumber.
	self initializeForWarp.
	NmWorldMap default incrementVersion.
	^ true! !

NmBaseSettings subclass: #NmServerSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Server'!

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:11'!
allocateByRandom
	^ self properties at: #allocateByRandom ifAbsentPutValue: false! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:08'!
allocateByRandom: aBoolean 
	self properties at: #allocateByRandom put: aBoolean == true.
	self changed: #allocateByRandom.
	! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 7/20/2005 19:22'!
broadcastingWarpPorts
	^ self availableWarpPorts - self defaultWarpPortOffset! !

!NmServerSettings class methodsFor: 'constants' stamp: 'mu 7/20/2005 19:23'!
defaultLevel1Matrix
	^2@3! !

!NmServerSettings class methodsFor: 'constants' stamp: 'mu 7/20/2005 19:23'!
defaultLevel2Matrix
	^3@3! !

!NmServerSettings class methodsFor: 'constants' stamp: 'mu 7/20/2005 19:23'!
defaultLevel3Matrix
	^2@3! !

!NmServerSettings class methodsFor: 'constants' stamp: 'mu 6/15/2005 18:58'!
defaultSaveMapServerPort
	^NmServerManager isMapServerOnlyImage! !

!NmServerSettings class methodsFor: 'testing' stamp: 'mu 5/30/2005 18:12'!
isMapServerRunning
	"NmServerSettings isMapServerRunning"
	^NmServerManager isMapServerRunning! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:25'!
level1Matrix
	^ self properties at: #level1Matrix ifAbsentPutValue: self defaultLevel1Matrix! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 21:04'!
level1Matrix: point
	self properties at: #level1Matrix put: (Point readFrom: point asString).
	self changed: #level1Matrix.
	! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:25'!
level2Matrix
	^ self properties at: #level2Matrix ifAbsentPutValue: self defaultLevel2Matrix! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 21:04'!
level2Matrix: point
	self properties at: #level2Matrix put: (Point readFrom: point asString).
	self changed: #level2Matrix.
	! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 19:25'!
level3Matrix
	^ self properties at: #level3Matrix ifAbsentPutValue: self defaultLevel3Matrix! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 7/20/2005 21:04'!
level3Matrix: point
	self properties at: #level3Matrix put: (Point readFrom: point asString).
	self changed: #level3Matrix.
	! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 5/29/2005 03:45'!
localMapServerUrl
	^'http://', NmBaseUtil localAddress, '/', self defaultMapServerTargetName! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 5/29/2005 03:12'!
mapServerPort
	^ self properties at: #mapServerPort ifAbsentPutValue: self defaultMapServerPort! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/2/2005 22:58'!
mapServerPort: aValue 
	"NmServerSettings mapServerPort: 8080"
	| aNumber |
	[aNumber _ aValue asNumber]
		on: Error
		do: [^ false].
	aNumber < 1 ifTrue: [aNumber _ self defaultMapServerPort].
	self properties at: #mapServerPort put: aNumber.
	self changed: #mapServerPort.
	self shouldRunMapServer
		ifTrue: [NmServerManager startMapServerWithBroadcaster]! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/15/2005 18:58'!
saveMapServerPort
	^ self properties at: #saveMapServerPort ifAbsentPutValue: self defaultSaveMapServerPort! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/2/2005 22:53'!
saveMapServerPort: aBoolean 
	| save |
	save _ aBoolean == true.
	self properties at: #saveMapServerPort put: save.
	! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/1/2005 16:38'!
shouldRunMapServer
	^ self properties at: #shouldRunMapServer ifAbsentPutValue: true! !

!NmServerSettings class methodsFor: 'accessing' stamp: 'mu 6/1/2005 16:37'!
shouldRunMapServer: aBoolean 
	| shouldRun |
	shouldRun _ aBoolean == true.
	self properties at: #shouldRunMapServer put: shouldRun.
	shouldRun
		ifTrue: [NmServerManager startMapServerWithBroadcaster]
		ifFalse: [NmServerManager stopMapServerWithBroadcaster]! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 7/20/2005 20:49'!
toggleAllocateByRandom
	self allocateByRandom: self allocateByRandom not! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 6/2/2005 22:47'!
toggleAutoTrimMapServers
	self autoTrimMapServers: self autoTrimMapServers not! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 5/30/2005 18:17'!
toggleMapServerRunning
	self shouldRunMapServer: self isMapServerRunning not! !

!NmServerSettings class methodsFor: 'actions' stamp: 'mu 6/2/2005 23:00'!
toggleSaveMapServerPort
	self saveMapServerPort: self saveMapServerPort not! !

NmBaseSettings subclass: #NmSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Client'!

!NmSettings class methodsFor: 'accessing' stamp: 'mu 5/8/2003 14:37'!
connectTimeoutSeconds
	^ self properties at: #connectTimeoutSeconds ifAbsentPutValue: NmRemoteConnector defaultTimeoutSeconds! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 5/8/2003 14:37'!
connectTimeoutSeconds:  aValue 
	NmRemoteConnector timeoutSeconds: aValue.
	self properties at: #connectTimeoutSeconds put: aValue.
	self changed: #connectTimeoutSeconds.
	^ true! !

!NmSettings class methodsFor: 'constants' stamp: 'mu 5/30/2005 16:39'!
defaultBroadcastingWarpPorts
	^self defaultWarpPort to: self defaultWarpPort + self defaultWarpPortRange -1.! !

!NmSettings class methodsFor: 'constants' stamp: 'mu 4/1/2005 00:35'!
defaultIntervalSeconds
	^ NmAutoWorldInfoUpdater defaultIntervalSeconds! !

!NmSettings class methodsFor: 'constants' stamp: 'kuri-t 10/16/2002 18:50'!
defaultScreenSize
	^ 800 @ 600! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 4/1/2005 00:34'!
intervalSeconds
	^ self properties at: #intervalSeconds ifAbsentPutValue: self defaultIntervalSeconds! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 5/31/2005 17:20'!
intervalSeconds: aValue 
	| aNumber |
	[aNumber _ aValue asNumber.
	self properties at: #intervalSeconds put: aNumber]
		on: Error
		do: [:ex | ^ false].
	NmAutoWorldInfoUpdater default intervalSeconds: (self properties at: #intervalSeconds).
	self changed: #intervalSeconds.
	^ true! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 7/28/2005 22:40'!
leaveMarker
	"self leaveMarker"
	^ self properties at: #leaveMarker ifAbsentPutValue: true! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 7/28/2005 22:40'!
leaveMarker: aBoolean
	self properties at: #leaveMarker put: aBoolean == true! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 6/21/2005 18:54'!
mapServerCountInSegment
	
	^ self properties at: #mapServerCountInSegment ifAbsentPutValue: 3! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 6/2/2005 22:49'!
mapServerCountInSegment: aValue 
	self properties at: #mapServerCountInSegment put: aValue asNumber.
	! !

!NmSettings class methodsFor: 'actions' stamp: 'mu 6/13/2005 23:10'!
toggleMapFromInternet
	self mapFromInternet: self mapFromInternet not.
	self mapFromInternet
		ifTrue: [self mapServerUrl: self defaultExternalMapServerUrl]
		ifFalse: [self mapServerUrl: self defaultMapServerUrl].
	^ self mapFromInternet! !

!NmSettings class methodsFor: 'actions' stamp: 'ka 2/17/2003 15:51'!
toggleUseAvailabilityChecker
	self useAvailabilityChecker: self useAvailabilityChecker not.
	^ self useAvailabilityChecker! !

!NmSettings class methodsFor: 'actions' stamp: 'mu 5/19/2003 14:42'!
toggleUseKeepMoving
	self useKeepMoving: self useKeepMoving not.
	^ self useKeepMoving! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 6/3/2004 23:09'!
useAvailabilityChecker
	"self useAvailabilityChecker"
	^ self properties at: #useAvailabilityChecker ifAbsentPutValue: true! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 5/31/2004 02:36'!
useAvailabilityChecker: boolean 
	boolean == self useAvailabilityChecker
		ifTrue: [^ self].
	self properties at: #useAvailabilityChecker put: boolean == true.
	boolean ifTrue: [NmAvailabilityChecker default start] ifFalse: [NmAvailabilityChecker default stop]! !

!NmSettings class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:35'!
useKeepMoving
	^self properties at: #useKeepMoving ifAbsentPutValue: false! !

!NmSettings class methodsFor: 'accessing' stamp: 'MU 2/25/2003 16:35'!
useKeepMoving: aValue 
	self properties at: #useKeepMoving put: aValue! !

!NmSettings class methodsFor: 'accessing' stamp: 'mu 6/5/2003 11:39'!
warpableInterval
	"minimum warpable interval (seconds)"
	^ 1! !

Model subclass: #NmFileouter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-Support-Common'!

!NmFileouter class methodsFor: 'actions' stamp: 'mu 8/18/2005 11:04'!
fileoutServerModule
"NmFileouter fileoutServerModule"

"Class categories"
| cs |
#(
'NetMorph-Support-Common'
'NetMorph-Support-Server'
'NetMorph-Network-RPC'
'NetMorph-Server-MapServer'
'NetMorph-WorldMap'
'NetMorph-Morphic-WorldMap'
'NetMorph-Morphic-Project'
) do: [:each |
SystemOrganization fileOutCategory: each.
].

"System changes"
cs := ChangeSet basicNewNamed: 'NetMorph-Server-SysChanges'.
cs atSelector: #getText class: PluggableTextMorph put: #add. "override"
cs atSelector: #textMorph class: PluggableTextMorph put: #add. 
cs atSelector: #dissolve class: Morph put: #add. 
cs atSelector: #scaledToSize: class: ImageMorph put: #add. 
cs atSelector: #asNmUrl class: String put: #add. 
cs atSelector: #isAddressString class: String put: #add. 
cs atSelector: #isNmUrlString class: String put: #add. 
cs atSelector: #isIpAndPortString class: String put: #add. 
cs atSelector: #absoluteFromText: class: Url class put: #add. 
cs atSelector: #isNmUrl class: Object put: #add. 
cs atSelector: #isNmUrl class: Url put: #add. 
cs atSelector: #id class: SystemDictionary put: #add. 
cs atSelector: #id class: SmalltalkImage put: #add. 
cs fileOut.! !

Model subclass: #NmWorldMap
	instanceVariableNames: 'version map mapName oldLocalEntry hasChanged locker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

NmWorldMap class
	instanceVariableNames: 'default'!

!NmWorldMap class methodsFor: 'instance creation' stamp: 'mu 12/28/2004 00:06'!
default
	default
		ifNil: [default _ self basicNew initialize].
	^ default! !

!NmWorldMap class methodsFor: 'constants' stamp: 'mu 4/28/2005 17:44'!
defaultMapName
	^ 'WorldMap' copy.! !

!NmWorldMap class methodsFor: 'instance creation' stamp: 'mu 4/29/2005 00:26'!
fromCsvString: aString 
	| inst |
	inst _ self new.
	inst fromCsvString: aString.
	^ inst! !

!NmWorldMap class methodsFor: 'class initialization' stamp: 'mu 5/12/2005 19:14'!
initialize
	"NmWorldMap initialize"
	default _ nil.
	NmImageId addDependent: self.
	! !

!NmWorldMap class methodsFor: 'utilities' stamp: 'mu 7/13/2005 19:00'!
localEntry
	^self default localEntry! !

!NmWorldMap class methodsFor: 'instance creation' stamp: 'mu 1/21/2005 02:20'!
new
	^self basicNew initialize! !

!NmWorldMap class methodsFor: 'class initialization' stamp: 'mu 12/28/2004 00:06'!
obsolete
	default _ nil.
	NmImageId removeDependent: self.
	! !

!NmWorldMap class methodsFor: 'updating' stamp: 'mu 8/16/2005 08:21'!
update: aspect with: value 
	NmServerManager isMapServerOnlyImage ifTrue: [^self].
	aspect == #imageIdNew
		ifTrue: [self default registerLocalEntry: value ].
	aspect == #imageIdLeave
		ifTrue: [self default leaveLocalEntry: value ].
	aspect == #imageIdLeaveIfFailedRemove
		ifTrue: [self default leaveIfFailedRemoveLocalEntry: value ].
	aspect == #imageIdNull
		ifTrue: [self default removeLocalEntry: value ].
	! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 6/15/2005 00:55'!
adapt: aSoapCall targetTo: url
	| port |
	port _ url port.
	aSoapCall locator: (SoapTcpLocator
				host: url authority
				port: (port isNil
						ifTrue: [NmBaseSettings defaultExternalMapServerPort]
						ifFalse: [port])) .
	aSoapCall targetObjectURI: url fullPath.
	^aSoapCall! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 5/10/2005 18:18'!
adjustEntryToNearest: anNmWorldMapEntry 
	| origPoint ents entPoints neighbors empties nearestPoint |
	origPoint _ anNmWorldMapEntry point.
	ents _ self entriesWithout: anNmWorldMapEntry.
	entPoints _ (ents
				collect: [:each | each point]) asSet.
	neighbors _ entPoints
				inject: Set new
				into: [:all :each | all addAll: each fourNeighbors;
						 yourself].
	empties _ neighbors removeAllFoundIn: entPoints;
				asSortedCollection: [:a :b | a y < b y].
	nearestPoint _ empties
				detectMin: [:each | each dist: origPoint].
	nearestPoint notNil
		ifTrue: [anNmWorldMapEntry point: nearestPoint.
			self forceRegister: anNmWorldMapEntry].
	^ anNmWorldMapEntry! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 7/29/2005 09:04'!
allConnectAddresses
	"NmWorldMap default allConnectAddresses"
	^self entries collect: [:each | each ipAndPortArray]! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 6/13/2004 01:30'!
allLocalIdentifiers
	^ (ActiveWorld allMorphs
		reject: [:each | each isRenderer])
		collect: [:each | each identifier]! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/26/2004 02:08'!
allPoints
	^self entries collect: [:each | each point]

! !

!NmWorldMap methodsFor: 'changing' stamp: 'mu 7/5/2005 20:59'!
allUnchanged
	self map
		valuesDo: [:each | each unchanged].
	self unchanged.
	! !

!NmWorldMap methodsFor: 'accessing name' stamp: 'mu 1/14/2005 00:59'!
allWorldNames
	^map collect: [:each | each destination]
	! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/27/2004 01:42'!
atAddress: ipAndPortArray
	
	^self entries detect: [:each | each ipAndPortArray = ipAndPortArray] ifNone: []! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 8/4/2005 08:25'!
atAddress: ipAndPortArray ifAbsent: block
	^self entries detect: [:each | each ipAndPortArray = ipAndPortArray] ifNone: [block value]! !

!NmWorldMap methodsFor: 'accessing name' stamp: 'mu 1/7/2005 01:22'!
atName: destinationName
	| nm |
	nm _ self normalizedDestinationStringFrom: destinationName. 
	^self entries detect: [:each | each destination = nm] ifNone: []
! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/25/2004 00:44'!
atPoint: aPoint
	^self entries detect: [:each | each point = aPoint] ifNone: []

! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/25/2004 01:07'!
atPoint: aPoint ifAbsent: aBlock
	^self entries detect: [:each | each point = aPoint] ifNone: aBlock

! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 12/21/2004 01:12'!
at: uuidStr
	^self findById: uuidStr! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 8/3/2005 09:57'!
at: uuidStr ifAbsent: aBlock
	
	^map at: uuidStr asString ifAbsent: aBlock! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/24/2005 00:54'!
at: uuidStr put: aWorldMapEntry 
	map at: uuidStr asString put: aWorldMapEntry.
	self changed! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 8/22/2005 09:36'!
basicLoad
	"NmWorldMap default basicLoad"
	| mapString |
	self isLocked
		ifTrue: [^ self].
	NmServerManager isMapServerOnlyImage
		ifTrue: [^ self].
	mapString := self callLoadNamed: self mapName.
	self fromCsvString: mapString.
	self localEntry isNil
		ifTrue: [| newLocal | 
			newLocal := oldLocalEntry
						ifNil: [NmWorldMapEntry newWithId: self localId]
						ifNotNil: [oldLocalEntry].
			self forceRegister: newLocal;
				 unchanged.
			self updateWithLocalEntry]! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 8/16/2005 12:16'!
basicRegisterLocalEntry: uuidStr 
	| newLocal |
	newLocal _ NmWorldMapEntry newWithId: uuidStr.
	oldLocalEntry isNil
		ifFalse: [newLocal inherit: oldLocalEntry.
			oldLocalEntry becomeForward: newLocal].
	self forceRegister: newLocal.
	^ newLocal! !

!NmWorldMap methodsFor: 'accessing destination' stamp: 'mu 5/10/2005 19:10'!
bottomDestination
	"NmWorldMap default bottomDestination"
	^self atPoint:  self localPoint + (0@-1) ifAbsent: []
		! !

!NmWorldMap methodsFor: 'obsolete' stamp: 'mu 12/25/2004 03:13'!
bottomOf: destinationName 
	"NmWorldMap bottomOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint entry |
	point _ self pointOf: destinationName.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x y: point y - 1.
	entry _ self atPoint: destinationPoint.
	^ entry
		ifNotNilDo: [:ent | 
			| nm | 
			nm _ entry name.
			nm
				ifNotNilDo: [:n | n asUrl isNmUrl
						ifTrue: [n asUrl]
						ifFalse: [n]]]! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 5/7/2005 10:25'!
callGetVersion
	| call |
	call _ self newCall.
	call methodName: 'getVersionNamed:'.
	call
		addParameter: (SoapVariable name: #mapName value: self mapName).
	^self invoke: call. 
	! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 4/21/2005 01:39'!
callListLoadableMapNames
	| call |
	call _ self newCall.
	call methodName: 'listAllMapNames'.
	^self invoke: call ! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 5/5/2005 23:30'!
callLoadNamed: mapNameStr
	| call |
	call _ self newCall.
	call methodName: 'getMapStringNamed:'.
	call
		addParameter: (SoapVariable name: #mapName value: mapNameStr).
	^self invoke: call 
	! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 5/13/2005 23:17'!
callRemoveEntry: uuidStr 
	| call |
	call _ self newCall.
	call methodName: 'removeEntryWith:named:'.
	call
		addParameter: (SoapVariable name: #uuidStr value: uuidStr).
	call
		addParameter: (SoapVariable name: #mapName value: self mapName).
	^self invoke: call ! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 4/21/2005 01:39'!
callStoreNamed: mapNameStr 
	| call |
	call _ self newCall.
	call methodName: 'putMapString:named:'.
	call
		addParameter: (SoapVariable name: #mapCSVString value: self csvString).
	call
		addParameter: (SoapVariable name: #mapName value: mapNameStr).
	^self invoke: call! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 5/13/2005 23:16'!
callUpdateLocalEntry
	| call |
	call _ self newCall.
	call methodName: 'updateEntryWith:named:'.
	call
		addParameter: (SoapVariable name: #mapEntryString value: self localEntry csvString).
	call
		addParameter: (SoapVariable name: #mapName value: self mapName).
	^self invoke: call. 
	! !

!NmWorldMap methodsFor: 'changing' stamp: 'mu 2/1/2005 23:52'!
changed
	super changed.
	hasChanged _ true! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/11/2005 00:08'!
clingTogetherAloneEntries
	| aloneEnts |
	[self lock.
	aloneEnts _ self selectAloneEntries.
	aloneEnts
		do: [:each | self adjustEntryToNearest: each].
	self hasChanged
		ifTrue: [self incrementVersion.
			self storeNamed: self mapName useServer: false]]
		ensure: [self unlock]! !

!NmWorldMap methodsFor: 'writing' stamp: 'mu 5/7/2005 00:52'!
csvString
	| mapDictionary stream |
	mapDictionary _ self map.
	mapDictionary isNil ifTrue: [^''].
	stream _ WriteStream on: String new.
	self headerCsvOn: stream.
	mapDictionary
		valuesDo: [ :value | 
			stream nextPutAll: value asString.
			stream nextPut: Character cr].
	^ stream contents! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 4/16/2003 02:30'!
deltaPointTo: destinationPoint
	| fromPoint toPoint |
	fromPoint _ self localPoint.
	toPoint _ destinationPoint.
	^ toPoint - fromPoint * (ActiveWorld extent) * (1 @ -1)! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 5/10/2005 20:09'!
destinationNameAt: ipAndPortArray
	| ent |
	ent _ self atAddress: ipAndPortArray.
	^ ent ifNotNil:[ent destination]! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 3/2/2005 00:28'!
emptyPoint
	^self emptyPointConsidering: self allPoints! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 7/20/2005 01:53'!
emptyPointConsidering: existingPoints 
	"NmWorldMap default emptyPointConsidering: {0@1. 0@0}"
	"NmWorldMap default emptyPointConsidering: {1@1. 0@0. 1@3. 2@3}"
	^NmPointAllocator default emptyPointConsidering: existingPoints ! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 5/31/2005 17:37'!
emptyPortConsidering: existingPorts 
	| interval removed |
	interval _ NmBaseSettings availableWarpPorts.
	removed _ interval asOrderedCollection removeAll: existingPorts;
				 yourself.
	^ removed
		ifEmpty: [NmBaseSettings defaultWarpPort]
		ifNotEmpty: [removed first]! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 12/21/2004 01:04'!
entries
	^map values
! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/24/2005 23:14'!
entriesWithout: worldMapEntry
	"NmWorldMap default entriesWithout: NmWorldMap default localEntry"
	| keys |
	keys _ map keys removeAllSuchThat: [:each | each = worldMapEntry id].
	^keys collect: [:k | self at: k ]
! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/25/2005 00:05'!
entries: aCollectionOfWorldMapEntry
	self initWithEntries: aCollectionOfWorldMapEntry! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/24/2005 01:46'!
findById: uuidStr
	^map at: uuidStr asString  ifAbsent:[]! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 6/16/2005 00:50'!
fixCallTarget
	NmWorldMapLocationListener refresh.
	(NmServerManager isMapServerInstalled
			and: [NmServerManager isMapServerRunning])
		ifTrue: [NmBaseSettings mapServerUrl: NmBaseUtil localMapServerUrl.
			NmBaseSettings mapFromInternet
				ifTrue: [NmBaseSettings mapFromInternet: false]]! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/24/2005 02:16'!
forceRegister: aWorldMapEntry 
	self at: aWorldMapEntry id put: aWorldMapEntry.
	^ aWorldMapEntry! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 5/10/2005 18:00'!
forget
	self forgetNamed: self mapName useServer: false 
	! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 5/10/2005 18:02'!
forgetNamed: mapNameStr
	self forgetNamed: self mapName 
	! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 5/10/2005 18:00'!
forgetNamed: mapNameStr useServer: useExternalAdminServer 
	self isLocked
		ifTrue: [^ self].
	useExternalAdminServer
		ifTrue: ["self callForgetNamed: mapNameStr"
			#TBD]
		ifFalse: [NmWorldInfoReadWriter deleteCsvFile: mapNameStr]! !

!NmWorldMap methodsFor: 'reading' stamp: 'mu 7/5/2005 20:46'!
fromCsvString: aString 
	aString isEmptyOrNil
		ifTrue: [^ self].
	self readFrom: (ReadStream on: aString).
	! !

!NmWorldMap methodsFor: 'changing' stamp: 'mu 1/22/2005 01:56'!
hasChanged
	hasChanged ifNil: [hasChanged _ false].
	^hasChanged! !

!NmWorldMap methodsFor: 'writing' stamp: 'mu 5/7/2005 09:34'!
headerCsvOn: aStream 
	aStream nextPutAll: self mapName asString;
		 nextPut: $,;
		 nextPutAll: self version asString;
		 nextPut: Character cr! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 12/21/2004 01:13'!
includesKey: uuidStr
	^map includesKey: uuidStr asString

! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/25/2004 00:44'!
includesPoint: aPoint
	^(self atPoint: aPoint) notNil

! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/6/2005 02:31'!
incrementVersion
	version _ version + 1! !

!NmWorldMap methodsFor: 'initialize-release' stamp: 'mu 5/7/2005 09:32'!
initialize
	"NmWorldMap default initialize"
	self initMap.
	mapName _ nil.
	version _ 0.
	! !

!NmWorldMap methodsFor: 'initialize-release' stamp: 'mu 4/3/2005 23:10'!
initMap
	map _ Dictionary new.
	self changed! !

!NmWorldMap methodsFor: 'initialize-release' stamp: 'mu 1/25/2005 00:04'!
initWithEntries: aCollectionOfWorldMapEntry
	self initMap.
	aCollectionOfWorldMapEntry do: [:each | self at: each id put: each]
! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 8/16/2005 09:44'!
invoke: aSoapCall 
	NmBaseSettings mapFromInternet
		ifFalse: [NmWorldMapLocationListener mapServerUrl
				ifNotNilDo: [:recomUrl | 
					self adapt: aSoapCall targetTo: recomUrl asUrl.
					NmBaseSettings mapServerUrl: recomUrl]].
	^ aSoapCall
		invokeAndReturnHandling: [:ex | 
			NmShortMessageMorph contents: ex messageText at: ActiveWorld center.
			self fixCallTarget.
			NmSoapCallFailedWarning signal: ex messageText.
			nil]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 3/23/2003 12:42'!
ipAndPortArrayAt: aPoint 
	^self ipAndPortArrayAt: aPoint ifAbsent: []! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/28/2004 00:27'!
ipAndPortArrayAt: aPoint ifAbsent: aBlock
	| ent |
	ent _ self atPoint: aPoint.
	ent	ifNil: [^ aBlock value].
	^ ent ipAndPortArray! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 5/10/2005 19:58'!
ipAndPortArrayFor: destinationEntry 
	| ent |
	ent _ destinationEntry isString
				ifTrue: [self atName: destinationEntry]
				ifFalse: [self at: destinationEntry id].
	^ ent isNil
		ifFalse: [ent ipAndPortArray]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/29/2004 22:19'!
ipAndPortArrays
	^ self entries
		collect: [:each | each ipAndPortArray]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 3/23/2003 12:42'!
ipAndPortAt: aPoint 
	^self ipAndPortAt: aPoint ifAbsent: []! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/28/2004 00:27'!
ipAndPortAt: aPoint ifAbsent: aBlock 
	| ent |
	ent _ self atPoint: aPoint.
	ent	ifNil: [^ aBlock value].
	^ ent ipAndPort! !

!NmWorldMap methodsFor: 'testing' stamp: 'mu 5/2/2005 01:54'!
isEmpty
	^self map isEmpty! !

!NmWorldMap methodsFor: 'testing' stamp: 'mu 4/10/2005 00:13'!
isLocal
	^self = NmWorldMap default! !

!NmWorldMap methodsFor: 'testing' stamp: 'mu 2/3/2005 22:08'!
isLocked
	^locker notNil! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/2/2005 01:56'!
keys
	^map keys
! !

!NmWorldMap methodsFor: 'local entry management' stamp: 'mu 8/18/2005 08:46'!
leaveIfFailedRemoveLocalEntry: uuidStr 
	| ret |
	ret _ self callRemoveEntry: uuidStr.
	ret
		ifNil: [oldLocalEntry _ self
						at: uuidStr
						ifAbsent: [].
			map
				removeKey: uuidStr
				ifAbsent: [].
			self basicRegisterLocalEntry: NmImageId current asString.
			self localEntry unchanged]! !

!NmWorldMap methodsFor: 'local entry management' stamp: 'mu 8/15/2005 11:38'!
leaveLocalEntry: uuidStr 
	self callRemoveEntry: uuidStr
	
! !

!NmWorldMap methodsFor: 'accessing destination' stamp: 'mu 5/10/2005 19:10'!
leftDestination
	"NmWorldMap default leftDestination"
	^self atPoint: self localPoint + (-1@0) ifAbsent: []
		! !

!NmWorldMap methodsFor: 'obsolete' stamp: 'mu 12/25/2004 03:13'!
leftOf: destinationName 
	"NmWorldMap leftOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint entry |
	point _ self pointOf: destinationName.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x - 1 y: point y.
	entry _ self atPoint: destinationPoint.
	^ entry
		ifNotNilDo: [:ent | 
			| nm | 
			nm _ entry name.
			nm
				ifNotNilDo: [:n | n asUrl isNmUrl
						ifTrue: [n asUrl]
						ifFalse: [n]]]! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 6/13/2005 23:43'!
listLoadableMapNames
	^ self callListLoadableMapNames! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 8/17/2005 08:16'!
load
	[self basicLoad]
		on: SoapImplError, RmtNetworkError
		do: [:ex | 
			self changed: #worldMapLoadFailed.
			^NmTranscript crShow: ex description].
	self changed: #worldMapLoaded.
	NmTranscript crShow: '## NmWorldMap was loaded: ' , self map printString.! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 1/15/2005 02:15'!
localEntry
	"NmWorldMap default localEntry"
	^self at: self localId ifAbsent:[]! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 1/15/2005 01:47'!
localId
	^NmImageId current asString! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 12/24/2004 02:49'!
localIp
	| ent |
	ent _ self at: self localId ifAbsent: [self resetLocal].
	ent ifNil: [^''].
	^ent ip
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 8/18/2005 09:00'!
localIpAndPortArray
	"NmWorldMap default localIpAndPortArray"
	^ self localEntry isNil
		ifTrue: [{NmBaseUtil localAddress. NmBaseSettings warpPort}]
		ifFalse: [self localEntry ipAndPortArray]! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 8/15/2005 12:45'!
localIp: aString
	| ent |
	ent _ self localEntry.
	ent ifNil: [^self].
	ent ip:  aString.
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 5/14/2005 00:35'!
localName
	| ent |
	ent _ self at: self localId ifAbsent: [].
	ent ifNil: [^''].
	^ent destination
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 8/15/2005 12:45'!
localName: aString
	| ent |
	ent _ self localEntry.
	ent ifNil: [^self].
	ent name:  aString.
	
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 5/14/2005 00:22'!
localPoint
	| ent |
	ent _ self at: self localId ifAbsent: [].
	ent ifNil: [^nil].
	^ent point
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 8/15/2005 12:45'!
localPoint: aPoint
	| ent |
	ent _ self localEntry.
	ent ifNil: [^self].
	ent point:  aPoint.
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 12/24/2004 02:49'!
localPort
	| ent |
	ent _ self at: self localId ifAbsent: [self resetLocal].
	ent ifNil: [^''].
	^ent port
	! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 8/15/2005 12:45'!
localPort: aString
	| ent |
	ent _ self localEntry.
	ent ifNil: [^self].
	ent port:  aString.
	! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 2/3/2005 22:34'!
lock
	^self lockWith: UUID new asString! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 2/3/2005 22:23'!
lockWith: uuidStr 
	self isLocked
		ifTrue: [NmLockFailed signal: 'Lock from wrong client: ' , uuidStr asString.
			^ nil].
	^ locker _ uuidStr asString! !

!NmWorldMap methodsFor: 'accessing' stamp: ''!
map
	^ map! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 4/3/2005 23:43'!
mapName
	mapName
		ifNil: [mapName _ self class defaultMapName].
	^ mapName! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 5/10/2005 17:24'!
mapName: aString
	mapName _ aString.
	self changed: #mapName.
	! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 1/22/2005 01:58'!
map: aDictionary
	map _ aDictionary.
	self changed
	
! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 7/29/2005 19:46'!
neighborConnectAddresses
	"NmWorldMap default neighborConnectAddresses"
	| neighborPoints ipAndPorts |
	neighborPoints _ self localPoint fourNeighbors.
	ipAndPorts _ OrderedCollection new.
	neighborPoints
		do: [:each | 
			| entry | 
			entry _ self atPoint: each.
			entry notNil
				ifTrue: [ipAndPorts add: entry ipAndPortArray]].
	^ ipAndPorts! !

!NmWorldMap methodsFor: 'soap calls' stamp: 'mu 6/1/2005 17:16'!
newCall
	| call url port |
	url _ NmBaseSettings mapServerUrl asUrl.
	port _ url port.
	call _ (SoapCallEntry
				tcpHost: url authority
				port: (port isNil
						ifTrue: [NmBaseSettings defaultExternalMapServerPort]
						ifFalse: [port])) newCall.
	call targetObjectURI: url fullPath.
	call useColocation: true.
	^call! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 12/25/2004 00:54'!
normalizedDestinationStringFrom: destString 
	| url |
	url _ destString asUrl.
	^ url isNmUrl
		ifTrue: [url asString]
		ifFalse: [destString]! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 12/25/2004 02:59'!
pointOf: destinationName 
	"NmWorldMap pointOf: 'nm://Smalltalk:37458/' asUrl"
	"NmWorldMap pointOf: 'nm://qwerty:37458/'"
	| ent |
	ent _ self atName: destinationName.
	
	^ent notNil ifTrue: [ent point]! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/28/2004 00:28'!
points
	^self allPoints! !

!NmWorldMap methodsFor: 'accessing point' stamp: 'mu 1/24/2005 02:26'!
pointsWithoutLocal
	^self allPoints reject: [:each | each = self localPoint]

! !

!NmWorldMap methodsFor: 'printing' stamp: 'mu 4/10/2005 00:17'!
printOn: aStream 
	| name |
	super printOn: aStream.
	name _ self mapName.
	name
		ifNotNilDo: [:n | aStream space; nextPutAll: ' ('; nextPutAll: n; nextPutAll: ')']! !

!NmWorldMap methodsFor: 'reading' stamp: 'mu 7/5/2005 20:50'!
readFrom: aStream
	| stream entries |
	stream _ aStream.
	self readHeaderCsvFrom: stream.
	entries _ OrderedCollection new.
	[stream atEnd]
		whileFalse: [| line | 
			line _ stream nextLine.
			(line includes: $,)
				ifTrue: [| ent | 
					ent _ NmWorldMapEntry fromCsvString: line. 
					entries add: ent]].
	self entries: entries.
	
	! !

!NmWorldMap methodsFor: 'reading' stamp: 'mu 5/7/2005 09:57'!
readHeaderCsvFrom: aStream 
	| line lineStream |
	line _ aStream nextLine.
	lineStream _ line readStream.
	self
		mapName: (lineStream upTo: $,).
	self
		version: (lineStream upTo: $,)! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 8/11/2005 11:16'!
registerDodgeIfConflict: aWorldMapEntry 
	| withoutMeEntries origPoint points sameIps sameIpAndPorts |
	withoutMeEntries := self entriesWithout: aWorldMapEntry.

	origPoint := aWorldMapEntry point.
	points := withoutMeEntries collect: [:each | each point].
	(points includes: origPoint)
		ifTrue: [aWorldMapEntry
				point: (self emptyPointConsidering: points)].

	sameIps := withoutMeEntries select: [:each | each ip = aWorldMapEntry ip].
	sameIpAndPorts := sameIps select: [:each | each port = aWorldMapEntry port].
	sameIpAndPorts ifNotEmpty: [aWorldMapEntry
				port: (self emptyPortConsidering: (sameIps collect: [:each | each port asInteger]))].

	self at: aWorldMapEntry id put: aWorldMapEntry.
	^ aWorldMapEntry! !

!NmWorldMap methodsFor: 'local entry management' stamp: 'mu 8/16/2005 12:16'!
registerLocalEntry: uuidStr 
	| newLocal |
	newLocal _ self basicRegisterLocalEntry: uuidStr.
	self updateWithLocalEntry.
	^ newLocal! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/27/2004 01:44'!
removeAtAddress: ipAndPortArray
	
	| ent |
	ent _ self atAddress: ipAndPortArray.
	ent isNil ifFalse: [self remove: ent]! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 4/30/2005 23:48'!
removeKey: uuidStr
	map removeKey: uuidStr asString.
	self changed! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/25/2005 00:14'!
removeKey: uuidStr ifAbsent: aBlock
	map removeKey: uuidStr asString ifAbsent: aBlock.
	self changed! !

!NmWorldMap methodsFor: 'local entry management' stamp: 'mu 8/15/2005 11:39'!
removeLocalEntry: uuidStr 
	oldLocalEntry _ self
				at: uuidStr
				ifAbsent: [].
	map
		removeKey: uuidStr
		ifAbsent: [].
	self leaveLocalEntry: uuidStr
	
! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 4/30/2005 23:51'!
removeNotUpdatedFor: seconds 
	| currentTime |
	currentTime _ DateAndTime totalSeconds.
	self map copy
		do: [:each | (currentTime - each lastChangedTime) abs > seconds
				ifTrue: [self remove: each ifAbsent:[]]]! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 1/22/2005 03:00'!
remove: aWorldMapEntry
	map removeKey: aWorldMapEntry id asString ifAbsent:[^nil].
	self changed! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/2/2005 01:49'!
remove: aWorldMapEntry ifAbsent: block
	map removeKey: aWorldMapEntry id asString ifAbsent:[^block value].
	self changed! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 5/13/2005 23:27'!
resetLocal
	"NmWorldMap default resetLocal"
	^self registerLocalEntry: self localId ! !

!NmWorldMap methodsFor: 'local info' stamp: 'mu 1/15/2005 02:14'!
resetLocalTo: uuid 
	self localEntry isNil
		ifTrue: [NmImageId resetTo: uuid.
			self registerLocalEntry: uuid]! !

!NmWorldMap methodsFor: 'accessing destination' stamp: 'mu 5/10/2005 19:10'!
rightDestination
	"NmWorldMap default rightDestination"
	^self atPoint: self localPoint + (1@0) ifAbsent: []
		! !

!NmWorldMap methodsFor: 'obsolete' stamp: 'mu 12/25/2004 03:14'!
rightOf: destinationName 
	"NmWorldMap rightOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint entry |
	point _ self pointOf: destinationName.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x + 1 y: point y.
	entry _ self atPoint: destinationPoint.
	^ entry
		ifNotNilDo: [:ent | 
			| nm | 
			nm _ entry name.
			nm
				ifNotNilDo: [:n | n asUrl isNmUrl
						ifTrue: [n asUrl]
						ifFalse: [n]]]! !

!NmWorldMap methodsFor: 'private' stamp: 'mu 5/10/2005 02:44'!
selectAloneEntries
	| allPoints aloneEnts |
	allPoints _ self allPoints.
	aloneEnts _ self entries
				select: [:eachEnt | (eachEnt point fourNeighbors
						 includesAnyOf: allPoints) not].
	^ aloneEnts! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 8/11/2005 13:17'!
store
	"NmWorldMap default store"
	NmTranscript crShow: #'STORE WorldMap: ', Time now asString.
	self storeNamed: self mapName useServer: NmServerManager isMapServerOnlyImage not! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 6/13/2005 23:43'!
storeNamed: mapNameStr 
	^ self storeNamed: mapNameStr useServer: true! !

!NmWorldMap methodsFor: 'storing/loading' stamp: 'mu 8/17/2005 10:15'!
storeNamed: mapNameStr useServer: useExternalServer
	self isLocked ifTrue: [ ^self].
	useExternalServer
		ifTrue: [self callStoreNamed: mapNameStr]
		ifFalse: [NmWorldInfoReadWriter putCsvString: self csvString toFile: mapNameStr].
	self allUnchanged.
	self changed: #worldMapStored.! !

!NmWorldMap methodsFor: 'accessing address' stamp: 'mu 12/25/2004 02:16'!
survivorsDo: aBlock 
	| allAddresses availableAddresses neighborAddresses otherAddresses |
	allAddresses _ self allConnectAddresses.
	availableAddresses _ NmAvailabilityChecker default availableAddresses.
	neighborAddresses _ self neighborConnectAddresses.
	(neighborAddresses intersection: availableAddresses)
		do: [:each | aBlock value: each].
	otherAddresses _ allAddresses reject:[:each | neighborAddresses includes: each].
	(otherAddresses intersection: availableAddresses)
		do: [:each | aBlock value: each]! !

!NmWorldMap methodsFor: 'accessing destination' stamp: 'mu 5/10/2005 19:10'!
topDestination
	"NmWorldMap default topDestination"
	^self atPoint:  self localPoint + (0@1) ifAbsent: []
		! !

!NmWorldMap methodsFor: 'obsolete' stamp: 'mu 12/25/2004 03:13'!
topOf: destinationName 
	"NmWorldMap topOf: 'nm://smalltalk:37458/' asUrl"
	| point destinationPoint entry |
	point _ self pointOf: destinationName.
	point isNil
		ifTrue: [^ nil].
	destinationPoint _ Point x: point x y: point y + 1.
	entry _ self atPoint: destinationPoint.
	^ entry
		ifNotNilDo: [:ent | 
			| nm | 
			nm _ entry name.
			nm
				ifNotNilDo: [:n | n asUrl isNmUrl
						ifTrue: [n asUrl]
						ifFalse: [n]]]! !

!NmWorldMap methodsFor: 'changing' stamp: 'mu 4/10/2005 00:26'!
unchanged
	hasChanged _ false! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 5/10/2005 03:02'!
unlock
	self unlockWith: locker! !

!NmWorldMap methodsFor: 'actions' stamp: 'mu 2/4/2005 00:28'!
unlockWith: uuidStr 
	self isLocked ifFalse: [^nil].
	uuidStr = locker
		ifTrue: [locker _ nil]
		ifFalse: [NmUnlockFailed signal: 'Unlock from wrong client: ' , uuidStr asString.
			^ nil]! !

!NmWorldMap methodsFor: 'auto update' stamp: 'mu 8/17/2005 11:16'!
update
	"NmWorldMap default update"
	"NmTranscript crShow: #'UPDATE WorldMap Entry: ', Time now asString."
	self updateWithVersion. 
	self updateWithLocalEntry.
	! !

!NmWorldMap methodsFor: 'auto update' stamp: 'mu 8/17/2005 08:16'!
updateWithLocalEntry
	"NmWorldMap default updateWithLocalEntry"
	| oldMap newMap csvStr |
	self isLocked
		ifTrue: [^ self].
	self localEntry
		ifNil: [^ self resetLocal].
	csvStr _ self callUpdateLocalEntry.
	csvStr ifNil: [^self]
		ifNotNil: [newMap _ (NmWorldMap new fromCsvString: csvStr) map].
	oldMap _ self map.
	oldMap = newMap
		ifFalse: [self fromCsvString: csvStr.
			self changed: #localEntryUpdated]! !

!NmWorldMap methodsFor: 'auto update' stamp: 'mu 8/22/2005 09:27'!
updateWithVersion
	"NmWorldMap default updateWithVersion"
	| currentVersion |
	self isLocked
		ifTrue: [^ self].
	currentVersion := self callGetVersion. 
	(currentVersion notNil
			and: [currentVersion > self version])
		ifTrue: [| voteBox | 
			voteBox := OrderedCollection with: true.
			self changed: #worldMapVersionUp with: voteBox.
			(voteBox includes: false)
				ifFalse: [self load]]! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 5/7/2005 10:04'!
version
	version ifNil: [version _ 0].
	^version! !

!NmWorldMap methodsFor: 'accessing' stamp: 'mu 5/10/2005 17:24'!
version: anInteger
	version _ anInteger asInteger.
	self changed: #version.! !

!NmWorldMap methodsFor: 'accessing name' stamp: 'mu 12/25/2004 01:04'!
worldNamesExcluding: point 
	^ (self entries
		reject: [:each | each point = point])
		collect: [:each | each name]! !

!NmWorldMap methodsFor: 'accessing name' stamp: 'mu 1/24/2005 02:25'!
worldNamesWithoutLocal
	^self allWorldNames reject: [:each | each = self localName]! !

!NmWorldMap methodsFor: 'comparing' stamp: 'mu 4/3/2005 23:40'!
= aNmWorldMap 
	(aNmWorldMap isKindOf: self class)
		ifFalse: [^ false].
	self map = aNmWorldMap map
		ifFalse: [^ false].
	self mapName = aNmWorldMap mapName
		ifFalse: [^ false].
	^ true! !

Model subclass: #NmWorldMapEntry
	instanceVariableNames: 'id point name ip port hasChanged lastChangedTime deferredUpdate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NetMorph-WorldMap'!

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 7/5/2005 19:24'!
fromCsvString: aString
	^self readCsvFrom: aString readStream! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 6/3/2005 19:15'!
id: uuid point: point name: nm 
	^ (self
		id: uuid
		point: point
		name: nm
		ip: NmBaseUtil localAddress
		port: NmBaseSettings warpPort) unchanged! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 1/21/2005 23:35'!
id: uuid point: point name: nm ip: ip port: port 
	^ (self newWithId: uuid) point: point;
		 name: nm;
		 ip: ip;
		 port: port;
		 unchanged! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 5/13/2005 02:16'!
ip: ip port: port 
	^self id: UUID new point: 0@0 name: '' ip: ip port: port ! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 8/18/2005 10:53'!
newWithId: uuidStr
	"NmWorldMapEntry newWithId: UUID new"
	| inst |
	inst := NmWorldMapEntry new.
	inst id: uuidStr.
	^inst! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 6/3/2005 19:15'!
point: point name: nm 
	^ self
		id: UUID new
		point: point
		name: nm
		ip: NmBaseUtil localAddress
		port: NmBaseSettings warpPort! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 12/24/2004 03:06'!
point: point name: nm ip: ip port: port 
	^self id: UUID new point: point name: nm ip: ip port: port ! !

!NmWorldMapEntry class methodsFor: 'instance creation' stamp: 'mu 1/21/2005 23:35'!
readCsvFrom: aStream 
	^ self basicNew readCsvFrom: aStream;
		 unchanged! !

!NmWorldMapEntry methodsFor: 'actions-updating' stamp: 'mu 8/7/2005 10:36'!
asDeferredUpdate
	^self copy beDeferredUpdate ! !

!NmWorldMapEntry methodsFor: 'converting' stamp: 'mu 5/10/2005 20:30'!
asDestination
	^self! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 1/22/2005 01:01'!
asString
	^self csvString! !

!NmWorldMapEntry methodsFor: 'actions-updating' stamp: 'mu 8/7/2005 19:45'!
beDeferredLocal
	id := NmImageId current asString.
	self beDeferredUpdate! !

!NmWorldMapEntry methodsFor: 'actions-updating' stamp: 'mu 8/7/2005 11:01'!
beDeferredUpdate
	point := ip := port := hasChanged := lastChangedTime := nil.
	self deferredUpdate: true! !

!NmWorldMapEntry methodsFor: 'changing' stamp: 'mu 8/11/2005 10:57'!
changed
	hasChanged := true.
	self resetLastChangedTime.
	super changed.! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 1/22/2005 01:01'!
csvString
	^String streamContents: [:str | self printCsvOn: str]! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:09'!
deferredLocal
	^self deferredUpdate and: [id isNil]! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 09:54'!
deferredUpdate
	deferredUpdate ifNil: [deferredUpdate := false].
	^deferredUpdate! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 09:56'!
deferredUpdate: aBoolean
	deferredUpdate _ aBoolean == true! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 2/3/2005 23:38'!
descriptionString
	^String streamContents: [:str | self printCsvOn: str]! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 12/27/2004 01:37'!
destination
	^ self name isEmptyOrNil
		ifTrue: [self ipAndPort]
		ifFalse: [self name]! !

!NmWorldMapEntry methodsFor: 'private' stamp: 'mu 8/7/2005 09:49'!
entryFromMap
	^ NmWorldMap default
		at: self id
		ifAbsent: []! !

!NmWorldMapEntry methodsFor: 'changing' stamp: 'mu 1/21/2005 23:17'!
hasChanged
	hasChanged ifNil: [hasChanged _ false].
	^hasChanged! !

!NmWorldMapEntry methodsFor: 'comparing' stamp: 'mu 12/21/2004 00:57'!
hash
	^self id hash! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 11:56'!
id
	self deferredLocal ifTrue: [^NmImageId current asString].
	id ifNil:[id := UUID new asString].
	^id! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 5/14/2005 00:21'!
id: uuidStr
	| oldId |
	oldId _ id.
	id _ uuidStr asString withBlanksTrimmed.
	oldId = id ifFalse: [self changed]
	! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 12/25/2004 23:51'!
inherit: aWorldMapEntry
	self name: aWorldMapEntry name.
	self point: aWorldMapEntry point.
	self ip: aWorldMapEntry ip.
	self port: aWorldMapEntry port.
	! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:44'!
ip
	self deferredUpdate  ifTrue: [self entryFromMap ifNotNilDo:[:ent | ^ent ip]].
	self isLocal ifTrue: [^NmBaseUtil localAddress].
	ip ifNil:[ip := NmBaseUtil localAddress].
	^ip! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 12/22/2004 00:58'!
ipAndPort
	^self ip, ':', self port! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 5/10/2005 19:17'!
ipAndPortArray
	^{self ip. self port asInteger}! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 7/6/2005 02:40'!
ip: aString 
	| oldIp |
	oldIp _ ip.
	ip _ aString asString withBlanksTrimmed.
	self isLocal
		ifTrue: [| locAdd | 
			locAdd _ NmBaseUtil localAddress.
			ip = locAdd
				ifFalse: [ip _ locAdd]].
	oldIp = ip ifFalse: [self changed]
	! !

!NmWorldMapEntry methodsFor: 'testing' stamp: 'mu 12/28/2004 00:19'!
isLocal
	^self id = NmWorldMap default localId! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 2/1/2005 23:55'!
lastChangedTime
	lastChangedTime ifNil: [lastChangedTime _ 0].
	^lastChangedTime! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/18/2005 11:06'!
name
	self deferredUpdate ifTrue: [self entryFromMap ifNotNilDo:[:ent | ^ent name]].
	name
		ifNil: [name := ''].
	(self isLocal
			and: [name isNmUrlString])
		ifTrue: [^ NmUrl local asString].
	^ name! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/18/2005 11:30'!
name: aString 
	| oldName |
	oldName := self destination.
	name := aString asString withBlanksTrimmed.
	(oldName isNil and: [name isEmpty]) ifTrue: [^ self name].
	name isNmUrlString
		ifTrue: [| url | 
			self isLocal
				ifTrue: [url := NmUrl local.
					name := url asString]
				ifFalse: [url := name asNmUrl].
			self ip: url resolvedIp.
			self port: url port].
	oldName = name
		ifFalse: [self changed].
	! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:44'!
point
	self deferredUpdate  ifTrue: [self entryFromMap ifNotNilDo:[:ent | ^ent point]].
	point ifNil:[point := 0@0].
	^point! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/11/2005 13:17'!
point: aPoint
	| oldPoint po  |
	oldPoint _ point.
	po _  aPoint isString ifTrue: [Point readFrom: aPoint] ifFalse:[aPoint].
	point _ po.
	oldPoint = point ifFalse: [self changed].
	! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 8/7/2005 10:44'!
port
	self deferredUpdate  ifTrue: [self entryFromMap ifNotNilDo:[:ent | ^ent port]].
	self isLocal ifTrue: [^NmBaseSettings warpPort asString].
	port ifNil:[port := NmBaseSettings warpPort asString].
	^port! !

!NmWorldMapEntry methodsFor: 'accessing' stamp: 'mu 1/21/2005 23:52'!
port: aString
	| oldPort |
	oldPort _ port. 
	port _ aString asString withBlanksTrimmed.
	self isLocal
		ifTrue: [NmBaseSettings warpPort: port asInteger].
	oldPort = port ifFalse: [self changed]! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 12/22/2004 01:54'!
printCsvOn: aStream 
	aStream nextPutAll: self id asString;
		 nextPutAll: ', ';
		 nextPutAll: self name;
		 nextPutAll: ', ';
		 nextPutAll: self point asString;
		 nextPutAll: ', ';
		 nextPutAll: self ip;
		 nextPutAll: ', ';
		 nextPutAll: self port! !

!NmWorldMapEntry methodsFor: 'printing' stamp: 'mu 12/26/2004 01:47'!
printOn: aStream 
	self isLocal
		ifTrue: [aStream nextPutAll: 'LOCAL:'].
	aStream nextPutAll: '(id: ';
		 nextPutAll: self id asString;
		 nextPutAll: ' name: ';
		 nextPutAll: self name;
		 nextPutAll: ' point: ';
		 nextPutAll: self point asString;
		 nextPutAll: ' ip: ';
		 nextPutAll: self ip;
		 nextPutAll: ' port: ';
		 nextPutAll: self port;
		 nextPutAll: ' )'! !

!NmWorldMapEntry methodsFor: 'reading' stamp: 'mu 7/5/2005 20:55'!
readCsvFrom: aStream
	self id: (aStream upTo: $,).
	self name: (aStream upTo: $,).
	self point: (aStream upTo: $,).
	self ip: (aStream upTo: $,).
	self port:  (aStream upToEnd).
	
	! !

!NmWorldMapEntry methodsFor: 'changing' stamp: 'mu 8/11/2005 10:56'!
resetLastChangedTime
	lastChangedTime := DateAndTime totalSeconds.
	! !

!NmWorldMapEntry methodsFor: 'actions' stamp: 'mu 8/10/2005 09:35'!
resetLocalPort: newPortNumber
	| newPort |
	self isLocal
		ifFalse: [^ self].
	newPort _ newPortNumber asString withBlanksTrimmed.
	port = newPort ifTrue: [^self].
	port := newPort.
	self name: (self destination copyLastPortPartTo: port).

	NmWorldMap default updateWithLocalEntry
	! !

!NmWorldMapEntry methodsFor: 'comparing' stamp: 'mu 1/24/2005 01:12'!
sameAs: aWorldMapEntry
	^self id = aWorldMapEntry id! !

!NmWorldMapEntry methodsFor: 'objects from disk' stamp: 'mu 7/13/2005 18:48'!
storeDataOn: aDataStream 
	self myDependents: nil.
	hasChanged _ lastChangedTime _ nil.
	super storeDataOn: aDataStream! !

!NmWorldMapEntry methodsFor: 'changing' stamp: 'mu 3/2/2005 01:22'!
unchanged
	hasChanged _ false.
	super changed.! !

!NmWorldMapEntry methodsFor: 'comparing' stamp: 'mu 1/24/2005 01:13'!
= aWorldMapEntry
	^self csvString = aWorldMapEntry csvString! !

!ScriptEditorMorph methodsFor: '*NetMorph-serializing' stamp: 'kuri-t 12/10/2002 14:45'!
prepareForWarp
	(self allMorphs
		select: [:morph | morph shouldPrepareForWarp])
		do: [:each | each prepareForWarp]! !

!ScriptEditorMorph methodsFor: '*NetMorph-testing' stamp: 'kuri-t 12/10/2002 14:44'!
shouldPrepareForWarp
	^ false! !

!SystemDictionary methodsFor: '*NetMorph-accessing' stamp: 'mu 12/17/2004 01:30'!
id
	^SmalltalkImage current id! !

!ProjectViewMorph class methodsFor: '*NetMorph-override-project window creation' stamp: 'mu 12/13/2004 01:12'!
newProjectViewInAWindowFor: aProject
	"Return an instance of me on a new Morphic project (in a SystemWindow)."

	| window proj |
	proj := self on: aProject.
	window _ (SystemWindow labelled: aProject name) model: aProject.
	window
		addMorph: proj
		frame: (0@0 corner: 1.0@1.0).
	window setProperty: #projectWindow toValue: true. "NetMorph"
	proj borderWidth: 0.
	^ window
! !

!ProjectViewMorph methodsFor: '*NetMorph-submorphs-add/remove' stamp: 'MU 1/19/2004 02:06'!
delete
	super delete.
	(Project named: projectNameForDelete) ifNotNilDo: [:proj | proj purge]
! !

!ProjectViewMorph methodsFor: '*NetMorph-override-drawing' stamp: 'mu 6/11/2004 16:22'!
isTheRealProjectPresent

	project ifNil: [^ false].
	project isInMemory ifFalse: [^ false].
	project class == DiskProxy ifTrue: [^ false].
	project isCollection ifTrue: [^false].	"NetMorph"
	^true
! !

!ProjectViewMorph methodsFor: '*NetMorph-callback' stamp: 'mu 6/11/2004 17:50'!
onWarpFailed
	project isCollection
		ifTrue: [self restoreAttributesAfterWarp].
	
	! !

!ProjectViewMorph methodsFor: '*NetMorph-private' stamp: 'MU 1/19/2004 02:03'!
restoreAttributesAfterWarp
	projectNameForDelete _ nil.
	project _ Project loadFrom: project
	! !

!ProjectViewMorph methodsFor: '*NetMorph-private' stamp: 'MU 1/19/2004 02:02'!
trimAttributesBeforeWarp
	project isCollection
		ifFalse: [
			projectNameForDelete _ project name.
			project _ project asLoadableData]! !

!ProjectViewMorph methodsFor: '*NetMorph-copying' stamp: 'MU 1/19/2004 02:10'!
veryDeepInner: deepCopier
	"Copy all of my instance variables.  Some need to be not copied at all, but shared.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	project _ project.		"Weakly copied"
	lastProjectThumbnail _ lastProjectThumbnail veryDeepCopyWith: deepCopier.
	mouseDownTime _ nil.
	projectNameForDelete _ projectNameForDelete
	! !

!ScriptInstantiation methodsFor: '*NetMorph-override-customevents-status control' stamp: 'mu 12/12/2004 23:54'!
presentScriptStatusPopUp
	"Put up a menu of status alternatives and carry out the request"

	| reply  m menu submenu |

	menu _ MenuMorph new.
	self addStatusChoices: #( normal " -- run when called" ) toMenu: menu.
	self addStatusChoices: 
		#(	paused 		"ready to run all the time"
			ticking			"run all the time" )
		toMenu: menu.
	self addStatusChoices: (ScriptingSystem standardEventStati copyFrom: 1 to: 3) toMenu: menu.
	self addStatusChoices: (ScriptingSystem standardEventStati allButFirst: 3) toMenu: menu.
	self addStatusChoices: 
		#(opening			"when I am being opened"
			closing			"when I am being closed" )
		toMenu: menu.
	self addStatusChoices: 
		#(warpingOut	"when I am warping out"
			warpedIn	"when I am being warped in" )
		toMenu: menu.

	submenu _ MenuMorph new.
	self addStatusChoices: (ScriptingSystem globalCustomEventNamesFor: player) toSubMenu: submenu forMenu: menu.
	menu add: 'more... ' translated subMenu: submenu.

	(Preferences allowEtoyUserCustomEvents) ifTrue: [
		submenu addLine.
		self addStatusChoices: ScriptingSystem userCustomEventNames toSubMenu: submenu forMenu: menu.
		submenu addLine.
		self addStatusChoices:
			(Array streamContents: [ :s | s nextPut: { 'define a new custom event'. #defineNewEvent }.
			ScriptingSystem userCustomEventNames isEmpty
				ifFalse: [ s nextPut: { 'delete a custom event'. #deleteCustomEvent } ]])
			toSubMenu: submenu forMenu: menu ].
	
	menu addLine.

	self addStatusChoices: #(
		('what do these mean?'explainStatusAlternatives)
		('apply my status to all siblings' assignStatusToAllSiblings) ) toMenu: menu.

	menu addTitle: 'When should this script run?' translated.
	menu submorphs last delete.
	menu invokeModal.
	
	reply := menu modalSelection.

	reply == #explainStatusAlternatives ifTrue: [^ self explainStatusAlternatives].
	reply == #assignStatusToAllSiblings ifTrue: [^ self assignStatusToAllSiblings].
	reply == #defineNewEvent ifTrue: [ ^self defineNewEvent ].
	reply == #deleteCustomEvent ifTrue: [ ^self deleteCustomEvent ].

	reply ifNotNil: 
		[self status: reply.  "Gets event handlers fixed up"
		reply == #paused ifTrue:
			[m _ player costume.
			(m isKindOf: SpeakerMorph) ifTrue: [m stopSound]].
		self updateAllStatusMorphs]
! !

!ScriptInstantiation methodsFor: '*NetMorph-override-running' stamp: 'mu 12/13/2004 00:15'!
runIfTicking: nowTick 
	"If the receiver is meant to be ticking, run it if it's time"

	| ticks rate |
	status == #ticking ifFalse: [^self].
	rate := self tickingRate.
	ticks := (lastTick isNil or: [nowTick < lastTick]) 
				ifTrue: 
					[lastTick := nowTick.
					1]
				ifFalse: [((nowTick - lastTick) * rate * 0.001) asInteger].
	ticks <= 0 ifTrue: [^self].

	"Scripts which have been out of the world and then return can have a huge number of ticks accumulated. A better fix would be to reset <lastTick> when a script leaves/enters the world. Also, if the system is falling behind, this attempt to catch up can result in falling further behind, leading to sluggish behavior and termination of ticking status. Whether the user really wants this catch up behavior needs to be determined (often she will not, I suspect) and better ways of doing it need to be found.  (This comment inserted by Bob Arning on 3/5/2001)"
	ticks := 1.
	"NetMorph->"
	1
		to: ticks * self frequency
		do: [:i | NmProcessManager
				process: [player triggerScript: selector]
				for: self
				ifError: [:ex | (ex isKindOf: NmNoSubmorphs)
						ifTrue: [RmtDebug crShow: '##No submorphs'.
							ex cleanUp]]].
	"<-NetMorph"

	lastTick := nowTick.
	ticks > 10 
		ifTrue: 
			["check if we're lagging behind"

			ticks <= ((Time millisecondClockValue - lastTick) * rate / 1000) asInteger 
				ifTrue: 
					["e.g., time to run script is higher than number of ticks"

					self status: #paused.
					self updateAllStatusMorphs]]! !

!ScriptInstantiation methodsFor: '*NetMorph-override-running' stamp: ''!
runIfWarpedIn
	| result |
	(result _ status == #warpedIn)
		ifTrue: [player perform: selector].
	^ result! !

!ScriptInstantiation methodsFor: '*NetMorph-override-running' stamp: ''!
runIfWarpingOut
	| result |
	(result _ status == #warpingOut)
		ifTrue: [player perform: selector].
	^ result! !
NmRemoteConnector initialize!
NmRpcMessage initialize!
NmAbstractInitializer initialize!
NmInitializer initialize!
NmBaseUtil initialize!
NmImageId initialize!
NmPointAllocator initialize!
NmPoofs initialize!
NmProcessManager initialize!
NmSoapServer initialize!
NmWorldMapServer initialize!
NmAvailabilityChecker initialize!
NmTimerUpdater initialize!
NmTranscript initialize!
NmWorldMapLocationListener initialize!
NmServiceHandler initialize!
Morph initialize!
NmUrl initialize!
NmBaseSettings initialize!
NmWorldMap initialize!
